/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/log/common/log","vs/base/common/uri","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/errors","vs/base/common/path","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/types","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/resources","vs/base/common/network","vs/platform/telemetry/common/telemetry","vs/base/common/cancellation","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/map","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/request/common/request","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncProfilesStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/userDataSync/electron-sandbox/userDataSyncProfilesStorageService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],se=function(Q){for(var e=[],D=0,i=Q.length;D<i;D++)e[D]=re[Q[D]];return e};define(re[53],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function D(L){return L?L.replace(/\$\((.*?)\)/g,(P,I)=>` ${I} `).trim():""}e.getCodiconAriaLabel=D;class i{constructor(P,I,w){this.id=P,this.definition=I,this.description=w,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}e.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",i.circleFilled.definition),i.closeDirty=new i("close-dirty",i.circleFilled.definition),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.definition),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.definition),i.debugHint=new i("debug-hint",i.circleFilled.definition),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circle=new i("circle",{fontCharacter:"\\eabc"}),i.circleOutline=new i("circle-outline",i.circle.definition),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.definition),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLarge=new i("circle-large",{fontCharacter:"\\ebb5"}),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.definition),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.searchFuzzy=new i("search-fuzzy",{fontCharacter:"\\ec0d"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function R(L,P){const I=["codicon","codicon-"+L];return P&&I.push("codicon-modifier-"+P),I}e.getClassNamesArray=R;var T;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function I(C){if(C instanceof i)return["codicon","codicon-"+C.id];const S=P.exec(C.id);if(!S)return I(i.error);const[,m,f]=S,v=["codicon","codicon-"+m];return f&&v.push("codicon-modifier-"+f.substr(1)),v}L.asClassNameArray=I;function w(C){return I(C).join(" ")}L.asClassName=w;function b(C){return"."+I(C).join(".")}L.asCSSSelector=b})(T=e.CSSIcon||(e.CSSIcon={}))}),define(re[63],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(L){return(P,I,w)=>{let b=null,C=null;if(typeof w.value=="function"?(b="value",C=w.value):typeof w.get=="function"&&(b="get",C=w.get),!C)throw new Error("not supported");w[b]=L(C,I)}}e.createDecorator=D;function i(L,P,I){let w=null,b=null;if(typeof I.value=="function"?(w="value",b=I.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(w="get",b=I.get),!b)throw new Error("not supported");const C=`$memoize$${P}`;I[w]=function(...S){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,S)}),this[C]}}e.memoize=i;function R(L,P,I){return D((w,b)=>{const C=`$debounce$${b}`,S=`$debounce$result$${b}`;return function(...m){this[S]||(this[S]=I?I():void 0),clearTimeout(this[C]),P&&(this[S]=P(this[S],...m),m=[this[S]]),this[C]=setTimeout(()=>{w.apply(this,m),this[S]=I?I():void 0},L)}})}e.debounce=R;function T(L,P,I){return D((w,b)=>{const C=`$throttle$timer$${b}`,S=`$throttle$result$${b}`,m=`$throttle$lastRun$${b}`,f=`$throttle$pending$${b}`;return function(...v){if(this[S]||(this[S]=I?I():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),P&&(this[S]=P(this[S],...v)),this[f])return;const y=this[m]+L;y<=Date.now()?(this[m]=Date.now(),w.apply(this,[this[S]]),this[S]=I?I():void 0):(this[f]=!0,this[C]=setTimeout(()=>{this[f]=!1,this[m]=Date.now(),w.apply(this,[this[S]]),this[S]=I?I():void 0},y-Date.now()))}})}e.throttle=T}),define(re[11],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?c.isErrorNoTelemetry(n)?new c(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(o=>{o(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=D,e.errorHandler=new D;function i(d){e.errorHandler.setUnexpectedErrorHandler(d)}e.setUnexpectedErrorHandler=i;function R(d){I(d)||e.errorHandler.onUnexpectedError(d)}e.onUnexpectedError=R;function T(d){I(d)||e.errorHandler.onUnexpectedExternalError(d)}e.onUnexpectedExternalError=T;function L(d){if(d instanceof Error){const{name:n,message:o}=d,t=d.stacktrace||d.stack;return{$isError:!0,name:n,message:o,stack:t,noTelemetry:c.isErrorNoTelemetry(d)}}return d}e.transformErrorForSerialization=L;const P="Canceled";function I(d){return d instanceof w?!0:d instanceof Error&&d.name===P&&d.message===P}e.isCancellationError=I;class w extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=w;function b(){const d=new Error(P);return d.name=d.message,d}e.canceled=b;function C(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}e.illegalArgument=C;function S(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}e.illegalState=S;function m(d){return d?new Error(`readonly property '${d} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function f(d){const n=new Error(`${d} has been disposed`);return n.name="DISPOSED",n}e.disposed=f;function v(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}e.getErrorMessage=v;class y extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.NotImplementedError=y;class h extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.NotSupportedError=h;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=p;class c extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof c)return n;const o=new c;return o.message=n.message,o.stack=n.stack,o}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.ErrorNoTelemetry=c;class u extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype);debugger}}e.BugIndicatingError=u}),define(re[20],se([0,1,11]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function i(X,ie=0){return X[X.length-(1+ie)]}e.tail=i;function R(X){if(X.length===0)throw new Error("Invalid tail call");return[X.slice(0,X.length-1),X[X.length-1]]}e.tail2=R;function T(X,ie,ne=(le,ue)=>le===ue){if(X===ie)return!0;if(!X||!ie||X.length!==ie.length)return!1;for(let le=0,ue=X.length;le<ue;le++)if(!ne(X[le],ie[le]))return!1;return!0}e.equals=T;function L(X,ie){const ne=X.length-1;ie<ne&&(X[ie]=X[ne]),X.pop()}e.removeFastWithoutKeepingOrder=L;function P(X,ie,ne){return I(X.length,le=>ne(X[le],ie))}e.binarySearch=P;function I(X,ie){let ne=0,le=X-1;for(;ne<=le;){const ue=(ne+le)/2|0,pe=ie(ue);if(pe<0)ne=ue+1;else if(pe>0)le=ue-1;else return ue}return-(ne+1)}e.binarySearch2=I;function w(X,ie){let ne=0,le=X.length;if(le===0)return 0;for(;ne<le;){const ue=Math.floor((ne+le)/2);ie(X[ue])?le=ue:ne=ue+1}return ne}e.findFirstInSorted=w;function b(X,ie,ne){if(X=X|0,X>=ie.length)throw new TypeError("invalid index");const le=ie[Math.floor(ie.length*Math.random())],ue=[],pe=[],we=[];for(const Ee of ie){const Ce=ne(Ee,le);Ce<0?ue.push(Ee):Ce>0?pe.push(Ee):we.push(Ee)}return X<ue.length?b(X,ue,ne):X<ue.length+we.length?we[0]:b(X-(ue.length+we.length),pe,ne)}e.quickSelect=b;function C(X,ie){const ne=[];let le;for(const ue of X.slice(0).sort(ie))!le||ie(le[0],ue)!==0?(le=[ue],ne.push(le)):le.push(ue);return ne}e.groupBy=C;function S(X,ie,ne){const le=[];function ue(Ee,Ce,_e){if(Ce===0&&_e.length===0)return;const Ne=le[le.length-1];Ne&&Ne.start+Ne.deleteCount===Ee?(Ne.deleteCount+=Ce,Ne.toInsert.push(..._e)):le.push({start:Ee,deleteCount:Ce,toInsert:_e})}let pe=0,we=0;for(;;){if(pe===X.length){ue(pe,0,ie.slice(we));break}if(we===ie.length){ue(pe,X.length-pe,[]);break}const Ee=X[pe],Ce=ie[we],_e=ne(Ee,Ce);_e===0?(pe+=1,we+=1):_e<0?(ue(pe,1,[]),pe+=1):_e>0&&(ue(pe,0,[Ce]),we+=1)}return le}e.sortedDiff=S;function m(X,ie,ne){const le=S(X,ie,ne),ue=[],pe=[];for(const we of le)ue.push(...X.slice(we.start,we.start+we.deleteCount)),pe.push(...we.toInsert);return{removed:ue,added:pe}}e.delta=m;function f(X,ie,ne){if(ne===0)return[];const le=X.slice(0,ne).sort(ie);return y(X,ie,le,ne,X.length),le}e.top=f;function v(X,ie,ne,le,ue){return ne===0?Promise.resolve([]):new Promise((pe,we)=>{(async()=>{const Ee=X.length,Ce=X.slice(0,ne).sort(ie);for(let _e=ne,Ne=Math.min(ne+le,Ee);_e<Ee;_e=Ne,Ne=Math.min(Ne+le,Ee)){if(_e>ne&&await new Promise(He=>setTimeout(He)),ue&&ue.isCancellationRequested)throw new D.CancellationError;y(X,ie,Ce,_e,Ne)}return Ce})().then(pe,we)})}e.topAsync=v;function y(X,ie,ne,le,ue){for(const pe=ne.length;le<ue;le++){const we=X[le];if(ie(we,ne[pe-1])<0){ne.pop();const Ee=w(ne,Ce=>ie(we,Ce)<0);ne.splice(Ee,0,we)}}}function h(X){return X.filter(ie=>!!ie)}e.coalesce=h;function p(X){let ie=0;for(let ne=0;ne<X.length;ne++)X[ne]&&(X[ie]=X[ne],ie+=1);X.length=ie}e.coalesceInPlace=p;function c(X,ie,ne){X.splice(ne,0,X.splice(ie,1)[0])}e.move=c;function u(X){return!Array.isArray(X)||X.length===0}e.isFalsyOrEmpty=u;function d(X){return Array.isArray(X)&&X.length>0}e.isNonEmptyArray=d;function n(X,ie=ne=>ne){const ne=new Set;return X.filter(le=>{const ue=ie(le);return ne.has(ue)?!1:(ne.add(ue),!0)})}e.distinct=n;function o(X){const ie=new Set;return ne=>{const le=X(ne);return ie.has(le)?!1:(ie.add(le),!0)}}e.uniqueFilter=o;function t(X,ie){const ne=r(X,ie);if(ne!==-1)return X[ne]}e.findLast=t;function r(X,ie){for(let ne=X.length-1;ne>=0;ne--){const le=X[ne];if(ie(le))return ne}return-1}e.lastIndex=r;function s(X,ie){return X.length>0?X[0]:ie}e.firstOrDefault=s;function l(X,ie){return X.length>0?X[X.length-1]:ie}e.lastOrDefault=l;function a(X,ie,ne=(le,ue)=>le===ue){let le=0;for(let ue=0,pe=Math.min(X.length,ie.length);ue<pe&&ne(X[ue],ie[ue]);ue++)le++;return le}e.commonPrefixLength=a;function g(X){return[].concat(...X)}e.flatten=g;function E(X,ie){let ne=typeof ie=="number"?X:0;typeof ie=="number"?ne=X:(ne=0,ie=X);const le=[];if(ne<=ie)for(let ue=ne;ue<ie;ue++)le.push(ue);else for(let ue=ne;ue>ie;ue--)le.push(ue);return le}e.range=E;function A(X,ie,ne){return X.reduce((le,ue)=>(le[ie(ue)]=ne?ne(ue):ue,le),Object.create(null))}e.index=A;function B(X,ie){return X.push(ie),()=>O(X,ie)}e.insert=B;function O(X,ie){const ne=X.indexOf(ie);if(ne>-1)return X.splice(ne,1),ie}e.remove=O;function N(X,ie,ne){const le=X.slice(0,ie),ue=X.slice(ie);return le.concat(ne,ue)}e.arrayInsert=N;function F(X,ie){let ne;if(typeof ie=="number"){let le=ie;ne=()=>{const ue=Math.sin(le++)*179426549;return ue-Math.floor(ue)}}else ne=Math.random;for(let le=X.length-1;le>0;le-=1){const ue=Math.floor(ne()*(le+1)),pe=X[le];X[le]=X[ue],X[ue]=pe}}e.shuffle=F;function k(X,ie){const ne=X.indexOf(ie);ne>-1&&(X.splice(ne,1),X.unshift(ie))}e.pushToStart=k;function U(X,ie){const ne=X.indexOf(ie);ne>-1&&(X.splice(ne,1),X.push(ie))}e.pushToEnd=U;function $(X,ie){for(const ne of ie)X.push(ne)}e.pushMany=$;function G(X,ie){return Array.isArray(X)?X.map(ie):ie(X)}e.mapArrayOrNot=G;function W(X){return Array.isArray(X)?X:[X]}e.asArray=W;function V(X){return X[Math.floor(Math.random()*X.length)]}e.getRandomElement=V;function z(X,ie){for(const ne of X){const le=ie(ne);if(le!==void 0)return le}}e.mapFind=z;function j(X,ie,ne){const le=ee(X,ie),ue=X.length,pe=ne.length;X.length=ue+pe;for(let we=ue-1;we>=le;we--)X[we+pe]=X[we];for(let we=0;we<pe;we++)X[we+le]=ne[we]}e.insertInto=j;function J(X,ie,ne,le){const ue=ee(X,ie),pe=X.splice(ue,ne);return j(X,ue,le),pe}e.splice=J;function ee(X,ie){return ie<0?Math.max(ie+X.length,0):Math.min(ie,X.length)}var ce;(function(X){function ie(ue){return ue<0}X.isLessThan=ie;function ne(ue){return ue>0}X.isGreaterThan=ne;function le(ue){return ue===0}X.isNeitherLessOrGreaterThan=le,X.greaterThan=1,X.lessThan=-1,X.neitherLessOrGreaterThan=0})(ce=e.CompareResult||(e.CompareResult={}));function q(X,ie){return(ne,le)=>ie(X(ne),X(le))}e.compareBy=q;function x(...X){return(ie,ne)=>{for(const le of X){const ue=le(ie,ne);if(!ce.isNeitherLessOrGreaterThan(ue))return ue}return ce.neitherLessOrGreaterThan}}e.tieBreakComparators=x;const _=(X,ie)=>X-ie;e.numberComparator=_;function M(X,ie){if(X.length===0)return;let ne=X[0];for(let le=1;le<X.length;le++){const ue=X[le];ie(ue,ne)>0&&(ne=ue)}return ne}e.findMaxBy=M;function Y(X,ie){if(X.length===0)return;let ne=X[0];for(let le=1;le<X.length;le++){const ue=X[le];ie(ue,ne)>=0&&(ne=ue)}return ne}e.findLastMaxBy=Y;function H(X,ie){return M(X,(ne,le)=>-ie(ne,le))}e.findMinBy=H;class Z{constructor(ie){this.items=ie,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ie){let ne=this.firstIdx;for(;ne<this.items.length&&ie(this.items[ne]);)ne++;const le=ne===this.firstIdx?null:this.items.slice(this.firstIdx,ne);return this.firstIdx=ne,le}takeFromEndWhile(ie){let ne=this.lastIdx;for(;ne>=0&&ie(this.items[ne]);)ne--;const le=ne===this.lastIdx?null:this.items.slice(ne+1,this.lastIdx+1);return this.lastIdx=ne,le}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ie=this.items[this.firstIdx];return this.firstIdx++,ie}removeLast(){const ie=this.items[this.lastIdx];return this.lastIdx--,ie}takeCount(ie){const ne=this.items.slice(this.firstIdx,this.firstIdx+ie);return this.firstIdx+=ie,ne}}e.ArrayQueue=Z;class oe{constructor(ie){this.iterate=ie}forEach(ie){this.iterate(ne=>(ie(ne),!0))}toArray(){const ie=[];return this.iterate(ne=>(ie.push(ne),!0)),ie}filter(ie){return new oe(ne=>this.iterate(le=>ie(le)?ne(le):!0))}map(ie){return new oe(ne=>this.iterate(le=>ne(ie(le))))}some(ie){let ne=!1;return this.iterate(le=>(ne=ie(le),!ne)),ne}findFirst(ie){let ne;return this.iterate(le=>ie(le)?(ne=le,!1):!0),ne}findLast(ie){let ne;return this.iterate(le=>(ie(le)&&(ne=le),!0)),ne}findLastMaxBy(ie){let ne,le=!0;return this.iterate(ue=>((le||ce.isGreaterThan(ie(ue,ne)))&&(le=!1,ne=ue),!0)),ne}}e.CallbackIterable=oe,oe.empty=new oe(X=>{})}),define(re[127],se([0,1,11]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function i(I,w){if(!I)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=i;function R(I,w="Unreachable"){throw new Error(w)}e.assertNever=R;function T(I){if(!I)throw new D.BugIndicatingError("Assertion Failed")}e.assert=T;function L(I){if(!I()){debugger;I(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}e.assertFn=L;function P(I,w){let b=0;for(;b<I.length-1;){const C=I[b],S=I[b+1];if(!w(C,S))return!1;b++}return!0}e.checkAdjacentItems=P}),define(re[80],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(i){const R=this;let T=!1,L;return function(){return T||(T=!0,L=i.apply(R,arguments)),L}}e.once=D}),define(re[64],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(i){function R(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}i.is=R;const T=Object.freeze([]);function L(){return T}i.empty=L;function*P(u){yield u}i.single=P;function I(u){return R(u)?u:P(u)}i.wrap=I;function w(u){return u||T}i.from=w;function b(u){return!u||u[Symbol.iterator]().next().done===!0}i.isEmpty=b;function C(u){return u[Symbol.iterator]().next().value}i.first=C;function S(u,d){for(const n of u)if(d(n))return!0;return!1}i.some=S;function m(u,d){for(const n of u)if(d(n))return n}i.find=m;function*f(u,d){for(const n of u)d(n)&&(yield n)}i.filter=f;function*v(u,d){let n=0;for(const o of u)yield d(o,n++)}i.map=v;function*y(...u){for(const d of u)for(const n of d)yield n}i.concat=y;function h(u,d,n){let o=n;for(const t of u)o=d(o,t);return o}i.reduce=h;function*p(u,d,n=u.length){for(d<0&&(d+=u.length),n<0?n+=u.length:n>u.length&&(n=u.length);d<n;d++)yield u[d]}i.slice=p;function c(u,d=Number.POSITIVE_INFINITY){const n=[];if(d===0)return[n,u];const o=u[Symbol.iterator]();for(let t=0;t<d;t++){const r=o.next();if(r.done)return[n,i.empty()];n.push(r.value)}return[n,{[Symbol.iterator](){return o}}]}i.consume=c})(D=e.Iterable||(e.Iterable={}))}),define(re[35],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var i;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(n){n.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function L(n,o=!1){let t=0;const r=n.length;let s="",l=0,a=16,g=0;function E(U){let $=0,G=0;for(;$<U;){const W=n.charCodeAt(t);if(W>=48&&W<=57)G=G*16+W-48;else if(W>=65&&W<=70)G=G*16+W-65+10;else if(W>=97&&W<=102)G=G*16+W-97+10;else break;t++,$++}return $<U&&(G=-1),G}function A(U){t=U,s="",l=0,a=16,g=0}function B(){const U=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&w(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&w(n.charCodeAt(t)))for(t++;t<n.length&&w(n.charCodeAt(t));)t++;else return g=3,n.substring(U,t);let $=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&w(n.charCodeAt(t))){for(t++;t<n.length&&w(n.charCodeAt(t));)t++;$=t}else g=3;return n.substring(U,$)}function O(){let U="",$=t;for(;;){if(t>=r){U+=n.substring($,t),g=2;break}const G=n.charCodeAt(t);if(G===34){U+=n.substring($,t),t++;break}if(G===92){if(U+=n.substring($,t),t++,t>=r){g=2;break}switch(n.charCodeAt(t++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const V=E(4);V>=0?U+=String.fromCharCode(V):g=4;break}default:g=5}$=t;continue}if(G>=0&&G<=31)if(I(G)){U+=n.substring($,t),g=2;break}else g=6;t++}return U}function N(){if(s="",g=0,l=t,t>=r)return l=r,a=17;let U=n.charCodeAt(t);if(P(U)){do t++,s+=String.fromCharCode(U),U=n.charCodeAt(t);while(P(U));return a=15}if(I(U))return t++,s+=String.fromCharCode(U),U===13&&n.charCodeAt(t)===10&&(t++,s+=`
`),a=14;switch(U){case 123:return t++,a=1;case 125:return t++,a=2;case 91:return t++,a=3;case 93:return t++,a=4;case 58:return t++,a=6;case 44:return t++,a=5;case 34:return t++,s=O(),a=10;case 47:{const $=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<r&&!I(n.charCodeAt(t));)t++;return s=n.substring($,t),a=12}if(n.charCodeAt(t+1)===42){t+=2;const G=r-1;let W=!1;for(;t<G;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,W=!0;break}t++}return W||(t++,g=1),s=n.substring($,t),a=13}return s+=String.fromCharCode(U),t++,a=16}case 45:if(s+=String.fromCharCode(U),t++,t===r||!w(n.charCodeAt(t)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=B(),a=11;default:for(;t<r&&F(U);)t++,U=n.charCodeAt(t);if(l!==t){switch(s=n.substring(l,t),s){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return s+=String.fromCharCode(U),t++,a=16}}function F(U){if(P(U)||I(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function k(){let U;do U=N();while(U>=12&&U<=15);return U}return{setPosition:A,getPosition:()=>t,scan:o?k:N,getToken:()=>a,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>t-l,getTokenError:()=>g}}e.createScanner=L;function P(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function I(n){return n===10||n===13||n===8232||n===8233}function w(n){return n>=48&&n<=57}var b;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(b||(b={}));function C(n,o){const t=[],r=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function g(E,A,B,O){l.value=E,l.offset=A,l.length=B,l.type=O,l.colonOffset=void 0,s=l}try{c(n,{onObjectBegin:(E,A)=>{if(o<=E)throw r;s=void 0,a=o>E,t.push("")},onObjectProperty:(E,A,B)=>{if(o<A||(g(E,A,B,"property"),t[t.length-1]=E,o<=A+B))throw r},onObjectEnd:(E,A)=>{if(o<=E)throw r;s=void 0,t.pop()},onArrayBegin:(E,A)=>{if(o<=E)throw r;s=void 0,t.push(0)},onArrayEnd:(E,A)=>{if(o<=E)throw r;s=void 0,t.pop()},onLiteralValue:(E,A,B)=>{if(o<A||(g(E,A,B,d(E)),o<=A+B))throw r},onSeparator:(E,A,B)=>{if(o<=A)throw r;if(E===":"&&s&&s.type==="property")s.colonOffset=A,a=!1,s=void 0;else if(E===","){const O=t[t.length-1];typeof O=="number"?t[t.length-1]=O+1:(a=!0,t[t.length-1]=""),s=void 0}}})}catch(E){if(E!==r)throw E}return{path:t,previousNode:s,isAtPropertyKey:a,matches:E=>{let A=0;for(let B=0;A<E.length&&B<t.length;B++)if(E[A]===t[B]||E[A]==="*")A++;else if(E[A]!=="**")return!1;return A===E.length}}}e.getLocation=C;function S(n,o=[],t=T.DEFAULT){let r=null,s=[];const l=[];function a(E){Array.isArray(s)?s.push(E):r!==null&&(s[r]=E)}return c(n,{onObjectBegin:()=>{const E={};a(E),l.push(s),s=E,r=null},onObjectProperty:E=>{r=E},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const E=[];a(E),l.push(s),s=E,r=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:a,onError:(E,A,B)=>{o.push({error:E,offset:A,length:B})}},t),s[0]}e.parse=S;function m(n,o=[],t=T.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(E){r.type==="property"&&(r.length=E-r.offset,r=r.parent)}function l(E){return r.children.push(E),E}c(n,{onObjectBegin:E=>{r=l({type:"object",offset:E,length:-1,parent:r,children:[]})},onObjectProperty:(E,A,B)=>{r=l({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:E,offset:A,length:B,parent:r})},onObjectEnd:(E,A)=>{r.length=E+A-r.offset,r=r.parent,s(E+A)},onArrayBegin:(E,A)=>{r=l({type:"array",offset:E,length:-1,parent:r,children:[]})},onArrayEnd:(E,A)=>{r.length=E+A-r.offset,r=r.parent,s(E+A)},onLiteralValue:(E,A,B)=>{l({type:d(E),offset:A,length:B,parent:r,value:E}),s(A+B)},onSeparator:(E,A,B)=>{r.type==="property"&&(E===":"?r.colonOffset=A:E===","&&s(A))},onError:(E,A,B)=>{o.push({error:E,offset:A,length:B})}},t);const g=r.children[0];return g&&delete g.parent,g}e.parseTree=m;function f(n,o){if(!n)return;let t=n;for(const r of o)if(typeof r=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const l of t.children)if(Array.isArray(l.children)&&l.children[0].value===r){t=l.children[1],s=!0;break}if(!s)return}else{const s=r;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.findNodeAtLocation=f;function v(n){if(!n.parent||!n.parent.children)return[];const o=v(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;o.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&o.push(t)}return o}e.getNodePath=v;function y(n){switch(n.type){case"array":return n.children.map(y);case"object":{const o=Object.create(null);for(const t of n.children){const r=t.children[1];r&&(o[t.children[0].value]=y(r))}return o}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=y;function h(n,o,t=!1){return o>=n.offset&&o<n.offset+n.length||t&&o===n.offset+n.length}e.contains=h;function p(n,o,t=!1){if(h(n,o,t)){const r=n.children;if(Array.isArray(r))for(let s=0;s<r.length&&r[s].offset<=o;s++){const l=p(r[s],o,t);if(l)return l}return n}}e.findNodeAtOffset=p;function c(n,o,t=T.DEFAULT){const r=L(n,!1);function s(q){return q?()=>q(r.getTokenOffset(),r.getTokenLength()):()=>!0}function l(q){return q?x=>q(x,r.getTokenOffset(),r.getTokenLength()):()=>!0}const a=s(o.onObjectBegin),g=l(o.onObjectProperty),E=s(o.onObjectEnd),A=s(o.onArrayBegin),B=s(o.onArrayEnd),O=l(o.onLiteralValue),N=l(o.onSeparator),F=s(o.onComment),k=l(o.onError),U=t&&t.disallowComments,$=t&&t.allowTrailingComma;function G(){for(;;){const q=r.scan();switch(r.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:U||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(q){case 12:case 13:U?W(10):F();break;case 16:W(1);break;case 15:case 14:break;default:return q}}}function W(q,x=[],_=[]){if(k(q),x.length+_.length>0){let M=r.getToken();for(;M!==17;){if(x.indexOf(M)!==-1){G();break}else if(_.indexOf(M)!==-1)break;M=G()}}}function V(q){const x=r.getTokenValue();return q?O(x):g(x),G(),!0}function z(){switch(r.getToken()){case 11:{let q=0;try{q=JSON.parse(r.getTokenValue()),typeof q!="number"&&(W(2),q=0)}catch{W(2)}O(q);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return G(),!0}function j(){return r.getToken()!==10?(W(3,[],[2,5]),!1):(V(!1),r.getToken()===6?(N(":"),G(),ce()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function J(){a(),G();let q=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(q||W(4,[],[]),N(","),G(),r.getToken()===2&&$)break}else q&&W(6,[],[]);j()||W(4,[],[2,5]),q=!0}return E(),r.getToken()!==2?W(7,[2],[]):G(),!0}function ee(){A(),G();let q=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(q||W(4,[],[]),N(","),G(),r.getToken()===4&&$)break}else q&&W(6,[],[]);ce()||W(4,[],[4,5]),q=!0}return B(),r.getToken()!==4?W(8,[4],[]):G(),!0}function ce(){switch(r.getToken()){case 3:return ee();case 1:return J();case 10:return V(!0);default:return z()}}return G(),r.getToken()===17?t.allowEmptyContent?!0:(W(4,[],[]),!1):ce()?(r.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=c;function u(n,o){const t=L(n),r=[];let s,l=0,a;do switch(a=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:l!==a&&r.push(n.substring(l,a)),o!==void 0&&r.push(t.getTokenValue().replace(/[^\r\n]/g,o)),l=t.getPosition();break}while(s!==17);return r.join("")}e.stripComments=u;function d(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=d}),define(re[42],se([0,1,35]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(w,b,C){let S,m,f,v,y;if(b){for(v=b.offset,y=v+b.length,f=v;f>0&&!I(w,f-1);)f--;let a=y;for(;a<w.length&&!I(w,a);)a++;m=w.substring(f,a),S=L(m,C)}else m=w,S=0,f=0,v=0,y=w.length;const h=P(C,w);let p=!1,c=0,u;C.insertSpaces?u=T(" ",C.tabSize||4):u="	";const d=(0,D.createScanner)(m,!1);let n=!1;function o(){return h+T(u,S+c)}function t(){let a=d.scan();for(p=!1;a===15||a===14;)p=p||a===14,a=d.scan();return n=a===16||d.getTokenError()!==0,a}const r=[];function s(a,g,E){!n&&g<y&&E>v&&w.substring(g,E)!==a&&r.push({offset:g,length:E-g,content:a})}let l=t();if(l!==17){const a=d.getTokenOffset()+f,g=T(u,S);s(g,f,a)}for(;l!==17;){let a=d.getTokenOffset()+d.getTokenLength()+f,g=t(),E="";for(;!p&&(g===12||g===13);){const B=d.getTokenOffset()+f;s(" ",a,B),a=d.getTokenOffset()+d.getTokenLength()+f,E=g===12?o():"",g=t()}if(g===2)l!==1&&(c--,E=o());else if(g===4)l!==3&&(c--,E=o());else{switch(l){case 3:case 1:c++,E=o();break;case 5:case 12:E=o();break;case 13:p?E=o():E=" ";break;case 6:E=" ";break;case 10:if(g===6){E="";break}case 7:case 8:case 9:case 11:case 2:case 4:g===12||g===13?E=" ":g!==5&&g!==17&&(n=!0);break;case 16:n=!0;break}p&&(g===12||g===13)&&(E=o())}const A=d.getTokenOffset()+f;s(E,a,A),l=g}return r}e.format=i;function R(w,b){const C=JSON.stringify(w,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?C.replace(/\r\n|\r|\n/g,b.eol):C}e.toFormattedString=R;function T(w,b){let C="";for(let S=0;S<b;S++)C+=w;return C}function L(w,b){let C=0,S=0;const m=b.tabSize||4;for(;C<w.length;){const f=w.charAt(C);if(f===" ")S++;else if(f==="	")S+=m;else break;C++}return Math.floor(S/m)}function P(w,b){for(let C=0;C<b.length;C++){const S=b.charAt(C);if(S==="\r")return C+1<b.length&&b.charAt(C+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=P;function I(w,b){return`\r
`.indexOf(w.charAt(b))!==-1}e.isEOL=I}),define(re[81],se([0,1,35,42]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(w,b,C){return T(w,b,void 0,C)}e.removeProperty=R;function T(w,b,C,S,m){const f=b.slice(),v=[],y=(0,D.parseTree)(w,v);let h,p;for(;f.length>0&&(p=f.pop(),h=(0,D.findNodeAtLocation)(y,f),h===void 0&&C!==void 0);)typeof p=="string"?C={[p]:C}:C=[C];if(h)if(h.type==="object"&&typeof p=="string"&&Array.isArray(h.children)){const c=(0,D.findNodeAtLocation)(h,[p]);if(c!==void 0)if(C===void 0){if(!c.parent)throw new Error("Malformed AST");const u=h.children.indexOf(c.parent);let d,n=c.parent.offset+c.parent.length;if(u>0){const o=h.children[u-1];d=o.offset+o.length}else d=h.offset+1,h.children.length>1&&(n=h.children[1].offset);return L(w,{offset:d,length:n-d,content:""},S)}else return L(w,{offset:c.offset,length:c.length,content:JSON.stringify(C)},S);else{if(C===void 0)return[];const u=`${JSON.stringify(p)}: ${JSON.stringify(C)}`,d=m?m(h.children.map(o=>o.children[0].value)):h.children.length;let n;if(d>0){const o=h.children[d-1];n={offset:o.offset+o.length,length:0,content:","+u}}else h.children.length===0?n={offset:h.offset+1,length:0,content:u}:n={offset:h.offset+1,length:0,content:u+","};return L(w,n,S)}}else if(h.type==="array"&&typeof p=="number"&&Array.isArray(h.children))if(C!==void 0){const c=`${JSON.stringify(C)}`;let u;if(h.children.length===0||p===0)u={offset:h.offset+1,length:0,content:h.children.length===0?c:c+","};else{const d=p===-1||p>h.children.length?h.children.length:p,n=h.children[d-1];u={offset:n.offset+n.length,length:0,content:","+c}}return L(w,u,S)}else{const c=p,u=h.children[c];let d;if(h.children.length===1)d={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===c){const n=h.children[c-1],o=n.offset+n.length,t=h.offset+h.length;d={offset:o,length:t-2-o,content:""}}else d={offset:u.offset,length:h.children[c+1].offset-u.offset,content:""};return L(w,d,S)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${h.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return L(w,{offset:y?y.offset:0,length:y?y.length:0,content:JSON.stringify(C)},S)}}e.setProperty=T;function L(w,b,C){let S=P(w,b),m=b.offset,f=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;m>0&&!(0,i.isEOL)(S,m-1);)m--;for(;f<S.length&&!(0,i.isEOL)(S,f);)f++}const v=(0,i.format)(S,{offset:m,length:f-m},C);for(let h=v.length-1;h>=0;h--){const p=v[h];S=P(S,p),m=Math.min(m,p.offset),f=Math.max(f,p.offset+p.length),f+=p.content.length-p.length}const y=w.length-(S.length-f)-m;return[{offset:m,length:y,content:S.substring(m,f)}]}e.withFormatting=L;function P(w,b){return w.substring(0,b.offset)+b.content+w.substring(b.offset+b.length)}e.applyEdit=P;function I(w,b){const C=b.slice(0).sort((m,f)=>{const v=m.offset-f.offset;return v===0?m.length-f.length:v});let S=w.length;for(let m=C.length-1;m>=0;m--){const f=C[m];if(f.offset+f.length<=S)w=P(w,f);else throw new Error("Overlapping edit");S=f.offset}return w}e.applyEdits=I}),define(re[128],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(R){this.executor=R,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(R){this._error=R}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(R){return new D(()=>R(this.getValue()))}}e.Lazy=D}),define(re[2],se([0,1,80,64]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let T=null;function L(l){T=l}if(e.setDisposableTracker=L,R){const l="__is_disposable_tracked__";L(new class{trackDisposable(a){const g=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[l]||console.log(g)},3e3)}setParent(a,g){if(a&&a!==p.None)try{a[l]=!0}catch{}}markAsDisposed(a){if(a&&a!==p.None)try{a[l]=!0}catch{}}markAsSingleton(a){}})}function P(l){return T?.trackDisposable(l),l}function I(l){T?.markAsDisposed(l)}function w(l,a){T?.setParent(l,a)}function b(l,a){if(!!T)for(const g of l)T.setParent(g,a)}function C(l){return T?.markAsSingleton(l),l}e.markAsSingleton=C;function S(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=S;function m(l){if(i.Iterable.is(l)){const a=[];for(const g of l)if(g)try{g.dispose()}catch(E){a.push(E)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(l)?[]:l}else if(l)return l.dispose(),l}e.dispose=m;function f(l){for(const a of l)S(a)&&a.dispose();return[]}e.disposeIfDisposable=f;function v(...l){const a=y(()=>m(l));return b(l,a),a}e.combinedDisposable=v;function y(l){const a=P({dispose:(0,D.once)(()=>{I(a),l()})});return a}e.toDisposable=y;class h{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(I(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{m(this._toDispose)}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return w(a,this),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class p{constructor(){this._store=new h,P(this),w(this._store,this)}dispose(){I(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=p,p.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&w(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,I(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&w(a,null),a}}e.MutableDisposable=c;class u{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=u;class d{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(a){let g=a;return this.unset=()=>g=void 0,this.isset=()=>g!==void 0,this.dispose=()=>{g&&(g(),g=void 0,I(this))},this}}e.SafeDisposable=d;class n{constructor(){this.references=new Map}acquire(a,...g){let E=this.references.get(a);E||(E={counter:0,object:this.createReferencedObject(a,...g)},this.references.set(a,E));const{object:A}=E,B=(0,D.once)(()=>{--E.counter===0&&(this.destroyReferencedObject(a,E.object),this.references.delete(a))});return E.counter++,{object:A,dispose:B}}}e.ReferenceCollection=n;class o{constructor(a){this.referenceCollection=a}async acquire(a,...g){const E=this.referenceCollection.acquire(a,...g);try{return{object:await E.object,dispose:()=>E.dispose()}}catch(A){throw E.dispose(),A}}}e.AsyncReferenceCollection=o;class t{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=t;function r(l){const a=new h;try{l(a)}finally{a.dispose()}}e.disposeOnReturn=r;class s{constructor(){this._store=new Map,this._isDisposed=!1,P(this)}dispose(){I(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{m(this._store.values())}finally{this._store.clear()}}has(a){return this._store.has(a)}get(a){return this._store.get(a)}set(a,g,E=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),E||this._store.get(a)?.dispose(),this._store.set(a,g)}deleteAndDispose(a){this._store.get(a)?.dispose(),this._store.delete(a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=s}),define(re[82],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(T){this.element=T,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class i{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let T=this._first;for(;T!==D.Undefined;){const L=T.next;T.prev=D.Undefined,T.next=D.Undefined,T=L}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,L){const P=new D(T);if(this._first===D.Undefined)this._first=P,this._last=P;else if(L){const w=this._last;this._last=P,P.prev=w,w.next=P}else{const w=this._first;this._first=P,P.next=w,w.prev=P}this._size+=1;let I=!1;return()=>{I||(I=!0,this._remove(P))}}shift(){if(this._first!==D.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==D.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==D.Undefined&&T.next!==D.Undefined){const L=T.prev;L.next=T.next,T.next.prev=L}else T.prev===D.Undefined&&T.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):T.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):T.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==D.Undefined;)yield T.element,T=T.next}}e.LinkedList=i}),define(re[41],se([0,1]),function(Q,e){"use strict";var D,i,R;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function T(f,v,y){let h=f.get(v);return h===void 0&&(h=y,f.set(v,h)),h}e.getOrSet=T;function L(f){const v=[];return f.forEach((y,h)=>{v.push(`${h} => ${y}`)}),`Map(${f.size}) {${v.join(", ")}}`}e.mapToString=L;function P(f){const v=[];return f.forEach(y=>{v.push(y)}),`Set(${f.size}) {${v.join(", ")}}`}e.setToString=P;class I{constructor(v,y){this.uri=v,this.value=y}}class w{constructor(v,y){this[D]="ResourceMap",v instanceof w?(this.map=new Map(v.map),this.toKey=y??w.defaultToKey):(this.map=new Map,this.toKey=v??w.defaultToKey)}set(v,y){return this.map.set(this.toKey(v),new I(v,y)),this}get(v){return this.map.get(this.toKey(v))?.value}has(v){return this.map.has(this.toKey(v))}get size(){return this.map.size}clear(){this.map.clear()}delete(v){return this.map.delete(this.toKey(v))}forEach(v,y){typeof y<"u"&&(v=v.bind(y));for(const[h,p]of this.map)v(p.value,p.uri,this)}*values(){for(const v of this.map.values())yield v.value}*keys(){for(const v of this.map.values())yield v.uri}*entries(){for(const v of this.map.values())yield[v.uri,v.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,v]of this.map)yield[v.uri,v.value]}}e.ResourceMap=w,w.defaultToKey=f=>f.toString();class b{constructor(v,y){this[i]="ResourceSet",!v||typeof v=="function"?this._map=new w(v):(this._map=new w(y),v.forEach(this.add,this))}get size(){return this._map.size}add(v){return this._map.set(v,v),this}clear(){this._map.clear()}delete(v){return this._map.delete(v)}forEach(v,y){this._map.forEach((h,p)=>v.call(y,p,p,this))}has(v){return this._map.has(v)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=b;var C;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(C=e.Touch||(e.Touch={}));class S{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(v){return this._map.has(v)}get(v,y=0){const h=this._map.get(v);if(!!h)return y!==0&&this.touch(h,y),h.value}set(v,y,h=0){let p=this._map.get(v);if(p)p.value=y,h!==0&&this.touch(p,h);else{switch(p={key:v,value:y,next:void 0,previous:void 0},h){case 0:this.addItemLast(p);break;case 1:this.addItemFirst(p);break;case 2:this.addItemLast(p);break;default:this.addItemLast(p);break}this._map.set(v,p),this._size++}return this}delete(v){return!!this.remove(v)}remove(v){const y=this._map.get(v);if(!!y)return this._map.delete(v),this.removeItem(y),this._size--,y.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const v=this._head;return this._map.delete(v.key),this.removeItem(v),this._size--,v.value}forEach(v,y){const h=this._state;let p=this._head;for(;p;){if(y?v.bind(y)(p.value,p.key,this):v(p.value,p.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const v=this,y=this._state;let h=this._head;const p={[Symbol.iterator](){return p},next(){if(v._state!==y)throw new Error("LinkedMap got modified during iteration.");if(h){const c={value:h.key,done:!1};return h=h.next,c}else return{value:void 0,done:!0}}};return p}values(){const v=this,y=this._state;let h=this._head;const p={[Symbol.iterator](){return p},next(){if(v._state!==y)throw new Error("LinkedMap got modified during iteration.");if(h){const c={value:h.value,done:!1};return h=h.next,c}else return{value:void 0,done:!0}}};return p}entries(){const v=this,y=this._state;let h=this._head;const p={[Symbol.iterator](){return p},next(){if(v._state!==y)throw new Error("LinkedMap got modified during iteration.");if(h){const c={value:[h.key,h.value],done:!1};return h=h.next,c}else return{value:void 0,done:!0}}};return p}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(v){if(v>=this.size)return;if(v===0){this.clear();return}let y=this._head,h=this.size;for(;y&&h>v;)this._map.delete(y.key),y=y.next,h--;this._head=y,this._size=h,y&&(y.previous=void 0),this._state++}addItemFirst(v){if(!this._head&&!this._tail)this._tail=v;else if(this._head)v.next=this._head,this._head.previous=v;else throw new Error("Invalid list");this._head=v,this._state++}addItemLast(v){if(!this._head&&!this._tail)this._head=v;else if(this._tail)v.previous=this._tail,this._tail.next=v;else throw new Error("Invalid list");this._tail=v,this._state++}removeItem(v){if(v===this._head&&v===this._tail)this._head=void 0,this._tail=void 0;else if(v===this._head){if(!v.next)throw new Error("Invalid list");v.next.previous=void 0,this._head=v.next}else if(v===this._tail){if(!v.previous)throw new Error("Invalid list");v.previous.next=void 0,this._tail=v.previous}else{const y=v.next,h=v.previous;if(!y||!h)throw new Error("Invalid list");y.previous=h,h.next=y}v.next=void 0,v.previous=void 0,this._state++}touch(v,y){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(y!==1&&y!==2)){if(y===1){if(v===this._head)return;const h=v.next,p=v.previous;v===this._tail?(p.next=void 0,this._tail=p):(h.previous=p,p.next=h),v.previous=void 0,v.next=this._head,this._head.previous=v,this._head=v,this._state++}else if(y===2){if(v===this._tail)return;const h=v.next,p=v.previous;v===this._head?(h.previous=void 0,this._head=h):(h.previous=p,p.next=h),v.next=void 0,v.previous=this._tail,this._tail.next=v,this._tail=v,this._state++}}}toJSON(){const v=[];return this.forEach((y,h)=>{v.push([h,y])}),v}fromJSON(v){this.clear();for(const[y,h]of v)this.set(y,h)}}e.LinkedMap=S;class m extends S{constructor(v,y=1){super(),this._limit=v,this._ratio=Math.min(Math.max(0,y),1)}get limit(){return this._limit}set limit(v){this._limit=v,this.checkTrim()}get ratio(){return this._ratio}set ratio(v){this._ratio=Math.min(Math.max(0,v),1),this.checkTrim()}get(v,y=2){return super.get(v,y)}peek(v){return super.get(v,0)}set(v,y){return super.set(v,y,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=m}),define(re[83],se([0,1,41]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new D.LRUCache(1e4);function R(w){return I(w,"NFC",i)}e.normalizeNFC=R;const T=new D.LRUCache(1e4);function L(w){return I(w,"NFD",T)}e.normalizeNFD=L;const P=/[^\u0000-\u0080]/;function I(w,b,C){if(!w)return w;const S=C.get(w);if(S)return S;let m;return P.test(w)?m=w.normalize(b):m=w,C.set(w,m),m}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(b){return L(b).replace(w,"")}}()}),function(){function Q(R){const T=[];typeof R=="number"&&T.push("code/timeOrigin",R);function L(I){T.push(I,Date.now())}function P(){const I=[];for(let w=0;w<T.length;w+=2)I.push({name:T[w],startTime:T[w+1]});return I}return{mark:L,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const L of performance.getEntriesByType("mark"))T.push({name:L.name,startTime:Math.round(R+L.startTime)});return T}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=D(i))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var i in D)(typeof exports=="object"?exports:Q)[i]=D[i]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function D(i){if(e[i])return e[i].exports;var R=e[i]={i,l:!1,exports:{}};return Q[i].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=Q,D.c=e,D.d=function(i,R,T){D.o(i,R)||Object.defineProperty(i,R,{enumerable:!0,get:T})},D.r=function(i){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(i,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(i,"__esModule",{value:!0})},D.t=function(i,R){if(1&R&&(i=D(i)),8&R||4&R&&typeof i=="object"&&i&&i.__esModule)return i;var T=Object.create(null);if(D.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:i}),2&R&&typeof i!="string")for(var L in i)D.d(T,L,function(P){return i[P]}.bind(null,L));return T},D.n=function(i){var R=i&&i.__esModule?function(){return i.default}:function(){return i};return D.d(R,"a",R),R},D.o=function(i,R){return Object.prototype.hasOwnProperty.call(i,R)},D.p="",D(D.s=0)}([function(Q,e,D){(function(i){var R;e=Q.exports=_,R=typeof i=="object"&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],I=e.src=[],w=0,b=w++;I[b]="0|[1-9]\\d*";var C=w++;I[C]="[0-9]+";var S=w++;I[S]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=w++;I[m]="("+I[b]+")\\.("+I[b]+")\\.("+I[b]+")";var f=w++;I[f]="("+I[C]+")\\.("+I[C]+")\\.("+I[C]+")";var v=w++;I[v]="(?:"+I[b]+"|"+I[S]+")";var y=w++;I[y]="(?:"+I[C]+"|"+I[S]+")";var h=w++;I[h]="(?:-("+I[v]+"(?:\\."+I[v]+")*))";var p=w++;I[p]="(?:-?("+I[y]+"(?:\\."+I[y]+")*))";var c=w++;I[c]="[0-9A-Za-z-]+";var u=w++;I[u]="(?:\\+("+I[c]+"(?:\\."+I[c]+")*))";var d=w++,n="v?"+I[m]+I[h]+"?"+I[u]+"?";I[d]="^"+n+"$";var o="[v=\\s]*"+I[f]+I[p]+"?"+I[u]+"?",t=w++;I[t]="^"+o+"$";var r=w++;I[r]="((?:<|>)?=?)";var s=w++;I[s]=I[C]+"|x|X|\\*";var l=w++;I[l]=I[b]+"|x|X|\\*";var a=w++;I[a]="[v=\\s]*("+I[l]+")(?:\\.("+I[l]+")(?:\\.("+I[l]+")(?:"+I[h]+")?"+I[u]+"?)?)?";var g=w++;I[g]="[v=\\s]*("+I[s]+")(?:\\.("+I[s]+")(?:\\.("+I[s]+")(?:"+I[p]+")?"+I[u]+"?)?)?";var E=w++;I[E]="^"+I[r]+"\\s*"+I[a]+"$";var A=w++;I[A]="^"+I[r]+"\\s*"+I[g]+"$";var B=w++;I[B]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=w++;I[O]="(?:~>?)";var N=w++;I[N]="(\\s*)"+I[O]+"\\s+",P[N]=new RegExp(I[N],"g");var F=w++;I[F]="^"+I[O]+I[a]+"$";var k=w++;I[k]="^"+I[O]+I[g]+"$";var U=w++;I[U]="(?:\\^)";var $=w++;I[$]="(\\s*)"+I[U]+"\\s+",P[$]=new RegExp(I[$],"g");var G=w++;I[G]="^"+I[U]+I[a]+"$";var W=w++;I[W]="^"+I[U]+I[g]+"$";var V=w++;I[V]="^"+I[r]+"\\s*("+o+")$|^$";var z=w++;I[z]="^"+I[r]+"\\s*("+n+")$|^$";var j=w++;I[j]="(\\s*)"+I[r]+"\\s*("+o+"|"+I[a]+")",P[j]=new RegExp(I[j],"g");var J=w++;I[J]="^\\s*("+I[a]+")\\s+-\\s+("+I[a]+")\\s*$";var ee=w++;I[ee]="^\\s*("+I[g]+")\\s+-\\s+("+I[g]+")\\s*$";var ce=w++;I[ce]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)R(q,I[q]),P[q]||(P[q]=new RegExp(I[q]));function x(ae,fe){if(ae instanceof _)return ae;if(typeof ae!="string"||ae.length>T||!(fe?P[t]:P[d]).test(ae))return null;try{return new _(ae,fe)}catch{return null}}function _(ae,fe){if(ae instanceof _){if(ae.loose===fe)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof _))return new _(ae,fe);R("SemVer",ae,fe),this.loose=fe;var ge=ae.trim().match(fe?P[t]:P[d]);if(!ge)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ie=+be;if(Ie>=0&&Ie<L)return Ie}return be}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=x,e.valid=function(ae,fe){var ge=x(ae,fe);return ge?ge.version:null},e.clean=function(ae,fe){var ge=x(ae.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(ae){return R("SemVer.compare",this.version,this.loose,ae),ae instanceof _||(ae=new _(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},_.prototype.compareMain=function(ae){return ae instanceof _||(ae=new _(ae,this.loose)),Y(this.major,ae.major)||Y(this.minor,ae.minor)||Y(this.patch,ae.patch)},_.prototype.comparePre=function(ae){if(ae instanceof _||(ae=new _(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],be=ae.prerelease[fe];if(R("prerelease compare",fe,ge,be),ge===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(ge===void 0)return-1;if(ge!==be)return Y(ge,be)}while(++fe)},_.prototype.inc=function(ae,fe){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,fe,ge,be){typeof ge=="string"&&(be=ge,ge=void 0);try{return new _(ae,ge).inc(fe,be).version}catch{return null}},e.diff=function(ae,fe){if(X(ae,fe))return null;var ge=x(ae),be=x(fe);if(ge.prerelease.length||be.prerelease.length){for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==be[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in ge)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&ge[Ie]!==be[Ie])return Ie},e.compareIdentifiers=Y;var M=/^[0-9]+$/;function Y(ae,fe){var ge=M.test(ae),be=M.test(fe);return ge&&be&&(ae=+ae,fe=+fe),ge&&!be?-1:be&&!ge?1:ae<fe?-1:ae>fe?1:0}function H(ae,fe,ge){return new _(ae,ge).compare(new _(fe,ge))}function Z(ae,fe,ge){return H(ae,fe,ge)>0}function oe(ae,fe,ge){return H(ae,fe,ge)<0}function X(ae,fe,ge){return H(ae,fe,ge)===0}function ie(ae,fe,ge){return H(ae,fe,ge)!==0}function ne(ae,fe,ge){return H(ae,fe,ge)>=0}function le(ae,fe,ge){return H(ae,fe,ge)<=0}function ue(ae,fe,ge,be){var Ie;switch(fe){case"===":typeof ae=="object"&&(ae=ae.version),typeof ge=="object"&&(ge=ge.version),Ie=ae===ge;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof ge=="object"&&(ge=ge.version),Ie=ae!==ge;break;case"":case"=":case"==":Ie=X(ae,ge,be);break;case"!=":Ie=ie(ae,ge,be);break;case">":Ie=Z(ae,ge,be);break;case">=":Ie=ne(ae,ge,be);break;case"<":Ie=oe(ae,ge,be);break;case"<=":Ie=le(ae,ge,be);break;default:throw new TypeError("Invalid operator: "+fe)}return Ie}function pe(ae,fe){if(ae instanceof pe){if(ae.loose===fe)return ae;ae=ae.value}if(!(this instanceof pe))return new pe(ae,fe);R("comparator",ae,fe),this.loose=fe,this.parse(ae),this.semver===we?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(ae,fe){return Y(fe,ae)},e.major=function(ae,fe){return new _(ae,fe).major},e.minor=function(ae,fe){return new _(ae,fe).minor},e.patch=function(ae,fe){return new _(ae,fe).patch},e.compare=H,e.compareLoose=function(ae,fe){return H(ae,fe,!0)},e.rcompare=function(ae,fe,ge){return H(fe,ae,ge)},e.sort=function(ae,fe){return ae.sort(function(ge,be){return e.compare(ge,be,fe)})},e.rsort=function(ae,fe){return ae.sort(function(ge,be){return e.rcompare(ge,be,fe)})},e.gt=Z,e.lt=oe,e.eq=X,e.neq=ie,e.gte=ne,e.lte=le,e.cmp=ue,e.Comparator=pe;var we={};function Ee(ae,fe){if(ae instanceof Ee)return ae.loose===fe?ae:new Ee(ae.raw,fe);if(ae instanceof pe)return new Ee(ae.value,fe);if(!(this instanceof Ee))return new Ee(ae,fe);if(this.loose=fe,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Ce(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function _e(ae,fe,ge,be,Ie,Te,Re,Fe,Oe,Me,We,ke,Ae){return((fe=Ce(ge)?"":Ce(be)?">="+ge+".0.0":Ce(Ie)?">="+ge+"."+be+".0":">="+fe)+" "+(Fe=Ce(Oe)?"":Ce(Me)?"<"+(+Oe+1)+".0.0":Ce(We)?"<"+Oe+"."+(+Me+1)+".0":ke?"<="+Oe+"."+Me+"."+We+"-"+ke:"<="+Fe)).trim()}function Ne(ae,fe){for(var ge=0;ge<ae.length;ge++)if(!ae[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<ae.length;ge++)if(R(ae[ge].semver),ae[ge].semver!==we&&ae[ge].semver.prerelease.length>0){var be=ae[ge].semver;if(be.major===fe.major&&be.minor===fe.minor&&be.patch===fe.patch)return!0}return!1}return!0}function He(ae,fe,ge){try{fe=new Ee(fe,ge)}catch{return!1}return fe.test(ae)}function Xe(ae,fe,ge,be){var Ie,Te,Re,Fe,Oe;switch(ae=new _(ae,be),fe=new Ee(fe,be),ge){case">":Ie=Z,Te=le,Re=oe,Fe=">",Oe=">=";break;case"<":Ie=oe,Te=ne,Re=Z,Fe="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(He(ae,fe,be))return!1;for(var Me=0;Me<fe.set.length;++Me){var We=fe.set[Me],ke=null,Ae=null;if(We.forEach(function(te){te.semver===we&&(te=new pe(">=0.0.0")),ke=ke||te,Ae=Ae||te,Ie(te.semver,ke.semver,be)?ke=te:Re(te.semver,Ae.semver,be)&&(Ae=te)}),ke.operator===Fe||ke.operator===Oe||(!Ae.operator||Ae.operator===Fe)&&Te(ae,Ae.semver)||Ae.operator===Oe&&Re(ae,Ae.semver))return!1}return!0}pe.prototype.parse=function(ae){var fe=this.loose?P[V]:P[z],ge=ae.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+ae);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new _(ge[2],this.loose):this.semver=we},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(ae){return R("Comparator.test",ae,this.loose),this.semver===we||(typeof ae=="string"&&(ae=new _(ae,this.loose)),ue(ae,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(ae,fe){if(!(ae instanceof pe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new Ee(ae.value,fe),He(this.value,ge,fe);if(ae.operator==="")return ge=new Ee(this.value,fe),He(ae.semver,ge,fe);var be=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Te=this.semver.version===ae.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),Fe=ue(this.semver,"<",ae.semver,fe)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),Oe=ue(this.semver,">",ae.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return be||Ie||Te&&Re||Fe||Oe},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(ae){var fe=this.loose;ae=ae.trim(),R("range",ae,fe);var ge=fe?P[ee]:P[J];ae=ae.replace(ge,_e),R("hyphen replace",ae),ae=ae.replace(P[j],"$1$2$3"),R("comparator trim",ae,P[j]),ae=(ae=(ae=ae.replace(P[N],"$1~")).replace(P[$],"$1^")).split(/\s+/).join(" ");var be=fe?P[V]:P[z],Ie=ae.split(" ").map(function(Te){return function(Re,Fe){return R("comp",Re),Re=function(Oe,Me){return Oe.trim().split(/\s+/).map(function(We){return function(ke,Ae){R("caret",ke,Ae);var te=Ae?P[W]:P[G];return ke.replace(te,function(he,de,me,Se,Pe){var De;return R("caret",ke,he,de,me,Se,Pe),Ce(de)?De="":Ce(me)?De=">="+de+".0.0 <"+(+de+1)+".0.0":Ce(Se)?De=de==="0"?">="+de+"."+me+".0 <"+de+"."+(+me+1)+".0":">="+de+"."+me+".0 <"+(+de+1)+".0.0":Pe?(R("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),De=de==="0"?me==="0"?">="+de+"."+me+"."+Se+Pe+" <"+de+"."+me+"."+(+Se+1):">="+de+"."+me+"."+Se+Pe+" <"+de+"."+(+me+1)+".0":">="+de+"."+me+"."+Se+Pe+" <"+(+de+1)+".0.0"):(R("no pr"),De=de==="0"?me==="0"?">="+de+"."+me+"."+Se+" <"+de+"."+me+"."+(+Se+1):">="+de+"."+me+"."+Se+" <"+de+"."+(+me+1)+".0":">="+de+"."+me+"."+Se+" <"+(+de+1)+".0.0"),R("caret return",De),De})}(We,Me)}).join(" ")}(Re,Fe),R("caret",Re),Re=function(Oe,Me){return Oe.trim().split(/\s+/).map(function(We){return function(ke,Ae){var te=Ae?P[k]:P[F];return ke.replace(te,function(he,de,me,Se,Pe){var De;return R("tilde",ke,he,de,me,Se,Pe),Ce(de)?De="":Ce(me)?De=">="+de+".0.0 <"+(+de+1)+".0.0":Ce(Se)?De=">="+de+"."+me+".0 <"+de+"."+(+me+1)+".0":Pe?(R("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),De=">="+de+"."+me+"."+Se+Pe+" <"+de+"."+(+me+1)+".0"):De=">="+de+"."+me+"."+Se+" <"+de+"."+(+me+1)+".0",R("tilde return",De),De})}(We,Me)}).join(" ")}(Re,Fe),R("tildes",Re),Re=function(Oe,Me){return R("replaceXRanges",Oe,Me),Oe.split(/\s+/).map(function(We){return function(ke,Ae){ke=ke.trim();var te=Ae?P[A]:P[E];return ke.replace(te,function(he,de,me,Se,Pe,De){R("xRange",ke,he,de,me,Se,Pe,De);var ze=Ce(me),$e=ze||Ce(Se),Le=$e||Ce(Pe);return de==="="&&Le&&(de=""),ze?he=de===">"||de==="<"?"<0.0.0":"*":de&&Le?($e&&(Se=0),Le&&(Pe=0),de===">"?(de=">=",$e?(me=+me+1,Se=0,Pe=0):Le&&(Se=+Se+1,Pe=0)):de==="<="&&(de="<",$e?me=+me+1:Se=+Se+1),he=de+me+"."+Se+"."+Pe):$e?he=">="+me+".0.0 <"+(+me+1)+".0.0":Le&&(he=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0"),R("xRange return",he),he})}(We,Me)}).join(" ")}(Re,Fe),R("xrange",Re),Re=function(Oe,Me){return R("replaceStars",Oe,Me),Oe.trim().replace(P[ce],"")}(Re,Fe),R("stars",Re),Re}(Te,fe)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Te){return!!Te.match(be)})),Ie=Ie.map(function(Te){return new pe(Te,fe)})},Ee.prototype.intersects=function(ae,fe){if(!(ae instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(be){return ae.set.some(function(Ie){return Ie.every(function(Te){return be.intersects(Te,fe)})})})})},e.toComparators=function(ae,fe){return new Ee(ae,fe).set.map(function(ge){return ge.map(function(be){return be.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new _(ae,this.loose));for(var fe=0;fe<this.set.length;fe++)if(Ne(this.set[fe],ae))return!0;return!1},e.satisfies=He,e.maxSatisfying=function(ae,fe,ge){var be=null,Ie=null;try{var Te=new Ee(fe,ge)}catch{return null}return ae.forEach(function(Re){Te.test(Re)&&(be&&Ie.compare(Re)!==-1||(Ie=new _(be=Re,ge)))}),be},e.minSatisfying=function(ae,fe,ge){var be=null,Ie=null;try{var Te=new Ee(fe,ge)}catch{return null}return ae.forEach(function(Re){Te.test(Re)&&(be&&Ie.compare(Re)!==1||(Ie=new _(be=Re,ge)))}),be},e.validRange=function(ae,fe){try{return new Ee(ae,fe).range||"*"}catch{return null}},e.ltr=function(ae,fe,ge){return Xe(ae,fe,"<",ge)},e.gtr=function(ae,fe,ge){return Xe(ae,fe,">",ge)},e.outside=Xe,e.prerelease=function(ae,fe){var ge=x(ae,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ae,fe,ge){return ae=new Ee(ae,ge),fe=new Ee(fe,ge),ae.intersects(fe)},e.coerce=function(ae){if(ae instanceof _)return ae;if(typeof ae!="string")return null;var fe=ae.match(P[B]);return fe==null?null:x((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,D(1))},function(Q,e){var D,i,R=Q.exports={};function T(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function P(y){if(D===setTimeout)return setTimeout(y,0);if((D===T||!D)&&setTimeout)return D=setTimeout,setTimeout(y,0);try{return D(y,0)}catch{try{return D.call(null,y,0)}catch{return D.call(this,y,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:T}catch{D=T}try{i=typeof clearTimeout=="function"?clearTimeout:L}catch{i=L}})();var I,w=[],b=!1,C=-1;function S(){b&&I&&(b=!1,I.length?w=I.concat(w):C=-1,w.length&&m())}function m(){if(!b){var y=P(S);b=!0;for(var h=w.length;h;){for(I=w,w=[];++C<h;)I&&I[C].run();C=-1,h=w.length}I=null,b=!1,function(p){if(i===clearTimeout)return clearTimeout(p);if((i===L||!i)&&clearTimeout)return i=clearTimeout,clearTimeout(p);try{i(p)}catch{try{return i.call(null,p)}catch{return i.call(this,p)}}}(y)}}function f(y,h){this.fun=y,this.array=h}function v(){}R.nextTick=function(y){var h=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)h[p-1]=arguments[p];w.push(new f(y,h)),w.length!==1||b||P(m)},f.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=v,R.addListener=v,R.once=v,R.off=v,R.removeListener=v,R.removeAllListeners=v,R.emit=v,R.prependListener=v,R.prependOnceListener=v,R.listeners=function(y){return[]},R.binding=function(y){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(y){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(re[129],se([0,1]),function(Q,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class i{constructor(P,I,w){this.level=P,this.key=I,this.value=w,this.forward=[]}}const R=void 0;class T{constructor(P,I=2**16){this.comparator=P,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(I)|0),this._header=new i(this._maxLevel,R,R)}get size(){return this._size}clear(){this._header=new i(this._maxLevel,R,R)}has(P){return Boolean(T._search(this,P,this.comparator))}get(P){return T._search(this,P,this.comparator)?.value}set(P,I){return T._insert(this,P,I,this.comparator)&&(this._size+=1),this}delete(P){const I=T._delete(this,P,this.comparator);return I&&(this._size-=1),I}forEach(P,I){let w=this._header.forward[0];for(;w;)P.call(I,w.value,w.key,this),w=w.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",I=this._header.forward[0];for(;I;)P+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return P}static _search(P,I,w){let b=P._header;for(let C=P._level-1;C>=0;C--)for(;b.forward[C]&&w(b.forward[C].key,I)<0;)b=b.forward[C];if(b=b.forward[0],b&&w(b.key,I)===0)return b}static _insert(P,I,w,b){const C=[];let S=P._header;for(let m=P._level-1;m>=0;m--){for(;S.forward[m]&&b(S.forward[m].key,I)<0;)S=S.forward[m];C[m]=S}if(S=S.forward[0],S&&b(S.key,I)===0)return S.value=w,!1;{const m=T._randomLevel(P);if(m>P._level){for(let f=P._level;f<m;f++)C[f]=P._header;P._level=m}S=new i(m,I,w);for(let f=0;f<m;f++)S.forward[f]=C[f].forward[f],C[f].forward[f]=S;return!0}}static _randomLevel(P,I=.5){let w=1;for(;Math.random()<I&&w<P._maxLevel;)w+=1;return w}static _delete(P,I,w){const b=[];let C=P._header;for(let S=P._level-1;S>=0;S--){for(;C.forward[S]&&w(C.forward[S].key,I)<0;)C=C.forward[S];b[S]=C}if(C=C.forward[0],!C||w(C.key,I)!==0)return!1;for(let S=0;S<P._level&&b[S].forward[S]===C;S++)b[S].forward[S]=C.forward[S];for(;P._level>0&&P._header.forward[P._level-1]===R;)P._level-=1;return!0}}e.SkipList=T}),define(re[43],se([0,1,11,2]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function R(u){const d=u;return d?typeof d.read=="function":!1}e.isReadable=R;function T(u){const d=u;return d?[d.on,d.pause,d.resume,d.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=T;function L(u){const d=u;return d?T(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=L;function P(u,d){return new I(u,d)}e.newWriteableStream=P;class I{constructor(d,n){this.reducer=d,this.options=n,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(n=>this.pendingWritePromises.push(n))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d<"u"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(n=>n(d))}emitError(d){this.listeners.error.length===0?(0,D.onUnexpectedError)(d):this.listeners.error.slice(0).forEach(n=>n(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,n){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(n),this.resume();break;case"end":this.listeners.end.push(n),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(n),this.state.flowing&&this.flowErrors();break}}removeListener(d,n){if(this.state.destroyed)return;let o;switch(d){case"data":o=this.listeners.data;break;case"end":o=this.listeners.end;break;case"error":o=this.listeners.error;break}if(o){const t=o.indexOf(n);t>=0&&o.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const n=[...this.pendingWritePromises];this.pendingWritePromises.length=0,n.forEach(o=>o())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(u,d){const n=[];let o;for(;(o=u.read())!==null;)n.push(o);return d(n)}e.consumeReadable=w;function b(u,d,n){const o=[];let t;for(;(t=u.read())!==null&&o.length<n;)o.push(t);return t===null&&o.length>0?d(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const r=t;return t=void 0,r}return u.read()}}}e.peekReadable=b;function C(u,d){return new Promise((n,o)=>{const t=[];S(u,{onData:r=>{d&&t.push(r)},onError:r=>{d?o(r):n(void 0)},onEnd:()=>{n(d?d(t):void 0)}})})}e.consumeStream=C;function S(u,d){let n=!1;return u.on("error",o=>{n||d.onError(o)}),u.on("end",()=>{n||d.onEnd()}),u.on("data",o=>{n||d.onData(o)}),(0,i.toDisposable)(()=>n=!0)}e.listenStream=S;function m(u,d){return new Promise((n,o)=>{const t=new i.DisposableStore,r=[],s=g=>{if(r.push(g),r.length>d)return t.dispose(),u.pause(),n({stream:u,buffer:r,ended:!1})},l=g=>o(g),a=()=>n({stream:u,buffer:r,ended:!0});t.add((0,i.toDisposable)(()=>u.removeListener("error",l))),u.on("error",l),t.add((0,i.toDisposable)(()=>u.removeListener("end",a))),u.on("end",a),t.add((0,i.toDisposable)(()=>u.removeListener("data",s))),u.on("data",s)})}e.peekStream=m;function f(u,d){const n=P(d);return n.end(u),n}e.toStream=f;function v(){const u=P(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=v;function y(u){let d=!1;return{read:()=>d?null:(d=!0,u)}}e.toReadable=y;function h(u,d,n){const o=P(n);return S(u,{onData:t=>o.write(d.data(t)),onError:t=>o.error(d.error?d.error(t):t),onEnd:()=>o.end()}),o}e.transform=h;function p(u,d,n){let o=!1;return{read:()=>{const t=d.read();return o?t:(o=!0,t!==null?n([u,t]):u)}}}e.prefixedReadable=p;function c(u,d,n){let o=!1;const t=P(n);return S(d,{onData:r=>o?t.write(r):(o=!0,t.write(n([u,r]))),onError:r=>t.error(r),onEnd:()=>{o||(o=!0,t.write(u)),t.end()}}),t}e.prefixedStream=c}),define(re[17],se([0,1,43]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer<"u";let R,T;class L{static alloc(g){return i?new L(Buffer.allocUnsafe(g)):new L(new Uint8Array(g))}static wrap(g){return i&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new L(g)}static fromString(g,E){return!(E?.dontUseNodeBuffer||!1)&&i?new L(Buffer.from(g)):(R||(R=new TextEncoder),new L(R.encode(g)))}static fromByteArray(g){const E=L.alloc(g.length);for(let A=0,B=g.length;A<B;A++)E.buffer[A]=g[A];return E}static concat(g,E){if(typeof E>"u"){E=0;for(let O=0,N=g.length;O<N;O++)E+=g[O].byteLength}const A=L.alloc(E);let B=0;for(let O=0,N=g.length;O<N;O++){const F=g[O];A.set(F,B),B+=F.byteLength}return A}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=L.alloc(this.byteLength);return g.set(this),g}toString(){return i?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(g,E){return new L(this.buffer.subarray(g,E))}set(g,E){if(g instanceof L)this.buffer.set(g.buffer,E);else if(g instanceof Uint8Array)this.buffer.set(g,E);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),E);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),E);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return w(this.buffer,g)}writeUInt32BE(g,E){b(this.buffer,g,E)}readUInt32LE(g){return C(this.buffer,g)}writeUInt32LE(g,E){S(this.buffer,g,E)}readUInt8(g){return m(this.buffer,g)}writeUInt8(g,E){f(this.buffer,g,E)}}e.VSBuffer=L;function P(a,g){return a[g+0]<<0>>>0|a[g+1]<<8>>>0}e.readUInt16LE=P;function I(a,g,E){a[E+0]=g&255,g=g>>>8,a[E+1]=g&255}e.writeUInt16LE=I;function w(a,g){return a[g]*2**24+a[g+1]*2**16+a[g+2]*2**8+a[g+3]}e.readUInt32BE=w;function b(a,g,E){a[E+3]=g,g=g>>>8,a[E+2]=g,g=g>>>8,a[E+1]=g,g=g>>>8,a[E]=g}e.writeUInt32BE=b;function C(a,g){return a[g+0]<<0>>>0|a[g+1]<<8>>>0|a[g+2]<<16>>>0|a[g+3]<<24>>>0}e.readUInt32LE=C;function S(a,g,E){a[E+0]=g&255,g=g>>>8,a[E+1]=g&255,g=g>>>8,a[E+2]=g&255,g=g>>>8,a[E+3]=g&255}e.writeUInt32LE=S;function m(a,g){return a[g]}e.readUInt8=m;function f(a,g,E){a[E]=g}e.writeUInt8=f;function v(a){return D.consumeReadable(a,g=>L.concat(g))}e.readableToBuffer=v;function y(a){return D.toReadable(a)}e.bufferToReadable=y;function h(a){return D.consumeStream(a,g=>L.concat(g))}e.streamToBuffer=h;async function p(a){return a.ended?L.concat(a.buffer):L.concat([...a.buffer,await h(a.stream)])}e.bufferedStreamToBuffer=p;function c(a){return D.toStream(a,g=>L.concat(g))}e.bufferToStream=c;function u(a){return D.transform(a,{data:g=>typeof g=="string"?L.fromString(g):L.wrap(g)},g=>L.concat(g))}e.streamToBufferReadableStream=u;function d(a){return D.newWriteableStream(g=>L.concat(g),a)}e.newWriteableBufferStream=d;function n(a,g){return D.prefixedReadable(a,g,E=>L.concat(E))}e.prefixedBufferReadable=n;function o(a,g){return D.prefixedStream(a,g,E=>L.concat(E))}e.prefixedBufferStream=o;function t(a){let g=0,E=0,A=0;const B=new Uint8Array(Math.floor(a.length/4*3)),O=F=>{switch(E){case 3:B[A++]=g|F,E=0;break;case 2:B[A++]=g|F>>>2,g=F<<6,E=3;break;case 1:B[A++]=g|F>>>4,g=F<<4,E=2;break;default:g=F<<2,E=1}};for(let F=0;F<a.length;F++){const k=a.charCodeAt(F);if(k>=65&&k<=90)O(k-65);else if(k>=97&&k<=122)O(k-97+26);else if(k>=48&&k<=57)O(k-48+52);else if(k===43||k===45)O(62);else if(k===47||k===95)O(63);else{if(k===61)break;throw new SyntaxError(`Unexpected base64 character ${a[F]}`)}}const N=A;for(;E>0;)O(0);return L.wrap(B).slice(0,N)}e.decodeBase64=t;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:a},g=!0,E=!1){const A=E?s:r;let B="";const O=a.byteLength%3;let N=0;for(;N<a.byteLength-O;N+=3){const F=a[N+0],k=a[N+1],U=a[N+2];B+=A[F>>>2],B+=A[(F<<4|k>>>4)&63],B+=A[(k<<2|U>>>6)&63],B+=A[U&63]}if(O===1){const F=a[N+0];B+=A[F>>>2],B+=A[F<<4&63],g&&(B+="==")}else if(O===2){const F=a[N+0],k=a[N+1];B+=A[F>>>2],B+=A[(F<<4|k>>>4)&63],B+=A[k<<2&63],g&&(B+="=")}return B}e.encodeBase64=l}),define(re[15],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function D(o){return typeof o=="string"}e.isString=D;function i(o){return Array.isArray(o)&&o.every(t=>D(t))}e.isStringArray=i;function R(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=R;function T(o){const t=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof t}e.isTypedArray=T;function L(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=L;function P(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=P;function I(o){return o===!0||o===!1}e.isBoolean=I;function w(o){return typeof o>"u"}e.isUndefined=w;function b(o){return!C(o)}e.isDefined=b;function C(o){return w(o)||o===null}e.isUndefinedOrNull=C;function S(o,t){if(!o)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=S;function m(o){if(C(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=m;function f(...o){const t=[];for(let r=0;r<o.length;r++){const s=o[r];if(C(s))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(s)}return t}e.assertAllDefined=f;const v=Object.prototype.hasOwnProperty;function y(o){if(!R(o))return!1;for(const t in o)if(v.call(o,t))return!1;return!0}e.isEmptyObject=y;function h(o){return typeof o=="function"}e.isFunction=h;function p(...o){return o.length>0&&o.every(h)}e.areFunctions=p;function c(o,t){const r=Math.min(o.length,t.length);for(let s=0;s<r;s++)u(o[s],t[s])}e.validateConstraints=c;function u(o,t){if(D(t)){if(typeof o!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(h(t)){try{if(o instanceof t)return}catch{}if(!C(o)&&o.constructor===t||t.length===1&&t.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function d(o){return o===null?void 0:o}e.withNullAsUndefined=d;function n(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=n}),define(re[32],se([0,1,15]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const p=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([c,u])=>{p[c]=u&&typeof u=="object"?i(u):u}),p}e.deepClone=i;function R(h){if(!h||typeof h!="object")return h;const p=[h];for(;p.length>0;){const c=p.shift();Object.freeze(c);for(const u in c)if(T.call(c,u)){const d=c[u];typeof d=="object"&&!Object.isFrozen(d)&&!(0,D.isTypedArray)(d)&&p.push(d)}}return h}e.deepFreeze=R;const T=Object.prototype.hasOwnProperty;function L(h,p){return P(h,p,new Set)}e.cloneAndChange=L;function P(h,p,c){if((0,D.isUndefinedOrNull)(h))return h;const u=p(h);if(typeof u<"u")return u;if(Array.isArray(h)){const d=[];for(const n of h)d.push(P(n,p,c));return d}if((0,D.isObject)(h)){if(c.has(h))throw new Error("Cannot clone recursive data-structure");c.add(h);const d={};for(const n in h)T.call(h,n)&&(d[n]=P(h[n],p,c));return c.delete(h),d}return h}function I(h,p,c=!0){return(0,D.isObject)(h)?((0,D.isObject)(p)&&Object.keys(p).forEach(u=>{u in h?c&&((0,D.isObject)(h[u])&&(0,D.isObject)(p[u])?I(h[u],p[u],c):h[u]=p[u]):h[u]=p[u]}),h):p}e.mixin=I;function w(h,p){if(h===p)return!0;if(h==null||p===null||p===void 0||typeof h!=typeof p||typeof h!="object"||Array.isArray(h)!==Array.isArray(p))return!1;let c,u;if(Array.isArray(h)){if(h.length!==p.length)return!1;for(c=0;c<h.length;c++)if(!w(h[c],p[c]))return!1}else{const d=[];for(u in h)d.push(u);d.sort();const n=[];for(u in p)n.push(u);if(n.sort(),!w(d,n))return!1;for(c=0;c<d.length;c++)if(!w(h[d[c]],p[d[c]]))return!1}return!0}e.equals=w;function b(h){const p=new Set;return JSON.stringify(h,(c,u)=>{if((0,D.isObject)(u)||Array.isArray(u)){if(p.has(u))return"[Circular]";p.add(u)}return u})}e.safeStringify=b;function C(h,p){const c=Object.create(null);return!h||!p||Object.keys(p).forEach(d=>{const n=h[d],o=p[d];w(n,o)||(c[d]=o)}),c}e.distinct=C;function S(h,p){const c=p.toLowerCase(),u=Object.keys(h).find(d=>d.toLowerCase()===c);return u?h[u]:h[p]}e.getCaseInsensitive=S;function m(h,p){const c=Object.create(null);for(const[u,d]of Object.entries(h))p(u,d)&&(c[u]=d);return c}e.filter=m;function f(h){let p=[],c=Object.getPrototypeOf(h);for(;Object.prototype!==c;)p=p.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return p}e.getAllPropertyNames=f;function v(h){const p=[];for(const c of f(h))typeof h[c]=="function"&&p.push(c);return p}e.getAllMethodNames=v;function y(h,p){const c=d=>function(){const n=Array.prototype.slice.call(arguments,0);return p(d,n)},u={};for(const d of h)u[d]=c(d);return u}e.createProxyObject=y}),define(re[31],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(R){return D.test(R)}e.isUUID=i,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(P){for(let I=0;I<P.length;I++)P[I]=Math.floor(Math.random()*256);return P};const T=new Uint8Array(16),L=[];for(let P=0;P<256;P++)L.push(P.toString(16).padStart(2,"0"));return function(){R(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let I=0,w="";return w+=L[T[I++]],w+=L[T[I++]],w+=L[T[I++]],w+=L[T[I++]],w+="-",w+=L[T[I++]],w+=L[T[I++]],w+="-",w+=L[T[I++]],w+=L[T[I++]],w+="-",w+=L[T[I++]],w+=L[T[I++]],w+="-",w+=L[T[I++]],w+=L[T[I++]],w+=L[T[I++]],w+=L[T[I++]],w+=L[T[I++]],w+=L[T[I++]],w}}()}),define(re[130],se([0,1,34]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const i=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(L){const P=L.replace(/\-/g,":").toLowerCase();return!i.has(P)}function T(){const L=(0,D.networkInterfaces)();for(const P in L){const I=L[P];if(I){for(const{mac:w}of I)if(R(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(re[131],se([0,1,84]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function i(P,I,w,b=1){let C=!1;return new Promise(S=>{const m=setTimeout(()=>{if(!C)return C=!0,S(0)},w);R(P,I,b,f=>{if(!C)return C=!0,clearTimeout(m),S(f)})})}e.findFreePort=i;function R(P,I,w,b){if(I===0)return b(0);const C=new D.Socket;C.once("connect",()=>(L(C),R(P+w,I-1,w,b))),C.once("data",()=>{}),C.once("error",S=>(L(C),S.code!=="ECONNREFUSED"?R(P+w,I-1,w,b):b(P))),C.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(P,I,w,b="127.0.0.1"){let C=!1,S,m=1;const f=D.createServer({pauseOnConnect:!0});function v(y,h){C||(C=!0,f.removeAllListeners(),f.close(),S&&clearTimeout(S),h(y))}return new Promise(y=>{S=setTimeout(()=>{v(0,y)},w),f.on("listening",()=>{v(P,y)}),f.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&m<I?(P++,m++,f.listen(P,b)):v(0,y)}),f.on("close",()=>{v(0,y)}),f.listen(P,b)})}e.findFreePortFaster=T;function L(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(I){console.error(I)}}}),define(re[132],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const D="Offline";function i(T){return T instanceof R?!0:T instanceof Error&&T.name===D&&T.message===D}e.isOfflineError=i;class R extends Error{constructor(){super(D),this.name=this.message}}e.OfflineError=R}),define(re[133],se([0,1,17,11,132]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function T(I,w){if(!navigator.onLine)throw new R.OfflineError;I.proxyAuthorization&&(I.headers={...I.headers||{},"Proxy-Authorization":I.proxyAuthorization});const b=new XMLHttpRequest;return new Promise((C,S)=>{b.open(I.type||"GET",I.url||"",!0,I.user,I.password),L(b,I),b.responseType="arraybuffer",b.onerror=m=>S(new Error(b.statusText&&"XHR failed: "+b.statusText||"XHR failed")),b.onload=m=>{C({res:{statusCode:b.status,headers:P(b)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(b.response)))})},b.ontimeout=m=>S(new Error(`XHR timeout: ${I.timeout}ms`)),I.timeout&&(b.timeout=I.timeout),b.send(I.data),w.onCancellationRequested(()=>{b.abort(),S((0,i.canceled)())})})}e.request=T;function L(I,w){if(w.headers){e:for(const b in w.headers){switch(b){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}I.setRequestHeader(b,w.headers[b])}}}function P(I){const w=Object.create(null);for(const b of I.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(b){const C=b.indexOf(":");w[b.substr(0,C).trim().toLowerCase()]=b.substr(C+1).trim()}return w}}),define(re[134],se([9,10]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(re[65],se([0,1,134]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,R=i*60,T=R*24,L=T*7,P=T*30,I=T*365;function w(C,S,m){typeof C!="number"&&(C=C.getTime());const f=Math.round((new Date().getTime()-C)/1e3);if(f<-30)return(0,D.localize)(0,null,w(new Date().getTime()+f*1e3,!1));if(f<30)return(0,D.localize)(1,null);let v;return f<i?(v=f,S?v===1?m?(0,D.localize)(2,null,v):(0,D.localize)(3,null,v):m?(0,D.localize)(4,null,v):(0,D.localize)(5,null,v):v===1?m?(0,D.localize)(6,null,v):(0,D.localize)(7,null,v):m?(0,D.localize)(8,null,v):(0,D.localize)(9,null,v)):f<R?(v=Math.floor(f/i),S?v===1?m?(0,D.localize)(10,null,v):(0,D.localize)(11,null,v):m?(0,D.localize)(12,null,v):(0,D.localize)(13,null,v):v===1?m?(0,D.localize)(14,null,v):(0,D.localize)(15,null,v):m?(0,D.localize)(16,null,v):(0,D.localize)(17,null,v)):f<T?(v=Math.floor(f/R),S?v===1?m?(0,D.localize)(18,null,v):(0,D.localize)(19,null,v):m?(0,D.localize)(20,null,v):(0,D.localize)(21,null,v):v===1?m?(0,D.localize)(22,null,v):(0,D.localize)(23,null,v):m?(0,D.localize)(24,null,v):(0,D.localize)(25,null,v)):f<L?(v=Math.floor(f/T),S?v===1?(0,D.localize)(26,null,v):(0,D.localize)(27,null,v):v===1?(0,D.localize)(28,null,v):(0,D.localize)(29,null,v)):f<P?(v=Math.floor(f/L),S?v===1?m?(0,D.localize)(30,null,v):(0,D.localize)(31,null,v):m?(0,D.localize)(32,null,v):(0,D.localize)(33,null,v):v===1?m?(0,D.localize)(34,null,v):(0,D.localize)(35,null,v):m?(0,D.localize)(36,null,v):(0,D.localize)(37,null,v)):f<I?(v=Math.floor(f/P),S?v===1?m?(0,D.localize)(38,null,v):(0,D.localize)(39,null,v):m?(0,D.localize)(40,null,v):(0,D.localize)(41,null,v):v===1?m?(0,D.localize)(42,null,v):(0,D.localize)(43,null,v):m?(0,D.localize)(44,null,v):(0,D.localize)(45,null,v)):(v=Math.floor(f/I),S?v===1?m?(0,D.localize)(46,null,v):(0,D.localize)(47,null,v):m?(0,D.localize)(48,null,v):(0,D.localize)(49,null,v):v===1?m?(0,D.localize)(50,null,v):(0,D.localize)(51,null,v):m?(0,D.localize)(52,null,v):(0,D.localize)(53,null,v))}e.fromNow=w;function b(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(re[135],se([9,10]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(re[37],se([0,1,20,15,135]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(C,S){return S&&(C.stack||C.stacktrace)?R.localize(0,null,P(C),L(C.stack)||L(C.stacktrace)):P(C)}function L(C){return Array.isArray(C)?C.join(`
`):C}function P(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?R.localize(1,null,C.message):C.message||R.localize(2,null)}function I(C=null,S=!1){if(!C)return R.localize(3,null);if(Array.isArray(C)){const m=D.coalesce(C),f=I(m[0],S);return m.length>1?R.localize(4,null,f,m.length):f}if(i.isString(C))return C;if(C.detail){const m=C.detail;if(m.error)return T(m.error,S);if(m.exception)return T(m.exception,S)}return C.stack?T(C,S):C.message?C.message:R.localize(5,null)}e.toErrorMessage=I;function w(C){const S=C;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=w;function b(C,S){let m;return typeof C=="string"?m=new Error(C):m=C,m.actions=S,m}e.createErrorWithActions=b}),define(re[136],se([9,10]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(re[137],se([0,1,136]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function i(R){switch(R){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.getParseErrorMessage=i}),define(re[138],se([9,10]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(re[5],se([0,1,138]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let i=!1,R=!1,T=!1,L=!1,P=!1,I=!1,w=!1,b=!1,C=!1,S=!1,m,f=e.LANGUAGE_DEFAULT,v,y;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const p=typeof h?.versions?.electron=="string",c=p&&h?.type==="renderer";if(typeof navigator=="object"&&!c)y=navigator.userAgent,i=y.indexOf("Windows")>=0,R=y.indexOf("Macintosh")>=0,b=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=y.indexOf("Linux")>=0,S=y?.indexOf("Mobi")>=0,I=!0,m=D.getConfiguredDefaultLocale(D.localize(0,null))||e.LANGUAGE_DEFAULT,f=m;else if(typeof h=="object"){i=h.platform==="win32",R=h.platform==="darwin",T=h.platform==="linux",L=T&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,w=p,C=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=e.LANGUAGE_DEFAULT,f=e.LANGUAGE_DEFAULT;const a=h.env.VSCODE_NLS_CONFIG;if(a)try{const g=JSON.parse(a),E=g.availableLanguages["*"];m=g.locale,f=E||e.LANGUAGE_DEFAULT,v=g._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var u;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(u=e.Platform||(e.Platform={}));function d(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=d;let n=0;R?n=1:i?n=3:T&&(n=2),e.isWindows=i,e.isMacintosh=R,e.isLinux=T,e.isLinuxSnap=L,e.isNative=P,e.isElectron=w,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=b,e.isMobile=S,e.isCI=C,e.platform=n,e.userAgent=y,e.language=f;var o;(function(a){function g(){return e.language}a.value=g;function E(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=E;function A(){return e.language==="en"}a.isDefault=A})(o=e.Language||(e.Language={})),e.locale=m,e.translationsConfigFile=v,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let A=0,B=a.length;A<B;A++){const O=a[A];if(O.id===E.data.vscodeScheduleAsyncWork){a.splice(A,1),O.callback();return}}});let g=0;return E=>{const A=++g;a.push({id:A,callback:E}),e.globals.postMessage({vscodeScheduleAsyncWork:A},"*")}}return a=>setTimeout(a)})();var t;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||b?2:i?1:3;let r=!0,s=!1;function l(){if(!s){s=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,r=new Uint16Array(a.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(re[36],se([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof D.globals.vscode<"u"&&typeof D.globals.vscode.process<"u"){const R=D.globals.vscode.process;i={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(re[12],se([0,1,36]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,R=97,T=90,L=122,P=46,I=47,w=92,b=58,C=63;class S extends Error{constructor(u,d,n){let o;typeof d=="string"&&d.indexOf("not ")===0?(o="must not be",d=d.replace(/^not /,"")):o="must be";const t=u.indexOf(".")!==-1?"property":"argument";let r=`The "${u}" ${t} ${o} of type ${d}`;r+=`. Received type ${typeof n}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function m(c,u){if(typeof c!="string")throw new S(u,"string",c)}function f(c){return c===I||c===w}function v(c){return c===I}function y(c){return c>=i&&c<=T||c>=R&&c<=L}function h(c,u,d,n){let o="",t=0,r=-1,s=0,l=0;for(let a=0;a<=c.length;++a){if(a<c.length)l=c.charCodeAt(a);else{if(n(l))break;l=I}if(n(l)){if(!(r===a-1||s===1))if(s===2){if(o.length<2||t!==2||o.charCodeAt(o.length-1)!==P||o.charCodeAt(o.length-2)!==P){if(o.length>2){const g=o.lastIndexOf(d);g===-1?(o="",t=0):(o=o.slice(0,g),t=o.length-1-o.lastIndexOf(d)),r=a,s=0;continue}else if(o.length!==0){o="",t=0,r=a,s=0;continue}}u&&(o+=o.length>0?`${d}..`:"..",t=2)}else o.length>0?o+=`${d}${c.slice(r+1,a)}`:o=c.slice(r+1,a),t=a-r-1;r=a,s=0}else l===P&&s!==-1?++s:s=-1}return o}function p(c,u){if(u===null||typeof u!="object")throw new S("pathObject","Object",u);const d=u.dir||u.root,n=u.base||`${u.name||""}${u.ext||""}`;return d?d===u.root?`${d}${n}`:`${d}${c}${n}`:n}e.win32={resolve(...c){let u="",d="",n=!1;for(let o=c.length-1;o>=-1;o--){let t;if(o>=0){if(t=c[o],m(t,"path"),t.length===0)continue}else u.length===0?t=D.cwd():(t=D.env[`=${u}`]||D.cwd(),(t===void 0||t.slice(0,2).toLowerCase()!==u.toLowerCase()&&t.charCodeAt(2)===w)&&(t=`${u}\\`));const r=t.length;let s=0,l="",a=!1;const g=t.charCodeAt(0);if(r===1)f(g)&&(s=1,a=!0);else if(f(g))if(a=!0,f(t.charCodeAt(1))){let E=2,A=E;for(;E<r&&!f(t.charCodeAt(E));)E++;if(E<r&&E!==A){const B=t.slice(A,E);for(A=E;E<r&&f(t.charCodeAt(E));)E++;if(E<r&&E!==A){for(A=E;E<r&&!f(t.charCodeAt(E));)E++;(E===r||E!==A)&&(l=`\\\\${B}\\${t.slice(A,E)}`,s=E)}}}else s=1;else y(g)&&t.charCodeAt(1)===b&&(l=t.slice(0,2),s=2,r>2&&f(t.charCodeAt(2))&&(a=!0,s=3));if(l.length>0)if(u.length>0){if(l.toLowerCase()!==u.toLowerCase())continue}else u=l;if(n){if(u.length>0)break}else if(d=`${t.slice(s)}\\${d}`,n=a,a&&u.length>0)break}return d=h(d,!n,"\\",f),n?`${u}\\${d}`:`${u}${d}`||"."},normalize(c){m(c,"path");const u=c.length;if(u===0)return".";let d=0,n,o=!1;const t=c.charCodeAt(0);if(u===1)return v(t)?"\\":c;if(f(t))if(o=!0,f(c.charCodeAt(1))){let s=2,l=s;for(;s<u&&!f(c.charCodeAt(s));)s++;if(s<u&&s!==l){const a=c.slice(l,s);for(l=s;s<u&&f(c.charCodeAt(s));)s++;if(s<u&&s!==l){for(l=s;s<u&&!f(c.charCodeAt(s));)s++;if(s===u)return`\\\\${a}\\${c.slice(l)}\\`;s!==l&&(n=`\\\\${a}\\${c.slice(l,s)}`,d=s)}}}else d=1;else y(t)&&c.charCodeAt(1)===b&&(n=c.slice(0,2),d=2,u>2&&f(c.charCodeAt(2))&&(o=!0,d=3));let r=d<u?h(c.slice(d),!o,"\\",f):"";return r.length===0&&!o&&(r="."),r.length>0&&f(c.charCodeAt(u-1))&&(r+="\\"),n===void 0?o?`\\${r}`:r:o?`${n}\\${r}`:`${n}${r}`},isAbsolute(c){m(c,"path");const u=c.length;if(u===0)return!1;const d=c.charCodeAt(0);return f(d)||u>2&&y(d)&&c.charCodeAt(1)===b&&f(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let u,d;for(let t=0;t<c.length;++t){const r=c[t];m(r,"path"),r.length>0&&(u===void 0?u=d=r:u+=`\\${r}`)}if(u===void 0)return".";let n=!0,o=0;if(typeof d=="string"&&f(d.charCodeAt(0))){++o;const t=d.length;t>1&&f(d.charCodeAt(1))&&(++o,t>2&&(f(d.charCodeAt(2))?++o:n=!1))}if(n){for(;o<u.length&&f(u.charCodeAt(o));)o++;o>=2&&(u=`\\${u.slice(o)}`)}return e.win32.normalize(u)},relative(c,u){if(m(c,"from"),m(u,"to"),c===u)return"";const d=e.win32.resolve(c),n=e.win32.resolve(u);if(d===n||(c=d.toLowerCase(),u=n.toLowerCase(),c===u))return"";let o=0;for(;o<c.length&&c.charCodeAt(o)===w;)o++;let t=c.length;for(;t-1>o&&c.charCodeAt(t-1)===w;)t--;const r=t-o;let s=0;for(;s<u.length&&u.charCodeAt(s)===w;)s++;let l=u.length;for(;l-1>s&&u.charCodeAt(l-1)===w;)l--;const a=l-s,g=r<a?r:a;let E=-1,A=0;for(;A<g;A++){const O=c.charCodeAt(o+A);if(O!==u.charCodeAt(s+A))break;O===w&&(E=A)}if(A!==g){if(E===-1)return n}else{if(a>g){if(u.charCodeAt(s+A)===w)return n.slice(s+A+1);if(A===2)return n.slice(s+A)}r>g&&(c.charCodeAt(o+A)===w?E=A:A===2&&(E=3)),E===-1&&(E=0)}let B="";for(A=o+E+1;A<=t;++A)(A===t||c.charCodeAt(A)===w)&&(B+=B.length===0?"..":"\\..");return s+=E,B.length>0?`${B}${n.slice(s,l)}`:(n.charCodeAt(s)===w&&++s,n.slice(s,l))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const u=e.win32.resolve(c);if(u.length<=2)return c;if(u.charCodeAt(0)===w){if(u.charCodeAt(1)===w){const d=u.charCodeAt(2);if(d!==C&&d!==P)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(y(u.charCodeAt(0))&&u.charCodeAt(1)===b&&u.charCodeAt(2)===w)return`\\\\?\\${u}`;return c},dirname(c){m(c,"path");const u=c.length;if(u===0)return".";let d=-1,n=0;const o=c.charCodeAt(0);if(u===1)return f(o)?c:".";if(f(o)){if(d=n=1,f(c.charCodeAt(1))){let s=2,l=s;for(;s<u&&!f(c.charCodeAt(s));)s++;if(s<u&&s!==l){for(l=s;s<u&&f(c.charCodeAt(s));)s++;if(s<u&&s!==l){for(l=s;s<u&&!f(c.charCodeAt(s));)s++;if(s===u)return c;s!==l&&(d=n=s+1)}}}}else y(o)&&c.charCodeAt(1)===b&&(d=u>2&&f(c.charCodeAt(2))?3:2,n=d);let t=-1,r=!0;for(let s=u-1;s>=n;--s)if(f(c.charCodeAt(s))){if(!r){t=s;break}}else r=!1;if(t===-1){if(d===-1)return".";t=d}return c.slice(0,t)},basename(c,u){u!==void 0&&m(u,"ext"),m(c,"path");let d=0,n=-1,o=!0,t;if(c.length>=2&&y(c.charCodeAt(0))&&c.charCodeAt(1)===b&&(d=2),u!==void 0&&u.length>0&&u.length<=c.length){if(u===c)return"";let r=u.length-1,s=-1;for(t=c.length-1;t>=d;--t){const l=c.charCodeAt(t);if(f(l)){if(!o){d=t+1;break}}else s===-1&&(o=!1,s=t+1),r>=0&&(l===u.charCodeAt(r)?--r===-1&&(n=t):(r=-1,n=s))}return d===n?n=s:n===-1&&(n=c.length),c.slice(d,n)}for(t=c.length-1;t>=d;--t)if(f(c.charCodeAt(t))){if(!o){d=t+1;break}}else n===-1&&(o=!1,n=t+1);return n===-1?"":c.slice(d,n)},extname(c){m(c,"path");let u=0,d=-1,n=0,o=-1,t=!0,r=0;c.length>=2&&c.charCodeAt(1)===b&&y(c.charCodeAt(0))&&(u=n=2);for(let s=c.length-1;s>=u;--s){const l=c.charCodeAt(s);if(f(l)){if(!t){n=s+1;break}continue}o===-1&&(t=!1,o=s+1),l===P?d===-1?d=s:r!==1&&(r=1):d!==-1&&(r=-1)}return d===-1||o===-1||r===0||r===1&&d===o-1&&d===n+1?"":c.slice(d,o)},format:p.bind(null,"\\"),parse(c){m(c,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return u;const d=c.length;let n=0,o=c.charCodeAt(0);if(d===1)return f(o)?(u.root=u.dir=c,u):(u.base=u.name=c,u);if(f(o)){if(n=1,f(c.charCodeAt(1))){let E=2,A=E;for(;E<d&&!f(c.charCodeAt(E));)E++;if(E<d&&E!==A){for(A=E;E<d&&f(c.charCodeAt(E));)E++;if(E<d&&E!==A){for(A=E;E<d&&!f(c.charCodeAt(E));)E++;E===d?n=E:E!==A&&(n=E+1)}}}}else if(y(o)&&c.charCodeAt(1)===b){if(d<=2)return u.root=u.dir=c,u;if(n=2,f(c.charCodeAt(2))){if(d===3)return u.root=u.dir=c,u;n=3}}n>0&&(u.root=c.slice(0,n));let t=-1,r=n,s=-1,l=!0,a=c.length-1,g=0;for(;a>=n;--a){if(o=c.charCodeAt(a),f(o)){if(!l){r=a+1;break}continue}s===-1&&(l=!1,s=a+1),o===P?t===-1?t=a:g!==1&&(g=1):t!==-1&&(g=-1)}return s!==-1&&(t===-1||g===0||g===1&&t===s-1&&t===r+1?u.base=u.name=c.slice(r,s):(u.name=c.slice(r,t),u.base=c.slice(r,s),u.ext=c.slice(t,s))),r>0&&r!==n?u.dir=c.slice(0,r-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let u="",d=!1;for(let n=c.length-1;n>=-1&&!d;n--){const o=n>=0?c[n]:D.cwd();m(o,"path"),o.length!==0&&(u=`${o}/${u}`,d=o.charCodeAt(0)===I)}return u=h(u,!d,"/",v),d?`/${u}`:u.length>0?u:"."},normalize(c){if(m(c,"path"),c.length===0)return".";const u=c.charCodeAt(0)===I,d=c.charCodeAt(c.length-1)===I;return c=h(c,!u,"/",v),c.length===0?u?"/":d?"./":".":(d&&(c+="/"),u?`/${c}`:c)},isAbsolute(c){return m(c,"path"),c.length>0&&c.charCodeAt(0)===I},join(...c){if(c.length===0)return".";let u;for(let d=0;d<c.length;++d){const n=c[d];m(n,"path"),n.length>0&&(u===void 0?u=n:u+=`/${n}`)}return u===void 0?".":e.posix.normalize(u)},relative(c,u){if(m(c,"from"),m(u,"to"),c===u||(c=e.posix.resolve(c),u=e.posix.resolve(u),c===u))return"";const d=1,n=c.length,o=n-d,t=1,r=u.length-t,s=o<r?o:r;let l=-1,a=0;for(;a<s;a++){const E=c.charCodeAt(d+a);if(E!==u.charCodeAt(t+a))break;E===I&&(l=a)}if(a===s)if(r>s){if(u.charCodeAt(t+a)===I)return u.slice(t+a+1);if(a===0)return u.slice(t+a)}else o>s&&(c.charCodeAt(d+a)===I?l=a:a===0&&(l=0));let g="";for(a=d+l+1;a<=n;++a)(a===n||c.charCodeAt(a)===I)&&(g+=g.length===0?"..":"/..");return`${g}${u.slice(t+l)}`},toNamespacedPath(c){return c},dirname(c){if(m(c,"path"),c.length===0)return".";const u=c.charCodeAt(0)===I;let d=-1,n=!0;for(let o=c.length-1;o>=1;--o)if(c.charCodeAt(o)===I){if(!n){d=o;break}}else n=!1;return d===-1?u?"/":".":u&&d===1?"//":c.slice(0,d)},basename(c,u){u!==void 0&&m(u,"ext"),m(c,"path");let d=0,n=-1,o=!0,t;if(u!==void 0&&u.length>0&&u.length<=c.length){if(u===c)return"";let r=u.length-1,s=-1;for(t=c.length-1;t>=0;--t){const l=c.charCodeAt(t);if(l===I){if(!o){d=t+1;break}}else s===-1&&(o=!1,s=t+1),r>=0&&(l===u.charCodeAt(r)?--r===-1&&(n=t):(r=-1,n=s))}return d===n?n=s:n===-1&&(n=c.length),c.slice(d,n)}for(t=c.length-1;t>=0;--t)if(c.charCodeAt(t)===I){if(!o){d=t+1;break}}else n===-1&&(o=!1,n=t+1);return n===-1?"":c.slice(d,n)},extname(c){m(c,"path");let u=-1,d=0,n=-1,o=!0,t=0;for(let r=c.length-1;r>=0;--r){const s=c.charCodeAt(r);if(s===I){if(!o){d=r+1;break}continue}n===-1&&(o=!1,n=r+1),s===P?u===-1?u=r:t!==1&&(t=1):u!==-1&&(t=-1)}return u===-1||n===-1||t===0||t===1&&u===n-1&&u===d+1?"":c.slice(u,n)},format:p.bind(null,"/"),parse(c){m(c,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return u;const d=c.charCodeAt(0)===I;let n;d?(u.root="/",n=1):n=0;let o=-1,t=0,r=-1,s=!0,l=c.length-1,a=0;for(;l>=n;--l){const g=c.charCodeAt(l);if(g===I){if(!s){t=l+1;break}continue}r===-1&&(s=!1,r=l+1),g===P?o===-1?o=l:a!==1&&(a=1):o!==-1&&(a=-1)}if(r!==-1){const g=t===0&&d?1:t;o===-1||a===0||a===1&&o===r-1&&o===t+1?u.base=u.name=c.slice(g,r):(u.name=c.slice(g,o),u.base=c.slice(g,r),u.ext=c.slice(o,r))}return t>0?u.dir=c.slice(0,t-1):d&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(re[139],se([0,1,12]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(b){const C=(0,D.extname)(b),S=i[C.toLowerCase()];return S!==void 0?S:L(b)}e.getMediaOrTextMime=T;function L(b){const C=(0,D.extname)(b);return R[C.toLowerCase()]}e.getMediaMime=L;function P(b){for(const C in R)if(R[C]===b)return C}e.getExtensionForMimeType=P;const I=/^(.+)\/(.+?)(;.+)?$/;function w(b,C){const S=I.exec(b);return S?`${S[1].toLowerCase()}/${S[2].toLowerCase()}${S[3]??""}`:C?void 0:b}e.normalizeMimeType=w}),define(re[85],se([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var i;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(i=e.Source||(e.Source={}));var R;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(P,...I){const w=I.reduce((S,m)=>(S[m]=!0,S),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(S=>!w[S]).forEach(S=>{for(let m=0;m<b.length;m++)if(S.search(b[m])!==-1){delete P[S];break}})}e.sanitizeProcessEnvironment=T;function L(P){!P||(delete P.DEBUG,D.isMacintosh&&delete P.DYLD_LIBRARY_PATH,D.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=L}),define(re[140],se([0,1,5]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=D.globals.performance&&typeof D.globals.performance.now=="function";class R{static create(L=!0){return new R(L)}constructor(L){this._highResolution=i&&L,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(re[3],se([0,1,11,80,2,82,140]),function(Q,e,D,i,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,I=!1;var w;(function(l){l.None=()=>R.Disposable.None;function a(H){if(I){const{onListenerDidAdd:Z}=H,oe=f.create();let X=0;H.onListenerDidAdd=()=>{++X===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),oe.print()),Z?.()}}}function g(H,Z){return G(H,()=>{},0,void 0,void 0,Z)}l.defer=g;function E(H,Z=0,oe){return l.debounce(H,(X,ie)=>X?(X.push(ie),X):[ie],Z,void 0,void 0,oe)}l.accumulate=E;function A(H){return(Z,oe=null,X)=>{let ie=!1,ne;return ne=H(le=>{if(!ie)return ne?ne.dispose():ie=!0,Z.call(oe,le)},null,X),ie&&ne.dispose(),ne}}l.once=A;function B(H,Z,oe){return $((X,ie=null,ne)=>H(le=>X.call(ie,Z(le)),null,ne),oe)}l.map=B;function O(H,Z,oe){return $((X,ie=null,ne)=>H(le=>{Z(le),X.call(ie,le)},null,ne),oe)}l.forEach=O;function N(H,Z,oe){return $((X,ie=null,ne)=>H(le=>Z(le)&&X.call(ie,le),null,ne),oe)}l.filter=N;function F(H){return H}l.signal=F;function k(...H){return(Z,oe=null,X)=>(0,R.combinedDisposable)(...H.map(ie=>ie(ne=>Z.call(oe,ne),null,X)))}l.any=k;function U(H,Z,oe,X){let ie=oe;return B(H,ne=>(ie=Z(ie,ne),ie),X)}l.reduce=U;function $(H,Z){let oe;const X={onFirstListenerAdd(){oe=H(ie.fire,ie)},onLastListenerRemove(){oe?.dispose()}};Z||a(X);const ie=new y(X);return Z?.add(ie),ie.event}function G(H,Z,oe=100,X=!1,ie,ne){let le,ue,pe,we=0;const Ee={leakWarningThreshold:ie,onFirstListenerAdd(){le=H(_e=>{we++,ue=Z(ue,_e),X&&!pe&&(Ce.fire(ue),ue=void 0),clearTimeout(pe),pe=setTimeout(()=>{const Ne=ue;ue=void 0,pe=void 0,(!X||we>1)&&Ce.fire(Ne),we=0},oe)})},onLastListenerRemove(){le.dispose()}};ne||a(Ee);const Ce=new y(Ee);return ne?.add(Ce),Ce.event}l.debounce=G;function W(H,Z=(X,ie)=>X===ie,oe){let X=!0,ie;return N(H,ne=>{const le=X||!Z(ne,ie);return X=!1,ie=ne,le},oe)}l.latch=W;function V(H,Z,oe){return[l.filter(H,Z,oe),l.filter(H,X=>!Z(X),oe)]}l.split=V;function z(H,Z=!1,oe=[]){let X=oe.slice(),ie=H(ue=>{X?X.push(ue):le.fire(ue)});const ne=()=>{X?.forEach(ue=>le.fire(ue)),X=null},le=new y({onFirstListenerAdd(){ie||(ie=H(ue=>le.fire(ue)))},onFirstListenerDidAdd(){X&&(Z?setTimeout(ne):ne())},onLastListenerRemove(){ie&&ie.dispose(),ie=null}});return le.event}l.buffer=z;class j{constructor(Z){this.event=Z,this.disposables=new R.DisposableStore}map(Z){return new j(B(this.event,Z,this.disposables))}forEach(Z){return new j(O(this.event,Z,this.disposables))}filter(Z){return new j(N(this.event,Z,this.disposables))}reduce(Z,oe){return new j(U(this.event,Z,oe,this.disposables))}latch(){return new j(W(this.event,void 0,this.disposables))}debounce(Z,oe=100,X=!1,ie){return new j(G(this.event,Z,oe,X,ie,this.disposables))}on(Z,oe,X){return this.event(Z,oe,X)}once(Z,oe,X){return A(this.event)(Z,oe,X)}dispose(){this.disposables.dispose()}}function J(H){return new j(H)}l.chain=J;function ee(H,Z,oe=X=>X){const X=(...ue)=>le.fire(oe(...ue)),ie=()=>H.on(Z,X),ne=()=>H.removeListener(Z,X),le=new y({onFirstListenerAdd:ie,onLastListenerRemove:ne});return le.event}l.fromNodeEventEmitter=ee;function ce(H,Z,oe=X=>X){const X=(...ue)=>le.fire(oe(...ue)),ie=()=>H.addEventListener(Z,X),ne=()=>H.removeEventListener(Z,X),le=new y({onFirstListenerAdd:ie,onLastListenerRemove:ne});return le.event}l.fromDOMEventEmitter=ce;function q(H){return new Promise(Z=>A(H)(Z))}l.toPromise=q;function x(H,Z){return Z(void 0),H(oe=>Z(oe))}l.runAndSubscribe=x;function _(H,Z){let oe=null;function X(ne){oe?.dispose(),oe=new R.DisposableStore,Z(ne,oe)}X(void 0);const ie=H(ne=>X(ne));return(0,R.toDisposable)(()=>{ie.dispose(),oe?.dispose()})}l.runAndSubscribeWithStore=_;class M{constructor(Z,oe){this.obs=Z,this._counter=0,this._hasChanged=!1;const X={onFirstListenerAdd:()=>{Z.addObserver(this)},onLastListenerRemove:()=>{Z.removeObserver(this)}};oe||a(X),this.emitter=new y(X),oe&&oe.add(this.emitter)}beginUpdate(Z){this._counter++}handleChange(Z,oe){this._hasChanged=!0}endUpdate(Z){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function Y(H,Z){return new M(H,Z).emitter.event}l.fromObservable=Y})(w=e.Event||(e.Event={}));class b{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${b._idPool++}`,b.all.add(this)}start(a){this._stopWatch=new L.StopWatch(!0),this.listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=b,b.all=new Set,b._idPool=0;let C=-1;function S(l){const a=C;return C=l,{dispose(){C=a}}}e.setGlobalLeakWarningThreshold=S;class m{constructor(a,g=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=g,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a,g){let E=C;if(typeof this.customThreshold=="number"&&(E=this.customThreshold),E<=0||g<E)return;this._stacks||(this._stacks=new Map);const A=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,A+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=E*.5;let B,O=0;for(const[N,F]of this._stacks)(!B||O<F)&&(B=N,O=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${O}):`),console.warn(B)}return()=>{const B=this._stacks.get(a.value)||0;this._stacks.set(a.value,B-1)}}}class f{static create(){return new f(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v{constructor(a,g,E){this.callback=a,this.callbackThis=g,this.stack=E,this.subscription=new R.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class y{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=C>0?new m(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new b(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(P){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const g of a)g.subscription.isset()&&(g.subscription.unset(),g.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,g,E)=>{this._listeners||(this._listeners=new T.LinkedList);const A=this._listeners.isEmpty();A&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let B,O;this._leakageMon&&this._listeners.size>=30&&(O=f.create(),B=this._leakageMon.check(O,this._listeners.size+1)),P&&(O=O??f.create());const N=new v(a,g,O),F=this._listeners.push(N);A&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,g);const k=N.subscription.set(()=>{B?.(),this._disposed||(F(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return E instanceof R.DisposableStore?E.add(k):Array.isArray(E)&&E.push(k),k}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new p);for(const g of this._listeners)this._deliveryQueue.push(this,g,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=y;class h{constructor(){this._queue=new T.LinkedList}get size(){return this._queue.size}push(a,g,E){this._queue.push(new c(a,g,E))}clear(a){const g=new T.LinkedList;for(const E of this._queue)E.emitter!==a&&g.push(E);this._queue=g}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(g){(0,D.onUnexpectedError)(g)}}}}e.EventDeliveryQueue=h;class p extends h{clear(a){this._queue.clear()}}class c{constructor(a,g,E){this.emitter=a,this.listener=g,this.event=E}}class u extends y{async fireAsync(a,g,E){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const A of this._listeners)this._asyncDeliveryQueue.push([A,a]);for(;this._asyncDeliveryQueue.size>0&&!g.isCancellationRequested;){const[A,B]=this._asyncDeliveryQueue.shift(),O=[],N={...B,token:g,waitUntil:F=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");E&&(F=E(F,A.callback)),O.push(F)}};try{A.invoke(N)}catch(F){(0,D.onUnexpectedError)(F);continue}Object.freeze(O),await Promise.allSettled(O).then(F=>{for(const k of F)k.status==="rejected"&&(0,D.onUnexpectedError)(k.reason)})}}}}e.AsyncEmitter=u;class d extends y{constructor(a){super(a),this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=d;class n extends d{constructor(a){super(a),this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=n;class o extends y{constructor(a){super(a),this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){!this.hasListeners()||(this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(g=>super.fire(g)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const g={event:a,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const E=()=>{this.hasListeners&&this.unhook(g);const A=this.events.indexOf(g);this.events.splice(A,1)};return(0,R.toDisposable)((0,i.once)(E))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(g=>this.emitter.fire(g))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class r{constructor(){this.buffers=[]}wrapEvent(a){return(g,E,A)=>a(B=>{const O=this.buffers[this.buffers.length-1];O?O.push(()=>g.call(E,B)):g.call(E,B)},void 0,A)}bufferEvents(a){const g=[];this.buffers.push(g);const E=a();return this.buffers.pop(),g.forEach(A=>A()),E}}e.EventBufferer=r;class s{constructor(){this.listening=!1,this.inputEvent=w.None,this.inputEventListener=R.Disposable.None,this.emitter=new y({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(re[24],se([0,1,3]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(P,I){const w=setTimeout(P.bind(I),0);return{dispose(){clearTimeout(w)}}});var R;(function(P){function I(w){return w===P.None||w===P.Cancelled||w instanceof T?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}P.isCancellationToken=I,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(R=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class L{constructor(I){this._token=void 0,this._parentListener=void 0,this._parentListener=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=R.Cancelled}dispose(I=!1){I&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=L}),define(re[141],se([0,1,24]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class i{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new D.CancellationTokenSource,I=this.task(P.token);return this.result={promise:I,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=i;class R{constructor(P){this.fn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const I=JSON.stringify(P);return this.lastArgKey!==I&&(this.lastArgKey=I,this.lastCache=this.fn(P)),this.lastCache}}e.LRUCachedFunction=R;class T{get cachedValues(){return this._map}constructor(P){this.fn=P,this._map=new Map}get(P){if(this._map.has(P))return this._map.get(P);const I=this.fn(P);return this._map.set(P,I),I}}e.CachedFunction=T}),define(re[86],se([0,1,3,2]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const R=L=>({onDidChange:D.Event.None,value:L});e.staticObservableValue=R;class T extends i.Disposable{get value(){return this._value}set value(P){P!==this._value&&(this._value=P,this.changeEmitter.fire(P))}constructor(P){super(),this._value=P,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=T}),define(re[27],se([0,1,141,128]),function(Q,e,D,i){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(te){return!te||typeof te!="string"?!0:te.trim().length===0}e.isFalsyOrWhitespace=T;const L=/{(\d+)}/g;function P(te,...he){return he.length===0?te:te.replace(L,function(de,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=he.length?de:he[Se]})}e.format=P;const I=/{([^}]+)}/g;function w(te,he){return te.replace(I,(de,me)=>he[me]??de)}e.format2=w;function b(te){return te.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=b;function C(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function S(te,he){let de=0;const me=he.charCodeAt(0);for(let Se=te.length-1;Se>=0;Se--)te.charCodeAt(Se)===me&&de++;return de}e.count=S;function m(te,he,de="\u2026"){return te.length<=he?te:`${te.substr(0,he)}${de}`}e.truncate=m;function f(te,he=" "){const de=v(te,he);return y(de,he)}e.trim=f;function v(te,he){if(!te||!he)return te;const de=he.length;if(de===0||te.length===0)return te;let me=0;for(;te.indexOf(he,me)===me;)me=me+de;return te.substring(me)}e.ltrim=v;function y(te,he){if(!te||!he)return te;const de=he.length,me=te.length;if(de===0||me===0)return te;let Se=me,Pe=-1;for(;Pe=te.lastIndexOf(he,Se-1),!(Pe===-1||Pe+de!==Se);){if(Pe===0)return"";Se=Pe}return te.substring(0,Se)}e.rtrim=y;function h(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function p(te){return te.replace(/\*/g,"")}e.stripWildcards=p;function c(te,he,de={}){if(!te)throw new Error("Cannot create regex from empty string");he||(te=C(te)),de.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let me="";return de.global&&(me+="g"),de.matchCase||(me+="i"),de.multiline&&(me+="m"),de.unicode&&(me+="u"),new RegExp(te,me)}e.createRegExp=c;function u(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}e.regExpLeadsToEndlessLoop=u;function d(te){return!!te.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=d;function n(te){return(te.global?"g":"")+(te.ignoreCase?"i":"")+(te.multiline?"m":"")+(te.unicode?"u":"")}e.regExpFlags=n;function o(te){return te.split(/\r\n|\r|\n/)}e.splitLines=o;function t(te){for(let he=0,de=te.length;he<de;he++){const me=te.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.firstNonWhitespaceIndex=t;function r(te,he=0,de=te.length){for(let me=he;me<de;me++){const Se=te.charCodeAt(me);if(Se!==32&&Se!==9)return te.substring(he,me)}return te.substring(he,de)}e.getLeadingWhitespace=r;function s(te,he=te.length-1){for(let de=he;de>=0;de--){const me=te.charCodeAt(de);if(me!==32&&me!==9)return de}return-1}e.lastNonWhitespaceIndex=s;function l(te,he,de){const me=[];let Se=0;for(const Pe of te.matchAll(he)){if(me.push(te.slice(Se,Pe.index)),Pe.index===void 0)throw new Error("match.index should be defined");Se=Pe.index+Pe[0].length,me.push(de(Pe[0],...Pe.slice(1),Pe.index,te,Pe.groups))}return me.push(te.slice(Se)),Promise.all(me).then(Pe=>Pe.join(""))}e.replaceAsync=l;function a(te,he){return te<he?-1:te>he?1:0}e.compare=a;function g(te,he,de=0,me=te.length,Se=0,Pe=he.length){for(;de<me&&Se<Pe;de++,Se++){const $e=te.charCodeAt(de),Le=he.charCodeAt(Se);if($e<Le)return-1;if($e>Le)return 1}const De=me-de,ze=Pe-Se;return De<ze?-1:De>ze?1:0}e.compareSubstring=g;function E(te,he){return A(te,he,0,te.length,0,he.length)}e.compareIgnoreCase=E;function A(te,he,de=0,me=te.length,Se=0,Pe=he.length){for(;de<me&&Se<Pe;de++,Se++){let $e=te.charCodeAt(de),Le=he.charCodeAt(Se);if($e===Le)continue;if($e>=128||Le>=128)return g(te.toLowerCase(),he.toLowerCase(),de,me,Se,Pe);O($e)&&($e-=32),O(Le)&&(Le-=32);const qe=$e-Le;if(qe!==0)return qe}const De=me-de,ze=Pe-Se;return De<ze?-1:De>ze?1:0}e.compareSubstringIgnoreCase=A;function B(te){return te>=48&&te<=57}e.isAsciiDigit=B;function O(te){return te>=97&&te<=122}e.isLowerAsciiLetter=O;function N(te){return te>=65&&te<=90}e.isUpperAsciiLetter=N;function F(te,he){return te.length===he.length&&A(te,he)===0}e.equalsIgnoreCase=F;function k(te,he){const de=he.length;return he.length>te.length?!1:A(te,he,0,de)===0}e.startsWithIgnoreCase=k;function U(te,he){const de=Math.min(te.length,he.length);let me;for(me=0;me<de;me++)if(te.charCodeAt(me)!==he.charCodeAt(me))return me;return de}e.commonPrefixLength=U;function $(te,he){const de=Math.min(te.length,he.length);let me;const Se=te.length-1,Pe=he.length-1;for(me=0;me<de;me++)if(te.charCodeAt(Se-me)!==he.charCodeAt(Pe-me))return me;return de}e.commonSuffixLength=$;function G(te){return 55296<=te&&te<=56319}e.isHighSurrogate=G;function W(te){return 56320<=te&&te<=57343}e.isLowSurrogate=W;function V(te,he){return(te-55296<<10)+(he-56320)+65536}e.computeCodePoint=V;function z(te,he,de){const me=te.charCodeAt(de);if(G(me)&&de+1<he){const Se=te.charCodeAt(de+1);if(W(Se))return V(me,Se)}return me}e.getNextCodePoint=z;function j(te,he){const de=te.charCodeAt(he-1);if(W(de)&&he>1){const me=te.charCodeAt(he-2);if(G(me))return V(me,de)}return de}class J{get offset(){return this._offset}constructor(he,de=0){this._str=he,this._len=he.length,this._offset=de}setOffset(he){this._offset=he}prevCodePoint(){const he=j(this._str,this._offset);return this._offset-=he>=65536?2:1,he}nextCodePoint(){const he=z(this._str,this._len,this._offset);return this._offset+=he>=65536?2:1,he}eol(){return this._offset>=this._len}}e.CodePointIterator=J;class ee{get offset(){return this._iterator.offset}constructor(he,de=0){this._iterator=new J(he,de)}nextGraphemeLength(){const he=Te.getInstance(),de=this._iterator,me=de.offset;let Se=he.getGraphemeBreakType(de.nextCodePoint());for(;!de.eol();){const Pe=de.offset,De=he.getGraphemeBreakType(de.nextCodePoint());if(be(Se,De)){de.setOffset(Pe);break}Se=De}return de.offset-me}prevGraphemeLength(){const he=Te.getInstance(),de=this._iterator,me=de.offset;let Se=he.getGraphemeBreakType(de.prevCodePoint());for(;de.offset>0;){const Pe=de.offset,De=he.getGraphemeBreakType(de.prevCodePoint());if(be(De,Se)){de.setOffset(Pe);break}Se=De}return me-de.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ee;function ce(te,he){return new ee(te,he).nextGraphemeLength()}e.nextCharLength=ce;function q(te,he){return new ee(te,he).prevGraphemeLength()}e.prevCharLength=q;function x(te,he){he>0&&W(te.charCodeAt(he))&&he--;const de=he+ce(te,he);return[de-q(te,de),de]}e.getCharContainingOffset=x;function _(te){const he=new ee(te);let de=0;for(;!he.eol();)de++,he.nextGraphemeLength();return de}e.charCount=_;let M;function Y(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function H(te){return M||(M=Y()),M.test(te)}e.containsRTL=H;const Z=/^[\t\n\r\x20-\x7E]*$/;function oe(te){return Z.test(te)}e.isBasicASCII=oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function X(te){return e.UNUSUAL_LINE_TERMINATORS.test(te)}e.containsUnusualLineTerminators=X;function ie(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}e.isFullWidthCharacter=ie;function ne(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}e.isEmojiImprecise=ne;function le(te,he){if(te.length<he)return te;const de=/\b/g;let me=0;for(;de.test(te)&&!(te.length-de.lastIndex<he);)me=de.lastIndex,de.lastIndex+=1;return te.substring(me).replace(/^\s/,"")}e.lcut=le;const ue=/\x1B\x5B[12]?K/g,pe=/\x1b\[\d+m/g,we=/\x1b\[0?m/g;function Ee(te){return te&&(te=te.replace(ue,""),te=te.replace(pe,""),te=te.replace(we,"")),te}e.removeAnsiEscapeCodes=Ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(te){return!!(te&&te.length>0&&te.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function _e(te){return Ce(te)?te.substr(1):te}e.stripUTF8BOM=_e;function Ne(te,he){if(!te||!he||te.length<he.length)return!1;const de=he.length,me=te.toLowerCase();let Se=0,Pe=-1;for(;Se<de;){const De=me.indexOf(he[Se],Pe+1);if(De<0)return!1;Pe=De,Se++}return!0}e.fuzzyContains=Ne;function He(te,he=!1){return te?(he&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}e.containsUppercaseCharacter=He;function Xe(te){return te.charAt(0).toUpperCase()+te.slice(1)}e.uppercaseFirstLetter=Xe;function ae(te,he=1){if(he===0)return"";let de=-1;do de=te.indexOf(`
`,de+1),he--;while(he>0&&de>=0);return de===-1?te:(te[de-1]==="\r"&&de--,te.substr(0,de))}e.getNLines=ae;function fe(te){return te=te%(2*26),te<26?String.fromCharCode(97+te):String.fromCharCode(65+te-26)}e.singleLetterHash=fe;function ge(te){return Te.getInstance().getGraphemeBreakType(te)}e.getGraphemeBreakType=ge;function be(te,he){return te===0?he!==5&&he!==7:te===2&&he===3?!1:te===4||te===2||te===3||he===4||he===2||he===3?!0:!(te===8&&(he===8||he===9||he===11||he===12)||(te===11||te===9)&&(he===9||he===10)||(te===12||te===10)&&he===10||he===5||he===13||he===7||te===1||te===13&&he===14||te===6&&he===6)}var Ie;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(Ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Te{static getInstance(){return Te._INSTANCE||(Te._INSTANCE=new Te),Te._INSTANCE}constructor(){this._data=Re()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const de=this._data,me=de.length/3;let Se=1;for(;Se<=me;)if(he<de[3*Se])Se=2*Se;else if(he>de[3*Se+1])Se=2*Se+1;else return de[3*Se+2];return 0}}Te._INSTANCE=null;function Re(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Fe(te,he){if(te===0)return 0;const de=Oe(te,he);if(de!==void 0)return de;const me=new J(he,te);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=Fe;function Oe(te,he){const de=new J(he,te);let me=de.prevCodePoint();for(;Me(me)||me===65039||me===8419;){if(de.offset===0)return;me=de.prevCodePoint()}if(!ne(me))return;let Se=de.offset;return Se>0&&de.prevCodePoint()===8205&&(Se=de.offset),Se}function Me(te){return 127995<=te&&te<=127999}var We;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),e.noBreakWhitespace="\xA0";class ke{static getInstance(he){return ke.cache.get(Array.from(he))}static getLocales(){return ke._locales.getValue()}constructor(he){this.confusableDictionary=he}isAmbiguous(he){return this.confusableDictionary.has(he)}getPrimaryConfusable(he){return this.confusableDictionary.get(he)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ke,R=ke,ke.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ke.cache=new D.LRUCachedFunction(te=>{function he(Le){const qe=new Map;for(let Ve=0;Ve<Le.length;Ve+=2)qe.set(Le[Ve],Le[Ve+1]);return qe}function de(Le,qe){const Ve=new Map(Le);for(const[et,tt]of qe)Ve.set(et,tt);return Ve}function me(Le,qe){if(!Le)return qe;const Ve=new Map;for(const[et,tt]of Le)qe.has(et)&&Ve.set(et,tt);return Ve}const Se=R.ambiguousCharacterData.getValue();let Pe=te.filter(Le=>!Le.startsWith("_")&&Le in Se);Pe.length===0&&(Pe=["_default"]);let De;for(const Le of Pe){const qe=he(Se[Le]);De=me(De,qe)}const ze=he(Se._common),$e=de(ze,De);return new ke($e)}),ke._locales=new i.Lazy(()=>Object.keys(ke.ambiguousCharacterData.getValue()).filter(te=>!te.startsWith("_")));class Ae{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ae.getRawData())),this._data}static isInvisibleCharacter(he){return Ae.getData().has(he)}static get codePoints(){return Ae.getData()}}e.InvisibleCharacters=Ae,Ae._data=void 0}),define(re[48],se([0,1,12,5,27,15]),function(Q,e,D,i,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function L(s){return s===47||s===92}e.isPathSeparator=L;function P(s){return s.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=P;function I(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=I;function w(s,l=D.posix.sep){if(!s)return"";const a=s.length,g=s.charCodeAt(0);if(L(g)){if(L(s.charCodeAt(1))&&!L(s.charCodeAt(2))){let A=3;const B=A;for(;A<a&&!L(s.charCodeAt(A));A++);if(B!==A&&!L(s.charCodeAt(A+1))){for(A+=1;A<a;A++)if(L(s.charCodeAt(A)))return s.slice(0,A+1).replace(/[\\/]/g,l)}}return l}else if(h(g)&&s.charCodeAt(1)===58)return L(s.charCodeAt(2))?s.slice(0,2)+l:s.slice(0,2);let E=s.indexOf("://");if(E!==-1){for(E+=3;E<a;E++)if(L(s.charCodeAt(E)))return s.slice(0,E+1)}return""}e.getRoot=w;function b(s){if(!i.isWindows||!s||s.length<5)return!1;let l=s.charCodeAt(0);if(l!==92||(l=s.charCodeAt(1),l!==92))return!1;let a=2;const g=a;for(;a<s.length&&(l=s.charCodeAt(a),l!==92);a++);return!(g===a||(l=s.charCodeAt(a+1),isNaN(l)||l===92))}e.isUNC=b;const C=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(s,l=i.isWindows){const a=l?C:S;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||l&&m.test(s)||s==="."||s===".."||l&&s[s.length-1]==="."||l&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=f;function v(s,l,a){const g=s===l;return!a||g?g:!s||!l?!1:(0,R.equalsIgnoreCase)(s,l)}e.isEqual=v;function y(s,l,a,g=D.sep){if(s===l)return!0;if(!s||!l||l.length>s.length)return!1;if(a){if(!(0,R.startsWithIgnoreCase)(s,l))return!1;if(l.length===s.length)return!0;let A=l.length;return l.charAt(l.length-1)===g&&A--,s.charAt(A)===g}return l.charAt(l.length-1)!==g&&(l+=g),s.indexOf(l)===0}e.isEqualOrParent=y;function h(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=h;function p(s,l){return i.isWindows&&s.endsWith(":")&&(s+=D.sep),(0,D.isAbsolute)(s)||(s=(0,D.join)(l,s)),s=(0,D.normalize)(s),i.isWindows?(s=(0,R.rtrim)(s,D.sep),s.endsWith(":")&&(s+=D.sep)):(s=(0,R.rtrim)(s,D.sep),s||(s=D.sep)),s}e.sanitizeFilePath=p;function c(s){const l=(0,D.normalize)(s);return i.isWindows?s.length>3?!1:u(l)&&(s.length===2||l.charCodeAt(2)===92):l===D.posix.sep}e.isRootOrDriveLetter=c;function u(s,l=i.isWindows){return l?h(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function d(s){return u(s)?s[0]:void 0}e.getDriveLetter=d;function n(s,l,a){return l.length>s.length?-1:s===l?0:(a&&(s=s.toLowerCase(),l=l.toLowerCase()),s.indexOf(l))}e.indexOfPath=n;function o(s){const l=s.split(":");let a,g,E;for(const A of l){const B=Number(A);(0,T.isNumber)(B)?g===void 0?g=B:E===void 0&&(E=B):a=a?[a,A].join(":"):A}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:g!==void 0?g:void 0,column:E!==void 0?E:g!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(s,l,a=8){let g="";for(let A=0;A<a;A++)g+=t.charAt(Math.floor(Math.random()*t.length));let E;return l?E=`${l}-${g}`:E=g,s?(0,D.join)(s,E):E}e.randomPath=r}),define(re[66],se([0,1,27]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(h){return R(h,0)}e.hash=i;function R(h,p){switch(typeof h){case"object":return h===null?T(349,p):Array.isArray(h)?I(h,p):w(h,p);case"string":return P(h,p);case"boolean":return L(h,p);case"number":return T(h,p);case"undefined":return T(937,p);default:return T(617,p)}}e.doHash=R;function T(h,p){return(p<<5)-p+h|0}e.numberHash=T;function L(h,p){return T(h?433:863,p)}function P(h,p){p=T(149417,p);for(let c=0,u=h.length;c<u;c++)p=T(h.charCodeAt(c),p);return p}e.stringHash=P;function I(h,p){return p=T(104579,p),h.reduce((c,u)=>R(u,c),p)}function w(h,p){return p=T(181387,p),Object.keys(h).sort().reduce((c,u)=>(c=P(u,c),R(h[u],c)),p)}class b{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=R(p,this._value),this._value}}e.Hasher=b;var C;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function S(h,p,c=32){const u=c-p,d=~((1<<u)-1);return(h<<p|(d&h)>>>u)>>>0}function m(h,p=0,c=h.byteLength,u=0){for(let d=0;d<c;d++)h[p+d]=u}function f(h,p,c="0"){for(;h.length<p;)h=c+h;return h}function v(h,p=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(c=>c.toString(16).padStart(2,"0")).join(""):f((h>>>0).toString(16),p/4)}e.toHexString=v;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const c=p.length;if(c===0)return;const u=this._buff;let d=this._buffLen,n=this._leftoverHighSurrogate,o,t;for(n!==0?(o=n,t=-1,n=0):(o=p.charCodeAt(0),t=0);;){let r=o;if(D.isHighSurrogate(o))if(t+1<c){const s=p.charCodeAt(t+1);D.isLowSurrogate(s)?(t++,r=D.computeCodePoint(o,s)):r=65533}else{n=o;break}else D.isLowSurrogate(o)&&(r=65533);if(d=this._push(u,d,r),t++,t<c)o=p.charCodeAt(t);else break}this._buffLen=d,this._leftoverHighSurrogate=n}_push(p,c,u){return u<128?p[c++]=u:u<2048?(p[c++]=192|(u&1984)>>>6,p[c++]=128|(u&63)>>>0):u<65536?(p[c++]=224|(u&61440)>>>12,p[c++]=128|(u&4032)>>>6,p[c++]=128|(u&63)>>>0):(p[c++]=240|(u&1835008)>>>18,p[c++]=128|(u&258048)>>>12,p[c++]=128|(u&4032)>>>6,p[c++]=128|(u&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=y._bigBlock32,c=this._buffDV;for(let a=0;a<64;a+=4)p.setUint32(a,c.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)p.setUint32(a,S(p.getUint32(a-12,!1)^p.getUint32(a-32,!1)^p.getUint32(a-56,!1)^p.getUint32(a-64,!1),1),!1);let u=this._h0,d=this._h1,n=this._h2,o=this._h3,t=this._h4,r,s,l;for(let a=0;a<80;a++)a<20?(r=d&n|~d&o,s=1518500249):a<40?(r=d^n^o,s=1859775393):a<60?(r=d&n|d&o|n&o,s=2400959708):(r=d^n^o,s=3395469782),l=S(u,5)+r+t+s+p.getUint32(a*4,!1)&4294967295,t=o,o=n,n=S(d,30),d=u,u=l;this._h0=this._h0+u&4294967295,this._h1=this._h1+d&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))}),define(re[87],se([0,1,27]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(i||(i={})),function(R){const T="error",L="warning",P="warn",I="info",w="ignore";function b(S){return S?D.equalsIgnoreCase(T,S)?R.Error:D.equalsIgnoreCase(L,S)||D.equalsIgnoreCase(P,S)?R.Warning:D.equalsIgnoreCase(I,S)?R.Info:R.Ignore:R.Ignore}R.fromValue=b;function C(S){switch(S){case R.Error:return T;case R.Warning:return L;case R.Info:return I;default:return w}}R.toString=C}(i||(i={})),e.default=i}),define(re[49],se([0,1,20,27]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class R{constructor(){this._value="",this._pos=0}reset(m){return this._value=m,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(m){const f=m.charCodeAt(0),v=this._value.charCodeAt(this._pos);return f-v}value(){return this._value[this._pos]}}e.StringIterator=R;class T{constructor(m=!0){this._caseSensitive=m}reset(m){return this._value=m,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let m=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(m)this._from++;else break;else m=!1;return this}cmp(m){return this._caseSensitive?(0,i.compareSubstring)(m,this._value,0,m.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(m,this._value,0,m.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=T;class L{constructor(m=!0,f=!0){this._splitOnBackslash=m,this._caseSensitive=f}reset(m){this._from=0,this._to=0,this._value=m,this._valueLen=m.length;for(let f=m.length-1;f>=0;f--,this._valueLen--){const v=this._value.charCodeAt(f);if(!(v===47||this._splitOnBackslash&&v===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let m=!0;for(;this._to<this._valueLen;this._to++){const f=this._value.charCodeAt(this._to);if(f===47||this._splitOnBackslash&&f===92)if(m)this._from++;else break;else m=!1}return this}cmp(m){return this._caseSensitive?(0,i.compareSubstring)(m,this._value,0,m.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(m,this._value,0,m.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=L;var P;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(P||(P={}));class I{constructor(m,f){this._ignorePathCasing=m,this._ignoreQueryAndFragment=f,this._states=[],this._stateIdx=0}reset(m){return this._value=m,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new L(!1,!this._ignorePathCasing(m)),this._pathIterator.reset(m.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(m)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(m){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(m,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(m,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(m);if(this._states[this._stateIdx]===4)return(0,i.compare)(m,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(m,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=I;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const m=this.right;return this.right=m.left,m.left=this,this.updateHeight(),m.updateHeight(),m}rotateRight(){const m=this.left;return this.left=m.right,m.right=this,this.updateHeight(),m.updateHeight(),m}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(b||(b={}));class C{static forUris(m=()=>!1,f=()=>!1){return new C(new I(m,f))}static forPaths(m=!1){return new C(new L(void 0,!m))}static forStrings(){return new C(new R)}static forConfigKeys(){return new C(new T)}constructor(m){this._iter=m}clear(){this._root=void 0}fill(m,f){if(f){const v=f.slice(0);(0,D.shuffle)(v);for(const y of v)this.set(y,m)}else{const v=m.slice(0);(0,D.shuffle)(v);for(const y of v)this.set(y[0],y[1])}}set(m,f){const v=this._iter.reset(m);let y;this._root||(this._root=new w,this._root.segment=v.value());const h=[];for(y=this._root;;){const c=v.cmp(y.segment);if(c>0)y.left||(y.left=new w,y.left.segment=v.value()),h.push([-1,y]),y=y.left;else if(c<0)y.right||(y.right=new w,y.right.segment=v.value()),h.push([1,y]),y=y.right;else if(v.hasNext())v.next(),y.mid||(y.mid=new w,y.mid.segment=v.value()),h.push([0,y]),y=y.mid;else break}const p=y.value;y.value=f,y.key=m;for(let c=h.length-1;c>=0;c--){const u=h[c][1];u.updateHeight();const d=u.balanceFactor();if(d<-1||d>1){const n=h[c][0],o=h[c+1][0];if(n===1&&o===1)h[c][1]=u.rotateLeft();else if(n===-1&&o===-1)h[c][1]=u.rotateRight();else if(n===1&&o===-1)u.right=h[c+1][1]=h[c+1][1].rotateRight(),h[c][1]=u.rotateLeft();else if(n===-1&&o===1)u.left=h[c+1][1]=h[c+1][1].rotateLeft(),h[c][1]=u.rotateRight();else throw new Error;if(c>0)switch(h[c-1][0]){case-1:h[c-1][1].left=h[c][1];break;case 1:h[c-1][1].right=h[c][1];break;case 0:h[c-1][1].mid=h[c][1];break}else this._root=h[0][1]}}return p}get(m){return this._getNode(m)?.value}_getNode(m){const f=this._iter.reset(m);let v=this._root;for(;v;){const y=f.cmp(v.segment);if(y>0)v=v.left;else if(y<0)v=v.right;else if(f.hasNext())f.next(),v=v.mid;else break}return v}has(m){const f=this._getNode(m);return!(f?.value===void 0&&f?.mid===void 0)}delete(m){return this._delete(m,!1)}deleteSuperstr(m){return this._delete(m,!0)}_delete(m,f){const v=this._iter.reset(m),y=[];let h=this._root;for(;h;){const p=v.cmp(h.segment);if(p>0)y.push([-1,h]),h=h.left;else if(p<0)y.push([1,h]),h=h.right;else if(v.hasNext())v.next(),y.push([0,h]),h=h.mid;else break}if(!!h){if(f?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const p=this._min(h.right);if(p.key){const{key:c,value:u,segment:d}=p;this._delete(p.key,!1),h.key=c,h.value=u,h.segment=d}}else{const p=h.left??h.right;if(y.length>0){const[c,u]=y[y.length-1];switch(c){case-1:u.left=p;break;case 0:u.mid=p;break;case 1:u.right=p;break}}else this._root=p}for(let p=y.length-1;p>=0;p--){const c=y[p][1];c.updateHeight();const u=c.balanceFactor();if(u>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),y[p][1]=c.rotateLeft()):u<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),y[p][1]=c.rotateRight()),p>0)switch(y[p-1][0]){case-1:y[p-1][1].left=y[p][1];break;case 1:y[p-1][1].right=y[p][1];break;case 0:y[p-1][1].mid=y[p][1];break}else this._root=y[0][1]}}}_min(m){for(;m.left;)m=m.left;return m}findSubstr(m){const f=this._iter.reset(m);let v=this._root,y;for(;v;){const h=f.cmp(v.segment);if(h>0)v=v.left;else if(h<0)v=v.right;else if(f.hasNext())f.next(),y=v.value||y,v=v.mid;else break}return v&&v.value||y}findSuperstr(m){const f=this._iter.reset(m);let v=this._root;for(;v;){const y=f.cmp(v.segment);if(y>0)v=v.left;else if(y<0)v=v.right;else if(f.hasNext())f.next(),v=v.mid;else return v.mid?this._entries(v.mid):void 0}}forEach(m){for(const[f,v]of this)m(v,f)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(m){const f=[];return this._dfsEntries(m,f),f[Symbol.iterator]()}_dfsEntries(m,f){!m||(m.left&&this._dfsEntries(m.left,f),m.value&&f.push([m.key,m.value]),m.mid&&this._dfsEntries(m.mid,f),m.right&&this._dfsEntries(m.right,f))}_isBalanced(){const m=f=>{if(!f)return!0;const v=f.balanceFactor();return v<-1||v>1?!1:m(f.left)&&m(f.right)};return m(this._root)}}e.TernarySearchTree=C}),define(re[8],se([0,1,12,5]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,T=/^\//,L=/^\/\//;function P(t,r){if(!t.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!R.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!T.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(t,r){return!t&&!r?"file":t}function w(t,r){switch(t){case"https":case"http":case"file":r?r[0]!==C&&(r=C+r):r=C;break}return r}const b="",C="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(r){return r instanceof m?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,s,l,a,g,E=!1){typeof r=="object"?(this.scheme=r.scheme||b,this.authority=r.authority||b,this.path=r.path||b,this.query=r.query||b,this.fragment=r.fragment||b):(this.scheme=I(r,E),this.authority=s||b,this.path=w(this.scheme,l||b),this.query=a||b,this.fragment=g||b,P(this,E))}get fsPath(){return c(this,!1)}with(r){if(!r)return this;let{scheme:s,authority:l,path:a,query:g,fragment:E}=r;return s===void 0?s=this.scheme:s===null&&(s=b),l===void 0?l=this.authority:l===null&&(l=b),a===void 0?a=this.path:a===null&&(a=b),g===void 0?g=this.query:g===null&&(g=b),E===void 0?E=this.fragment:E===null&&(E=b),s===this.scheme&&l===this.authority&&a===this.path&&g===this.query&&E===this.fragment?this:new v(s,l,a,g,E)}static parse(r,s=!1){const l=S.exec(r);return l?new v(l[2]||b,o(l[4]||b),o(l[5]||b),o(l[7]||b),o(l[9]||b),s):new v(b,b,b,b,b)}static file(r){let s=b;if(i.isWindows&&(r=r.replace(/\\/g,C)),r[0]===C&&r[1]===C){const l=r.indexOf(C,2);l===-1?(s=r.substring(2),r=C):(s=r.substring(2,l),r=r.substring(l)||C)}return new v("file",s,r,b,b)}static from(r){const s=new v(r.scheme,r.authority,r.path,r.query,r.fragment);return P(s,!0),s}static joinPath(r,...s){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return i.isWindows&&r.scheme==="file"?l=m.file(D.win32.join(c(r,!0),...s)).path:l=D.posix.join(r.path,...s),r.with({path:l})}toString(r=!1){return u(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof m)return r;{const s=new v(r);return s._formatted=r.external,s._fsPath=r._sep===f?r.fsPath:null,s}}else return r}}e.URI=m;const f=i.isWindows?1:void 0;class v extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(r=!1){return r?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=f),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(t,r){let s,l=-1;for(let a=0;a<t.length;a++){const g=t.charCodeAt(a);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||r&&g===47)l!==-1&&(s+=encodeURIComponent(t.substring(l,a)),l=-1),s!==void 0&&(s+=t.charAt(a));else{s===void 0&&(s=t.substr(0,a));const E=y[g];E!==void 0?(l!==-1&&(s+=encodeURIComponent(t.substring(l,a)),l=-1),s+=E):l===-1&&(l=a)}}return l!==-1&&(s+=encodeURIComponent(t.substring(l))),s!==void 0?s:t}function p(t){let r;for(let s=0;s<t.length;s++){const l=t.charCodeAt(s);l===35||l===63?(r===void 0&&(r=t.substr(0,s)),r+=y[l]):r!==void 0&&(r+=t[s])}return r!==void 0?r:t}function c(t,r){let s;return t.authority&&t.path.length>1&&t.scheme==="file"?s=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?r?s=t.path.substr(1):s=t.path[1].toLowerCase()+t.path.substr(2):s=t.path,i.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=c;function u(t,r){const s=r?p:h;let l="",{scheme:a,authority:g,path:E,query:A,fragment:B}=t;if(a&&(l+=a,l+=":"),(g||a==="file")&&(l+=C,l+=C),g){let O=g.indexOf("@");if(O!==-1){const N=g.substr(0,O);g=g.substr(O+1),O=N.indexOf(":"),O===-1?l+=s(N,!1):(l+=s(N.substr(0,O),!1),l+=":",l+=s(N.substr(O+1),!1)),l+="@"}g=g.toLowerCase(),O=g.indexOf(":"),O===-1?l+=s(g,!1):(l+=s(g.substr(0,O),!1),l+=g.substr(O))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const O=E.charCodeAt(1);O>=65&&O<=90&&(E=`/${String.fromCharCode(O+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const O=E.charCodeAt(0);O>=65&&O<=90&&(E=`${String.fromCharCode(O+32)}:${E.substr(2)}`)}l+=s(E,!0)}return A&&(l+="?",l+=s(A,!1)),B&&(l+="#",l+=r?B:h(B,!1)),l}function d(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+d(t.substr(3)):t}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(t){return t.match(n)?t.replace(n,r=>d(r)):t}}),define(re[142],se([0,1,8]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function i(w){const b=w;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=i;function R(w){const b=[];let C;try{const S=JSON.parse(w.arguments),m=S[S.length-1];m&&m.__$stack&&(S.pop(),C=m.__$stack),b.push(...S)}catch{b.push("Unable to log remote console arguments",w.arguments)}return{args:b,stack:C}}e.parse=R;function T(w){if(typeof w!="string")return T(R(w).stack);const b=w;if(b){const C=L(b),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(S&&S.length===4)return{uri:D.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=T;function L(w){if(!w)return w;const b=w.indexOf(`
`);return b===-1?w:w.substring(0,b)}function P(w,b){const{args:C,stack:S}=R(w),m=typeof C[0]=="string"&&C.length===1;let f=L(S);f&&(f=`(${f.trim()})`);let v=[];if(typeof C[0]=="string"?f&&m?v=[`%c[${b}] %c${C[0]} %c${f}`,I("blue"),I(""),I("grey")]:v=[`%c[${b}] %c${C[0]}`,I("blue"),I(""),...C.slice(1)]:v=[`%c[${b}]%`,I("blue"),...C],f&&!m&&v.push(f),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,v)}e.log=P;function I(w){return`color: ${w}`}}),define(re[67],se([0,1,17,27,8]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(w){return JSON.stringify(w,P)}e.stringify=T;function L(w){let b=JSON.parse(w);return b=I(b),b}e.parse=L;function P(w,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,i.regExpFlags)(b)}:b}function I(w,b=0){if(!w||b>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return R.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 15:return new Date(w.source)}if(w instanceof D.VSBuffer||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let C=0;C<w.length;++C)w[C]=I(w[C],b+1);else for(const C in w)Object.hasOwnProperty.call(w,C)&&(w[C]=I(w[C],b+1))}return w}e.revive=I}),define(re[22],se([0,1,5,8]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.vscodeUserData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls",I.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}setServerRootPath(w){this._remoteResourcesPath=`${w}/${R.vscodeRemoteResource}`}set(w,b,C){this._hosts[w]=b,this._ports[w]=C}setConnectionToken(w,b){this._connectionTokens[w]=b}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(w){if(this._delegate)return this._delegate(w);const b=w.authority;let C=this._hosts[b];C&&C.indexOf(":")!==-1&&C.indexOf("[")===-1&&(C=`[${C}]`);const S=this._ports[b],m=this._connectionTokens[b];let f=`path=${encodeURIComponent(w.path)}`;return typeof m=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),i.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${C}:${S}`,path:this._remoteResourcesPath,query:f})}}e.RemoteAuthorities=new T;class L{asBrowserUri(w,b){const C=this.toUri(w,b);return C.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===R.file&&(D.isNative||D.isWebWorker&&D.globals.origin===`${R.vscodeFileResource}://${L.FALLBACK_AUTHORITY}`)?C.with({scheme:R.vscodeFileResource,authority:C.authority||L.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(w,b){const C=this.toUri(w,b);return C.scheme===R.vscodeFileResource?C.with({scheme:R.file,authority:C.authority!==L.FALLBACK_AUTHORITY?C.authority:null,query:null,fragment:null}):C}toUri(w,b){return i.URI.isUri(w)?w:i.URI.parse(b.toUrl(w))}}L.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new L;var P;(function(I){const w=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);I.CoopAndCoep=Object.freeze(w.get("3"));const b="vscode-coi";function C(m){let f;typeof m=="string"?f=new URL(m).searchParams:m instanceof URL?f=m.searchParams:i.URI.isUri(m)&&(f=new URL(m.toString(!0)).searchParams);const v=f?.get(b);if(!!v)return w.get(v)}I.getHeadersFromQuery=C;function S(m,f,v){if(!globalThis.crossOriginIsolated)return;const y=f&&v?"3":v?"2":"1";m instanceof URLSearchParams?m.set(b,y):m[b]=y}I.addSearchParam=S})(P=e.COI||(e.COI={}))}),define(re[21],se([0,1,48,22,12,5,27,8]),function(Q,e,D,i,R,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(m){return(0,P.uriToFsPath)(m,!0)}e.originalFSPath=I;class w{constructor(f){this._ignorePathCasing=f}compare(f,v,y=!1){return f===v?0:(0,L.compare)(this.getComparisonKey(f,y),this.getComparisonKey(v,y))}isEqual(f,v,y=!1){return f===v?!0:!f||!v?!1:this.getComparisonKey(f,y)===this.getComparisonKey(v,y)}getComparisonKey(f,v=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,v,y=!1){if(f.scheme===v.scheme){if(f.scheme===i.Schemas.file)return D.isEqualOrParent(I(f),I(v),this._ignorePathCasing(f))&&f.query===v.query&&(y||f.fragment===v.fragment);if((0,e.isEqualAuthority)(f.authority,v.authority))return D.isEqualOrParent(f.path,v.path,this._ignorePathCasing(f),"/")&&f.query===v.query&&(y||f.fragment===v.fragment)}return!1}joinPath(f,...v){return P.URI.joinPath(f,...v)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return R.posix.basename(f.path)}extname(f){return R.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let v;return f.scheme===i.Schemas.file?v=P.URI.file(R.dirname(I(f))).path:(v=R.posix.dirname(f.path),f.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),v="/")),f.with({path:v})}normalizePath(f){if(!f.path.length)return f;let v;return f.scheme===i.Schemas.file?v=P.URI.file(R.normalize(I(f))).path:v=R.posix.normalize(f.path),f.with({path:v})}relativePath(f,v){if(f.scheme!==v.scheme||!(0,e.isEqualAuthority)(f.authority,v.authority))return;if(f.scheme===i.Schemas.file){const p=R.relative(I(f),I(v));return T.isWindows?D.toSlashes(p):p}let y=f.path||"/";const h=v.path||"/";if(this._ignorePathCasing(f)){let p=0;for(const c=Math.min(y.length,h.length);p<c&&!(y.charCodeAt(p)!==h.charCodeAt(p)&&y.charAt(p).toLowerCase()!==h.charAt(p).toLowerCase());p++);y=h.substr(0,p)+y.substr(p)}return R.posix.relative(y,h)}resolvePath(f,v){if(f.scheme===i.Schemas.file){const y=P.URI.file(R.resolve(I(f),v));return f.with({authority:y.authority,path:y.path})}return v=D.toPosixPath(v),f.with({path:R.posix.resolve(f.path,v)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,v){return f===v||f!==void 0&&v!==void 0&&(0,L.equalsIgnoreCase)(f,v)}hasTrailingPathSeparator(f,v=R.sep){if(f.scheme===i.Schemas.file){const y=I(f);return y.length>D.getRoot(y).length&&y[y.length-1]===v}else{const y=f.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,v=R.sep){return(0,e.hasTrailingPathSeparator)(f,v)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,v=R.sep){let y=!1;if(f.scheme===i.Schemas.file){const h=I(f);y=h!==void 0&&h.length===D.getRoot(h).length&&h[h.length-1]===v}else{v="/";const h=f.path;y=h.length===1&&h.charCodeAt(h.length-1)===47}return!y&&!(0,e.hasTrailingPathSeparator)(f,v)?f.with({path:f.path+"/"}):f}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(m=>m.scheme===i.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new w(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function b(m,f){const v=[];for(let y=0;y<m.length;y++){const h=f(m[y]);m.some((p,c)=>c===y?!1:(0,e.isEqualOrParent)(h,f(p)))||v.push(m[y])}return v}e.distinctParents=b;var C;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function f(v){const y=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(c=>{const[u,d]=c.split(":");u&&d&&y.set(u,d)});const p=v.path.substring(0,v.path.indexOf(";"));return p&&y.set(m.META_DATA_MIME,p),y}m.parseMetaData=f})(C=e.DataUri||(e.DataUri={}));function S(m,f,v){if(f){let y=m.path;return y&&y[0]!==R.posix.sep&&(y=R.posix.sep+y),m.with({scheme:v,authority:f,path:y})}return m.with({scheme:v})}e.toLocalResource=S}),define(re[6],se([0,1,24,11,3,2,21,5]),function(Q,e,D,i,R,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(x){return!!x&&typeof x.then=="function"}e.isThenable=I;function w(x){const _=new D.CancellationTokenSource,M=x(_.token),Y=new Promise((H,Z)=>{const oe=_.token.onCancellationRequested(()=>{oe.dispose(),_.dispose(),Z(new i.CancellationError)});Promise.resolve(M).then(X=>{oe.dispose(),_.dispose(),H(X)},X=>{oe.dispose(),_.dispose(),Z(X)})});return new class{cancel(){_.cancel()}then(H,Z){return Y.then(H,Z)}catch(H){return this.then(void 0,H)}finally(H){return Y.finally(H)}}}e.createCancelablePromise=w;function b(x,_,M){return new Promise((Y,H)=>{const Z=_.onCancellationRequested(()=>{Z.dispose(),Y(M)});x.then(Y,H).finally(()=>Z.dispose())})}e.raceCancellation=b;function C(x,_){return new Promise((M,Y)=>{const H=_.onCancellationRequested(()=>{H.dispose(),Y(new i.CancellationError)});x.then(M,Y).finally(()=>H.dispose())})}e.raceCancellationError=C;async function S(x){let _=-1;const M=x.map((H,Z)=>H.then(oe=>(_=Z,oe))),Y=await Promise.race(M);return x.forEach((H,Z)=>{Z!==_&&H.cancel()}),Y}e.raceCancellablePromises=S;function m(x,_,M){let Y;const H=setTimeout(()=>{Y?.(void 0),M?.()},_);return Promise.race([x.finally(()=>clearTimeout(H)),new Promise(Z=>Y=Z)])}e.raceTimeout=m;function f(x){return new Promise((_,M)=>{const Y=x();I(Y)?Y.then(_,M):_(Y)})}e.asPromise=f;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(_){if(this.activePromise){if(this.queuedPromiseFactory=_,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const Y=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Y};this.queuedPromise=new Promise(Y=>{this.activePromise.then(M,M).then(Y)})}return new Promise((M,Y)=>{this.queuedPromise.then(M,Y)})}return this.activePromise=_(),new Promise((M,Y)=>{this.activePromise.then(H=>{this.activePromise=null,M(H)},H=>{this.activePromise=null,Y(H)})})}}e.Throttler=v;class y{constructor(){this.current=Promise.resolve(null)}queue(_){return this.current=this.current.then(()=>_(),()=>_())}}e.Sequencer=y;class h{constructor(){this.promiseMap=new Map}queue(_,M){const H=(this.promiseMap.get(_)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(_)===H&&this.promiseMap.delete(_)});return this.promiseMap.set(_,H),H}}e.SequencerByKey=h;const p=(x,_)=>{let M=!0;const Y=setTimeout(()=>{M=!1,_()},x);return{isTriggered:()=>M,dispose:()=>{clearTimeout(Y),M=!1}}},c=x=>{let _=!0;return queueMicrotask(()=>{_&&(_=!1,x())}),{isTriggered:()=>_,dispose:()=>{_=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class u{constructor(_){this.defaultDelay=_,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(_,M=this.defaultDelay){this.task=_,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((H,Z)=>{this.doResolve=H,this.doReject=Z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const H=this.task;return this.task=null,H()}}));const Y=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=M===e.MicrotaskDelay?c(Y):p(M,Y),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new i.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class d{constructor(_){this.delayer=new u(_),this.throttler=new v}trigger(_,M){return this.delayer.trigger(()=>this.throttler.queue(_),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=d;class n{constructor(){this._isOpen=!1,this._promise=new Promise((_,M)=>{this._completePromise=_})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=n;class o extends n{constructor(_){super(),this._timeout=setTimeout(()=>this.open(),_)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function t(x,_){return _?new Promise((M,Y)=>{const H=setTimeout(()=>{Z.dispose(),M()},x),Z=_.onCancellationRequested(()=>{clearTimeout(H),Z.dispose(),Y(new i.CancellationError)})}):w(M=>t(x,M))}e.timeout=t;function r(x,_=0){const M=setTimeout(x,_);return(0,T.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=r;function s(x){const _=[];let M=0;const Y=x.length;function H(){return M<Y?x[M++]():null}function Z(oe){oe!=null&&_.push(oe);const X=H();return X?X.then(Z):Promise.resolve(_)}return Promise.resolve(null).then(Z)}e.sequence=s;function l(x,_=Y=>!!Y,M=null){let Y=0;const H=x.length,Z=()=>{if(Y>=H)return Promise.resolve(M);const oe=x[Y++];return Promise.resolve(oe()).then(ie=>_(ie)?Promise.resolve(ie):Z())};return Z()}e.first=l;function a(x,_=Y=>!!Y,M=null){if(x.length===0)return Promise.resolve(M);let Y=x.length;const H=()=>{Y=-1;for(const Z of x)Z.cancel?.()};return new Promise((Z,oe)=>{for(const X of x)X.then(ie=>{--Y>=0&&_(ie)?(H(),Z(ie)):Y===0&&Z(M)}).catch(ie=>{--Y>=0&&(H(),oe(ie))})})}e.firstParallel=a;class g{constructor(_){this._size=0,this.maxDegreeOfParalellism=_,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new R.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(_){return this._size++,new Promise((M,Y)=>{this.outstandingPromises.push({factory:_,c:M,e:Y}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const _=this.outstandingPromises.shift();this.runningPromises++;const M=_.factory();M.then(_.c,_.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=g;class E extends g{constructor(){super(1)}}e.Queue=E;class A{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const _=new z;return this.drainers.add(_),_.p}isDrained(){for(const[,_]of this.queues)if(_.size>0)return!1;return!0}queueFor(_,M=L.extUri){const Y=M.getComparisonKey(_);let H=this.queues.get(Y);return H||(H=new E,R.Event.once(H.onDrained)(()=>{H?.dispose(),this.queues.delete(Y),this.onDidQueueDrain()}),this.queues.set(Y,H)),H}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const _ of this.drainers)_.complete();this.drainers.clear()}dispose(){for(const[,_]of this.queues)_.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=A;class B{constructor(_,M){this._token=-1,typeof _=="function"&&typeof M=="number"&&this.setIfNotSet(_,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(_,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,_()},M)}setIfNotSet(_,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,_()},M))}}e.TimeoutTimer=B;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(_,M){this.cancel(),this._token=setInterval(()=>{_()},M)}}e.IntervalTimer=O;class N{constructor(_,M){this.timeoutToken=-1,this.runner=_,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(_=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,_)}get delay(){return this.timeout}set delay(_){this.timeout=_}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=N;class F{constructor(_,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.runner=_,this.timeout=M,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(_=this.timeout){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(_/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=F;class k extends N{constructor(_,M){super(_,M),this.units=[]}work(_){this.units.push(_),this.isScheduled()||this.schedule()}doRun(){const _=this.units;this.units=[],this.runner?.(_)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=k;class U extends T.Disposable{constructor(_,M){super(),this.options=_,this.handler=M,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(_){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+_.length>this.options.maxBufferedWork)return!1}else if(this.pending+_.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(..._),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new N(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=x=>{(0,P.setTimeout0)(()=>{if(_)return;const M=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.runWhenIdle=(x,_)=>{const M=requestIdleCallback(x,typeof _=="number"?{timeout:_}:void 0);let Y=!1;return{dispose(){Y||(Y=!0,cancelIdleCallback(M))}}}}();class ${constructor(_){this._didRun=!1,this._executor=()=>{try{this._value=_()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=$;async function G(x,_,M){let Y;for(let H=0;H<M;H++)try{return await x()}catch(Z){Y=Z,await t(_)}throw Y}e.retry=G;class W{hasPending(_){return this._pending?typeof _=="number"?this._pending.taskId===_:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(_,M,Y){return this._pending={taskId:_,cancel:()=>Y?.(),promise:M},M.then(()=>this.donePending(_),()=>this.donePending(_)),M}donePending(_){this._pending&&_===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const _=this._next;this._next=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this._next)this._next.run=_;else{let M,Y;const H=new Promise((Z,oe)=>{M=Z,Y=oe});this._next={run:_,promise:H,promiseResolve:M,promiseReject:Y}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=W;class V{constructor(_,M=()=>Date.now()){this.interval=_,this.nowFn=M,this.lastIncrementTime=0,this.value=0}increment(){const _=this.nowFn();return _-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=_,this.value=0),this.value++,this.value}}e.IntervalCounter=V;class z{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((_,M)=>{this.completeCallback=_,this.errorCallback=M})}complete(_){return new Promise(M=>{this.completeCallback(_),this.resolved=!0,M()})}error(_){return new Promise(M=>{this.errorCallback(_),this.rejected=!0,M()})}cancel(){new Promise(_=>{this.errorCallback(new i.CancellationError),this.rejected=!0,_()})}}e.DeferredPromise=z;var j;(function(x){async function _(Y){let H;const Z=await Promise.all(Y.map(oe=>oe.then(X=>X,X=>{H||(H=X)})));if(typeof H<"u")throw H;return Z}x.settled=_;function M(Y){return new Promise(async(H,Z)=>{try{await Y(H,Z)}catch(oe){Z(oe)}})}x.withAsyncBody=M})(j=e.Promises||(e.Promises={}));var J;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(J||(J={}));class ee{static fromArray(_){return new ee(M=>{M.emitMany(_)})}static fromPromise(_){return new ee(async M=>{M.emitMany(await _)})}static fromPromises(_){return new ee(async M=>{await Promise.all(_.map(async Y=>M.emitOne(await Y)))})}static merge(_){return new ee(async M=>{await Promise.all(_.map(async Y=>{for await(const H of Y)M.emitOne(H)}))})}constructor(_){this._state=0,this._results=[],this._error=null,this._onStateChanged=new R.Emitter,queueMicrotask(async()=>{const M={emitOne:Y=>this.emitOne(Y),emitMany:Y=>this.emitMany(Y),reject:Y=>this.reject(Y)};try{await Promise.resolve(_(M)),this.resolve()}catch(Y){this.reject(Y)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let _=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(_<this._results.length)return{done:!1,value:this._results[_++]};if(this._state===1)return{done:!0,value:void 0};await R.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(_,M){return new ee(async Y=>{for await(const H of _)Y.emitOne(M(H))})}map(_){return ee.map(this,_)}static filter(_,M){return new ee(async Y=>{for await(const H of _)M(H)&&Y.emitOne(H)})}filter(_){return ee.filter(this,_)}static coalesce(_){return ee.filter(_,M=>!!M)}coalesce(){return ee.coalesce(this)}static async toPromise(_){const M=[];for await(const Y of _)M.push(Y);return M}toPromise(){return ee.toPromise(this)}emitOne(_){this._state===0&&(this._results.push(_),this._onStateChanged.fire())}emitMany(_){this._state===0&&(this._results=this._results.concat(_),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(_){this._state===0&&(this._state=2,this._error=_,this._onStateChanged.fire())}}e.AsyncIterableObject=ee,ee.EMPTY=ee.fromArray([]);class ce extends ee{constructor(_,M){super(M),this._source=_}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ce;function q(x){const _=new D.CancellationTokenSource,M=x(_.token);return new ce(_,async Y=>{const H=_.token.onCancellationRequested(()=>{H.dispose(),_.dispose(),Y.reject(new i.CancellationError)});try{for await(const Z of M){if(_.token.isCancellationRequested)return;Y.emitOne(Z)}H.dispose(),_.dispose()}catch(Z){H.dispose(),_.dispose(),Y.reject(Z)}})}e.createCancelableAsyncIterable=q}),define(re[88],se([0,1,20,6,48,41,12,5,27]),function(Q,e,D,i,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function w(){return Object.create(null)}e.getEmptyExpression=w,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",C="[^/\\\\]",S=/\//g;function m(z,j){switch(z){case 0:return"";case 1:return`${C}*?`;default:return`(?:${b}|${C}+${b}${j?`|${b}${C}+`:""})*?`}}function f(z,j){if(!z)return[];const J=[];let ee=!1,ce=!1,q="";for(const x of z){switch(x){case j:if(!ee&&!ce){J.push(q),q="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}q+=x}return q&&J.push(q),J}e.splitGlobAware=f;function v(z){if(!z)return"";let j="";const J=f(z,e.GLOB_SPLIT);if(J.every(ee=>ee===e.GLOBSTAR))j=".*";else{let ee=!1;J.forEach((ce,q)=>{if(ce===e.GLOBSTAR){if(ee)return;j+=m(2,q===J.length-1)}else{let x=!1,_="",M=!1,Y="";for(const H of ce){if(H!=="}"&&x){_+=H;continue}if(M&&(H!=="]"||!Y)){let Z;H==="-"?Z=H:(H==="^"||H==="!")&&!Y?Z="^":H===e.GLOB_SPLIT?Z="":Z=(0,I.escapeRegExpCharacters)(H),Y+=Z;continue}switch(H){case"{":x=!0;continue;case"[":M=!0;continue;case"}":{j+=`(?:${f(_,",").map(X=>v(X)).join("|")})`,x=!1,_="";break}case"]":{j+="["+Y+"]",M=!1,Y="";break}case"?":j+=C;continue;case"*":j+=m(1);continue;default:j+=(0,I.escapeRegExpCharacters)(H)}}q<J.length-1&&(J[q+1]!==e.GLOBSTAR||q+2<J.length)&&(j+=b)}ee=ce===e.GLOBSTAR})}return j}const y=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new T.LRUCache(1e4),o=function(){return!1},t=function(){return null};function r(z,j){if(!z)return t;let J;typeof z!="string"?J=z.pattern:J=z,J=J.trim();const ee=`${J}_${!!j.trimForExclusions}`;let ce=n.get(ee);if(ce)return s(ce,z);let q;return y.test(J)?ce=a(J.substr(4),J):(q=h.exec(l(J,j)))?ce=g(q[1],J):(j.trimForExclusions?c:p).test(J)?ce=E(J,j):(q=u.exec(l(J,j)))?ce=A(q[1].substr(1),J,!0):(q=d.exec(l(J,j)))?ce=A(q[1],J,!1):ce=B(J),n.set(ee,ce),s(ce,z)}function s(z,j){if(typeof j=="string")return z;const J=function(ee,ce){return(0,R.isEqualOrParent)(ee,j.base,!P.isLinux)?z(ee.substr(j.base.length+1),ce):null};return J.allBasenames=z.allBasenames,J.allPaths=z.allPaths,J.basenames=z.basenames,J.patterns=z.patterns,J}function l(z,j){return j.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function a(z,j){return function(J,ee){return typeof J=="string"&&J.endsWith(z)?j:null}}function g(z,j){const J=`/${z}`,ee=`\\${z}`,ce=function(x,_){return typeof x!="string"?null:_?_===z?j:null:x===z||x.endsWith(J)||x.endsWith(ee)?j:null},q=[z];return ce.basenames=q,ce.patterns=[j],ce.allBasenames=q,ce}function E(z,j){const J=W(z.slice(1,-1).split(",").map(_=>r(_,j)).filter(_=>_!==t),z),ee=J.length;if(!ee)return t;if(ee===1)return J[0];const ce=function(_,M){for(let Y=0,H=J.length;Y<H;Y++)if(J[Y](_,M))return z;return null},q=J.find(_=>!!_.allBasenames);q&&(ce.allBasenames=q.allBasenames);const x=J.reduce((_,M)=>M.allPaths?_.concat(M.allPaths):_,[]);return x.length&&(ce.allPaths=x),ce}function A(z,j,J){const ee=L.sep===L.posix.sep,ce=ee?z:z.replace(S,L.sep),q=L.sep+ce,x=L.posix.sep+z;let _;return J?_=function(M,Y){return typeof M=="string"&&(M===ce||M.endsWith(q)||!ee&&(M===z||M.endsWith(x)))?j:null}:_=function(M,Y){return typeof M=="string"&&(M===ce||!ee&&M===z)?j:null},_.allPaths=[(J?"*/":"./")+z],_}function B(z){try{const j=new RegExp(`^${v(z)}$`);return function(J){return j.lastIndex=0,typeof J=="string"&&j.test(J)?z:null}}catch{return t}}function O(z,j,J){return!z||typeof j!="string"?!1:N(z)(j,void 0,J)}e.match=O;function N(z,j={}){if(!z)return o;if(typeof z=="string"||F(z)){const J=r(z,j);if(J===t)return o;const ee=function(ce,q){return!!J(ce,q)};return J.allBasenames&&(ee.allBasenames=J.allBasenames),J.allPaths&&(ee.allPaths=J.allPaths),ee}return $(z,j)}e.parse=N;function F(z){const j=z;return j?typeof j.base=="string"&&typeof j.pattern=="string":!1}e.isRelativePattern=F;function k(z){return z.allBasenames||[]}e.getBasenameTerms=k;function U(z){return z.allPaths||[]}e.getPathTerms=U;function $(z,j){const J=W(Object.getOwnPropertyNames(z).map(_=>G(_,z[_],j)).filter(_=>_!==t)),ee=J.length;if(!ee)return t;if(!J.some(_=>!!_.requiresSiblings)){if(ee===1)return J[0];const _=function(H,Z){let oe;for(let X=0,ie=J.length;X<ie;X++){const ne=J[X](H,Z);if(typeof ne=="string")return ne;(0,i.isThenable)(ne)&&(oe||(oe=[]),oe.push(ne))}return oe?(async()=>{for(const X of oe){const ie=await X;if(typeof ie=="string")return ie}return null})():null},M=J.find(H=>!!H.allBasenames);M&&(_.allBasenames=M.allBasenames);const Y=J.reduce((H,Z)=>Z.allPaths?H.concat(Z.allPaths):H,[]);return Y.length&&(_.allPaths=Y),_}const ce=function(_,M,Y){let H,Z;for(let oe=0,X=J.length;oe<X;oe++){const ie=J[oe];ie.requiresSiblings&&Y&&(M||(M=(0,L.basename)(_)),H||(H=M.substr(0,M.length-(0,L.extname)(_).length)));const ne=ie(_,M,H,Y);if(typeof ne=="string")return ne;(0,i.isThenable)(ne)&&(Z||(Z=[]),Z.push(ne))}return Z?(async()=>{for(const oe of Z){const X=await oe;if(typeof X=="string")return X}return null})():null},q=J.find(_=>!!_.allBasenames);q&&(ce.allBasenames=q.allBasenames);const x=J.reduce((_,M)=>M.allPaths?_.concat(M.allPaths):_,[]);return x.length&&(ce.allPaths=x),ce}function G(z,j,J){if(j===!1)return t;const ee=r(z,J);if(ee===t)return t;if(typeof j=="boolean")return ee;if(j){const ce=j.when;if(typeof ce=="string"){const q=(x,_,M,Y)=>{if(!Y||!ee(x,_))return null;const H=ce.replace("$(basename)",M),Z=Y(H);return(0,i.isThenable)(Z)?Z.then(oe=>oe?z:null):Z?z:null};return q.requiresSiblings=!0,q}}return ee}function W(z,j){const J=z.filter(_=>!!_.basenames);if(J.length<2)return z;const ee=J.reduce((_,M)=>{const Y=M.basenames;return Y?_.concat(Y):_},[]);let ce;if(j){ce=[];for(let _=0,M=ee.length;_<M;_++)ce.push(j)}else ce=J.reduce((_,M)=>{const Y=M.patterns;return Y?_.concat(Y):_},[]);const q=function(_,M){if(typeof _!="string")return null;if(!M){let H;for(H=_.length;H>0;H--){const Z=_.charCodeAt(H-1);if(Z===47||Z===92)break}M=_.substr(H)}const Y=ee.indexOf(M);return Y!==-1?ce[Y]:null};q.basenames=ee,q.patterns=ce,q.allBasenames=ee;const x=z.filter(_=>!_.basenames);return x.push(q),x}function V(z,j){return(0,D.equals)(z,j,(J,ee)=>typeof J=="string"&&typeof ee=="string"?J===ee:typeof J!="string"&&typeof ee!="string"?J.base===ee.base&&J.pattern===ee.pattern:!1)}e.patternsEquals=V}),define(re[143],se([0,1,8]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(b){return b.toJSON()}class R{constructor(C){this._uriTransformer=C}transformIncoming(C){const S=this._uriTransformer.transformIncoming(C);return S===C?C:i(D.URI.from(S))}transformOutgoing(C){const S=this._uriTransformer.transformOutgoing(C);return S===C?C:i(D.URI.from(S))}transformOutgoingURI(C){const S=this._uriTransformer.transformOutgoing(C);return S===C?C:D.URI.from(S)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function T(b,C,S){if(!b||S>200)return null;if(typeof b=="object"){if(b instanceof D.URI)return C.transformOutgoing(b);for(const m in b)if(Object.hasOwnProperty.call(b,m)){const f=T(b[m],C,S+1);f!==null&&(b[m]=f)}}return null}function L(b,C){const S=T(b,C,0);return S===null?b:S}e.transformOutgoingURIs=L;function P(b,C,S,m){if(!b||m>200)return null;if(typeof b=="object"){if(b.$mid===1)return S?D.URI.revive(C.transformIncoming(b)):C.transformIncoming(b);for(const f in b)if(Object.hasOwnProperty.call(b,f)){const v=P(b[f],C,S,m+1);v!==null&&(b[f]=v)}}return null}function I(b,C){const S=P(b,C,!1,0);return S===null?b:S}e.transformIncomingURIs=I;function w(b,C){const S=P(b,C,!0,0);return S===null?b:S}e.transformAndReviveIncomingURIs=w}),define(re[144],se([0,1,34,11,49,31,130]),function(Q,e,D,i,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(b){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(b)}value(){if(this._value===void 0){let b=0,C=0;const S=(0,D.networkInterfaces)();for(const m in S){const f=S[m];if(f)for(const{mac:v,internal:y}of f)y||(C+=1,this._isVirtualMachineMacAddress(v.toUpperCase())&&(b+=1))}this._value=C>0?b/C:0}return this._value}};let P;async function I(){return P||(P=(async()=>await w()||T.generateUuid())()),P}e.getMachineId=I;async function w(){try{const b=await new Promise((S,m)=>{Q(["crypto"],S,m)}),C=(0,L.getMac)();return b.createHash("sha256").update(C,"utf8").digest("hex")}catch(b){i.onUnexpectedError(b);return}}}),define(re[28],se([0,1,54,34,282,6,48,83,12,5,21,8]),function(Q,e,D,i,R,T,L,P,I,w,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function m($,G=S.UNLINK){if((0,L.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return G===S.UNLINK?v($):f($)}async function f($){try{const G=(0,L.randomPath)((0,i.tmpdir)());try{await D.promises.rename($,G)}catch(W){return W.code==="ENOENT"?void 0:v($)}v(G).catch(W=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function v($){return(0,R.promisify)(D.rm)($,{recursive:!0,force:!0,maxRetries:3})}function y($){if((0,L.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync($,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=y;async function h($,G){return u(await(G?p($):(0,R.promisify)(D.readdir)($)))}async function p($){try{return await(0,R.promisify)(D.readdir)($,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const G=[],W=await h($);for(const V of W){let z=!1,j=!1,J=!1;try{const ee=await e.Promises.lstat((0,I.join)($,V));z=ee.isFile(),j=ee.isDirectory(),J=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}G.push({name:V,isFile:()=>z,isDirectory:()=>j,isSymbolicLink:()=>J})}return G}function c($){return u(D.readdirSync($))}e.readdirSync=c;function u($){return $.map(G=>typeof G=="string"?w.isMacintosh?(0,P.normalizeNFC)(G):G:(G.name=w.isMacintosh?(0,P.normalizeNFC)(G.name):G.name,G))}async function d($){const G=await h($),W=[];for(const V of G)await o.existsDirectory((0,I.join)($,V))&&W.push(V);return W}function n($,G=1e3){return new Promise(W=>{let V=!1;const z=setInterval(()=>{V||(V=!0,D.access($,j=>{V=!1,j&&(clearInterval(z),W(void 0))}))},G)})}e.whenDeleted=n;var o;(function($){async function G(z){let j;try{if(j=await e.Promises.lstat(z),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(z),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(J){if(J.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(w.isWindows&&J.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw ee}throw J}}$.stat=G;async function W(z){try{const{stat:j,symbolicLink:J}=await $.stat(z);return j.isFile()&&J?.dangling!==!0}catch{}return!1}$.existsFile=W;async function V(z){try{const{stat:j,symbolicLink:J}=await $.stat(z);return j.isDirectory()&&J?.dangling!==!0}catch{}return!1}$.existsDirectory=V})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new T.ResourceQueue;function r($,G,W){return t.queueFor(C.URI.file($),b.extUriBiasedIgnorePathCase).queue(()=>{const V=E(W);return new Promise((z,j)=>a($,G,V,J=>J?j(J):z()))})}let s=!0;function l($){s=$}e.configureFlushOnWrite=l;function a($,G,W,V){if(!s)return D.writeFile($,G,{mode:W.mode,flag:W.flag},V);D.open($,W.flag,W.mode,(z,j)=>{if(z)return V(z);D.writeFile(j,G,J=>{if(J)return D.close(j,()=>V(J));D.fdatasync(j,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),l(!1)),D.close(j,ce=>V(ce))))})})}function g($,G,W){const V=E(W);if(!s)return D.writeFileSync($,G,{mode:V.mode,flag:V.flag});const z=D.openSync($,V.flag,V.mode);try{D.writeFileSync(z,G);try{D.fdatasyncSync(z)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),l(!1)}}finally{D.closeSync(z)}}e.writeFileSync=g;function E($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function A($,G){if($!==G)try{await e.Promises.rename($,G)}catch(W){if($.toLowerCase()!==G.toLowerCase()&&W.code==="EXDEV"||$.endsWith("."))await B($,G,{preserveSymlinks:!1}),await m($,S.MOVE);else throw W}}async function B($,G,W){return N($,G,{root:{source:$,target:G},options:W,handledSourcePaths:new Set})}const O=511;async function N($,G,W){if(W.handledSourcePaths.has($))return;W.handledSourcePaths.add($);const{stat:V,symbolicLink:z}=await o.stat($);if(z){if(W.options.preserveSymlinks)try{return await U($,G,W)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(z.dangling)return}return V.isDirectory()?F($,G,V.mode&O,W):k($,G,V.mode&O)}async function F($,G,W,V){await e.Promises.mkdir(G,{recursive:!0,mode:W});const z=await h($);for(const j of z)await N((0,I.join)($,j),(0,I.join)(G,j),V)}async function k($,G,W){await e.Promises.copyFile($,G),await e.Promises.chmod(G,W)}async function U($,G,W){let V=await e.Promises.readlink($);(0,L.isEqualOrParent)(V,W.root.source,!w.isLinux)&&(V=(0,I.join)(W.root.target,V.substr(W.root.source.length+1))),await e.Promises.symlink(V,G)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return($,G,W,V,z)=>new Promise((j,J)=>{D.read($,G,W,V,z,(ee,ce,q)=>ee?J(ee):j({bytesRead:ce,buffer:q}))})}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return($,G,W,V,z)=>new Promise((j,J)=>{D.write($,G,W,V,z,(ee,ce,q)=>ee?J(ee):j({bytesWritten:ce,buffer:q}))})}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists($){try{return await e.Promises.access($),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return d}get writeFile(){return r}get rm(){return m}get move(){return A}get copy(){return B}}}),define(re[145],se([0,1,54,12,5,27,28]),function(Q,e,D,i,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(S){if(R.isLinux)return S;const m=(0,i.dirname)(S);if(S===m)return S;const f=((0,i.basename)(S)||S).toLowerCase();try{const y=(0,L.readdirSync)(m).filter(h=>h.toLowerCase()===f);if(y.length===1){const h=P(m);if(h)return(0,i.join)(h,y[0])}else if(y.length>1){const h=y.indexOf(f);if(h>=0){const p=P(m);if(p)return(0,i.join)(p,y[h])}}}catch{}return null}e.realcaseSync=P;async function I(S){if(R.isLinux)return S;const m=(0,i.dirname)(S);if(S===m)return S;const f=((0,i.basename)(S)||S).toLowerCase();try{const y=(await L.Promises.readdir(m)).filter(h=>h.toLowerCase()===f);if(y.length===1){const h=await I(m);if(h)return(0,i.join)(h,y[0])}else if(y.length>1){const h=y.indexOf(f);if(h>=0){const p=await I(m);if(p)return(0,i.join)(p,y[h])}}}catch{}return null}e.realcase=I;async function w(S){try{return await L.Promises.realpath(S)}catch{const f=C(S);return await L.Promises.access(f,D.constants.R_OK),f}}e.realpath=w;function b(S){try{return D.realpathSync(S)}catch{const f=C(S);return D.accessSync(f,D.constants.R_OK),f}}e.realpathSync=b;function C(S){return(0,T.rtrim)((0,i.normalize)(S),i.sep)}}),define(re[89],se([0,1,34,12,28]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,L=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var I;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(I||(I={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class C{constructor(d,n,o){this.exePath=d,this.displayName=n,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:u=!1}={}){return u?w===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:u=!1,findPreview:d=!1}={}){const n=S({useAlternateBitness:u});if(!n)return null;const o=i.join(n,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(o))return null;let t=-1,r=null;for(const a of await R.Promises.readdir(o)){let g=-1;if(d){const A=a.indexOf("-");if(A<0)continue;const B=a.substring(0,A);if(!T.test(B)||a.substring(A+1)!=="preview")continue;g=parseInt(B,10)}else{if(!T.test(a))continue;g=parseInt(a,10)}if(g<=t)continue;const E=i.join(o,a,"pwsh.exe");!await R.SymlinkSupport.existsFile(E)||(r=E,t=g)}if(!r)return null;const s=n.includes("x86")?" (x86)":"",l=d?" Preview":"";return new C(r,`PowerShell${l}${s}`,!0)}async function f({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const d=i.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(d))return null;const{pwshMsixDirRegex:n,pwshMsixName:o}=u?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const t of await R.Promises.readdir(d))if(n.test(t)){const r=i.join(d,t,"pwsh.exe");return new C(r,o)}return null}function v(){const u=i.join(D.homedir(),".dotnet","tools","pwsh.exe");return new C(u,".NET Core PowerShell Global Tool")}function y(){const u=i.join(process.env.windir,w===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(u,"Windows PowerShell",!0)}async function*h(){let u=await m();u&&(yield u),u=await m({useAlternateBitness:!0}),u&&(yield u),u=await f(),u&&(yield u),u=v(),u&&(yield u),u=await m({findPreview:!0}),u&&(yield u),u=await f({findPreview:!0}),u&&(yield u),u=await m({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=y(),u&&(yield u)}async function*p(){for await(const u of h())await u.exists()&&(yield u)}e.enumeratePowerShellInstallations=p;async function c(){for await(const u of p())return u;return null}e.getFirstAvailablePowerShellInstallation=c}),define(re[90],se([0,1,12,5,36,85,15,28]),function(Q,e,D,i,R,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function I(C=R.env){return C.comspec||"cmd.exe"}e.getWindowsShell=I;function w(C){let S=[],m=!1;const f=function(v){if(m){S.push(v);return}(!C.send(v,h=>{if(h&&console.error(h),m=!1,S.length>0){const p=S.slice(0);S=[],p.forEach(c=>f(c))}})||i.isWindows)&&(m=!0)};return{send:f}}e.createQueuedSender=w;var b;(function(C){async function S(m,f,v){if(D.isAbsolute(m))return m;if(f===void 0&&(f=R.cwd()),D.dirname(m)!=="."||(v===void 0&&L.isString(R.env.PATH)&&(v=R.env.PATH.split(D.delimiter)),v===void 0||v.length===0))return D.join(f,m);async function h(p){if(await P.Promises.exists(p)){let c;try{c=await P.Promises.stat(p)}catch(u){u.message.startsWith("EACCES")&&(c=await P.Promises.lstat(p))}return c?!c.isDirectory():!1}return!1}for(const p of v){let c;if(D.isAbsolute(p)?c=D.join(p,m):c=D.join(f,p,m),await h(c))return c;let u=c+".com";if(await h(u)||(u=c+".exe",await h(u)))return u}return D.join(f,m)}C.findExecutable=S})(b=e.win32||(e.win32={}))}),define(re[146],se([0,1,50,22]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(L){return new Promise((P,I)=>{let w;const b=new Map;function C(m,f,v,y,h){const p=b.get(f);if(m===L||p){const c={name:S(v),cmd:v,pid:m,ppid:f,load:y,mem:h};b.set(m,c),m===L&&(w=c),p&&(p.children||(p.children=[]),p.children.push(c),p.children.length>1&&(p.children=p.children.sort((u,d)=>u.pid-d.pid)))}}function S(m){const f=/--vscode-window-kind=shared-process/,v=/--vscode-window-kind=issue-reporter/,y=/--vscode-window-kind=process-explorer/,h=/--utility-sub-type=network/,p=/--utility-sub-type=node.mojom.NodeService/,c=/--crashes-directory/,u=/\\pipe\\winpty-control/,d=/conhost\.exe/,n=/--type=([a-zA-Z-]+)/;if(c.exec(m))return"electron-crash-reporter";if(u.exec(m))return"winpty-process";if(d.exec(m))return"console-window-host (Windows internal process)";let o=n.exec(m);if(o&&o.length===2){if(o[1]==="renderer")return f.exec(m)?"shared-process":v.exec(m)?"issue-reporter":y.exec(m)?"process-explorer":"window";if(o[1]==="utility"){if(h.exec(m))return"utility-network-service";if(p.exec(m))return"extension-host"}return o[1]}const t=/[a-zA-Z-]+\.js/g;let r="";do o=t.exec(m),o&&(r+=o+" ");while(o);return r&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron_node ${r}`:m}if(process.platform==="win32"){const m=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,v)=>{Q(["windows-process-tree"],f,v)}).then(f=>{f.getProcessList(L,v=>{if(!v){I(new Error(`Root process ${L} not found`));return}f.getProcessCpuUsage(v,y=>{const h=new Map;y.forEach(p=>{const c=m(p.commandLine||"");h.set(p.pid,{name:S(c),cmd:c,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),w=h.get(L),w?(h.forEach(p=>{const c=h.get(p.ppid);c&&(c.children||(c.children=[]),c.children.push(p))}),h.forEach(p=>{p.children&&(p.children=p.children.sort((c,u)=>c.pid-u.pid))}),P(w)):I(new Error(`Root process ${L} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let m=function(){let f=[w];const v=[];for(;f.length;){const h=f.shift();h&&(v.push(h.pid),h.children&&(f=f.concat(h.children)))}let y=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Q).fsPath);y+=" "+v.join(" "),(0,D.exec)(y,{},(h,p,c)=>{if(h||c)I(h||new Error(c.toString()));else{const u=p.toString().split(`
`);for(let d=0;d<v.length;d++){const n=b.get(v[d]);n.load=parseFloat(u[d])}if(!w){I(new Error(`Root process ${L} not found`));return}P(w)}})};(0,D.exec)("which ps",{},(f,v,y)=>{if(f||y)if(process.platform!=="linux")I(f||new Error(y.toString()));else{const h=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/ps.sh",Q).fsPath);(0,D.exec)(h,{},(p,c,u)=>{p||u?I(p||new Error(u.toString())):(T(c,C),m())})}else{const h=v.toString().trim(),p="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${h} ${p}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,u,d)=>{c||d&&!d.includes("screen size is bogus")?I(c||new Error(d.toString())):(T(u,C),process.platform==="linux"?m():w?P(w):I(new Error(`Root process ${L} not found`)))})}})}})}e.listProcesses=R;function T(L,P){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=L.toString().split(`
`);for(const b of w){const C=I.exec(b.trim());C&&C.length===6&&P(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}}),define(re[147],se([0,1,34,5,89,90]),function(Q,e,D,i,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function L(m,f){return m===1?i.isWindows?C():T.getWindowsShell(f):w(m,f)}e.getSystemShell=L;function P(m,f){return m===1?i.isWindows?S(f):T.getWindowsShell(f):w(m,f)}e.getSystemShellSync=P;let I=null;function w(m,f){if(i.isLinux&&m===2||i.isMacintosh&&m===3)return"/bin/bash";if(!I){let v;if(i.isWindows)v="/bin/bash";else{if(v=f.SHELL,!v)try{v=(0,D.userInfo)().shell}catch{}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}I=v}return I}let b=null;async function C(){return b||(b=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),b}function S(m){if(b)return b;const f=i.isWindows&&parseFloat((0,D.release)())>=10,v=m.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${m.windir}\\${v?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?y:T.getWindowsShell(m)}});var ve=this&&this.__decorate||function(Q,e,D,i){var R=arguments.length,T=R<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,D):i,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(Q,e,D,i);else for(var P=Q.length-1;P>=0;P--)(L=Q[P])&&(T=(R<3?L(T):R>3?L(e,D,T):L(e,D))||T);return R>3&&T&&Object.defineProperty(e,D,T),T};define(re[38],se([0,1,20,6,17,24,63,11,3,2,67,27,15]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function f(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function y(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(h||(h={}));class p{constructor(j){this.buffer=j,this.pos=0}read(j){const J=this.buffer.slice(this.pos,this.pos+j);return this.pos+=J.byteLength,J}}class c{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(j){this.buffers.push(j)}}var u;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(u||(u={}));function d(z){const j=R.VSBuffer.alloc(4);return j.writeUInt32BE(z,0),j}function n(z){return z.read(4).readUInt32BE(0)}function o(z){const j=R.VSBuffer.alloc(1);return j.writeUInt8(z,0),j}const t={Undefined:o(u.Undefined),String:o(u.String),Buffer:o(u.Buffer),VSBuffer:o(u.VSBuffer),Array:o(u.Array),Object:o(u.Object)},r=typeof Buffer<"u";function s(z,j){if(typeof j>"u")z.write(t.Undefined);else if(typeof j=="string"){const J=R.VSBuffer.fromString(j);z.write(t.String),z.write(d(J.byteLength)),z.write(J)}else if(r&&Buffer.isBuffer(j)){const J=R.VSBuffer.wrap(j);z.write(t.Buffer),z.write(d(J.byteLength)),z.write(J)}else if(j instanceof R.VSBuffer)z.write(t.VSBuffer),z.write(d(j.byteLength)),z.write(j);else if(Array.isArray(j)){z.write(t.Array),z.write(d(j.length));for(const J of j)s(z,J)}else{const J=R.VSBuffer.fromString(JSON.stringify(j));z.write(t.Object),z.write(d(J.byteLength)),z.write(J)}}function l(z){switch(z.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return z.read(n(z)).toString();case u.Buffer:return z.read(n(z)).buffer;case u.VSBuffer:return z.read(n(z));case u.Array:{const J=n(z),ee=[];for(let ce=0;ce<J;ce++)ee.push(l(z));return ee}case u.Object:return JSON.parse(z.read(n(z)).toString())}}class a{constructor(j,J,ee=null,ce=1e3){this.protocol=j,this.ctx=J,this.logger=ee,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(q=>this.onRawMessage(q)),this.sendResponse({type:200})}registerChannel(j,J){this.channels.set(j,J),setTimeout(()=>this.flushPendingRequests(j),0)}sendResponse(j){switch(j.type){case 200:{const J=this.send([j.type]);this.logger?.logOutgoing(J,0,1,y(j.type));return}case 201:case 202:case 204:case 203:{const J=this.send([j.type,j.id],j.data);this.logger?.logOutgoing(J,j.id,1,y(j.type),j.data);return}}}send(j,J=void 0){const ee=new c;return s(ee,j),s(ee,J),this.sendBuffer(ee.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onRawMessage(j){const J=new p(j),ee=l(J),ce=l(J),q=ee[0];switch(q){case 100:return this.logger?.logIncoming(j.byteLength,ee[1],1,`${f(q)}: ${ee[2]}.${ee[3]}`,ce),this.onPromise({type:q,id:ee[1],channelName:ee[2],name:ee[3],arg:ce});case 102:return this.logger?.logIncoming(j.byteLength,ee[1],1,`${f(q)}: ${ee[2]}.${ee[3]}`,ce),this.onEventListen({type:q,id:ee[1],channelName:ee[2],name:ee[3],arg:ce});case 101:return this.logger?.logIncoming(j.byteLength,ee[1],1,`${f(q)}`),this.disposeActiveRequest({type:q,id:ee[1]});case 103:return this.logger?.logIncoming(j.byteLength,ee[1],1,`${f(q)}`),this.disposeActiveRequest({type:q,id:ee[1]})}}onPromise(j){const J=this.channels.get(j.channelName);if(!J){this.collectPendingRequest(j);return}const ee=new T.CancellationTokenSource;let ce;try{ce=J.call(this.ctx,j.name,j.arg,ee.token)}catch(_){ce=Promise.reject(_)}const q=j.id;ce.then(_=>{this.sendResponse({id:q,data:_,type:201}),this.activeRequests.delete(j.id)},_=>{_ instanceof Error?this.sendResponse({id:q,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:q,data:_,type:203}),this.activeRequests.delete(j.id)});const x=(0,w.toDisposable)(()=>ee.cancel());this.activeRequests.set(j.id,x)}onEventListen(j){const J=this.channels.get(j.channelName);if(!J){this.collectPendingRequest(j);return}const ee=j.id,q=J.listen(this.ctx,j.name,j.arg)(x=>this.sendResponse({id:ee,data:x,type:204}));this.activeRequests.set(j.id,q)}disposeActiveRequest(j){const J=this.activeRequests.get(j.id);J&&(J.dispose(),this.activeRequests.delete(j.id))}collectPendingRequest(j){let J=this.pendingRequests.get(j.channelName);J||(J=[],this.pendingRequests.set(j.channelName,J));const ee=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.sendResponse({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);J.push({request:j,timeoutTimer:ee})}flushPendingRequests(j){const J=this.pendingRequests.get(j);if(J){for(const ee of J)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.onPromise(ee.request);break;case 102:this.onEventListen(ee.request);break}this.pendingRequests.delete(j)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,w.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var g;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(j,J=null){this.protocol=j,this.isDisposed=!1,this.state=h.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new I.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ee=>this.onBuffer(ee)),this.logger=J}getChannel(j){const J=this;return{call(ee,ce,q){return J.isDisposed?Promise.reject(new P.CancellationError):J.requestPromise(j,ee,ce,q)},listen(ee,ce){return J.isDisposed?I.Event.None:J.requestEvent(j,ee,ce)}}}requestPromise(j,J,ee,ce=T.CancellationToken.None){const q=this.lastRequestId++,_={id:q,type:100,channelName:j,name:J,arg:ee};if(ce.isCancellationRequested)return Promise.reject(new P.CancellationError);let M;return new Promise((H,Z)=>{if(ce.isCancellationRequested)return Z(new P.CancellationError);const oe=()=>{const le=ue=>{switch(ue.type){case 201:this.handlers.delete(q),H(ue.data);break;case 202:{this.handlers.delete(q);const pe=new Error(ue.data.message);pe.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,pe.name=ue.data.name,Z(pe);break}case 203:this.handlers.delete(q),Z(ue.data);break}};this.handlers.set(q,le),this.sendRequest(_)};let X=null;this.state===h.Idle?oe():(X=(0,i.createCancelablePromise)(le=>this.whenInitialized()),X.then(()=>{X=null,oe()}));const ie=()=>{X?(X.cancel(),X=null):this.sendRequest({id:q,type:101}),Z(new P.CancellationError)},ne=ce.onCancellationRequested(ie);M=(0,w.combinedDisposable)((0,w.toDisposable)(ie),ne),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(j,J,ee){const ce=this.lastRequestId++,x={id:ce,type:102,channelName:j,name:J,arg:ee};let _=null;const M=new I.Emitter({onFirstListenerAdd:()=>{_=(0,i.createCancelablePromise)(H=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(M),this.sendRequest(x)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(M),this.sendRequest({id:ce,type:103}))}}),Y=H=>M.fire(H.data);return this.handlers.set(ce,Y),M.event}sendRequest(j){switch(j.type){case 100:case 102:{const J=this.send([j.type,j.id,j.channelName,j.name],j.arg);this.logger?.logOutgoing(J,j.id,0,`${f(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const J=this.send([j.type,j.id]);this.logger?.logOutgoing(J,j.id,0,f(j.type));return}}}send(j,J=void 0){const ee=new c;return s(ee,j),s(ee,J),this.sendBuffer(ee.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onBuffer(j){const J=new p(j),ee=l(J),ce=l(J),q=ee[0];switch(q){case 200:return this.logger?.logIncoming(j.byteLength,0,0,y(q)),this.onResponse({type:ee[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(j.byteLength,ee[1],0,y(q),ce),this.onResponse({type:ee[0],id:ee[1],data:ce})}}onResponse(j){if(j.type===200){this.state=h.Idle,this._onDidInitialize.fire();return}this.handlers.get(j.id)?.(j)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,w.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ve([L.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class A{get connections(){const j=[];return this._connections.forEach(J=>j.push(J)),j}constructor(j){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new I.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new I.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,j(({protocol:J,onDidClientDisconnect:ee})=>{I.Event.once(J.onMessage)(q=>{const x=new p(q),_=l(x),M=new a(J,_),Y=new E(J);this.channels.forEach((Z,oe)=>M.registerChannel(oe,Z));const H={channelServer:M,channelClient:Y,ctx:_};this._connections.add(H),this._onDidAddConnection.fire(H),ee(()=>{M.dispose(),Y.dispose(),this._connections.delete(H),this._onDidRemoveConnection.fire(H)})})})}getChannel(j,J){const ee=this;return{call(ce,q,x){let _;if((0,S.isFunction)(J)){const Y=(0,D.getRandomElement)(ee.connections.filter(J));_=Y?Promise.resolve(Y):I.Event.toPromise(I.Event.filter(ee.onDidAddConnection,J))}else _=J.routeCall(ee,ce,q);const M=_.then(Y=>Y.channelClient.getChannel(j));return O(M).call(ce,q,x)},listen(ce,q){if((0,S.isFunction)(J))return ee.getMulticastEvent(j,J,ce,q);const x=J.routeEvent(ee,ce,q).then(_=>_.channelClient.getChannel(j));return O(x).listen(ce,q)}}}getMulticastEvent(j,J,ee,ce){const q=this;let x=new w.DisposableStore;const _=new I.Emitter({onFirstListenerAdd:()=>{x=new w.DisposableStore;const M=new I.EventMultiplexer,Y=new Map,H=oe=>{const ie=oe.channelClient.getChannel(j).listen(ee,ce),ne=M.add(ie);Y.set(oe,ne)},Z=oe=>{const X=Y.get(oe);!X||(X.dispose(),Y.delete(oe))};q.connections.filter(J).forEach(H),I.Event.filter(q.onDidAddConnection,J)(H,void 0,x),q.onDidRemoveConnection(Z,void 0,x),M.event(_.fire,_,x),x.add(M)},onLastListenerRemove:()=>{x.dispose()}});return _.event}registerChannel(j,J){this.channels.set(j,J),this._connections.forEach(ee=>{ee.channelServer.registerChannel(j,J)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class B{constructor(j,J,ee=null){const ce=new c;s(ce,J),j.send(ce.buffer),this.channelClient=new E(j,ee),this.channelServer=new a(j,J,ee)}getChannel(j){return this.channelClient.getChannel(j)}registerChannel(j,J){this.channelServer.registerChannel(j,J)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=B;function O(z){return{call(j,J,ee){return z.then(ce=>ce.call(j,J,ee))},listen(j,J){const ee=new I.Relay;return z.then(ce=>ee.input=ce.listen(j,J)),ee.event}}}e.getDelayedChannel=O;function N(z){let j=!1;return{call(J,ee,ce){return j?z.call(J,ee,ce):(0,i.timeout)(0).then(()=>j=!0).then(()=>z.call(J,ee,ce))},listen(J,ee){if(j)return z.listen(J,ee);const ce=new I.Relay;return(0,i.timeout)(0).then(()=>j=!0).then(()=>ce.input=z.listen(J,ee)),ce.event}}}e.getNextTickChannel=N;class F{constructor(j){this.fn=j}routeCall(j){return this.route(j)}routeEvent(j){return this.route(j)}async route(j){for(const J of j.connections)if(await Promise.resolve(this.fn(J.ctx)))return Promise.resolve(J);return await I.Event.toPromise(j.onDidAddConnection),await this.route(j)}}e.StaticRouter=F;var k;(function(z){function j(q,x){const _=q,M=x&&x.disableMarshalling,Y=new Map;for(const H in _)ee(H)&&Y.set(H,I.Event.buffer(_[H],!0));return new class{listen(H,Z,oe){const X=Y.get(Z);if(X)return X;if(ce(Z)){const ie=_[Z];if(typeof ie=="function")return ie.call(_,oe)}throw new Error(`Event not found: ${Z}`)}call(H,Z,oe){const X=_[Z];if(typeof X=="function"){if(!M&&Array.isArray(oe))for(let ie=0;ie<oe.length;ie++)oe[ie]=(0,b.revive)(oe[ie]);return X.apply(_,oe)}throw new Error(`Method not found: ${Z}`)}}}z.fromService=j;function J(q,x){const _=x&&x.disableMarshalling;return new Proxy({},{get(M,Y){if(typeof Y=="string")return x?.properties?.has(Y)?x.properties.get(Y):ce(Y)?function(H){return q.listen(Y,H)}:ee(Y)?q.listen(Y):async function(...H){let Z;x&&!(0,S.isUndefinedOrNull)(x.context)?Z=[x.context,...H]:Z=H;const oe=await q.call(Y,Z);return _?oe:(0,b.revive)(oe)};throw new Error(`Property not found: ${String(Y)}`)}})}z.toService=J;function ee(q){return q[0]==="o"&&q[1]==="n"&&C.isUpperAsciiLetter(q.charCodeAt(2))}function ce(q){return/^onDynamic/.test(q)&&C.isUpperAsciiLetter(q.charCodeAt(9))}})(k=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const j=z.toString();if(j!=="[object Object]")return j}return z}function G(z){return Array.isArray(z)?z.map($):$(z)}function W(z,j,J,ee,ce,q,x){x=G(x);const _=U[ce],M=_[ee%_.length];let Y=[`%c[${z}]%c[${String(j).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${q}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(q)?(Y=Y.concat(x),Y.push(")")):Y.push(x),console.log.apply(console,Y)}e.logWithColors=W;class V{constructor(j,J){this._outgoingPrefix=j,this._incomingPrefix=J,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(j,J,ee,ce,q){this._totalOutgoing+=j,W(this._outgoingPrefix,this._totalOutgoing,j,J,ee,ce,q)}logIncoming(j,J,ee,ce,q){this._totalIncoming+=j,W(this._incomingPrefix,this._totalIncoming,j,J,ee,ce,q)}}e.IPCLogger=V}),define(re[148],se([0,1,17,3,38]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(I){this.port=I,this.onMessage=i.Event.fromDOMEventEmitter(this.port,"message",w=>D.VSBuffer.wrap(w.data)),I.start()}send(I){this.port.postMessage(I.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class L extends R.IPCClient{constructor(I,w){const b=new T(I);super(b,w),this.protocol=b}dispose(){this.protocol.disconnect()}}e.Client=L}),define(re[91],se([0,1,17,3,2,38]),function(Q,e,D,i,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(L=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(r){r.enableDiagnostics=!1,r.records=[];const s=new WeakMap;let l=0;function a(E,A){if(!s.has(E)){const B=String(++l);s.set(E,B)}return s.get(E)}function g(E,A,B,O){if(!r.enableDiagnostics)return;const N=a(E,A);if(O instanceof D.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const F=D.VSBuffer.alloc(O.byteLength);F.set(O),r.records.push({timestamp:Date.now(),id:N,label:A,type:B,buff:F})}else r.records.push({timestamp:Date.now(),id:N,label:A,type:B,data:O})}r.traceSocketEvent=g})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var I;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(I=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function b(){return w||(w=D.VSBuffer.alloc(0)),w}class C{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,l){if(s===0)return b();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const A=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=s),A}if(this._chunks[0].byteLength>s){const A=this._chunks[0].slice(0,s);return l&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),A}const a=D.VSBuffer.alloc(s);let g=0,E=0;for(;s>0;){const A=this._chunks[E];if(A.byteLength>s){const B=A.slice(0,s);a.set(B,g),g+=s,l&&(this._chunks[E]=A.slice(s),this._totalLength-=s),s-=s}else a.set(A,g),g+=A.byteLength,l?(this._chunks.shift(),this._totalLength-=A.byteLength):E++,s-=A.byteLength}return a}}e.ChunkStream=C;var S;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(S||(S={}));function m(r){switch(r){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var f;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class v{constructor(s,l,a,g){this.type=s,this.id=l,this.ack=a,this.data=g,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends R.Disposable{constructor(s){super(),this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:m(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,g=this._state.id,E=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",l),this._onMessage.fire(new v(a,g,E,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class h{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=D.VSBuffer.alloc(13);l.writeUInt8(s.type,0),l.writeUInt32BE(s.id,1),l.writeUInt32BE(s.ack,5),l.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:m(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(l,s.data)}_bufferAdd(s,l){const a=this._totalLength===0;return this._data.push(s,l),this._totalLength+=s.byteLength+l.byteLength,a}_bufferTake(){const s=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,l){this._bufferAdd(s,l)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class p extends R.Disposable{constructor(s){super(),this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new h(this._socket)),this._socketReader=this._register(new y(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new v(1,0,0,s))}}e.Protocol=p;class c extends T.IPCClient{static fromSocket(s,l){return new c(new p(s),l)}get onDidDispose(){return this.protocol.onDidDispose}constructor(s,l,a=null){super(s,l,a),this.protocol=s}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=c;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class d{constructor(s){this.data=s,this.next=null}}class n{constructor(){this._first=null,this._last=null}length(){let s=0,l=this._first;for(;l;)l=l.next,s++;return s}peek(){return this._first?this._first.data:null}toArray(){const s=[];let l=0,a=this._first;for(;a;)s[l++]=a.data,a=a.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const l=new d(s);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class o{static getInstance(){return o._INSTANCE||(o._INSTANCE=new o),o._INSTANCE}constructor(){this.lastRuns=[];const s=Date.now();for(let l=0;l<o._HISTORY_LENGTH;l++)this.lastRuns[l]=s-1e3*l;setInterval(()=>{for(let l=o._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}load(){const s=Date.now(),l=(1+o._HISTORY_LENGTH)*1e3;let a=0;for(let g=0;g<o._HISTORY_LENGTH;g++)s-this.lastRuns[g]<=l&&a++;return 1-a/o._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}o._HISTORY_LENGTH=10,o._INSTANCE=null;class t{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(s,l=null,a=o.getInstance()){this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new n,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(g=>this._receiveMessage(g))),this._socketDisposables.push(this._socket.onClose(g=>this._onSocketClose.fire(g))),l&&this._socketReader.acceptChunk(l),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new v(5,0,0,b());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new v(7,0,0,b());this._socketWriter.write(s)}sendResume(){const s=new v(8,0,0,b());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,l){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new h(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new v(3,0,this._incomingAckId,b());this._socketWriter.write(s);const l=this._outgoingUnackMsg.toArray();for(let a=0,g=l.length;a<g;a++)this._socketWriter.write(l[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new v(6,0,0,b())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const l=this._outgoingUnackMsg.toArray();for(let a=0,g=l.length;a<g;a++)this._socketWriter.write(l[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new v(1,l,this._incomingAckId,s);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(s){const l=new v(2,0,0,s);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),l=Date.now()-s.writtenTime,a=Date.now()-this._socketReader.lastReadTime,g=Date.now()-this._lastSocketTimeoutTime;if(l>=2e4&&a>=2e4&&g>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:a});return}const E=Math.max(2e4-l,2e4-a,2e4-g,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},E)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new v(3,0,this._incomingAckId,b());this._socketWriter.write(s)}_sendKeepAlive(){const s=new v(9,0,0,b());this._socketWriter.write(s)}}e.PersistentProtocol=t}),define(re[149],se([0,1,92,3,38,148]),function(Q,e,D,i,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class L extends R.IPCServer{static getOnDidClientConnect(){const I=i.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(w,b)=>b);return i.Event.map(I,w=>{const{port1:b,port2:C}=new MessageChannel,m={protocol:new T.Protocol(b),onDidClientDisconnect:i.Event.fromDOMEventEmitter(b,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",w,[C]),m})}constructor(){super(L.getOnDidClientConnect())}}e.Server=L}),define(re[68],se([0,1,50,6,17,24,142,11,3,2,32,90,85,38]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends m.ChannelServer{constructor(h){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",p=>R.VSBuffer.wrap(Buffer.from(p,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.Server=f;class v{constructor(h,p){this.modulePath=h,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new I.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new i.Delayer(c),this.child=null,this._client=null}getChannel(h){const p=this;return{call(c,u,d){return p.requestPromise(h,c,u,d)},listen(c,u){return p.requestEvent(h,c,u)}}}requestPromise(h,p,c,u=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const d=this.getCachedChannel(h),n=(0,i.createCancelablePromise)(r=>d.call(p,c,r)),o=u.onCancellationRequested(()=>n.cancel()),t=(0,w.toDisposable)(()=>n.cancel());return this.activeRequests.add(t),n.finally(()=>{o.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),n}requestEvent(h,p,c){if(!this.disposeDelayer)return I.Event.None;this.disposeDelayer.cancel();let u;const d=new I.Emitter({onFirstListenerAdd:()=>{u=this.getCachedChannel(h).listen(p,c)(d.fire,d),this.activeRequests.add(u)},onLastListenerRemove:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return d.event}get client(){if(!this._client){const h=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,S.removeDangerousEnvVariables)(p.env),this.child=(0,D.fork)(this.modulePath,h,p);const c=new I.Emitter;I.Event.fromNodeEventEmitter(this.child,"message",s=>s)(s=>{if((0,L.isRemoteConsoleLog)(s)){(0,L.log)(s,`IPC Library: ${this.options.serverName}`);return}c.fire(R.VSBuffer.wrap(Buffer.from(s,"base64")))});const d=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,n=s=>this.child&&this.child.connected&&d.send(s.buffer.toString("base64")),o=c.event,t={send:n,onMessage:o};this._client=new m.ChannelClient(t);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",s=>console.warn('IPC "'+this.options.serverName+'" errored with '+s)),this.child.on("exit",(s,l)=>{process.removeListener("exit",r),this.activeRequests.forEach(a=>(0,w.dispose)(a)),this.activeRequests.clear(),s!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+s+" and signal "+l),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:s,signal:l})})}return this._client}getCachedChannel(h){let p=this.channels.get(h);return p||(p=this.client.getChannel(h),this.channels.set(h,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=v}),define(re[150],se([0,1,17,11,3,2,12,5,31,38,91]),function(Q,e,D,i,R,T,L,P,I,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function C(){return{crypto:Q.__$__nodeRequire("crypto"),zlib:Q.__$__nodeRequire("zlib"),net:Q.__$__nodeRequire("net"),os:Q.__$__nodeRequire("os")}}class S{traceSocketEvent(a,g){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,g)}constructor(a,g=""){this._canWrite=!0,this.debugLabel=g,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=E=>{if(this.traceSocketEvent("error",{code:E?.code,message:E?.message}),E){if(E.code==="EPIPE")return;(0,i.onUnexpectedError)(E)}},this.socket.on("error",this._errorListener),this._closeListener=E=>{this.traceSocketEvent("close",{hadError:E}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(a){const g=E=>{this.traceSocketEvent("read",E),a(D.VSBuffer.wrap(E))};return this.socket.on("data",g),{dispose:()=>this.socket.off("data",g)}}onClose(a){const g=E=>{a({type:0,hadError:E,error:void 0})};return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(a){const g=()=>{a()};return this.socket.on("end",g),{dispose:()=>this.socket.off("end",g)}}write(a){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,g=>{if(g){if(g.code==="EPIPE")return;(0,i.onUnexpectedError)(g)}})}catch(g){if(g.code==="EPIPE")return;(0,i.onUnexpectedError)(g)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,g)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const E=()=>{this.socket.off("close",E),this.socket.off("end",E),this.socket.off("error",E),this.socket.off("timeout",E),this.socket.off("drain",E),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",E),this.socket.on("end",E),this.socket.on("error",E),this.socket.on("timeout",E),this.socket.on("drain",E)})}}e.NodeSocket=S;var m;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(m||(m={}));var f;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(f||(f={}));class v extends T.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(a,g){this.socket.traceSocketEvent(a,g)}constructor(a,g,E,A){super(),this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:g,inflateBytesLength:E?.byteLength||0,recordInflateBytes:A}),this._flowManager=this._register(new y(this,g,E,A,this._onData,(B,O)=>this._write(B,O))),this._register(this._flowManager.onError(B=>{console.error(B),(0,i.onUnexpectedError)(B),this._onClose.fire({type:0,hadError:!0,error:B})})),this._incomingData=new b.ChunkStream,this._register(this.socket.onData(B=>this._acceptChunk(B))),this._register(this.socket.onClose(B=>this._onClose.fire(B)))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this._onData.event(a)}onClose(a){return this._onClose.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this._flowManager.writeMessage(a)}_write(a,g){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let E=2;a.byteLength<126?E+=0:a.byteLength<2**16?E+=2:E+=8;const A=D.VSBuffer.alloc(E);if(g?A.writeUInt8(194,0):A.writeUInt8(130,0),a.byteLength<126)A.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){A.writeUInt8(126,1);let B=1;A.writeUInt8(a.byteLength>>>8&255,++B),A.writeUInt8(a.byteLength>>>0&255,++B)}else{A.writeUInt8(127,1);let B=1;A.writeUInt8(0,++B),A.writeUInt8(0,++B),A.writeUInt8(0,++B),A.writeUInt8(0,++B),A.writeUInt8(a.byteLength>>>24&255,++B),A.writeUInt8(a.byteLength>>>16&255,++B),A.writeUInt8(a.byteLength>>>8&255,++B),A.writeUInt8(a.byteLength>>>0&255,++B)}this.socket.write(D.VSBuffer.concat([A,a]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(a){if(a.byteLength!==0){for(this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const g=this._incomingData.peek(this._state.readLen),E=g.readUInt8(0),A=(E&128)>>>7,B=(E&64)>>>6,O=g.readUInt8(1),N=(O&128)>>>7,F=O&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(F===126?2:0)+(F===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(B)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const g=this._incomingData.read(this._state.readLen),E=g.readUInt8(1),A=(E&128)>>>7;let B=E&127,O=1;B===126?B=g.readUInt8(++O)*2**8+g.readUInt8(++O):B===127&&(B=g.readUInt8(++O)*0+g.readUInt8(++O)*0+g.readUInt8(++O)*0+g.readUInt8(++O)*0+g.readUInt8(++O)*2**24+g.readUInt8(++O)*2**16+g.readUInt8(++O)*2**8+g.readUInt8(++O));let N=0;A&&(N=g.readUInt8(++O)*2**24+g.readUInt8(++O)*2**16+g.readUInt8(++O)*2**8+g.readUInt8(++O)),this._state.state=3,this._state.readLen=B,this._state.mask=N,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const g=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",g),c(g,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",g),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(g,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=v;class y extends T.Disposable{get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}constructor(a,g,E,A,B,O){super(),this._tracer=a,this._onData=B,this._writeFn=O,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,g?(this._zlibInflateStream=this._register(new h(this._tracer,A,E,{windowBits:15})),this._zlibDeflateStream=this._register(new p(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(N=>this._onError.fire(N))),this._register(this._zlibDeflateStream.onError(N=>this._onError.fire(N)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(a){this._writeQueue.push(a),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const a=this._writeQueue.shift();if(this._zlibDeflateStream){const g=await this._deflateMessage(this._zlibDeflateStream,a);this._writeFn(g,!0)}else this._writeFn(a,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(a,g){return new Promise((E,A)=>{a.write(g),a.flush(B=>E(B))})}acceptFrame(a,g,E){this._readQueue.push({data:a,isCompressed:g,isLastFrameOfMessage:E}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const a=this._readQueue.shift();if(this._zlibInflateStream&&a.isCompressed){const g=await this._inflateFrame(this._zlibInflateStream,a.data,a.isLastFrameOfMessage);this._onData.fire(g)}else this._onData.fire(a.data)}this._isProcessingReadQueue=!1}}_inflateFrame(a,g,E){return new Promise((A,B)=>{a.write(g),E&&a.write(D.VSBuffer.fromByteArray([0,0,255,255])),a.flush(O=>A(O))})}}class h extends T.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}constructor(a,g,E,A){super(),this._tracer=a,this._recordInflateBytes=g,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=C().zlib.createInflateRaw(A),this._zlibInflate.on("error",B=>{this._tracer.traceSocketEvent("zlibInflateError",{message:B?.message,code:B?.code}),this._onError.fire(B)}),this._zlibInflate.on("data",B=>{this._tracer.traceSocketEvent("zlibInflateData",B),this._pendingInflateData.push(D.VSBuffer.wrap(B))}),E&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",E.buffer),this._zlibInflate.write(E.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(a){this._recordInflateBytes&&this._recordedInflateBytes.push(a.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",a),this._zlibInflate.write(a.buffer)}flush(a){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const g=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,a(g)})}}class p extends T.Disposable{constructor(a,g){super(),this._tracer=a,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=C().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",E=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:E?.message,code:E?.code}),this._onError.fire(E)}),this._zlibDeflate.on("data",E=>{this._tracer.traceSocketEvent("zlibDeflateData",E),this._pendingDeflateData.push(D.VSBuffer.wrap(E))})}write(a){this._tracer.traceSocketEvent("zlibDeflateWrite",a.buffer),this._zlibDeflate.write(a.buffer)}flush(a){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let g=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,g=g.slice(0,g.byteLength-4),a(g)})}}function c(l,a){if(a===0)return;const g=l.byteLength>>>2;for(let F=0;F<g;F++){const k=l.readUInt32BE(F*4);l.writeUInt32BE(k^a,F*4)}const E=g*4,A=l.byteLength-E,B=a>>>24&255,O=a>>>16&255,N=a>>>8&255;A>=1&&l.writeUInt8(l.readUInt8(E)^B,E),A>=2&&l.writeUInt8(l.readUInt8(E+1)^O,E+1),A>=3&&l.writeUInt8(l.readUInt8(E+2)^N,E+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const u={[2]:107,[1]:103};function d(){const l=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,L.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):a=(0,L.join)(C().os.tmpdir(),`vscode-ipc-${l}.sock`),o(a),a}e.createRandomIPCHandle=d;function n(l,a,g){const E=C().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${E}-${g}-${a}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,L.join)(e.XDG_RUNTIME_DIR,`vscode-${E.substr(0,8)}-${g}-${a}.sock`):A=(0,L.join)(l,`${g}-${a}.sock`),o(A),A}e.createStaticIPCHandle=n;function o(l){const a=u[P.platform];typeof a=="number"&&l.length>=a&&console.warn(`WARNING: IPC handle "${l}" is longer than ${a} chars, try a shorter --user-data-dir`)}class t extends w.IPCServer{static toClientConnectionEvent(a){const g=R.Event.fromNodeEventEmitter(a,"connection");return R.Event.map(g,E=>({protocol:new b.Protocol(new S(E,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(E,"close"))}))}constructor(a){super(t.toClientConnectionEvent(a)),this.server=a}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function r(l){return new Promise((a,g)=>{const E=C().net.createServer();E.on("error",g),E.listen(l,()=>{E.removeListener("error",g),a(new t(E))})})}e.serve=r;function s(l,a){return new Promise((g,E)=>{const A=C().net.createConnection(l,()=>{A.removeListener("error",E),g(b.Client.fromSocket(new S(A,`ipc-client${a}`),a))});A.once("error",E)})}e.connect=s}),define(re[69],se([0,1,6,3,2,15]),function(Q,e,D,i,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var L;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=e.StorageHint||(e.StorageHint={}));function P(C){const S=C;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var I;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(I=e.StorageState||(e.StorageState={}));class w extends R.Disposable{constructor(S,m=Object.create(null)){super(),this.database=S,this.options=m,this._onDidChangeStorage=this._register(new i.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=I.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){S.changed?.forEach((m,f)=>this.accept(f,m)),S.deleted?.forEach(m=>this.accept(m,void 0))}accept(S,m){if(this.state===I.Closed)return;let f=!1;(0,T.isUndefinedOrNull)(m)?f=this.cache.delete(S):this.cache.get(S)!==m&&(this.cache.set(S,m),f=!0),f&&this._onDidChangeStorage.fire(S)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===I.None&&(this.state=I.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,m){const f=this.cache.get(S);return(0,T.isUndefinedOrNull)(f)?m:f}getBoolean(S,m){const f=this.get(S);return(0,T.isUndefinedOrNull)(f)?m:f==="true"}getNumber(S,m){const f=this.get(S);return(0,T.isUndefinedOrNull)(f)?m:parseInt(f,10)}async set(S,m){if(this.state===I.Closed)return;if((0,T.isUndefinedOrNull)(m))return this.delete(S);const f=String(m);if(this.cache.get(S)!==f)return this.cache.set(S,f),this.pendingInserts.set(S,f),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async delete(S){if(!(this.state===I.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=I.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(!!this.hasPending)return this.doFlush(S)}async doFlush(S){return this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(!!this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class b{constructor(){this.onDidChangeItemsExternal=i.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert?.forEach((m,f)=>this.items.set(f,m)),S.delete?.forEach(m=>this.items.delete(m))}async close(){}}e.InMemoryStorageDatabase=b}),define(re[151],se([9,10]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(re[152],se([9,10]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[153],se([9,10]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(re[154],se([9,10]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(re[155],se([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[156],se([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[157],se([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[158],se([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[159],se([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(re[160],se([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[161],se([9,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[162],se([9,10]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[163],se([9,10]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(re[164],se([9,10]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(re[165],se([9,10]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(re[166],se([9,10]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[167],se([9,10]),function(Q,e){return Q.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[168],se([9,10]),function(Q,e){return Q.create("vs/platform/remoteTunnel/electron-browser/remoteTunnelService",e)}),define(re[169],se([9,10]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(re[170],se([9,10]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(re[171],se([9,10]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[172],se([9,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[173],se([9,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[174],se([9,10]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[175],se([9,10]),function(Q,e){return Q.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(re[176],se([9,10]),function(Q,e){return Q.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(re[177],se([9,10]),function(Q,e){return Q.create("vs/platform/userDataSync/common/settingsSync",e)}),define(re[178],se([9,10]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(re[179],se([9,10]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSync",e)}),define(re[180],se([9,10]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(re[181],se([9,10]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(re[182],se([9,10]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(re[93],se([0,1,65,63,22,12,36,21,8]),function(Q,e,D,i,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class w{get appRoot(){return(0,T.dirname)(R.FileAccess.asFileUri("",Q).fsPath)}get userHome(){return I.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return I.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.paths.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const v=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",v)}return this.args.logsPath}get userDataSyncLogResource(){return I.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return I.URI.file((0,T.join)(this.logsPath,"editSessions.log"))}get remoteTunnelLogResource(){return I.URI.file((0,T.join)(this.logsPath,"remoteTunnel.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(I.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const v=L.env.VSCODE_PORTABLE;return v?I.URI.file((0,T.join)(v,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const v=this.args["builtin-extensions-dir"];return v?(0,T.resolve)(v):(0,T.normalize)((0,T.join)(R.FileAccess.asFileUri("",Q).fsPath,"..","extensions"))}get extensionsDownloadLocation(){const v=this.args["extensions-download-dir"];return v?I.URI.file((0,T.resolve)(v)):I.URI.file((0,T.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const v=this.args["extensions-dir"];if(v)return(0,T.resolve)(v);const y=L.env.VSCODE_EXTENSIONS;if(y)return y;const h=L.env.VSCODE_PORTABLE;return h?(0,T.join)(h,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const v=this.args.extensionDevelopmentPath;if(Array.isArray(v))return v.map(y=>/^[^:/?#]+?:\/\//.test(y)?I.URI.parse(y):I.URI.file((0,T.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const v=this.args.extensionTestsPath;if(v)return/^[^:/?#]+?:\/\//.test(v)?I.URI.parse(v):I.URI.file((0,T.normalize)(v))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const v=this.args["disable-extension"];if(v){if(typeof v=="string")return[v];if(Array.isArray(v)&&v.length>0)return v}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(v=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(v))}get extensionLogLevel(){const v=[];for(const y of this.args.log||[]){const h=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(y);h&&h[1]&&h[2]&&v.push([h[1],h[2]])}return v.length?v:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return I.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const v=L.env.VSCODE_PORTABLE;return v?I.URI.file((0,T.join)(v,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(v){this.args.continueOn=v}get args(){return this._args}constructor(v,y,h){this._args=v,this.paths=y,this.productService=h,this.editSessionId=this.args.editSessionId}}ve([i.memoize],w.prototype,"appRoot",null),ve([i.memoize],w.prototype,"userHome",null),ve([i.memoize],w.prototype,"userDataPath",null),ve([i.memoize],w.prototype,"appSettingsHome",null),ve([i.memoize],w.prototype,"tmpDir",null),ve([i.memoize],w.prototype,"cacheHome",null),ve([i.memoize],w.prototype,"stateResource",null),ve([i.memoize],w.prototype,"userRoamingDataHome",null),ve([i.memoize],w.prototype,"userDataSyncHome",null),ve([i.memoize],w.prototype,"userDataSyncLogResource",null),ve([i.memoize],w.prototype,"editSessionsLogResource",null),ve([i.memoize],w.prototype,"remoteTunnelLogResource",null),ve([i.memoize],w.prototype,"sync",null),ve([i.memoize],w.prototype,"machineSettingsResource",null),ve([i.memoize],w.prototype,"workspaceStorageHome",null),ve([i.memoize],w.prototype,"localHistoryHome",null),ve([i.memoize],w.prototype,"keyboardLayoutResource",null),ve([i.memoize],w.prototype,"argvResource",null),ve([i.memoize],w.prototype,"isExtensionDevelopment",null),ve([i.memoize],w.prototype,"untitledWorkspacesHome",null),ve([i.memoize],w.prototype,"installSourcePath",null),ve([i.memoize],w.prototype,"builtinExtensionsPath",null),ve([i.memoize],w.prototype,"extensionsPath",null),ve([i.memoize],w.prototype,"extensionDevelopmentLocationURI",null),ve([i.memoize],w.prototype,"extensionDevelopmentKind",null),ve([i.memoize],w.prototype,"extensionTestsLocationURI",null),ve([i.memoize],w.prototype,"debugExtensionHost",null),ve([i.memoize],w.prototype,"logLevel",null),ve([i.memoize],w.prototype,"extensionLogLevel",null),ve([i.memoize],w.prototype,"serviceMachineIdResource",null),ve([i.memoize],w.prototype,"telemetryLogResource",null),ve([i.memoize],w.prototype,"disableWorkspaceTrust",null),ve([i.memoize],w.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=w;function b(f,v){return m(f["inspect-extensions"],f["inspect-brk-extensions"],5870,v,f.debugId,f.extensionEnvironment)}e.parseExtensionHostPort=b;function C(f,v){return m(f["inspect-search"],f["inspect-brk-search"],5876,v,f.extensionEnvironment)}e.parseSearchPort=C;function S(f,v){return m(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,v,f.extensionEnvironment)}e.parsePtyHostPort=S;function m(f,v,y,h,p,c){const d=Number(v||f)||(h?null:y),n=d?Boolean(!!v):!1;let o;if(c)try{o=JSON.parse(c)}catch{}return{port:d,break:n,debugId:p,env:o}}}),define(re[183],se([0,1,283,5,153]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,R.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,R.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(12,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,R.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,R.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(17,null)},category:{type:"string",cat:"e",description:(0,R.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,R.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,R.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,R.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,R.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,R.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,R.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,R.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,R.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,R.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,R.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const L={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(v,y,h=L){const p=v.find(l=>l.length>0&&l[0]!=="-"),c={},u=["_"],d=[],n={};let o;for(const l in y){const a=y[l];a.type==="subcommand"?l===p&&(o=a):(a.alias&&(c[l]=a.alias),a.type==="string"||a.type==="string[]"?(u.push(l),a.deprecates&&u.push(...a.deprecates)):a.type==="boolean"&&(d.push(l),a.deprecates&&d.push(...a.deprecates)),a.global&&(n[l]=a))}if(o&&p){const l=n;for(const A in o.options)l[A]=o.options[A];const a=v.filter(A=>A!==p),g=h.getSubcommandReporter?h.getSubcommandReporter(p):void 0,E=P(a,l,g);return{[p]:E,_:[]}}const t=D(v,{string:u,boolean:d,alias:c}),r={},s=t;r._=t._.map(l=>String(l)).filter(l=>l.length>0),delete s._;for(const l in y){const a=y[l];if(a.type==="subcommand")continue;a.alias&&delete s[a.alias];let g=s[l];if(a.deprecates)for(const E of a.deprecates)s.hasOwnProperty(E)&&(g||(g=s[E],g&&h.onDeprecatedOption(E,a.deprecationMessage||(0,R.localize)(36,null,l))),delete s[E]);if(typeof g<"u"){if(a.type==="string[]"){if(Array.isArray(g)||(g=[g]),!a.allowEmptyValue){const E=g.filter(A=>A.length>0);E.length!==g.length&&(h.onEmptyValue(l),g=E.length>0?E:void 0)}}else a.type==="string"&&(Array.isArray(g)?(g=g.pop(),h.onMultipleValues(l,g)):!g&&!a.allowEmptyValue&&(h.onEmptyValue(l),g=void 0));r[l]=g,a.deprecationMessage&&h.onDeprecatedOption(l,a.deprecationMessage)}delete s[l]}for(const l in s)h.onUnknownOption(l);return r}e.parseArgs=P;function I(v,y){let h="";return y.args&&(Array.isArray(y.args)?h=` <${y.args.join("> <")}>`:h=` <${y.args}>`),y.alias?`-${y.alias} --${v}${h}`:`--${v}${h}`}function w(v,y){const h=[];for(const p in v){const c=v[p],u=I(p,c);h.push([u,c.description])}return b(h,y)}e.formatOptions=w;function b(v,y){const p=v.reduce((d,n)=>Math.max(d,n[0].length),12)+2+1;if(y-p<25)return v.reduce((d,n)=>d.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const c=y-p-1,u=[];for(const d of v){const n=d[0],o=S(d[1],c),t=C(p-n.length-2);u.push("  "+n+t+o[0]);for(let r=1;r<o.length;r++)u.push(C(p)+o[r])}return u}function C(v){return" ".repeat(v)}function S(v,y){const h=[];for(;v.length;){const p=v.length<y?v.length:v.lastIndexOf(" ",y),c=v.slice(0,p).trim();v=v.slice(p),h.push(c)}return h}function m(v,y,h,p,c){const u=process.stdout.isTTY&&process.stdout.columns||80,d=c?.noInputFiles!==!0?`[${(0,R.localize)(37,null)}...]`:"",n=[`${v} ${h}`];n.push(""),n.push(`${(0,R.localize)(38,null)}: ${y} [${(0,R.localize)(39,null)}]${d}`),n.push(""),c?.noPipe!==!0&&(i.isWindows?n.push((0,R.localize)(40,null,y)):n.push((0,R.localize)(41,null,y)),n.push(""));const o={},t=[];for(const r in p){const s=p[r];if(s.type==="subcommand")s.description&&t.push({command:r,description:s.description});else if(s.description&&s.cat){let l=o[s.cat];l||(o[s.cat]=l={}),l[r]=s}}for(const r in o){const s=r,l=o[s];l&&(n.push(T[s]),n.push(...w(l,u)),n.push(""))}return t.length&&(n.push((0,R.localize)(42,null)),n.push(...b(t.map(r=>[r.command,r.description]),u)),n.push("")),n.join(`
`)}e.buildHelpMessage=m;function f(v,y){return`${v||(0,R.localize)(43,null)}
${y||(0,R.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=f}),define(re[184],se([0,1,284,154,183]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const T=2048;function L(S,m){const f=(u,d)=>{console.warn((0,i.localize)(0,null,u,d))},v=u=>{console.warn((0,i.localize)(1,null,u))},y=(u,d)=>{console.warn((0,i.localize)(2,null,u,d))},h=u=>({onUnknownOption:d=>{u!=="tunnel"&&console.warn((0,i.localize)(3,null,d,u))},onMultipleValues:f,onEmptyValue:v,onDeprecatedOption:y,getSubcommandReporter:u!=="tunnel"?h:void 0}),p={onUnknownOption:u=>{console.warn((0,i.localize)(4,null,u))},onMultipleValues:f,onEmptyValue:v,onDeprecatedOption:y,getSubcommandReporter:h},c=(0,R.parseArgs)(S,R.OPTIONS,m?p:void 0);return c.goto&&c._.forEach(u=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(u),(0,i.localize)(5,null))),c["max-memory"]&&D(parseInt(c["max-memory"])>=T,`The max-memory argument cannot be specified lower than ${T} MB.`),c}function P(S){const m=S.findIndex(f=>!/^-/.test(f));if(m>-1)return[...S.slice(0,m),...S.slice(m+1)]}function I(S){let[,...m]=S;process.env.VSCODE_DEV&&(m=P(m)||[]);const f=!C(process.env);return L(m,f)}e.parseMainProcessArgv=I;function w(S){let[,,...m]=S;return process.env.VSCODE_DEV&&(m=P(m)||[]),L(m,!0)}e.parseCLIProcessArgv=w;function b(S,...m){const f=S.indexOf("--");return f===-1?S.push(...m):S.splice(f,0,...m),S}e.addArg=b;function C(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),function(){"use strict";function Q(e,D,i){function R(L,P){const I=T(L,P),w=[I];return e.isAbsolute(I)||w.unshift(i),e.resolve(...w)}function T(L,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,P);const b=L["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(C,"AppData","Roaming")}break;case"darwin":w=e.join(D.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,P)}return{getUserDataPath:R}}if(typeof define=="function")define(re[185],se([285,34,36]),function(e,D,i){return Q(e,D,i.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=Q(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[186],se([0,1,34,93,185]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends i.AbstractNativeEnvironmentService{constructor(P,I){super(P,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(P,I.nameShort)},I)}}e.NativeEnvironmentService=T}),define(re[187],se([0,1,8]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const i=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,L=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,I=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function w(y){const h=y.match(L);return h?h[1]:null}function b(y){if(y.indexOf("://")===-1){const h=y.match(i);return h?w(h[2]):null}try{const h=D.URI.parse(y);if(h.authority)return w(h.authority)}catch{}return null}function C(y,h){const p=new Set;let c;for(;c=P.exec(y);){const d=b(c[1]);d&&p.add(d)}const u=new Set(h);return Array.from(p).map(d=>u.has(d)?d:d.replace(I,"a"))}e.getDomainsOfRemotes=C;function S(y){const h=y.match(T);return h?h[2]:null}function m(y,h,p){return y&&h?(p&&h.endsWith(".git")&&(h=h.substr(0,h.length-4)),h.indexOf("/")===0?`${y}${h}`:`${y}/${h}`):null}function f(y,h){if(y.indexOf("://")===-1){const p=y.match(R);if(p)return m(p[2],p[3],h)}try{const p=D.URI.parse(y);if(p.authority)return m(S(p.authority),p.path,h)}catch{}return null}function v(y,h=!1){const p=[];let c;for(;c=P.exec(y);){const u=f(c[1],h);u&&p.push(u)}return p}e.getRemotes=v}),define(re[188],se([0,1,15,157]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function R(L,P,I){try{T(L,P,I)}catch{}return L}e.localizeManifest=R;function T(L,P,I){const w=(b,C,S)=>{const m=b[C];if((0,D.isString)(m)){const f=m,v=f.length;if(v>1&&f[0]==="%"&&f[v-1]==="%"){const y=f.substr(1,v-2);let h=P[y];h===void 0&&I&&(h=I[y]);const p=typeof h=="string"?h:h.message;if(p!==void 0){const c=I?.[y],u=typeof c=="string"?c:c?.message;if(S&&(C==="title"||C==="category")&&u&&u!==p){const d={value:p,original:u};b[C]=d}else b[C]=p}else console.warn(`[${L.name}]: ${(0,i.localize)(0,null,y)}`)}}else if((0,D.isObject)(m))for(const f in m)m.hasOwnProperty(f)&&(f==="commands"?w(m,f,!0):w(m,f,S));else if(Array.isArray(m))for(let f=0;f<m.length;f++)w(m,f,S)};for(const b in L)L.hasOwnProperty(b)&&w(L,b)}}),define(re[189],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,L,P,I){return this.channel.call("promptImportantExtensionsInstallNotification",[T,L,P,I])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class i{constructor(T){this.service=T}listen(T,L){throw new Error(`Event not found: ${L}`)}call(T,L,P){switch(L){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${L}`)}}e.ExtensionRecommendationNotificationServiceChannel=i}),define(re[70],se([0,1,21,87,162,55]),function(Q,e,D,i,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function I(h){return h=h.trim(),h==="*"||L.test(h)}e.isValidVersionStr=I;function w(h){if(!I(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=h.match(L);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=w;function b(h){if(!h)return null;const p=h.majorBase,c=h.majorMustEqual,u=h.minorBase;let d=h.minorMustEqual;const n=h.patchBase;let o=h.patchMustEqual;h.hasCaret&&(p===0||(d=!1),o=!1);let t=0;if(h.preRelease){const r=P.exec(h.preRelease);if(r){const[,s,l,a]=r;t=Date.UTC(Number(s),Number(l)-1,Number(a))}}return{majorBase:p,majorMustEqual:c,minorBase:u,minorMustEqual:d,patchBase:n,patchMustEqual:o,isMinimum:h.hasGreaterEquals,notBefore:t}}e.normalizeVersion=b;function C(h,p,c){let u;typeof h=="string"?u=b(w(h)):u=h;let d;p instanceof Date?d=p.getTime():typeof p=="string"&&(d=new Date(p).getTime());let n;if(typeof c=="string"?n=b(w(c)):n=c,!u||!n)return!1;const o=u.majorBase,t=u.minorBase,r=u.patchBase;let s=n.majorBase,l=n.minorBase,a=n.patchBase;const g=n.notBefore;let E=n.majorMustEqual,A=n.minorMustEqual,B=n.patchMustEqual;return n.isMinimum?o>s?!0:o<s?!1:t>l?!0:t<l||d&&d<g?!1:r>=a:(o===1&&s===0&&(!E||!A||!B)&&(s=1,l=0,a=0,E=!0,A=!1,B=!1),o<s?!1:o>s?!E:t<l?!1:t>l?!A:r<a?!1:r>a?!B:!(d&&d<g))}e.isValidVersion=C;function S(h,p,c,u,d){const n=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return n.push([i.default.Error,R.localize(0,null)]),n;if(typeof u.name!="string")return n.push([i.default.Error,R.localize(1,null,"name")]),n;if(typeof u.version!="string")return n.push([i.default.Error,R.localize(2,null,"version")]),n;if(!u.engines)return n.push([i.default.Error,R.localize(3,null,"engines")]),n;if(typeof u.engines.vscode!="string")return n.push([i.default.Error,R.localize(4,null,"engines.vscode")]),n;if(typeof u.extensionDependencies<"u"&&!y(u.extensionDependencies))return n.push([i.default.Error,R.localize(5,null,"extensionDependencies")]),n;if(typeof u.activationEvents<"u"){if(!y(u.activationEvents))return n.push([i.default.Error,R.localize(6,null,"activationEvents")]),n;if(typeof u.main>"u"&&typeof u.browser>"u")return n.push([i.default.Error,R.localize(7,null,"activationEvents","main")]),n}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&n.push([i.default.Warning,R.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return n.push([i.default.Error,R.localize(9,null,"main")]),n;{const r=(0,D.joinPath)(c,u.main);(0,D.isEqualOrParent)(r,c)||n.push([i.default.Warning,R.localize(10,null,r.path,c.path)])}if(typeof u.activationEvents>"u")return n.push([i.default.Error,R.localize(11,null,"activationEvents","main")]),n}if(typeof u.browser<"u"){if(typeof u.browser!="string")return n.push([i.default.Error,R.localize(12,null,"browser")]),n;{const r=(0,D.joinPath)(c,u.browser);(0,D.isEqualOrParent)(r,c)||n.push([i.default.Warning,R.localize(13,null,r.path,c.path)])}if(typeof u.activationEvents>"u")return n.push([i.default.Error,R.localize(14,null,"activationEvents","browser")]),n}if(!T.valid(u.version))return n.push([i.default.Error,R.localize(15,null)]),n;const o=[];if(!m(h,p,u,d,o))for(const r of o)n.push([i.default.Error,r]);return n}e.validateExtensionManifest=S;function m(h,p,c,u,d){return u||typeof c.main>"u"&&typeof c.browser>"u"?!0:v(h,p,c.engines.vscode,d)}e.isValidExtensionVersion=m;function f(h,p,c){return h==="*"||v(p,c,h)}e.isEngineValid=f;function v(h,p,c,u=[]){const d=b(w(c));if(!d)return u.push(R.localize(16,null,c)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return u.push(R.localize(17,null,c)),!1}else if(!d.majorMustEqual)return u.push(R.localize(18,null,c)),!1;return C(h,p,d)?!0:(u.push(R.localize(19,null,h,c)),!1)}function y(h){if(!Array.isArray(h))return!1;for(let p=0,c=h.length;p<c;p++)if(typeof h[p]!="string")return!1;return!0}}),define(re[44],se([0,1,17,31]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(T,L,P){let I=P&&P.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const b=(await L.readFile(T.serviceMachineIdResource)).value.toString();I=(0,i.isUUID)(b)?b:null}catch{I=null}if(!I){I=(0,i.generateUuid)();try{await L.writeFile(T.serviceMachineIdResource,D.VSBuffer.fromString(I))}catch{}}return P?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=R}),define(re[56],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,T=[],L=!1){this.ctor=R,this.staticArguments=T,this.supportsDelayedInstantiation=L}}e.SyncDescriptor=D}),define(re[94],se([0,1,56]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const i=[];var R;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(R=e.InstantiationType||(e.InstantiationType={}));function T(P,I,w){I instanceof D.SyncDescriptor||(I=new D.SyncDescriptor(I,[],Boolean(w))),i.push([P,I])}e.registerSingleton=T;function L(){return i}e.getSingletonServiceDescriptors=L}),define(re[190],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(T,L){this.key=T,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.Node=D;class i{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(const L of this._nodes.values())L.outgoing.size===0&&T.push(L);return T}insertEdge(T,L){const P=this.lookupOrInsertNode(T),I=this.lookupOrInsertNode(L);P.outgoing.set(I.key,I),I.incoming.set(P.key,P)}removeNode(T){const L=this._hashFn(T);this._nodes.delete(L);for(const P of this._nodes.values())P.outgoing.delete(L),P.incoming.delete(L)}lookupOrInsertNode(T){const L=this._hashFn(T);let P=this._nodes.get(L);return P||(P=new D(L,T),this._nodes.set(L,P)),P}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){const T=[];for(const[L,P]of this._nodes)T.push(`${L}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,L]of this._nodes){const P=new Set([T]),I=this._findCycle(L,P);if(I)return I}}_findCycle(T,L){for(const[P,I]of T.outgoing){if(L.has(P))return[...L,P].join(" -> ");L.add(P);const w=this._findCycle(I,L);if(w)return w;L.delete(P)}}}e.Graph=i}),define(re[4],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function P(I){return I[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=P})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function i(L,P,I){P[D.DI_TARGET]===P?P[D.DI_DEPENDENCIES].push({id:L,index:I}):(P[D.DI_DEPENDENCIES]=[{id:L,index:I}],P[D.DI_TARGET]=P)}function R(L){if(D.serviceIds.has(L))return D.serviceIds.get(L);const P=function(I,w,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(P,I,b)};return P.toString=()=>L,D.serviceIds.set(L,P),P}e.createDecorator=R;function T(L){return L}e.refineServiceDecorator=T}),define(re[191],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(re[16],se([0,1,15,8,4]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function T(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof i.URI)}e.isConfigurationOverrides=T;function L(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=L;var P;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function w(h,p){const c=Object.create(null);for(const u in h)b(c,u,h[u],p);return c}e.toValuesTree=w;function b(h,p,c,u){const d=p.split("."),n=d.pop();let o=h;for(let t=0;t<d.length;t++){const r=d[t];let s=o[r];switch(typeof s){case"undefined":s=o[r]=Object.create(null);break;case"object":break;default:u(`Ignoring ${p} as ${d.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[n]=c}catch{u(`Ignoring ${p} as ${d.join(".")} is ${JSON.stringify(o)}`)}else u(`Ignoring ${p} as ${d.join(".")} is ${JSON.stringify(o)}`)}e.addToValueTree=b;function C(h,p){const c=p.split(".");S(h,c)}e.removeFromValueTree=C;function S(h,p){const c=p.shift();if(p.length===0){delete h[c];return}if(Object.keys(h).indexOf(c)!==-1){const u=h[c];typeof u=="object"&&!Array.isArray(u)&&(S(u,p),Object.keys(u).length===0&&delete h[c])}}function m(h,p,c){function u(o,t){let r=o;for(const s of t){if(typeof r!="object"||r===null)return;r=r[s]}return r}const d=p.split("."),n=u(h,d);return typeof n>"u"?c:n}e.getConfigurationValue=m;function f(h,p,c){Object.keys(p).forEach(u=>{u!=="__proto__"&&(u in h?D.isObject(h[u])&&D.isObject(p[u])?f(h[u],p[u],c):c&&(h[u]=p[u]):h[u]=p[u])})}e.merge=f;function v(h,p,c){const u=h.inspect(p),d=h.inspect(c);return typeof u.userValue<"u"||typeof u.workspaceValue<"u"||typeof u.workspaceFolderValue<"u"?u.value:typeof d.userValue<"u"||typeof d.workspaceValue<"u"||typeof d.workspaceFolderValue<"u"?d.value:u.defaultValue}e.getMigratedSettingValue=v;function y(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=y}),define(re[192],se([0,1,5,27,4]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",D.isMacintosh),T.set("isLinux",D.isLinux),T.set("isWindows",D.isWindows),T.set("isWeb",D.isWeb),T.set("isMacNative",D.isMacintosh&&!D.isWeb),T.set("isEdge",D.isEdge),T.set("isFirefox",D.isFirefox),T.set("isChrome",D.isChrome),T.set("isSafari",D.isSafari);const L=Object.prototype.hasOwnProperty;var P;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return C.INSTANCE}static true(){return S.INSTANCE}static has(k){return m.create(k)}static equals(k,U){return f.create(k,U)}static notEquals(k,U){return h.create(k,U)}static regex(k,U){return t.create(k,U)}static in(k,U){return v.create(k,U)}static notIn(k,U){return y.create(k,U)}static not(k){return p.create(k)}static and(...k){return l.create(k,null,!0)}static or(...k){return a.create(k,null,!0)}static greater(k,U){return u.create(k,U)}static greaterEquals(k,U){return d.create(k,U)}static smaller(k,U){return n.create(k,U)}static smallerEquals(k,U){return o.create(k,U)}static deserialize(k,U=!1){if(!!k)return this._deserializeOrExpression(k,U)}static _deserializeOrExpression(k,U){const $=k.split("||");return a.create($.map(G=>this._deserializeAndExpression(G,U)),null,!0)}static _deserializeAndExpression(k,U){const $=k.split("&&");return l.create($.map(G=>this._deserializeOne(G,U)),null,!0)}static _deserializeOne(k,U){if(k=k.trim(),k.indexOf("!=")>=0){const $=k.split("!=");return h.create($[0].trim(),this._deserializeValue($[1],U))}if(k.indexOf("==")>=0){const $=k.split("==");return f.create($[0].trim(),this._deserializeValue($[1],U))}if(k.indexOf("=~")>=0){const $=k.split("=~");return t.create($[0].trim(),this._deserializeRegexValue($[1],U))}if(k.indexOf(" not in ")>=0){const $=k.split(" not in ");return y.create($[0].trim(),this._deserializeValue($[1],U))}if(k.indexOf(" in ")>=0){const $=k.split(" in ");return v.create($[0].trim(),this._deserializeValue($[1],U))}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const $=k.split(">=");return d.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const $=k.split(">");return u.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const $=k.split("<=");return o.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const $=k.split("<");return n.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(k)?p.create(k.substr(1).trim()):m.create(k)}static _deserializeValue(k,U){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;const $=/^'([^']*)'$/.exec(k);return $?$[1].trim():k}static _deserializeRegexValue(k,U){if((0,i.isFalsyOrWhitespace)(k)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=k.indexOf("/"),G=k.lastIndexOf("/");if($===G||$<0){if(U)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}const W=k.slice($+1,G),V=k[G+1]==="i"?"i":"";try{return new RegExp(W,V)}catch(z){if(U)throw new Error(`bad regexp-value '${k}', parse error: ${z}`);return console.warn(`bad regexp-value '${k}', parse error: ${z}`),null}}}e.ContextKeyExpr=I;function w(F,k){const U=F?F.substituteConstants():void 0,$=k?k.substituteConstants():void 0;return!U&&!$?!0:!U||!$?!1:U.equals($)}e.expressionsAreEqualWithConstantSubstitution=w;function b(F,k){return F.cmp(k)}class C{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return S.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class S{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=S,S.INSTANCE=new S;class m{static create(k,U=null){const $=T.get(k);return typeof $=="boolean"?$?S.INSTANCE:C.INSTANCE:new m(k,U)}constructor(k,U){this.key=k,this.negated=U,this.type=2}cmp(k){return k.type!==this.type?this.type-k.type:E(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?S.INSTANCE:C.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=m;class f{static create(k,U,$=null){if(typeof U=="boolean")return U?m.create(k,$):p.create(k,$);const G=T.get(k);return typeof G=="boolean"?U===(G?"true":"false")?S.INSTANCE:C.INSTANCE:new f(k,U,$)}constructor(k,U,$){this.key=k,this.value=U,this.negated=$,this.type=4}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const U=k?"true":"false";return this.value===U?S.INSTANCE:C.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class v{static create(k,U){return new v(k,U)}constructor(k,U){this.key=k,this.valueKey=U,this.type=10,this.negated=null}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const U=k.getValue(this.valueKey),$=k.getValue(this.key);return Array.isArray(U)?U.includes($):typeof $=="string"&&typeof U=="object"&&U!==null?L.call(U,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=y.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=v;class y{static create(k,U){return new y(k,U)}constructor(k,U){this.key=k,this.valueKey=U,this.type=11,this._negated=v.create(k,U)}cmp(k){return k.type!==this.type?this.type-k.type:this._negated.cmp(k._negated)}equals(k){return k.type===this.type?this._negated.equals(k._negated):!1}substituteConstants(){return this}evaluate(k){return!this._negated.evaluate(k)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(k){return k.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=y;class h{static create(k,U,$=null){if(typeof U=="boolean")return U?p.create(k,$):m.create(k,$);const G=T.get(k);return typeof G=="boolean"?U===(G?"true":"false")?C.INSTANCE:S.INSTANCE:new h(k,U,$)}constructor(k,U,$){this.key=k,this.value=U,this.negated=$,this.type=5}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const U=k?"true":"false";return this.value===U?C.INSTANCE:S.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=h;class p{static create(k,U=null){const $=T.get(k);return typeof $=="boolean"?$?C.INSTANCE:S.INSTANCE:new p(k,U)}constructor(k,U){this.key=k,this.negated=U,this.type=3}cmp(k){return k.type!==this.type?this.type-k.type:E(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?C.INSTANCE:S.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=p;function c(F,k){if(typeof F=="string"){const U=parseFloat(F);isNaN(U)||(F=U)}return typeof F=="string"||typeof F=="number"?k(F):C.INSTANCE}class u{static create(k,U,$=null){return c(U,G=>new u(k,G,$))}constructor(k,U,$){this.key=k,this.value=U,this.negated=$,this.type=12}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=u;class d{static create(k,U,$=null){return c(U,G=>new d(k,G,$))}constructor(k,U,$){this.key=k,this.value=U,this.negated=$,this.type=13}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=d;class n{static create(k,U,$=null){return c(U,G=>new n(k,G,$))}constructor(k,U,$){this.key=k,this.value=U,this.negated=$,this.type=14}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=n;class o{static create(k,U,$=null){return c(U,G=>new o(k,G,$))}constructor(k,U,$){this.key=k,this.value=U,this.negated=$,this.type=15}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=o;class t{static create(k,U){return new t(k,U)}constructor(k,U){this.key=k,this.regexp=U,this.type=7,this.negated=null}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const U=this.regexp?this.regexp.source:"",$=k.regexp?k.regexp.source:"";return U<$?-1:U>$?1:0}equals(k){if(k.type===this.type){const U=this.regexp?this.regexp.source:"",$=k.regexp?k.regexp.source:"";return this.key===k.key&&U===$}return!1}substituteConstants(){return this}evaluate(k){const U=k.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class r{static create(k){return new r(k)}constructor(k){this._actual=k,this.type=8}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new r(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;function s(F){let k=null;for(let U=0,$=F.length;U<$;U++){const G=F[U].substituteConstants();if(F[U]!==G&&k===null){k=[];for(let W=0;W<U;W++)k[W]=F[W]}k!==null&&(k[U]=G)}return k===null?F:k}class l{static create(k,U,$){return l._normalizeArr(k,U,$)}constructor(k,U){this.expr=k,this.negated=U,this.type=6}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let U=0,$=this.expr.length;U<$;U++){const G=b(this.expr[U],k.expr[U]);if(G!==0)return G}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let U=0,$=this.expr.length;U<$;U++)if(!this.expr[U].equals(k.expr[U]))return!1;return!0}return!1}substituteConstants(){const k=s(this.expr);return k===this.expr?this:l.create(k,this.negated,!1)}evaluate(k){for(let U=0,$=this.expr.length;U<$;U++)if(!this.expr[U].evaluate(k))return!1;return!0}static _normalizeArr(k,U,$){const G=[];let W=!1;for(const V of k)if(!!V){if(V.type===1){W=!0;continue}if(V.type===0)return C.INSTANCE;if(V.type===6){G.push(...V.expr);continue}G.push(V)}if(G.length===0&&W)return S.INSTANCE;if(G.length!==0){if(G.length===1)return G[0];G.sort(b);for(let V=1;V<G.length;V++)G[V-1].equals(G[V])&&(G.splice(V,1),V--);if(G.length===1)return G[0];for(;G.length>1;){const V=G[G.length-1];if(V.type!==9)break;G.pop();const z=G.pop(),j=G.length===0,J=a.create(V.expr.map(ee=>l.create([ee,z],null,$)),null,j);J&&(G.push(J),G.sort(b))}if(G.length===1)return G[0];if($){for(let V=0;V<G.length;V++)for(let z=V+1;z<G.length;z++)if(G[V].negate().equals(G[z]))return C.INSTANCE;if(G.length===1)return G[0]}return new l(G,U)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const U of this.expr)k.push(...U.keys());return k}map(k){return new l(this.expr.map(U=>U.map(k)),null)}negate(){if(!this.negated){const k=[];for(const U of this.expr)k.push(U.negate());this.negated=a.create(k,this,!0)}return this.negated}}class a{static create(k,U,$){return a._normalizeArr(k,U,$)}constructor(k,U){this.expr=k,this.negated=U,this.type=9}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let U=0,$=this.expr.length;U<$;U++){const G=b(this.expr[U],k.expr[U]);if(G!==0)return G}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let U=0,$=this.expr.length;U<$;U++)if(!this.expr[U].equals(k.expr[U]))return!1;return!0}return!1}substituteConstants(){const k=s(this.expr);return k===this.expr?this:a.create(k,this.negated,!1)}evaluate(k){for(let U=0,$=this.expr.length;U<$;U++)if(this.expr[U].evaluate(k))return!0;return!1}static _normalizeArr(k,U,$){let G=[],W=!1;if(k){for(let V=0,z=k.length;V<z;V++){const j=k[V];if(!!j){if(j.type===0){W=!0;continue}if(j.type===1)return S.INSTANCE;if(j.type===9){G=G.concat(j.expr);continue}G.push(j)}}if(G.length===0&&W)return C.INSTANCE;G.sort(b)}if(G.length!==0){if(G.length===1)return G[0];for(let V=1;V<G.length;V++)G[V-1].equals(G[V])&&(G.splice(V,1),V--);if(G.length===1)return G[0];if($){for(let V=0;V<G.length;V++)for(let z=V+1;z<G.length;z++)if(G[V].negate().equals(G[z]))return S.INSTANCE;if(G.length===1)return G[0]}return new a(G,U)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const U of this.expr)k.push(...U.keys());return k}map(k){return new a(this.expr.map(U=>U.map(k)),null)}negate(){if(!this.negated){const k=[];for(const U of this.expr)k.push(U.negate());for(;k.length>1;){const U=k.shift(),$=k.shift(),G=[];for(const W of N(U))for(const V of N($))G.push(l.create([W,V],null,!1));k.unshift(a.create(G,null,!1))}this.negated=a.create(k,this,!0)}return this.negated}}class g extends m{static all(){return g._info.values()}constructor(k,U,$){super(k,null),this._defaultValue=U,typeof $=="object"?g._info.push({...$,key:k}):$!==!0&&g._info.push({key:k,description:$,type:U!=null?typeof U:void 0})}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return f.create(this.key,k)}notEqualsTo(k){return h.create(this.key,k)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function E(F,k){return F<k?-1:F>k?1:0}function A(F,k,U,$){return F<U?-1:F>U?1:k<$?-1:k>$?1:0}function B(F,k){if(F.type===0||k.type===1)return!0;if(F.type===9)return k.type===9?O(F.expr,k.expr):!1;if(k.type===9){for(const U of k.expr)if(B(F,U))return!0;return!1}if(F.type===6){if(k.type===6)return O(k.expr,F.expr);for(const U of F.expr)if(B(U,k))return!0;return!1}return F.equals(k)}e.implies=B;function O(F,k){let U=0,$=0;for(;U<F.length&&$<k.length;){const G=F[U].cmp(k[$]);if(G<0)return!1;G===0&&U++,$++}return U===F.length}function N(F){return F.type===9?F.expr:[F]}}),define(re[95],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function i(T){return!!T.hostName&&!!T.errorMessage}e.isRemoteDiagnosticError=i;class R{async getPerformanceInfo(L,P){return{}}async getSystemInfo(L,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(L,P){return""}async getWorkspaceFileExtensions(L){return{extensions:[]}}async reportWorkspaceStats(L){}}e.NullDiagnosticsService=R}),define(re[96],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(re[13],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(re[29],se([0,1,156,4]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function R(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=R;function T(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function L(h,p){switch(h){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=L;function P(h,p){return p==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function I(h,p,c){return P(p,c)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===c?!0:w(c).includes(h)}e.isTargetPlatformCompatible=I;function w(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=w;function b(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=b;var C;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(C=e.SortBy||(e.SortBy={}));var S;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var m;(function(h){h.Install="install",h.Uninstall="uninstall"})(m=e.StatisticType||(e.StatisticType={}));var f;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,i.createDecorator)("extensionGalleryService");var v;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal",h.Signature="Signature"})(v=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class y extends Error{constructor(p,c){super(p),this.code=c,this.name=c}}e.ExtensionManagementError=y,e.IExtensionManagementService=(0,i.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,i.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,i.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(re[193],se([0,1,3,2,67,32,8,143,29]),function(Q,e,D,i,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function w(y,h){return L.URI.revive(h?h.transformIncoming(y):y)}function b(y,h){return h?h.transformOutgoingURI(y):y}function C(y,h){h=h||P.DefaultURITransformer;const p=y.manifest;return{...(0,P.transformAndReviveIncomingURIs)({...y,manifest:void 0},h),manifest:p}}function S(y,h){return h?(0,T.cloneAndChange)(y,p=>p instanceof L.URI?h.transformOutgoingURI(p):void 0):y}class m{constructor(h,p){this.service=h,this.getUriTransformer=p,this.onInstallExtension=D.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(h.onDidUninstallExtension,!0)}listen(h,p){const c=this.getUriTransformer(h);switch(p){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,u=>u.map(d=>({...d,local:d.local?S(d.local,c):d.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(h,p,c){const u=this.getUriTransformer(h);switch(p){case"zip":return this.service.zip(C(c[0],u)).then(d=>b(d,u));case"unzip":return this.service.unzip(w(c[0],u));case"install":return this.service.install(w(c[0],u),(0,R.revive)(c[1]));case"getManifest":return this.service.getManifest(w(c[0],u));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(c[0]);case"installFromGallery":return this.service.installFromGallery(c[0],(0,R.revive)(c[1]));case"uninstall":return this.service.uninstall(C(c[0],u),(0,R.revive)(c[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(C(c[0],u));case"getInstalled":return this.service.getInstalled(c[0],L.URI.revive(c[1])).then(d=>d.map(n=>S(n,u)));case"getMetadata":return this.service.getMetadata(C(c[0],u));case"updateMetadata":return this.service.updateMetadata(C(c[0],u),c[1]).then(d=>S(d,u));case"updateExtensionScope":return this.service.updateExtensionScope(C(c[0],u),c[1]).then(d=>S(d,u));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(c[0],c[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=m;class f extends i.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(h){super(),this.channel=h,this._onInstallExtension=this._register(new D.Emitter),this._onDidInstallExtensions=this._register(new D.Emitter),this._onUninstallExtension=this._register(new D.Emitter),this._onDidUninstallExtension=this._register(new D.Emitter),this._register(this.channel.listen("onInstallExtension")(p=>this._onInstallExtension.fire({identifier:p.identifier,source:this.isUriComponents(p.source)?L.URI.revive(p.source):p.source,profileLocation:L.URI.revive(p.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(p=>this._onDidInstallExtensions.fire(p.map(c=>({...c,local:c.local?C(c.local,null):c.local,source:this.isUriComponents(c.source)?L.URI.revive(c.source):c.source,profileLocation:L.URI.revive(c.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(p=>this._onUninstallExtension.fire({identifier:p.identifier,profileLocation:L.URI.revive(p.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(p=>this._onDidUninstallExtension.fire({...p,profileLocation:L.URI.revive(p.profileLocation)})))}isUriComponents(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(h){const p=await this.getTargetPlatform();return h.allTargetPlatforms.some(c=>(0,I.isTargetPlatformCompatible)(c,h.allTargetPlatforms,p))}zip(h){return Promise.resolve(this.channel.call("zip",[h]).then(p=>L.URI.revive(p)))}unzip(h){return Promise.resolve(this.channel.call("unzip",[h]))}install(h,p){return Promise.resolve(this.channel.call("install",[h,p])).then(c=>C(c,null))}getManifest(h){return Promise.resolve(this.channel.call("getManifest",[h]))}installFromGallery(h,p){return Promise.resolve(this.channel.call("installFromGallery",[h,p])).then(c=>C(c,null))}uninstall(h,p){return Promise.resolve(this.channel.call("uninstall",[h,p]))}reinstallFromGallery(h){return Promise.resolve(this.channel.call("reinstallFromGallery",[h]))}getInstalled(h=null,p){return Promise.resolve(this.channel.call("getInstalled",[h,p])).then(c=>c.map(u=>C(u,null)))}getMetadata(h){return Promise.resolve(this.channel.call("getMetadata",[h]))}updateMetadata(h,p){return Promise.resolve(this.channel.call("updateMetadata",[h,p])).then(c=>C(c,null))}updateExtensionScope(h,p){return Promise.resolve(this.channel.call("updateExtensionScope",[h,p])).then(c=>C(c,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(h,p){const c=await this.channel.call("download",[h,p]);return L.URI.revive(c)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=f;class v{constructor(h){this.service=h}listen(h,p){throw new Error("Invalid listen")}call(h,p,c){switch(p){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(c[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=v}),define(re[97],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,D.createDecorator)("IExtensionSignatureVerificationService");class i{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((T,L)=>Q(["node-vsce-sign"],async P=>T(P),L))),this.moduleLoadingPromise}async verify(T,L){let P;try{P=await this.vsceSign()}catch{return!1}return P.verify(T,L)}}e.ExtensionSignatureVerificationService=i}),define(re[98],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var i;(function(L){L[L.FILE=1]="FILE",L[L.WORKSPACE=2]="WORKSPACE",L[L.EXE=3]="EXE"})(i=e.RecommendationSource||(e.RecommendationSource={}));function R(L){switch(L){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var T;(function(L){L.Ignored="ignored",L.Cancelled="cancelled",L.TooMany="toomany",L.IncompatibleWindow="incompatibleWindow",L.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(re[14],se([0,1,49,12,27,15,8,164,4]),function(Q,e,D,i,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function w(W){return W.create===!0}e.isFileOpenForWriteOptions=w;var b;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var C;(function(W){W[W.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var S;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=m;function f(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=f;function v(W){return!!(W.capabilities&32768)}e.hasFileCloneCapability=v;function y(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=y;function h(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=h;function p(W){return m(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;var c;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(c=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(V,z){super(V),this.code=z}}e.FileSystemProviderError=u;function d(W,V){const z=new u(W.toString(),V);return o(z,V),z}e.createFileSystemProviderError=d;function n(W){return W||d((0,P.localize)(0,null),c.Unknown)}e.ensureFileSystemProviderError=n;function o(W,V){return W.name=V?`${V} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=o;function t(W){if(!W)return c.Unknown;if(W instanceof u)return W.code;const V=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!V)return c.Unknown;switch(V[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileExceedsMemoryLimit:return c.FileExceedsMemoryLimit;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.toFileSystemProviderErrorCode=t;function r(W){if(W instanceof A)return W.fileOperationResult;switch(t(W)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 10;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileExceedsMemoryLimit:return 9;case c.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class l{constructor(V,z,j){this.resource=V,this.operation=z,this.target=j}isOperation(V){return this.operation===V}}e.FileOperationEvent=l;var a;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class g{constructor(V,z){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=V;const j=new Map;for(const J of V){const ee=j.get(J.type);switch(ee?ee.push([J.resource,J]):j.set(J.type,[[J.resource,J]]),J.type){case 1:this.rawAdded.push(J.resource);break;case 0:this.rawUpdated.push(J.resource);break;case 2:this.rawDeleted.push(J.resource);break}}for(const[J,ee]of j)switch(J){case 1:this.added=D.TernarySearchTree.forUris(()=>z),this.added.fill(ee);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>z),this.updated.fill(ee);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>z),this.deleted.fill(ee);break}}contains(V,...z){return this.doContains(V,{includeChildren:!1},...z)}affects(V,...z){return this.doContains(V,{includeChildren:!0},...z)}doContains(V,z,...j){if(!V)return!1;const J=j.length>0;return!!((!J||j.includes(1))&&(this.added?.get(V)||z.includeChildren&&this.added?.findSuperstr(V))||(!J||j.includes(0))&&(this.updated?.get(V)||z.includeChildren&&this.updated?.findSuperstr(V))||(!J||j.includes(2))&&(this.deleted?.findSubstr(V)||z.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=g;function E(W,V,z){return!W||!V||W===V||V.length>W.length?!1:(V.charAt(V.length-1)!==i.sep&&(V+=i.sep),z?(0,R.startsWithIgnoreCase)(W,V):W.indexOf(V)===0)}e.isParent=E;class A extends Error{constructor(V,z,j){super(V),this.fileOperationResult=z,this.options=j}}e.FileOperationError=A;class B extends A{constructor(V,z,j){super(V,2,j),this.stat=z}}e.NotModifiedSinceFileOperationError=B;var O;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(O=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var N;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(N=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=F;async function k(W,V){if(!V.hasProvider(L.URI.from({scheme:W.scheme})))return new Promise(z=>{const j=V.onDidChangeFileSystemProviderRegistrations(J=>{J.scheme===W.scheme&&J.added&&(j.dispose(),z())})})}e.whenProviderRegistered=k,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(V){return(0,T.isNumber)(V)||(V=0),V<U.KB?(0,P.localize)(1,null,V.toFixed(0)):V<U.MB?(0,P.localize)(2,null,(V/U.KB).toFixed(2)):V<U.GB?(0,P.localize)(3,null,(V/U.MB).toFixed(2)):V<U.TB?(0,P.localize)(4,null,(V/U.GB).toFixed(2)):(0,P.localize)(5,null,(V/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var $;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})($=e.Arch||(e.Arch={}));function G(W){return{maxFileSize:W===0?300*U.MB:16*U.GB,maxHeapSize:W===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=G});var K=this&&this.__param||function(Q,e){return function(D,i){e(D,i,Q)}};define(re[194],se([0,1,99,43,14]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(P){this.fileService=P}async checksum(P){const I=(await this.fileService.readFileStream(P)).value;return new Promise((w,b)=>{const C=(0,D.createHash)("md5");(0,i.listenStream)(I,{onData:S=>C.update(S.buffer),onError:S=>b(S),onEnd:()=>w(C.digest("base64").replace(/=+$/,""))})})}};T=ve([K(0,R.IFileService)],T),e.ChecksumService=T}),define(re[195],se([0,1,17,37,11,3,2,43,8,31,14]),function(Q,e,D,i,R,T,L,P,I,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class C extends L.Disposable{constructor(m,f){super(),this.channel=m,this.extraCapabilities=f,this.onDidChangeCapabilities=T.Event.None,this._onDidChange=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,w.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(m){return this.channel.call("stat",[m])}readdir(m){return this.channel.call("readdir",[m])}async readFile(m,f){const{buffer:v}=await this.channel.call("readFile",[m,f]);return v}readFileStream(m,f,v){const y=(0,P.newWriteableStream)(p=>D.VSBuffer.concat(p.map(c=>D.VSBuffer.wrap(c))).buffer),h=this.channel.listen("readFileStream",[m,f])(p=>{if(p instanceof D.VSBuffer)y.write(p.buffer);else{if(p==="end")y.end();else{let c=p;c instanceof Error||(c=(0,b.createFileSystemProviderError)((0,i.toErrorMessage)(c),b.FileSystemProviderErrorCode.Unknown)),y.error(c),y.end()}h.dispose()}});return v.onCancellationRequested(()=>{y.error((0,R.canceled)()),y.end(),h.dispose()}),y}writeFile(m,f,v){return this.channel.call("writeFile",[m,D.VSBuffer.wrap(f),v])}open(m,f){return this.channel.call("open",[m,f])}close(m){return this.channel.call("close",[m])}async read(m,f,v,y,h){const[p,c]=await this.channel.call("read",[m,f,h]);return v.set(p.buffer.slice(0,c),y),c}write(m,f,v,y,h){return this.channel.call("write",[m,f,D.VSBuffer.wrap(v),y,h])}mkdir(m){return this.channel.call("mkdir",[m])}delete(m,f){return this.channel.call("delete",[m,f])}rename(m,f,v){return this.channel.call("rename",[m,f,v])}copy(m,f,v){return this.channel.call("copy",[m,f,v])}cloneFile(m,f){return this.channel.call("cloneFile",[m,f])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(m=>{if(Array.isArray(m)){const f=m;this._onDidChange.fire(f.map(v=>({resource:I.URI.revive(v.resource),type:v.type})))}else{const f=m;this._onDidWatchError.fire(f)}}))}watch(m,f){const v=(0,w.generateUuid)();return this.channel.call("watch",[this.sessionId,v,m,f]),(0,L.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,v]))}}e.DiskFileSystemProviderClient=C}),define(re[100],se([0,1,17,11,165,14]),function(Q,e,D,i,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function L(b,C,S,m,f,v){let y;try{await P(b,C,S,m,f,v)}catch(h){y=h}finally{y&&f.errorTransformer&&(y=f.errorTransformer(y)),typeof y<"u"&&S.error(y),S.end()}}e.readFileIntoStream=L;async function P(b,C,S,m,f,v){I(v);const y=await b.open(C,{create:!1});try{I(v);let h=0,p=0,c=f&&typeof f.length=="number"?f.length:void 0,u=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof c=="number"?c:f.bufferSize)),d=f&&typeof f.position=="number"?f.position:0,n=0;do p=await b.read(y,d,u.buffer,n,u.byteLength-n),d+=p,n+=p,h+=p,typeof c=="number"&&(c-=p),n===u.byteLength&&(await S.write(m(u)),u=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof c=="number"?c:f.bufferSize)),n=0);while(p>0&&(typeof c!="number"||c>0)&&I(v)&&w(h,f));if(n>0){let o=n;typeof c=="number"&&(o=Math.min(n,c)),S.write(m(u.slice(0,o)))}}catch(h){throw(0,T.ensureFileSystemProviderError)(h)}finally{await b.close(y)}}function I(b){if(b.isCancellationRequested)throw(0,i.canceled)();return!0}function w(b,C){if(C?.limits){if(typeof C.limits.memory=="number"&&b>C.limits.memory)throw(0,T.createFileSystemProviderError)((0,R.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&b>C.limits.size)throw(0,T.createFileSystemProviderError)((0,R.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(re[57],se([0,1,88,2,12,5,8,14]),function(Q,e,D,i,R,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(h){return h.recursive===!0}e.isRecursiveWatchRequest=I;class w extends i.Disposable{constructor(p,c,u,d){super(),this.onFileChanges=p,this.onLogMessage=c,this.verboseLogging=u,this.options=d,this.watcherDisposables=this._register(new i.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const p=new i.DisposableStore;this.watcherDisposables.value=p,this.watcher=this.createWatcher(p),this.watcher.setVerboseLogging(this.verboseLogging),p.add(this.watcher.onDidChangeFile(c=>this.onFileChanges(c))),p.add(this.watcher.onDidLogMessage(c=>this.onLogMessage(c))),p.add(this.watcher.onDidError(c=>this.onError(c)))}onError(p){this.options.restartOnError?this.restartCounter<w.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${p}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${p}`):this.error(p)}restart(p){this.restartCounter++,this.init(),this.watch(p)}async watch(p){this.requests=p,await this.watcher?.watch(p)}async setVerboseLogging(p){this.verboseLogging=p,await this.watcher?.setVerboseLogging(p)}error(p){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${p}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=w,w.MAX_RESTARTS=5;class b extends w{constructor(p,c,u){super(p,c,u,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class C extends w{constructor(p,c,u){super(p,c,u,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=C;function S(h){return h.map(p=>({type:p.type,resource:L.URI.file(p.path)}))}e.toFileChanges=S;function m(h){const p=new y;for(const c of h)p.processEvent(c);return p.coalesce()}e.coalesceEvents=m;function f(h,p){return typeof p=="string"&&!p.startsWith(D.GLOBSTAR)&&!(0,R.isAbsolute)(p)?{base:h,pattern:p}:p}e.normalizeWatcherPattern=f;function v(h,p){const c=[];for(const u of p)c.push((0,D.parse)(f(h,u)));return c}e.parseWatcherPatterns=v;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(p){return T.isLinux?p.path:p.path.toLowerCase()}processEvent(p){const c=this.mapPathToChange.get(this.toKey(p));let u=!1;if(c){const d=c.type,n=p.type;c.path!==p.path&&(p.type===2||p.type===1)?u=!0:d===1&&n===2?(this.mapPathToChange.delete(this.toKey(p)),this.coalesced.delete(c)):d===2&&n===1?c.type=0:d===1&&n===0||(c.type=n)}else u=!0;u&&(this.coalesced.add(p),this.mapPathToChange.set(this.toKey(p),p))}coalesce(){const p=[],c=[];return Array.from(this.coalesced).filter(u=>u.type!==2?(p.push(u),!1):!0).sort((u,d)=>u.path.length-d.path.length).filter(u=>c.some(d=>(0,P.isParent)(u.path,d,!T.isLinux))?!1:(c.push(u.path),!0)).concat(p)}}}),define(re[196],se([0,1,54,6,24,48,2,83,12,5,145,28,57]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class m extends L.Disposable{constructor(y,h,p,c){super(),this.request=y,this.onDidFilesChange=h,this.onLogMessage=p,this.verboseLogging=c,this.throttledFileChangesWorker=new i.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},u=>this.onDidFilesChange(u)),this.fileChangesDelayer=this._register(new i.ThrottledDelayer(m.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new R.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const y=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const h=await C.Promises.stat(y);this._register(await this.doWatch(y,h.isDirectory()))}catch(y){y.code!=="ENOENT"?this.error(y):this.trace(y)}}async normalizePath(y){let h=y.path;try{h=await C.Promises.realpath(y.path),y.path===h&&(h=await(0,b.realcase)(y.path)??y.path),y.path!==h&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${y.path}, real: ${h})`)}catch{}return h}async doWatch(y,h){if(w.isMacintosh&&(0,T.isEqualOrParent)(y,"/Volumes/",!0))return this.error(`Refusing to watch ${y} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.Disposable.None;const p=new R.CancellationTokenSource(this.cts.token),c=new L.DisposableStore;try{const u=(0,I.basename)(y),d=(0,D.watch)(y);c.add((0,L.toDisposable)(()=>{d.removeAllListeners(),d.close()})),this.trace(`Started watching: '${y}'`);const n=new Set;if(h)try{for(const t of await C.Promises.readdir(y))n.add(t)}catch(t){this.error(t)}const o=new Map;c.add((0,L.toDisposable)(()=>{for(const[,t]of o)t.dispose();o.clear()})),d.on("error",(t,r)=>{this.error(`Failed to watch ${y} for changes using fs.watch() (${t}, ${r})`),this.dispose()}),d.on("change",(t,r)=>{if(p.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${r}`);let s="";if(r&&(s=r.toString(),w.isMacintosh&&(s=(0,P.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(h)if(t==="rename"){o.get(s)?.dispose();const l=setTimeout(async()=>{if(o.delete(s),s===u&&!await C.Promises.exists(y)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.existsChildStrictCase((0,I.join)(y,s));if(p.token.isCancellationRequested)return;let g;a?n.has(s)?g=0:(g=1,n.add(s)):(n.delete(s),g=2),this.onFileChange({path:(0,I.join)(this.request.path,s),type:g})},m.FILE_DELETE_HANDLER_DELAY);o.set(s,(0,L.toDisposable)(()=>clearTimeout(l)))}else{let l;n.has(s)?l=0:(l=1,n.add(s)),this.onFileChange({path:(0,I.join)(this.request.path,s),type:l})}else if(t==="rename"||s!==u){const l=setTimeout(async()=>{const a=await C.Promises.exists(y);p.token.isCancellationRequested||(a?(this.onFileChange({path:this.request.path,type:0},!0),c.add(await this.doWatch(y,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},m.FILE_DELETE_HANDLER_DELAY);c.clear(),c.add((0,L.toDisposable)(()=>clearTimeout(l)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(u){await C.Promises.exists(y)&&!p.token.isCancellationRequested&&this.error(`Failed to watch ${y} for changes using fs.watch() (${u.toString()})`)}return(0,L.toDisposable)(()=>{p.dispose(!0),c.dispose()})}async onFileChange(y,h=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),!h&&this.excludes.some(p=>p(y.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${y.path}`):!h&&this.includes&&this.includes.length>0&&!this.includes.some(p=>p(y.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${y.path}`):this.fileChangesBuffer.push(y);try{await this.fileChangesDelayer.trigger(async()=>{const p=this.fileChangesBuffer;this.fileChangesBuffer=[];const c=(0,S.coalesceEvents)(p);if(c.length>0){if(this.verboseLogging)for(const d of c)this.trace(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);this.throttledFileChangesWorker.work(c)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(y){if(w.isLinux)return C.Promises.exists(y);try{const h=(0,I.basename)(y);return(await C.Promises.readdir((0,I.dirname)(y))).some(c=>c===h)}catch(h){return this.trace(h),!1}}setVerboseLogging(y){this.verboseLogging=y}error(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${y}`})}warn(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${y}`})}trace(y){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=m,m.FILE_DELETE_HANDLER_DELAY=100,m.FILE_CHANGES_HANDLER_DELAY=50;async function f(v,y,h,p,c=512){const u=await C.Promises.open(v,"r"),d=Buffer.allocUnsafe(c),n=new R.CancellationTokenSource(p);let o,t=!1;const r={path:v,excludes:[],recursive:!1},s=new m(r,l=>{(async()=>{for(const{type:a}of l)if(a===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:g}=await C.Promises.read(u,d,0,c,null);if(!g||n.token.isCancellationRequested)break;y(d.slice(0,g))}}catch(g){o=new Error(g),n.dispose(!0)}finally{t=!1}}})()});return await s.ready,h(),new Promise((l,a)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await C.Promises.close(u)}catch(g){o=new Error(g)}o?a(o):l()})})}e.watchFileContents=f}),define(re[197],se([0,1,3,88,2,5,196]),function(Q,e,D,i,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends R.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(w){const b=this.normalizeRequests(w),C=b.filter(m=>{const f=this.watchers.get(m.path);return f?!(0,i.patternsEquals)(f.request.excludes,m.excludes)||!(0,i.patternsEquals)(f.request.includes,m.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:m})=>!b.find(f=>f.path===m.path&&(0,i.patternsEquals)(f.excludes,m.excludes)&&(0,i.patternsEquals)(f.includes,m.includes))).map(({request:m})=>m.path);C.length&&this.trace(`Request to start watching: ${C.map(m=>`${m.path} (excludes: ${m.excludes.length>0?m.excludes:"<none>"}, includes: ${m.includes&&m.includes.length>0?JSON.stringify(m.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const m of S)this.stopWatching(m);for(const m of C)this.startWatching(m)}startWatching(w){const b=new L.NodeJSFileWatcherLibrary(w,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),C={request:w,instance:b};this.watchers.set(w.path,C)}async stop(){for(const[w]of this.watchers)this.stopWatching(w);this.watchers.clear()}stopWatching(w){const b=this.watchers.get(w);b&&(this.watchers.delete(w),b.instance.dispose())}normalizeRequests(w){const b=new Map;for(const C of w){const S=T.isLinux?C.path:C.path.toLowerCase();b.set(S,C)}return Array.from(b.values())}async setVerboseLogging(w){this.verboseLogging=w;for(const[,b]of this.watchers)b.instance.setVerboseLogging(w)}trace(w){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(w)})}toMessage(w,b){return b?`[File Watcher (node.js)] ${w} (path: ${b.request.path})`:`[File Watcher (node.js)] ${w}`}}e.NodeJSWatcher=P}),define(re[198],se([0,1,57,197]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class R extends D.AbstractNonRecursiveWatcherClient{constructor(L,P,I){super(L,P,I),this.init()}createWatcher(){return new i.NodeJSWatcher}}e.NodeJSWatcherClient=R}),define(re[199],se([0,1,22,38,68,57]),function(Q,e,D,i,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class L extends T.AbstractUniversalWatcherClient{constructor(I,w,b){super(I,w,b),this.init()}createWatcher(I){const w=I.add(new R.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(w.onDidProcessExit(({code:b,signal:C})=>this.onError(`terminated by itself with code ${b}, signal: ${C}`))),i.ProxyChannel.toService((0,i.getNextTickChannel)(w.getChannel("watcher")))}}e.UniversalWatcherClient=L}),define(re[71],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this._entries=new Map;for(const[T,L]of R)this.set(T,L)}set(R,T){const L=this._entries.get(R);return this._entries.set(R,T),L}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=D}),define(re[200],se([0,1,6,11,2,56,190,4,71,82]),function(Q,e,D,i,R,T,L,P,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class C extends Error{constructor(y){super("cyclic dependency between services"),this.message=y.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${y.toString()}`}}class S{constructor(y=new I.ServiceCollection,h=!1,p,c=b){this._services=y,this._strict=h,this._parent=p,this._enableTracing=c,this._activeInstantiations=new Set,this._services.set(P.IInstantiationService,this),this._globalGraph=c?p?._globalGraph??new L.Graph(u=>u):void 0}createChild(y){return new S(y,this._strict,this,this._enableTracing)}invokeFunction(y,...h){const p=f.traceInvocation(this._enableTracing,y);let c=!1;try{return y({get:d=>{if(c)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const n=this._getOrCreateServiceInstance(d,p);if(!n)throw new Error(`[invokeFunction] unknown service '${d}'`);return n}},...h)}finally{c=!0,p.stop()}}createInstance(y,...h){let p,c;return y instanceof T.SyncDescriptor?(p=f.traceCreation(this._enableTracing,y.ctor),c=this._createInstance(y.ctor,y.staticArguments.concat(h),p)):(p=f.traceCreation(this._enableTracing,y),c=this._createInstance(y,h,p)),p.stop(),c}_createInstance(y,h=[],p){const c=P._util.getServiceDependencies(y).sort((n,o)=>n.index-o.index),u=[];for(const n of c){const o=this._getOrCreateServiceInstance(n.id,p);o||this._throwIfStrict(`[createInstance] ${y.name} depends on UNKNOWN service ${n.id}.`,!1),u.push(o)}const d=c.length>0?c[0].index:h.length;if(h.length!==d){console.trace(`[createInstance] First service dependency of ${y.name} at position ${d+1} conflicts with ${h.length} static arguments`);const n=d-h.length;n>0?h=h.concat(new Array(n)):h=h.slice(0,d)}return Reflect.construct(y,h.concat(u))}_setServiceInstance(y,h){if(this._services.get(y)instanceof T.SyncDescriptor)this._services.set(y,h);else if(this._parent)this._parent._setServiceInstance(y,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(y){const h=this._services.get(y);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(y):h}_getOrCreateServiceInstance(y,h){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(y));const p=this._getServiceInstanceOrDescriptor(y);return p instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(y,p,h.branch(y,!0)):(h.branch(y,!1),p)}_safeCreateAndCacheServiceInstance(y,h,p){if(this._activeInstantiations.has(y))throw new Error(`illegal state - RECURSIVELY instantiating service '${y}'`);this._activeInstantiations.add(y);try{return this._createAndCacheServiceInstance(y,h,p)}finally{this._activeInstantiations.delete(y)}}_createAndCacheServiceInstance(y,h,p){const c=new L.Graph(n=>n.id.toString());let u=0;const d=[{id:y,desc:h,_trace:p}];for(;d.length;){const n=d.pop();if(c.lookupOrInsertNode(n),u++>1e3)throw new C(c);for(const o of P._util.getServiceDependencies(n.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(o.id);if(t||this._throwIfStrict(`[createInstance] ${y} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(o.id)),t instanceof T.SyncDescriptor){const r={id:o.id,desc:t,_trace:n._trace.branch(o.id,!0)};c.insertEdge(n,r),d.push(r)}}}for(;;){const n=c.roots();if(n.length===0){if(!c.isEmpty())throw new C(c);break}for(const{data:o}of n){if(this._getServiceInstanceOrDescriptor(o.id)instanceof T.SyncDescriptor){const r=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,r)}c.removeNode(o)}}return this._getServiceInstanceOrDescriptor(y)}_createServiceInstanceWithOwner(y,h,p=[],c,u){if(this._services.get(y)instanceof T.SyncDescriptor)return this._createServiceInstance(y,h,p,c,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(y,h,p,c,u);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(y,h,p=[],c,u){if(c){const d=new S(void 0,this._strict,this,this._enableTracing);d._globalGraphImplicitDependency=String(y);const n=new Map,o=new D.IdleValue(()=>{const t=d._createInstance(h,p,u);for(const[r,s]of n){const l=t[r];if(typeof l=="function")for(const a of s)l.apply(t,a)}return n.clear(),t});return new Proxy(Object.create(null),{get(t,r){if(!o.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let a=n.get(r);return a||(a=new w.LinkedList,n.set(r,a)),(E,A,B)=>{const O=a.push([E,A,B]);return(0,R.toDisposable)(O)}}if(r in t)return t[r];const s=o.value;let l=s[r];return typeof l!="function"||(l=l.bind(s),t[r]=l),l},set(t,r,s){return o.value[r]=s,!0}})}else return this._createInstance(h,p,u)}_throwIfStrict(y,h){if(h&&console.warn(y),this._strict)throw new Error(y)}}e.InstantiationService=S;var m;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(m||(m={}));class f{static traceInvocation(y,h){return y?new f(1,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f._None}static traceCreation(y,h){return y?new f(0,h.name):f._None}constructor(y,h){this.type=y,this.name=h,this._start=Date.now(),this._dep=[]}branch(y,h){const p=new f(2,y.toString());return this._dep.push([y,h,p]),p}stop(){const y=Date.now()-this._start;f._totals+=y;let h=!1;function p(u,d){const n=[],o=new Array(u+1).join("	");for(const[t,r,s]of d._dep)if(r&&s){h=!0,n.push(`${o}CREATES -> ${t}`);const l=p(u+1,s);l&&n.push(l)}else n.push(`${o}uses -> ${t}`);return n.join(`
`)}const c=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${y.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(y>2||h)&&f.all.add(c.join(`
`))}}e.Trace=f,f.all=new Set,f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(re[201],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,T){this.server=R,this.router=T}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,T){this.server.registerChannel(R,T)}}e.MessagePortMainProcessService=D}),define(re[58],se([0,1,38,56,94,4]),function(Q,e,D,i,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class L{constructor(m,f,v,y){const h=v.getChannel(m);return P(f)?y.createInstance(new i.SyncDescriptor(f.channelClientCtor,[h])):D.ProxyChannel.toService(h,f?.proxyOptions)}}function P(S){return!!S?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let I=class extends L{constructor(m,f,v,y){super(m,f,v,y)}};I=ve([K(2,e.IMainProcessService),K(3,T.IInstantiationService)],I);function w(S,m,f){(0,R.registerSingleton)(S,new i.SyncDescriptor(I,[m,f],!0))}e.registerMainProcessRemoteService=w,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let b=class extends L{constructor(m,f,v,y){super(m,f,v,y)}};b=ve([K(2,e.ISharedProcessService),K(3,T.IInstantiationService)],b);function C(S,m,f){(0,R.registerSingleton)(S,new i.SyncDescriptor(b,[m,f],!0))}e.registerSharedProcessRemoteService=C}),define(re[72],se([0,1,24,2,5,167,29,4]),function(Q,e,D,i,R,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let I=class extends i.Disposable{constructor(b){super(),this.extensionGalleryService=b}async getAvailableLanguages(){const b=new D.CancellationTokenSource;setTimeout(()=>b.cancel(),1e3);let C;try{C=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const m=C.firstPage.filter(f=>f.properties.localizedLanguages?.length&&f.tags.some(v=>v.startsWith("lp-"))).map(f=>{const v=f.properties.localizedLanguages?.[0],y=this.getLocale(f);return{...this.createQuickPickItem(y,v,f),extensionId:f.identifier.id,galleryExtension:f}});return m.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),m}getLocale(b){return b.tags.find(C=>C.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(b,C,S){const m=C??b;let f;if(m!==b&&(f=`(${b})`),b.toLowerCase()===R.language.toLowerCase()&&(f??="",f+=(0,T.localize)(0,null)),S?.installCount){f??="";const v=S.installCount;let y;v>1e6?y=`${Math.floor(v/1e5)/10}M`:v>1e3?y=`${Math.floor(v/1e3)}K`:y=String(v),f+=` $(cloud-download) ${y}`}return{id:b,label:m,description:f}}};I=ve([K(0,L.IExtensionGalleryService)],I),e.LanguagePackBaseService=I}),define(re[202],se([0,1,2,72]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(L){super(),this.localizationsService=L,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=ve([K(0,i.ILanguagePackService)],R),e.LocalizationsUpdater=R}),define(re[7],se([0,1,37,3,2,41,5,8,4]),function(Q,e,D,i,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function w(){return new Date().toISOString()}var b;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function C(l,a,g){switch(a){case b.Trace:l.trace(g);break;case b.Debug:l.debug(g);break;case b.Info:l.info(g);break;case b.Warning:l.warn(g);break;case b.Error:l.error(g);break;case b.Critical:l.critical(g);break;default:throw new Error("Invalid log level")}}e.log=C;function S(l){let a="";for(let g=0;g<l.length;g++){let E=l[g];if(typeof E=="object")try{E=JSON.stringify(E)}catch{}a+=(g>0?" ":"")+E}return a}e.format=S;class m extends R.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new i.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=m;class f extends m{constructor(a){super(),this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...g){this.checkLogLevel(b.Trace)&&this.log(b.Trace,S([a,...g]))}debug(a,...g){this.checkLogLevel(b.Debug)&&this.log(b.Debug,S([a,...g]))}info(a,...g){this.checkLogLevel(b.Info)&&this.log(b.Info,S([a,...g]))}warn(a,...g){this.checkLogLevel(b.Warning)&&this.log(b.Warning,S([a,...g]))}error(a,...g){if(this.checkLogLevel(b.Error))if(a instanceof Error){const E=Array.prototype.slice.call(arguments);E[0]=a.stack,this.log(b.Error,S(E))}else this.log(b.Error,S([a,...g]))}critical(a,...g){this.checkLogLevel(b.Critical)&&this.log(b.Critical,S([a,...g]))}flush(){}}e.AbstractMessageLogger=f;class v extends m{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.useColors=!L.isWindows}trace(a,...g){this.getLevel()<=b.Trace&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,a,...g):console.log(`[main ${w()}]`,a,...g))}debug(a,...g){this.getLevel()<=b.Debug&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,a,...g):console.log(`[main ${w()}]`,a,...g))}info(a,...g){this.getLevel()<=b.Info&&(this.useColors?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,a,...g):console.log(`[main ${w()}]`,a,...g))}warn(a,...g){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,a,...g):console.warn(`[main ${w()}]`,a,...g))}error(a,...g){this.getLevel()<=b.Error&&(this.useColors?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,a,...g):console.error(`[main ${w()}]`,a,...g))}critical(a,...g){this.getLevel()<=b.Critical&&(this.useColors?console.error(`\x1B[90m[main ${w()}]\x1B[0m`,a,...g):console.error(`[main ${w()}]`,a,...g))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class y extends m{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...g){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",a,...g)}debug(a,...g){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...g)}info(a,...g){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",a,...g)}warn(a,...g){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",a,...g)}error(a,...g){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",a,...g)}critical(a,...g){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",a,...g)}dispose(){}flush(){}}e.ConsoleLogger=y;class h extends m{constructor(a,g=e.DEFAULT_LOG_LEVEL){super(),this.adapter=a,this.setLevel(g)}trace(a,...g){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(a),...g])}debug(a,...g){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(a),...g])}info(a,...g){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(a),...g])}warn(a,...g){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(a),...g])}error(a,...g){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(a),...g])}critical(a,...g){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(a),...g])}extractMessage(a){return typeof a=="string"?a:(0,D.toErrorMessage)(a,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class p extends m{constructor(a){super(),this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const g of this.logServices)g.setLevel(a);super.setLevel(a)}trace(a,...g){for(const E of this.logServices)E.trace(a,...g)}debug(a,...g){for(const E of this.logServices)E.debug(a,...g)}info(a,...g){for(const E of this.logServices)E.info(a,...g)}warn(a,...g){for(const E of this.logServices)E.warn(a,...g)}error(a,...g){for(const E of this.logServices)E.error(a,...g)}critical(a,...g){for(const E of this.logServices)E.critical(a,...g)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}e.MultiplexLogService=p;class c extends R.Disposable{constructor(a){super(),this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...g){this.logger.trace(a,...g)}debug(a,...g){this.logger.debug(a,...g)}info(a,...g){this.logger.info(a,...g)}warn(a,...g){this.logger.warn(a,...g)}error(a,...g){this.logger.error(a,...g)}critical(a,...g){this.logger.critical(a,...g)}flush(){this.logger.flush()}}e.LogService=c;class u extends R.Disposable{constructor(a,g){super(),this.logLevel=a,this.loggerItems=new T.ResourceMap,this._register(g(E=>this.setLevel(E)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:a})=>a)}getLogger(a){return this.loggerItems.get(a)?.logger}createLogger(a,g,E){let A=this.loggerItems.get(a)?.logger;return A||(E=g?.always?b.Trace:E,A=this.doCreateLogger(a,E??this.logLevel,g),this.loggerItems.set(a,{logger:A,logLevel:E})),A}setLevel(a,g){const E=P.URI.isUri(a)?a:void 0,A=E?g:a;if(E){const B=this.loggerItems.get(E);B&&B.logLevel!==A&&(B.logLevel=A,B.logger.setLevel(A))}else this.logLevel=A,this.loggerItems.forEach(({logLevel:B,logger:O})=>{B===void 0&&O.setLevel(this.logLevel)})}getLogLevel(a){return this.loggerItems.get(a)?.logLevel}dispose(){this.loggerItems.forEach(({logger:a})=>a.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=u;class d{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(a){}getLevel(){return b.Info}trace(a,...g){}debug(a,...g){}info(a,...g){}warn(a,...g){}error(a,...g){}critical(a,...g){}dispose(){}flush(){}}e.NullLogger=d;class n extends d{}e.NullLogService=n;class o extends u{constructor(){super(b.Info,i.Event.None)}doCreateLogger(a,g,E){return new d}}e.NullLoggerService=o;function t(l){if(l.verbose)return b.Trace;if(typeof l.logLevel=="string"){const a=r(l.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=t;function r(l){switch(l){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=r;function s(l){switch(l){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=s}),define(re[203],se([0,1,6,11,2,12,28,13,7]),function(Q,e,D,i,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let w=class extends R.Disposable{constructor(C,S){super(),this.environmentService=C,this.logService=S,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,T.basename)(this.environmentService.logsPath),S=(0,T.dirname)(this.environmentService.logsPath),v=(await L.Promises.readdir(S)).filter(h=>/^\d{8}T\d{6}$/.test(h)).sort().filter(h=>h!==C),y=v.slice(0,Math.max(0,v.length-9));y.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${y.join(", ")}'`),await Promise.all(y.map(h=>L.Promises.rm((0,T.join)(S,h)))))}catch(C){(0,i.onUnexpectedError)(C)}}};w=ve([K(0,P.IEnvironmentService),K(1,I.ILogService)],w),e.LogsDataCleaner=w}),define(re[204],se([0,1,20,6,11,3,2,12,57,7]),function(Q,e,D,i,R,T,L,P,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends L.Disposable{constructor(S,m){super(),this.logService=S,this.options=m,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new i.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new i.ThrottledDelayer(0))}watch(S,m){return m.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,m):this.watchNonRecursive(S,m)}watchUniversal(S,m){const f={path:this.toFilePath(S),excludes:m.excludes,includes:m.includes,recursive:m.recursive},v=(0,D.insert)(this.universalPathsToWatch,f);return this.refreshUniversalWatchers(),(0,L.toDisposable)(()=>{v(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,R.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(m=>this._onDidChangeFile.fire((0,I.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const m of this.universalPathsToWatch)(0,I.isRecursiveWatchRequest)(m)&&(m.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const m of this.universalPathsToWatch)(0,I.isRecursiveWatchRequest)(m)&&S.includes(m.path)&&(m.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,m){const f={path:this.toFilePath(S),excludes:m.excludes,includes:m.includes,recursive:!1},v=(0,D.insert)(this.nonRecursivePathsToWatch,f);return this.refreshNonRecursiveWatchers(),(0,L.toDisposable)(()=>{v(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,R.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,I.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,P.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(re[205],se([0,1,20,6,17,24,3,66,64,2,49,22,206,21,43,163,14,100,7]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v,y,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class extends w.Disposable{constructor(d){super(),this.logService=d,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new i.ResourceQueue)}registerProvider(d,n){if(this.provider.has(d))throw new Error(`A filesystem provider for the scheme '${d}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${d}`);const o=new w.DisposableStore;return this.provider.set(d,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:d,provider:n}),o.add(n.onDidChangeFile(t=>this._onDidFilesChange.fire(new y.FileChangesEvent(t,!this.isPathCaseSensitive(n))))),typeof n.onDidWatchError=="function"&&o.add(n.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),o.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:d}))),(0,w.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:d,provider:n}),this.provider.delete(d),(0,w.dispose)(o)})}getProvider(d){return this.provider.get(d)}async activateProvider(d){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:d,join(o){n.push(o)}}),!this.provider.has(d)&&await i.Promises.settled(n)}async canHandleResource(d){return await this.activateProvider(d.scheme),this.hasProvider(d)}hasProvider(d){return this.provider.has(d.scheme)}hasCapability(d,n){const o=this.provider.get(d.scheme);return!!(o&&o.capabilities&n)}listCapabilities(){return I.Iterable.map(this.provider,([d,n])=>({scheme:d,capabilities:n.capabilities}))}async withProvider(d){if(!(0,m.isAbsolutePath)(d))throw new y.FileOperationError((0,v.localize)(0,null,this.resourceForError(d)),8);await this.activateProvider(d.scheme);const n=this.provider.get(d.scheme);if(!n){const o=new Error;throw o.name="ENOPRO",o.message=(0,v.localize)(1,null,d.toString()),o}return n}async withReadProvider(d){const n=await this.withProvider(d);if((0,y.hasOpenReadWriteCloseCapability)(n)||(0,y.hasReadWriteCapability)(n)||(0,y.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${d.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(d){const n=await this.withProvider(d);if((0,y.hasOpenReadWriteCloseCapability)(n)||(0,y.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${d.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(d,n){try{return await this.doResolveFile(d,n)}catch(o){throw(0,y.toFileSystemProviderErrorCode)(o)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,v.localize)(2,null,this.resourceForError(d)),1):(0,y.ensureFileSystemProviderError)(o)}}async doResolveFile(d,n){const o=await this.withProvider(d),t=this.isPathCaseSensitive(o),r=n?.resolveTo,s=n?.resolveSingleChildDescendants,l=n?.resolveMetadata,a=await o.stat(d);let g;return this.toFileStat(o,d,a,void 0,!!l,(E,A)=>(g||(g=b.TernarySearchTree.forUris(()=>!t),g.set(d,!0),r&&g.fill(!0,r)),g.get(E.resource)||g.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&s?A===1:!1))}async toFileStat(d,n,o,t,r,s){const{providerExtUri:l}=this.getExtUri(d),a={resource:n,name:l.basename(n),isFile:(o.type&y.FileType.File)!==0,isDirectory:(o.type&y.FileType.Directory)!==0,isSymbolicLink:(o.type&y.FileType.SymbolicLink)!==0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:Boolean((o.permissions??0)&y.FilePermission.Readonly)||Boolean(d.capabilities&2048),etag:(0,y.etag)({mtime:o.mtime,size:o.size}),children:void 0};if(a.isDirectory&&s(a,t)){try{const g=await d.readdir(n),E=await i.Promises.settled(g.map(async([A,B])=>{try{const O=l.joinPath(n,A),N=r?await d.stat(O):{type:B};return await this.toFileStat(d,O,N,g.length,r,s)}catch(O){return this.logService.trace(O),null}}));a.children=(0,D.coalesce)(E)}catch(g){this.logService.trace(g),a.children=[]}return a}return a}async resolveAll(d){return i.Promises.settled(d.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(o){return this.logService.trace(o),{stat:void 0,success:!1}}}))}async stat(d){const n=await this.withProvider(d),o=await n.stat(d);return this.toFileStat(n,d,o,void 0,!0,()=>!1)}async exists(d){const n=await this.withProvider(d);try{return!!await n.stat(d)}catch{return!1}}async canCreateFile(d,n){try{await this.doValidateCreateFile(d,n)}catch(o){return o}return!0}async doValidateCreateFile(d,n){if(!n?.overwrite&&await this.exists(d))throw new y.FileOperationError((0,v.localize)(3,null,this.resourceForError(d)),3,n)}async createFile(d,n=R.VSBuffer.fromString(""),o){await this.doValidateCreateFile(d,o);const t=await this.writeFile(d,n);return this._onDidRunOperation.fire(new y.FileOperationEvent(d,0,t)),t}async writeFile(d,n,o){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(d),d),{providerExtUri:r}=this.getExtUri(t);try{await this.validateWriteFile(t,d,o)||await this.mkdirp(t,r.dirname(d));let l;if((0,y.hasReadWriteCapability)(t)&&!(n instanceof R.VSBuffer))if((0,f.isReadableStream)(n)){const a=await(0,f.peekStream)(n,3);a.ended?l=R.VSBuffer.concat(a.buffer):l=a}else l=(0,f.peekReadable)(n,a=>R.VSBuffer.concat(a),3);else l=n;!(0,y.hasOpenReadWriteCloseCapability)(t)||(0,y.hasReadWriteCapability)(t)&&l instanceof R.VSBuffer?await this.doWriteUnbuffered(t,d,o,l):await this.doWriteBuffered(t,d,o,l instanceof R.VSBuffer?(0,R.bufferToReadable)(l):l),this._onDidRunOperation.fire(new y.FileOperationEvent(d,4))}catch(s){throw new y.FileOperationError((0,v.localize)(4,null,this.resourceForError(d),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),o)}return this.resolve(d,{resolveMetadata:!0})}async validateWriteFile(d,n,o){if(!!o?.unlock&&!(d.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(n)));let r;try{r=await d.stat(n)}catch{return}if((r.type&y.FileType.Directory)!==0)throw new y.FileOperationError((0,v.localize)(6,null,this.resourceForError(n)),0,o);if(this.throwIfFileIsReadonly(n,r),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==y.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&o.mtime<r.mtime&&o.etag!==(0,y.etag)({mtime:o.mtime,size:r.size}))throw new y.FileOperationError((0,v.localize)(7,null),3,o);return r}async readFile(d,n,o){const t=await this.withReadProvider(d);return n?.atomic?this.doReadFileAtomic(t,d,n,o):this.doReadFile(t,d,n,o)}async doReadFileAtomic(d,n,o,t){return new Promise((r,s)=>{this.writeQueue.queueFor(n,this.getExtUri(d).providerExtUri).queue(async()=>{try{const l=await this.doReadFile(d,n,o,t);r(l)}catch(l){s(l)}})})}async doReadFile(d,n,o,t){const r=await this.doReadFileStream(d,n,{...o,preferUnbuffered:!0},t);return{...r,value:await(0,R.streamToBuffer)(r.value)}}async readFileStream(d,n,o){const t=await this.withReadProvider(d);return this.doReadFileStream(t,d,n,o)}async doReadFileStream(d,n,o,t){const r=new T.CancellationTokenSource(t),s=this.validateReadFile(n,o).then(a=>a,a=>{throw r.cancel(),a});let l;try{return typeof o?.etag=="string"&&o.etag!==y.ETAG_DISABLED&&await s,o?.atomic&&(0,y.hasFileAtomicReadCapability)(d)||!((0,y.hasOpenReadWriteCloseCapability)(d)||(0,y.hasFileReadStreamCapability)(d))||(0,y.hasReadWriteCapability)(d)&&o?.preferUnbuffered?l=this.readFileUnbuffered(d,n,o):(0,y.hasFileReadStreamCapability)(d)?l=this.readFileStreamed(d,n,r.token,o):l=this.readFileBuffered(d,n,r.token,o),{...await s,value:l}}catch(a){l&&await(0,f.consumeStream)(l);const g=(0,v.localize)(8,null,this.resourceForError(n),(0,y.ensureFileSystemProviderError)(a).toString());throw a instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(g,a.stat,o):new y.FileOperationError(g,(0,y.toFileOperationResult)(a),o)}}readFileStreamed(d,n,o,t=Object.create(null)){const r=d.readFileStream(n,t,o);return(0,f.transform)(r,{data:s=>s instanceof R.VSBuffer?s:R.VSBuffer.wrap(s),error:s=>new y.FileOperationError((0,v.localize)(9,null,this.resourceForError(n),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),t)},s=>R.VSBuffer.concat(s))}readFileBuffered(d,n,o,t=Object.create(null)){const r=(0,R.newWriteableBufferStream)();return(0,h.readFileIntoStream)(d,n,r,s=>s,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new y.FileOperationError((0,v.localize)(10,null,this.resourceForError(n),(0,y.ensureFileSystemProviderError)(s).toString()),(0,y.toFileOperationResult)(s),t)},o),r}readFileUnbuffered(d,n,o){const t=(0,f.newWriteableStream)(r=>R.VSBuffer.concat(r));return(async()=>{try{let r;o?.atomic&&(0,y.hasFileAtomicReadCapability)(d)?r=await d.readFile(n,{atomic:!0}):r=await d.readFile(n),typeof o?.position=="number"&&(r=r.slice(o.position)),typeof o?.length=="number"&&(r=r.slice(0,o.length)),this.validateReadFileLimits(n,r.byteLength,o),t.end(R.VSBuffer.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async validateReadFile(d,n){const o=await this.resolve(d,{resolveMetadata:!0});if(o.isDirectory)throw new y.FileOperationError((0,v.localize)(11,null,this.resourceForError(d)),0,n);if(typeof n?.etag=="string"&&n.etag!==y.ETAG_DISABLED&&n.etag===o.etag)throw new y.NotModifiedSinceFileOperationError((0,v.localize)(12,null),o,n);return this.validateReadFileLimits(d,o.size,n),o}validateReadFileLimits(d,n,o){if(o?.limits){let t;if(typeof o.limits.memory=="number"&&n>o.limits.memory&&(t=9),typeof o.limits.size=="number"&&n>o.limits.size&&(t=7),typeof t=="number")throw new y.FileOperationError((0,v.localize)(13,null,this.resourceForError(d)),t)}}async canMove(d,n,o){return this.doCanMoveCopy(d,n,"move",o)}async canCopy(d,n,o){return this.doCanMoveCopy(d,n,"copy",o)}async doCanMoveCopy(d,n,o,t){if(d.toString()!==n.toString())try{const r=o==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(d),d):await this.withReadProvider(d),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(r,d,s,n,o,t)}catch(r){return r}return!0}async move(d,n,o){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(d),d),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(t,d,r,n,"move",!!o),l=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(d,s==="move"?2:3,l)),l}async copy(d,n,o){const t=await this.withReadProvider(d),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(t,d,r,n,"copy",!!o),l=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(d,s==="copy"?3:2,l)),l}async doMoveCopy(d,n,o,t,r,s){if(n.toString()===t.toString())return r;const{exists:l,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(d,n,o,t,r,s);if(l&&!a&&s&&await this.del(t,{recursive:!0}),await this.mkdirp(o,this.getExtUri(o).providerExtUri.dirname(t)),r==="copy"){if(d===o&&(0,y.hasFileFolderCopyCapability)(d))await d.copy(n,t,{overwrite:s});else{const g=await this.resolve(n);g.isDirectory?await this.doCopyFolder(d,g,o,t):await this.doCopyFile(d,n,o,t)}return r}else return d===o?(await d.rename(n,t,{overwrite:s}),r):(await this.doMoveCopy(d,n,o,t,"copy",s),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(d,n,o,t){if((0,y.hasOpenReadWriteCloseCapability)(d)&&(0,y.hasOpenReadWriteCloseCapability)(o))return this.doPipeBuffered(d,n,o,t);if((0,y.hasOpenReadWriteCloseCapability)(d)&&(0,y.hasReadWriteCapability)(o))return this.doPipeBufferedToUnbuffered(d,n,o,t);if((0,y.hasReadWriteCapability)(d)&&(0,y.hasOpenReadWriteCloseCapability)(o))return this.doPipeUnbufferedToBuffered(d,n,o,t);if((0,y.hasReadWriteCapability)(d)&&(0,y.hasReadWriteCapability)(o))return this.doPipeUnbuffered(d,n,o,t)}async doCopyFolder(d,n,o,t){await o.mkdir(t),Array.isArray(n.children)&&await i.Promises.settled(n.children.map(async r=>{const s=this.getExtUri(o).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.doCopyFolder(d,await this.resolve(r.resource),o,s):this.doCopyFile(d,r.resource,o,s)}))}async doValidateMoveCopy(d,n,o,t,r,s){let l=!1;if(d===o){const{providerExtUri:g,isPathCaseSensitive:E}=this.getExtUri(d);if(E||(l=g.isEqual(n,t)),l&&r==="copy")throw new Error((0,v.localize)(14,null,this.resourceForError(n),this.resourceForError(t)));if(!l&&g.isEqualOrParent(t,n))throw new Error((0,v.localize)(15,null,this.resourceForError(n),this.resourceForError(t)))}const a=await this.exists(t);if(a&&!l){if(!s)throw new y.FileOperationError((0,v.localize)(16,null,this.resourceForError(n),this.resourceForError(t)),4);if(d===o){const{providerExtUri:g}=this.getExtUri(d);if(g.isEqualOrParent(n,t))throw new Error((0,v.localize)(17,null,this.resourceForError(n),this.resourceForError(t)))}}return{exists:a,isSameResourceWithDifferentPathCase:l}}getExtUri(d){const n=this.isPathCaseSensitive(d);return{providerExtUri:n?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(d){return!!(d.capabilities&1024)}async createFolder(d){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(d),d);await this.mkdirp(n,d);const o=await this.resolve(d,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(d,0,o)),o}async mkdirp(d,n){const o=[],{providerExtUri:t}=this.getExtUri(d);for(;!t.isEqual(n,t.dirname(n));)try{if(((await d.stat(n)).type&y.FileType.Directory)===0)throw new Error((0,v.localize)(18,null,this.resourceForError(n)));break}catch(r){if((0,y.toFileSystemProviderErrorCode)(r)!==y.FileSystemProviderErrorCode.FileNotFound)throw r;o.push(t.basename(n)),n=t.dirname(n)}for(let r=o.length-1;r>=0;r--){n=t.joinPath(n,o[r]);try{await d.mkdir(n)}catch(s){if((0,y.toFileSystemProviderErrorCode)(s)!==y.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(d,n){try{await this.doValidateDelete(d,n)}catch(o){return o}return!0}async doValidateDelete(d,n){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(d),d);if(!!n?.useTrash&&!(o.capabilities&4096))throw new Error((0,v.localize)(19,null,this.resourceForError(d)));let r;try{r=await o.stat(d)}catch{}if(r)this.throwIfFileIsReadonly(d,r);else throw new y.FileOperationError((0,v.localize)(20,null,this.resourceForError(d)),1);if(!!!n?.recursive){const l=await this.resolve(d);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,v.localize)(21,null,this.resourceForError(d)))}return o}async del(d,n){const o=await this.doValidateDelete(d,n),t=!!n?.useTrash,r=!!n?.recursive;await o.delete(d,{recursive:r,useTrash:t}),this._onDidRunOperation.fire(new y.FileOperationEvent(d,1))}async cloneFile(d,n){const o=await this.withProvider(d),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(o===t&&this.getExtUri(o).providerExtUri.isEqual(d,n))return;if(o===t&&(0,y.hasFileCloneCapability)(o))return o.cloneFile(d,n);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(n));const r=this.writeQueue.queueFor(d,this.getExtUri(o).providerExtUri);return o===t&&(0,y.hasFileFolderCopyCapability)(o)?r.queue(()=>o.copy(d,n,{overwrite:!0})):r.queue(()=>this.doCopyFile(o,d,t,n))}watch(d,n={recursive:!1,excludes:[]}){const o=new w.DisposableStore;let t=!1,r=()=>{t=!0};return o.add((0,w.toDisposable)(()=>r())),(async()=>{try{const s=await this.doWatch(d,n);t?(0,w.dispose)(s):r=()=>(0,w.dispose)(s)}catch(s){this.logService.error(s)}})(),o}async doWatch(d,n){const o=await this.withProvider(d),t=(0,P.hash)([this.getExtUri(o).providerExtUri.getComparisonKey(d),n]);let r=this.activeWatchers.get(t);return r||(r={count:0,disposable:o.watch(d,n)},this.activeWatchers.set(t,r)),r.count+=1,(0,w.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,w.dispose)(r.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,d]of this.activeWatchers)(0,w.dispose)(d.disposable);this.activeWatchers.clear()}async doWriteBuffered(d,n,o,t){return this.writeQueue.queueFor(n,this.getExtUri(d).providerExtUri).queue(async()=>{const r=await d.open(n,{create:!0,unlock:o?.unlock??!1});try{(0,f.isReadableStream)(t)||(0,f.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(d,r,t):await this.doWriteReadableBufferedQueued(d,r,t)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await d.close(r)}})}async doWriteStreamBufferedQueued(d,n,o){let t=0,r;if((0,f.isReadableBufferedStream)(o)){if(o.buffer.length>0){const s=R.VSBuffer.concat(o.buffer);await this.doWriteBuffer(d,n,s,s.byteLength,t,0),t+=s.byteLength}if(o.ended)return;r=o.stream}else r=o;return new Promise((s,l)=>{(0,f.listenStream)(r,{onData:async a=>{r.pause();try{await this.doWriteBuffer(d,n,a,a.byteLength,t,0)}catch(g){return l(g)}t+=a.byteLength,setTimeout(()=>r.resume())},onError:a=>l(a),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(d,n,o){let t=0,r;for(;(r=o.read())!==null;)await this.doWriteBuffer(d,n,r,r.byteLength,t,0),t+=r.byteLength}async doWriteBuffer(d,n,o,t,r,s){let l=0;for(;l<t;)l+=await d.write(n,r+l,o.buffer,s+l,t-l)}async doWriteUnbuffered(d,n,o,t){return this.writeQueue.queueFor(n,this.getExtUri(d).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(d,n,o,t))}async doWriteUnbufferedQueued(d,n,o,t){let r;t instanceof R.VSBuffer?r=t:(0,f.isReadableStream)(t)?r=await(0,R.streamToBuffer)(t):(0,f.isReadableBufferedStream)(t)?r=await(0,R.bufferedStreamToBuffer)(t):r=(0,R.readableToBuffer)(t),await d.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1})}async doPipeBuffered(d,n,o,t){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeBufferedQueued(d,n,o,t))}async doPipeBufferedQueued(d,n,o,t){let r,s;try{r=await d.open(n,{create:!1}),s=await o.open(t,{create:!0,unlock:!1});const l=R.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,g=0,E=0;do E=await d.read(r,a,l.buffer,g,l.byteLength-g),await this.doWriteBuffer(o,s,l,E,a,g),a+=E,g+=E,g===l.byteLength&&(g=0);while(E>0)}catch(l){throw(0,y.ensureFileSystemProviderError)(l)}finally{await i.Promises.settled([typeof r=="number"?d.close(r):Promise.resolve(),typeof s=="number"?o.close(s):Promise.resolve()])}}async doPipeUnbuffered(d,n,o,t){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(d,n,o,t))}async doPipeUnbufferedQueued(d,n,o,t){return o.writeFile(t,await d.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(d,n,o,t){return this.writeQueue.queueFor(t,this.getExtUri(o).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(d,n,o,t))}async doPipeUnbufferedToBufferedQueued(d,n,o,t){const r=await o.open(t,{create:!0,unlock:!1});try{const s=await d.readFile(n);await this.doWriteBuffer(o,r,R.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await o.close(r)}}async doPipeBufferedToUnbuffered(d,n,o,t){const r=await(0,R.streamToBuffer)(this.readFileBuffered(d,n,T.CancellationToken.None));await this.doWriteUnbuffered(o,t,void 0,r)}throwIfFileSystemIsReadonly(d,n){if(d.capabilities&2048)throw new y.FileOperationError((0,v.localize)(22,null,this.resourceForError(n)),6);return d}throwIfFileIsReadonly(d,n){if((n.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,v.localize)(23,null,this.resourceForError(d)),6)}resourceForError(d){return d.scheme===C.Schemas.file?d.fsPath:d.toString(!0)}};c=ve([K(0,p.ILogService)],c),e.FileService=c}),define(re[207],se([0,1,54,286,6,41,17,3,48,2,12,5,21,43,28,166,14,100,204,37,199,198]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v,y,h,p,c,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,i.gracefulify)(D)}catch(o){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(o)}`)}})();class n extends p.AbstractDiskFileSystemProvider{constructor(t,r){super(t,r),this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new T.ResourceMap(s=>S.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:r,symbolicLink:s}=await f.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(r,s),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(t){try{const r=await f.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),s=[];return await Promise.all(r.map(async l=>{try{let a;l.isSymbolicLink()?a=(await this.stat((0,S.joinPath)(t,l.name))).type:a=this.toType(l),s.push([l.name,a])}catch(a){this.logService.trace(a)}})),s}catch(r){throw this.toFileSystemProviderError(r)}}toType(t,r){let s;return r?.dangling?s=y.FileType.Unknown:t.isFile()?s=y.FileType.File:t.isDirectory()?s=y.FileType.Directory:s=y.FileType.Unknown,r&&(s|=y.FileType.SymbolicLink),s}async createResourceLock(t){const r=this.toFilePath(t);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let s;for(;s=this.resourceLocks.get(t);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await s.wait();const l=new R.Barrier;return this.resourceLocks.set(t,l),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,w.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(t)===l&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(t)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),l.open()})}async readFile(t,r){let s;try{r?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),s=await this.createResourceLock(t));const l=this.toFilePath(t);return await f.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}finally{s?.dispose()}}traceLock(t){n.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(t)}readFileStream(t,r,s){const l=(0,m.newWriteableStream)(a=>L.VSBuffer.concat(a.map(g=>L.VSBuffer.wrap(g))).buffer);return(0,h.readFileIntoStream)(this,t,l,a=>a.buffer,{...r,bufferSize:256*1024},s),l}async writeFile(t,r,s){let l;try{const a=this.toFilePath(t);if(!s.create||!s.overwrite){if(await f.Promises.exists(a)){if(!s.overwrite)throw(0,y.createFileSystemProviderError)((0,v.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,y.createFileSystemProviderError)((0,v.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:s.unlock}),await this.write(l,0,r,0,r.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(t,a)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(t){n.canFlush=t}async open(t,r){const s=this.toFilePath(t);let l;(0,y.isFileOpenForWriteOptions)(r)&&(l=await this.createResourceLock(t));let a;try{if((0,y.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:E}=await f.SymlinkSupport.stat(s);E.mode&128||await f.Promises.chmod(s,E.mode|128)}catch(E){this.logService.trace(E)}let g;if((0,y.isFileOpenForWriteOptions)(r)){if(C.isWindows)try{await f.Promises.truncate(s,0),g="r+"}catch(E){E.code!=="ENOENT"&&this.logService.trace(E)}g||(g="w")}else g="r";a=await f.Promises.open(s,g)}catch(g){throw l?.dispose(),(0,y.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(t,g):this.toFileSystemProviderError(g)}if(this.mapHandleToPos.set(a,0),(0,y.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(a,t),l){const g=this.mapHandleToLock.get(a);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${s})`),this.mapHandleToLock.set(a,l),g&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${s})`),g.dispose())}return a}async close(t){const r=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&n.canFlush)try{await f.Promises.fdatasync(t)}catch(s){n.configureFlushOnWrite(!1),this.logService.error(s)}return await f.Promises.close(t)}catch(s){throw this.toFileSystemProviderError(s)}finally{r&&(this.mapHandleToLock.get(t)===r&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),r.dispose())}}async read(t,r,s,l,a){const g=this.normalizePos(t,r);let E=null;try{E=(await f.Promises.read(t,s,l,a,g)).bytesRead}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(t,g,E)}return E}normalizePos(t,r){return r===this.mapHandleToPos.get(t)?null:r}updatePos(t,r,s){const l=this.mapHandleToPos.get(t);typeof l=="number"&&(typeof r=="number"||(typeof s=="number"?this.mapHandleToPos.set(t,l+s):this.mapHandleToPos.delete(t)))}async write(t,r,s,l,a){return(0,R.retry)(()=>this.doWrite(t,r,s,l,a),100,3)}async doWrite(t,r,s,l,a){const g=this.normalizePos(t,r);let E=null;try{E=(await f.Promises.write(t,s,l,a,g)).bytesWritten}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),A)}finally{this.updatePos(t,g,E)}return E}async mkdir(t){try{await f.Promises.mkdir(this.toFilePath(t))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(t,r){try{const s=this.toFilePath(t);r.recursive?await f.Promises.rm(s,f.RimRafMode.MOVE):await f.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(t,r,s){const l=this.toFilePath(t),a=this.toFilePath(r);if(l!==a)try{await this.validateTargetDeleted(t,r,"move",s.overwrite),await f.Promises.move(l,a)}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,v.localize)(2,null,(0,b.basename)(l),(0,b.basename)((0,b.dirname)(a)),g.toString()))),this.toFileSystemProviderError(g)}}async copy(t,r,s){const l=this.toFilePath(t),a=this.toFilePath(r);if(l!==a)try{await this.validateTargetDeleted(t,r,"copy",s.overwrite),await f.Promises.copy(l,a,{preserveSymlinks:!0})}catch(g){throw(g.code==="EINVAL"||g.code==="EBUSY"||g.code==="ENAMETOOLONG")&&(g=new Error((0,v.localize)(3,null,(0,b.basename)(l),(0,b.basename)((0,b.dirname)(a)),g.toString()))),this.toFileSystemProviderError(g)}}async validateTargetDeleted(t,r,s,l){const a=this.toFilePath(t),g=this.toFilePath(r);let E=!1;if(!!(this.capabilities&1024)||(E=(0,I.isEqual)(a,g,!0)),E&&s==="copy")throw(0,y.createFileSystemProviderError)((0,v.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!E&&await f.Promises.exists(g)){if(!l)throw(0,y.createFileSystemProviderError)((0,v.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(t,r){return this.doCloneFile(t,r,!1)}async doCloneFile(t,r,s){const l=this.toFilePath(t),a=this.toFilePath(r),g=!!(this.capabilities&1024);if((0,I.isEqual)(l,a,!g))return;const E=new w.DisposableStore;try{const[A,B]=await Promise.all([this.createResourceLock(t),this.createResourceLock(r)]);E.add(A),E.add(B),s&&await f.Promises.mkdir((0,b.dirname)(a),{recursive:!0}),await f.Promises.copyFile(l,a)}catch(A){if(A.code==="ENOENT"&&!s)return this.doCloneFile(t,r,!0);throw this.toFileSystemProviderError(A)}finally{E.dispose()}}createUniversalWatcher(t,r,s){return new u.UniversalWatcherClient(l=>t(l),l=>r(l),s)}createNonRecursiveWatcher(t,r,s){return new d.NodeJSWatcherClient(l=>t(l),l=>r(l),s)}toFileSystemProviderError(t){if(t instanceof y.FileSystemProviderError)return t;let r;switch(t.code){case"ENOENT":r=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=y.FileSystemProviderErrorCode.NoPermissions;break;default:r=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(t,r)}async toFileSystemProviderWriteError(t,r){let s=this.toFileSystemProviderError(r);if(t&&s.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await f.SymlinkSupport.stat(this.toFilePath(t));l.mode&128||(s=(0,y.createFileSystemProviderError)(r,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return s}}e.DiskFileSystemProvider=n,n.TRACE_LOG_RESOURCE_LOCKS=!1,n.canFlush=!0}),define(re[101],se([0,1,6,3,2,4,7]),function(Q,e,D,i,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,T.createDecorator)("lifecycleSharedProcessService");let P=class extends R.Disposable{constructor(w){super(),this.logService=w,this.pendingWillShutdownPromise=void 0,this._onWillShutdown=this._register(new i.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const w=[];return this._onWillShutdown.fire({join(b){w.push(b)}}),this.pendingWillShutdownPromise=(async()=>{try{await D.Promises.settled(w)}catch(b){this.logService.error(b)}})(),this.pendingWillShutdownPromise}};P=ve([K(0,L.ILogService)],P),e.SharedProcessLifecycleService=P}),define(re[102],se([0,1,3,8,7]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(S,m){this.logService=S,this.loggerService=m,this.onDidChangeLogLevel=D.Event.buffer(S.onDidChangeLogLevel,!0)}listen(S,m){switch(m){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${m}`)}async call(S,m,f){switch(m){case"setLevel":return f[1]?this.loggerService.setLevel(i.URI.revive(f[1]),f[0]):this.logService.setLevel(f[0])}throw new Error(`Call not found: ${m}`)}}e.LogLevelChannel=T;class L{constructor(S){this.channel=S}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(S,m){L.setLevel(this.channel,S,m)}static setLevel(S,m,f){return S.call("setLevel",[m,f])}}e.LogLevelChannelClient=L;class P{constructor(S){this.loggerService=S,this.loggers=new Map}listen(S,m){throw new Error(`Event not found: ${m}`)}async call(S,m,f){switch(m){case"createLogger":this.createLogger(i.URI.revive(f[0]),f[1]);return;case"log":return this.log(i.URI.revive(f[0]),f[1]);case"consoleLog":return this.consoleLog(f[0],f[1])}throw new Error(`Call not found: ${m}`)}createLogger(S,m){this.loggers.set(S.toString(),this.loggerService.createLogger(S,m))}consoleLog(S,m){let f=console.log;switch(S){case R.LogLevel.Error:f=console.error;break;case R.LogLevel.Warning:f=console.warn;break;case R.LogLevel.Info:f=console.info;break}f.call(console,...m)}log(S,m){const f=this.loggers.get(S.toString());if(!f)throw new Error("Create the logger before logging");for(const[v,y]of m)(0,R.log)(f,v,y)}}e.LoggerChannel=P;class I extends R.AbstractLoggerService{constructor(S,m,f){super(S,m),this.channel=f}createConsoleMainLogger(){return new R.AdapterLogger({log:(S,m)=>{this.channel.call("consoleLog",[S,m])}})}doCreateLogger(S,m,f){return new w(this.channel,S,m,f)}}e.LoggerChannelClient=I;class w extends R.AbstractMessageLogger{constructor(S,m,f,v){super(v?.always),this.channel=S,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[m,v]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,m){const f=[[S,m]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(S){this.channel.call("log",[this.file,S])}}class b extends R.LogService{constructor(S,m){super(m),this.parent=S,this._register(S.onDidChangeLogLevel(f=>m.setLevel(f)))}setLevel(S){super.setLevel(S),this.parent.setLevel(S)}}e.FollowerLogService=b}),define(re[59],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(re[60],se([0,1,3,64,2,4]),function(Q,e,D,i,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,T.createDecorator)("policy");class L extends R.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(w){const b=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...w,...this.policyDefinitions},b!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(w),i.Iterable.reduce(this.policies.entries(),(C,[S,m])=>({...C,[S]:m}),{})}getPolicyValue(w){return this.policies.get(w)}serialize(){return i.Iterable.reduce(Object.entries(this.policyDefinitions),(w,[b,C])=>({...w,[b]:{definition:C,value:this.policies.get(b)}}),{})}}e.AbstractPolicyService=L;class P{constructor(){this.onDidChange=D.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(re[208],se([0,1,3,2,60]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class T{constructor(I){this.service=I,this.disposables=new i.DisposableStore}listen(I,w){switch(w){case"onDidChange":return D.Event.map(this.service.onDidChange,b=>b.reduce((C,S)=>({...C,[S]:this.service.getPolicyValue(S)??null}),{}),this.disposables)}throw new Error(`Event not found: ${w}`)}call(I,w,b){switch(w){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(b)}throw new Error(`Call not found: ${w}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=T;class L extends R.AbstractPolicyService{constructor(I,w){super(),this.channel=w;for(const b in I){const{definition:C,value:S}=I[b];this.policyDefinitions[b]=C,S!==void 0&&this.policies.set(b,S)}this.channel.listen("onDidChange")(b=>{for(const C in b){const S=b[C];S===null?this.policies.delete(C):this.policies.set(C,S)}this._onDidChange.fire(Object.keys(b))})}async initializePolicies(I){const w=await this.channel.call("registerPolicyDefinitions",I);for(const b in w)this.policies.set(b,w[b])}}e.PolicyChannelClient=L}),define(re[103],se([0,1,22,5,36,21]),function(Q,e,D,i,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;if(typeof i.globals.vscode<"u"&&typeof i.globals.vscode.context<"u"){const P=i.globals.vscode.context.configuration();if(P)L=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Q?.__$__nodeRequire=="function"){const P=(0,T.dirname)(D.FileAccess.asFileUri("",Q));if(L=Q.__$__nodeRequire((0,T.joinPath)(P,"product.json").fsPath),R.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const I=Q.__$__nodeRequire((0,T.joinPath)(P,"package.json").fsPath);Object.assign(L,{version:I.version})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(re[25],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(re[209],se([0,1,6,11,2,12,28,7,25]),function(Q,e,D,i,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let w=class extends R.Disposable{constructor(C,S,m){super(),this.productService=S,this.logService=m,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},3e4)).schedule()}async cleanUpCodeCaches(C){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const S=Date.now(),m=(0,T.dirname)(C),f=(0,T.basename)(C),v=await L.Promises.readdir(m);await Promise.all(v.map(async y=>{if(y===f)return;const h=(0,T.join)(m,y),p=await L.Promises.stat(h);if(p.isDirectory()&&S-p.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${y}.`),L.Promises.rm(h)}))}catch(S){(0,i.onUnexpectedError)(S)}}};w=ve([K(1,I.IProductService),K(2,P.ILogService)],w),e.CodeCacheCleaner=w}),define(re[210],se([0,1,6,11,2,12,28,13,7,25]),function(Q,e,D,i,R,T,L,P,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let b=class extends R.Disposable{constructor(S,m,f){super(),this.environmentService=S,this.logService=m,this.productService=f,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const S=Object.create(null),m=JSON.parse(await L.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const p of Object.keys(m)){const c=m[p];S[`${c.hash}.${p}`]=!0}const f=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await L.Promises.exists(f))return;const y=await L.Promises.readdir(f);for(const p of y){if(S[p]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${p}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${p}`),await L.Promises.rm((0,T.join)(f,p))}const h=Date.now();for(const p of Object.keys(S)){const c=(0,T.join)(f,p),u=await L.Promises.readdir(c);for(const d of u){if(d==="tcf.json")continue;const n=(0,T.join)(c,d),o=await L.Promises.stat(n);o.isDirectory()&&h-o.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(p,d)}`),await L.Promises.rm(n))}}}catch(S){(0,i.onUnexpectedError)(S)}}};b=ve([K(0,P.INativeEnvironmentService),K(1,I.ILogService),K(2,w.IProductService)],b),e.LanguagePackCachedDataCleaner=b}),define(re[211],se([0,1,12,4]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,i.createDecorator)("IV8InspectProfilingService");var R;(function(T){function L(I){return Boolean(I.samples&&I.timeDeltas)}T.isValidProfile=L;function P(I,w="noAbsolutePaths"){for(const b of I.nodes)b.callFrame&&b.callFrame.url&&((0,D.isAbsolute)(b.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(b.callFrame.url))&&(b.callFrame.url=(0,D.join)(w,(0,D.basename)(b.callFrame.url)));return I}T.rewriteAbsolutePaths=P})(R=e.Utils||(e.Utils={}))}),define(re[212],se([0,1,31]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class i{constructor(){this._sessions=new Map}async startProfiling(T){const P=await(await new Promise((w,b)=>{Q(["v8-inspect-profiler"],w,b)})).startProfiling({port:T.port,checkForPaused:!0}),I=(0,D.generateUuid)();return this._sessions.set(I,P),I}async stopProfiling(T){const L=this._sessions.get(T);if(!L)throw new Error(`UNKNOWN session '${T}'`);const P=await L.stop();return this._sessions.delete(T),P.profile}}e.InspectProfilingService=i}),define(re[39],se([0,1,127,15]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(L,P){D.ok(i.isString(L)),D.ok(i.isObject(P)),D.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,P)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}e.Registry=new R}),define(re[104],se([0,1,3,39]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class T{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(I,w){this.schemasById[R(I)]=w,this._onDidChangeSchema.fire(I)}notifySchemaChanged(I){this._onDidChangeSchema.fire(I)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new T;i.Registry.add(e.Extensions.JSONContribution,L)}),define(re[45],se([0,1,20,3,15,152,16,104,39]),function(Q,e,D,i,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const C=I.Registry.as(P.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new i.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new i.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(n,o=!0){this.registerConfigurations([n],o)}registerConfigurations(n,o=!0){const t=this.doRegisterConfigurations(n,o);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(n){const o=this.doDeregisterConfigurations(n);C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}updateConfigurations({add:n,remove:o}){const t=[];t.push(...this.doDeregisterConfigurations(o)),t.push(...this.doRegisterConfigurations(n,!1)),C.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(t)})}registerDefaultConfigurations(n){const o=[],t=[];for(const{overrides:r,source:s}of n)for(const l in r)if(o.push(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const a=this.configurationDefaultsOverrides.get(l),g=a?.valuesSources??new Map;if(s)for(const O of Object.keys(r[l]))g.set(O,s);const E={...a?.value||{},...r[l]};this.configurationDefaultsOverrides.set(l,{source:s,value:E,valuesSources:g});const A=(0,L.getLanguageTagSettingPlainKey)(l),B={type:"object",default:E,description:T.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:E,source:R.isString(s)?void 0:s,defaultValueSource:s};t.push(...v(l)),this.configurationProperties[l]=B,this.defaultLanguageConfigurationOverridesNode.properties[l]=B}else{this.configurationDefaultsOverrides.set(l,{value:r[l],source:s});const a=this.configurationProperties[l];a&&(this.updatePropertyDefaultValue(l,a),this.updateSchema(l,a))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}deregisterDefaultConfigurations(n){const o=[];for(const{overrides:t,source:r}of n)for(const s in t){const l=this.configurationDefaultsOverrides.get(s),a=R.isString(r)?r:r?.id,g=R.isString(l?.source)?l?.source:l?.source?.id;if(a===g)if(o.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const E=this.configurationProperties[s];E&&(this.updatePropertyDefaultValue(s,E),this.updateSchema(s,E))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...n){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(n){for(const o of n)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(n,o){const t=[];return n.forEach(r=>{t.push(...this.validateAndRegisterProperties(r,o,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),t}doDeregisterConfigurations(n){const o=[],t=r=>{if(r.properties)for(const s in r.properties){o.push(s);const l=this.configurationProperties[s];l?.policy?.name&&this.policyConfigurations.delete(l.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,r.properties[s])}r.allOf?.forEach(s=>t(s))};for(const r of n){t(r);const s=this.configurationContributors.indexOf(r);s!==-1&&this.configurationContributors.splice(s,1)}return o}validateAndRegisterProperties(n,o=!0,t,r,s=3){s=R.isUndefinedOrNull(n.scope)?s:n.scope;const l=[],a=n.properties;if(a)for(const E in a){const A=a[E];if(o&&c(E,A)){delete a[E];continue}if(A.source=t,A.defaultDefaultValue=a[E].default,this.updatePropertyDefaultValue(E,A),e.OVERRIDE_PROPERTY_REGEX.test(E)?A.scope=void 0:(A.scope=R.isUndefinedOrNull(A.scope)?s:A.scope,A.restricted=R.isUndefinedOrNull(A.restricted)?!!r?.includes(E):A.restricted),a[E].hasOwnProperty("included")&&!a[E].included){this.excludedConfigurationProperties[E]=a[E],delete a[E];continue}else this.configurationProperties[E]=a[E],a[E].policy?.name&&this.policyConfigurations.set(a[E].policy.name,E);!a[E].deprecationMessage&&a[E].markdownDeprecationMessage&&(a[E].deprecationMessage=a[E].markdownDeprecationMessage),l.push(E)}const g=n.allOf;if(g)for(const E of g)l.push(...this.validateAndRegisterProperties(E,o,t,r,s));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(n){const o=t=>{const r=t.properties;if(r)for(const l in r)this.updateSchema(l,r[l]);t.allOf?.forEach(o)};o(n)}updateSchema(n,o){switch(e.allSettings.properties[n]=o,o.scope){case 1:e.applicationSettings.properties[n]=o;break;case 2:e.machineSettings.properties[n]=o;break;case 6:e.machineOverridableSettings.properties[n]=o;break;case 3:e.windowSettings.properties[n]=o;break;case 4:e.resourceSettings.properties[n]=o;break;case 5:e.resourceSettings.properties[n]=o,this.resourceLanguageSettingsSchema.properties[n]=o;break}}removeFromSchema(n,o){switch(delete e.allSettings.properties[n],o.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.resourceLanguageSettingsSchema.properties[n];break}}updateOverridePropertyPatternKey(){for(const n of this.overrideIdentifiers.values()){const o=`[${n}]`,t={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,t),e.allSettings.properties[o]=t,e.applicationSettings.properties[o]=t,e.machineSettings.properties[o]=t,e.machineOverridableSettings.properties[o]=t,e.windowSettings.properties[o]=t,e.resourceSettings.properties[o]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const n={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(n,o){const t=this.configurationDefaultsOverrides.get(n);let r=t?.value,s=t?.source;R.isUndefined(r)&&(r=o.defaultDefaultValue,s=void 0),R.isUndefined(r)&&(r=h(o.type)),o.default=r,o.defaultValueSource=s}}const m="\\[([^\\]]+)\\]",f=new RegExp(m,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(d){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(d)){let o=f.exec(d);for(;o?.length;){const t=o[1].trim();t&&n.push(t),o=f.exec(d)}}return(0,D.distinct)(n)}e.overrideIdentifiersFromKey=v;function y(d){return d.reduce((n,o)=>`${n}[${o}]`,"")}e.keyFromOverrideIdentifiers=y;function h(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const p=new S;I.Registry.add(e.Extensions.Configuration,p);function c(d,n){return d.trim()?e.OVERRIDE_PROPERTY_REGEX.test(d)?T.localize(7,null,d):p.getConfigurationProperties()[d]!==void 0?T.localize(8,null,d):n.policy?.name&&p.getPolicyConfigurations().get(n.policy?.name)!==void 0?T.localize(9,null,d,n.policy?.name,p.getPolicyConfigurations().get(n.policy?.name)):null:T.localize(6,null)}e.validateProperty=c;function u(){const d=[],n=p.getConfigurationProperties();for(const o of Object.keys(n))d.push([o,n[o].scope]);return d.push(["launch",4]),d.push(["task",4]),d}e.getScopes=u}),define(re[73],se([0,1,20,3,35,2,41,32,15,8,16,45,39]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class m{constructor(o={},t=[],r=[],s){this._contents=o,this._keys=t,this._overrides=r,this.raw=s,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const o=this.raw.map(t=>{if(t instanceof m)return t;const r=new f("");return r.parseRaw(t),r.configurationModel});this._rawConfiguration=o.reduce((t,r)=>r===t?r:t.merge(r),o[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(o){return o?(0,b.getConfigurationValue)(this.contents,o):this.contents}inspect(o,t){const r=this.rawConfiguration.getValue(o),s=t?this.rawConfiguration.getOverrideValue(o,t):void 0,l=t?this.rawConfiguration.override(t).getValue(o):r;return{value:r,override:s,merged:l}}getOverrideValue(o,t){const r=this.getContentsForOverrideIdentifer(t);return r?o?(0,b.getConfigurationValue)(r,o):r:void 0}getKeysForOverrideIdentifier(o){const t=[];for(const r of this.overrides)r.identifiers.includes(o)&&t.push(...r.keys);return D.distinct(t)}getAllOverrideIdentifiers(){const o=[];for(const t of this.overrides)o.push(...t.identifiers);return D.distinct(o)}override(o){let t=this.overrideConfigurations.get(o);return t||(t=this.createOverrideConfigurationModel(o),this.overrideConfigurations.set(o,t)),t}merge(...o){const t=P.deepClone(this.contents),r=P.deepClone(this.overrides),s=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const a of o)if(l.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.mergeContents(t,a.contents);for(const g of a.overrides){const[E]=r.filter(A=>D.equals(A.identifiers,g.identifiers));E?(this.mergeContents(E.contents,g.contents),E.keys.push(...g.keys),E.keys=D.distinct(E.keys)):r.push(P.deepClone(g))}for(const g of a.keys)s.indexOf(g)===-1&&s.push(g)}return new m(t,s,r,l.every(a=>a instanceof m)?void 0:l)}freeze(){return this.frozen=!0,this}clone(){return new m(P.deepClone(this.contents),[...this.keys],P.deepClone(this.overrides))}createOverrideConfigurationModel(o){const t=this.getContentsForOverrideIdentifer(o);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const r={};for(const s of D.distinct([...Object.keys(this.contents),...Object.keys(t)])){let l=this.contents[s];const a=t[s];a&&(typeof l=="object"&&typeof a=="object"?(l=P.deepClone(l),this.mergeContents(l,a)):l=a),r[s]=l}return new m(r,this.keys,this.overrides)}mergeContents(o,t){for(const r of Object.keys(t)){if(r in o&&I.isObject(o[r])&&I.isObject(t[r])){this.mergeContents(o[r],t[r]);continue}o[r]=P.deepClone(t[r])}}checkAndFreeze(o){return this.frozen&&!Object.isFrozen(o)?P.deepFreeze(o):o}getContentsForOverrideIdentifer(o){let t=null,r=null;const s=l=>{l&&(r?this.mergeContents(r,l):r=P.deepClone(l))};for(const l of this.overrides)D.equals(l.identifiers,[o])?t=l.contents:l.identifiers.includes(o)&&s(l.contents);return s(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(o,t){this.addKey(o),(0,b.addToValueTree)(this.contents,o,t,r=>{throw new Error(r)})}removeValue(o){this.removeKey(o)&&(0,b.removeFromValueTree)(this.contents,o)}addKey(o){let t=this.keys.length;for(let r=0;r<t;r++)o.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,o)}removeKey(o){const t=this.keys.indexOf(o);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=m;class f{constructor(o){this._name=o,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(o,t){if(!I.isUndefinedOrNull(o)){const r=this.doParseContent(o);this.parseRaw(r,t)}}reparse(o){this._raw&&this.parseRaw(this._raw,o)}parseRaw(o,t){this._raw=o;const{contents:r,keys:s,overrides:l,restricted:a,hasExcludedProperties:g}=this.doParseRaw(o,t);this._configurationModel=new m(r,s,l,g?[o]:void 0),this._restrictedConfigurations=a||[]}doParseContent(o){let t={},r=null,s=[];const l=[],a=[];function g(A){Array.isArray(s)?s.push(A):r!==null&&(s[r]=A)}const E={onObjectBegin:()=>{const A={};g(A),l.push(s),s=A,r=null},onObjectProperty:A=>{r=A},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const A=[];g(A),l.push(s),s=A,r=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:g,onError:(A,B,O)=>{a.push({error:A,offset:B,length:O})}};if(o)try{R.visit(o,E),t=s[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return t}doParseRaw(o,t){const r=S.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),s=this.filter(o,r,!0,t);o=s.raw;const l=(0,b.toValuesTree)(o,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),a=Object.keys(o),g=this.toOverrides(o,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:l,keys:a,overrides:g,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}filter(o,t,r,s){let l=!1;if(!s?.scopes&&!s?.skipRestricted)return{raw:o,restricted:[],hasExcludedProperties:l};const a={},g=[];for(const E in o)if(C.OVERRIDE_PROPERTY_REGEX.test(E)&&r){const A=this.filter(o[E],t,!1,s);a[E]=A.raw,l=l||A.hasExcludedProperties,g.push(...A.restricted)}else{const A=t[E],B=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&g.push(E),(B===void 0||s.scopes===void 0||s.scopes.includes(B))&&!(s.skipRestricted&&A?.restricted)?a[E]=o[E]:l=!0}return{raw:a,restricted:g,hasExcludedProperties:l}}toOverrides(o,t){const r=[];for(const s of Object.keys(o))if(C.OVERRIDE_PROPERTY_REGEX.test(s)){const l={};for(const a in o[s])l[a]=o[s][a];r.push({identifiers:(0,C.overrideIdentifiersFromKey)(s),keys:Object.keys(l),contents:(0,b.toValuesTree)(l,t)})}return r}}e.ConfigurationModelParser=f;class v extends T.Disposable{constructor(o,t,r,s){super(),this.userSettingsResource=o,this.scopes=t,this.fileService=s,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(i.Event.any(i.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource)),i.Event.filter(this.fileService.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&r.isEqual(l.resource,o)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const o=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(o.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class y{constructor(o,t,r,s,l,a,g,E,A,B,O,N,F){this.key=o,this.overrides=t,this.value=r,this.overrideIdentifiers=s,this.defaultConfiguration=l,this.policyConfiguration=a,this.applicationConfiguration=g,this.userConfiguration=E,this.localUserConfiguration=A,this.remoteUserConfiguration=B,this.workspaceConfiguration=O,this.folderConfigurationModel=N,this.memoryInspectValue=F}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class h{constructor(o,t,r,s,l=new m,a=new m,g=new L.ResourceMap,E=new m,A=new L.ResourceMap,B=!0){this._defaultConfiguration=o,this._policyConfiguration=t,this._applicationConfiguration=r,this._localUserConfiguration=s,this._remoteUserConfiguration=l,this._workspaceConfiguration=a,this._folderConfigurations=g,this._memoryConfiguration=E,this._memoryConfigurationByResource=A,this._freeze=B,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(o,t,r){return this.getConsolidatedConfigurationModel(o,t,r).getValue(o)}updateValue(o,t,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new m,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,t===void 0?s.removeValue(o):s.setValue(o,t),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(o,t,r){const s=this.getConsolidatedConfigurationModel(o,t,r),l=D.distinct(s.overrides.map(E=>E.identifiers).flat()).filter(E=>s.getOverrideValue(o,E)!==void 0),a=this.getFolderConfigurationModelForResource(t.resource,r),g=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration;return new y(o,t,s.getValue(o),l.length?l:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),r?this._workspaceConfiguration.freeze():void 0,a?a.freeze():void 0,g.inspect(o,t.overrideIdentifier))}keys(o){const t=this.getFolderConfigurationModelForResource(void 0,o);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(o){this._defaultConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(o){this._policyConfiguration=o}updateApplicationConfiguration(o){this._applicationConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(o){this._localUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(o){this._remoteUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(o){this._workspaceConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(o,t){this._folderConfigurations.set(o,t),this._foldersConsolidatedConfigurations.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this._foldersConsolidatedConfigurations.delete(o)}compareAndUpdateDefaultConfiguration(o,t){const r=[];if(!t){const{added:s,updated:l,removed:a}=u(this._defaultConfiguration,o);t=[...s,...l,...a]}for(const s of t)for(const l of(0,C.overrideIdentifiersFromKey)(s)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(l),g=o.getKeysForOverrideIdentifier(l),E=[...g.filter(A=>a.indexOf(A)===-1),...a.filter(A=>g.indexOf(A)===-1),...a.filter(A=>!P.equals(this._defaultConfiguration.override(l).getValue(A),o.override(l).getValue(A)))];r.push([l,E])}return this.updateDefaultConfiguration(o),{keys:t,overrides:r}}compareAndUpdatePolicyConfiguration(o){const{added:t,updated:r,removed:s}=u(this._policyConfiguration,o),l=[...t,...r,...s];return l.length&&this.updatePolicyConfiguration(o),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:t,updated:r,removed:s,overrides:l}=u(this.applicationConfiguration,o),a=[...t,...r,...s];return a.length&&this.updateApplicationConfiguration(o),{keys:a,overrides:l}}compareAndUpdateLocalUserConfiguration(o){const{added:t,updated:r,removed:s,overrides:l}=u(this.localUserConfiguration,o),a=[...t,...r,...s];return a.length&&this.updateLocalUserConfiguration(o),{keys:a,overrides:l}}compareAndUpdateRemoteUserConfiguration(o){const{added:t,updated:r,removed:s,overrides:l}=u(this.remoteUserConfiguration,o),a=[...t,...r,...s];return a.length&&this.updateRemoteUserConfiguration(o),{keys:a,overrides:l}}compareAndUpdateWorkspaceConfiguration(o){const{added:t,updated:r,removed:s,overrides:l}=u(this.workspaceConfiguration,o),a=[...t,...r,...s];return a.length&&this.updateWorkspaceConfiguration(o),{keys:a,overrides:l}}compareAndUpdateFolderConfiguration(o,t){const r=this.folderConfigurations.get(o),{added:s,updated:l,removed:a,overrides:g}=u(r,t),E=[...s,...l,...a];return(E.length||!r)&&this.updateFolderConfiguration(o,t),{keys:E,overrides:g}}compareAndDeleteFolderConfiguration(o){const t=this.folderConfigurations.get(o);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:r,updated:s,removed:l,overrides:a}=u(t,void 0);return{keys:[...r,...s,...l],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(o,t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier&&(s=s.override(t.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(o)!==void 0&&(s=s.merge(this._policyConfiguration)),s}getConsolidatedConfigurationModelForResource({resource:o},t){let r=this.getWorkspaceConsolidatedConfiguration();if(t&&o){const s=t.getFolder(o);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const l=this._memoryConfigurationByResource.get(o);l&&(r=r.merge(l))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(o){let t=this._foldersConsolidatedConfigurations.get(o);if(!t){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(o);s?(t=r.merge(s),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(o,t)):t=r}return t}getFolderConfigurationModelForResource(o,t){if(t&&o){const r=t.getFolder(o);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((o,t)=>{const{contents:r,overrides:s,keys:l}=this._folderConfigurations.get(t);return o.push([t,{contents:r,overrides:s,keys:l}]),o},[])}}allKeys(){const o=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>o.add(t)),this.userConfiguration.freeze().keys.forEach(t=>o.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>o.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(r=>o.add(r))),[...o.values()]}allOverrideIdentifiers(){const o=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>o.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>o.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>o.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>o.add(r))),[...o.values()]}getAllKeysForOverrideIdentifier(o){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(o).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(r=>t.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(o).forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(o).forEach(s=>t.add(s))),[...t.values()]}static parse(o){const t=this.parseConfigurationModel(o.defaults),r=this.parseConfigurationModel(o.policy),s=this.parseConfigurationModel(o.application),l=this.parseConfigurationModel(o.user),a=this.parseConfigurationModel(o.workspace),g=o.folders.reduce((E,A)=>(E.set(w.URI.revive(A[0]),this.parseConfigurationModel(A[1])),E),new L.ResourceMap);return new h(t,r,s,l,new m,a,g,new m,new L.ResourceMap,!1)}static parseConfigurationModel(o){return new m(o.contents,o.keys,o.overrides).freeze()}}e.Configuration=h;function p(...n){if(n.length===0)return{keys:[],overrides:[]};if(n.length===1)return n[0];const o=new Set,t=new Map;for(const s of n)s.keys.forEach(l=>o.add(l)),s.overrides.forEach(([l,a])=>{const g=(0,L.getOrSet)(t,l,new Set);a.forEach(E=>g.add(E))});const r=[];return t.forEach((s,l)=>r.push([l,[...s.values()]])),{keys:[...o.values()],overrides:r}}e.mergeChanges=p;class c{constructor(o,t,r,s){this.change=o,this.previous=t,this.currentConfiguraiton=r,this.currentWorkspace=s,this._previousConfiguration=void 0;const l=new Set;o.keys.forEach(g=>l.add(g)),o.overrides.forEach(([,g])=>g.forEach(E=>l.add(E))),this.affectedKeys=[...l.values()];const a=new m;this.affectedKeys.forEach(g=>a.setValue(g,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(o,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,o)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(o,t,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(o,t,this.currentWorkspace);return!P.equals(r,s)}return!0}return!1}doesAffectedKeysTreeContains(o,t){let r=(0,b.toValuesTree)({[t]:!0},()=>{}),s;for(;typeof r=="object"&&(s=Object.keys(r)[0]);){if(o=o[s],!o)return!1;r=r[s]}return!0}}e.ConfigurationChangeEvent=c;function u(n,o){const{added:t,removed:r,updated:s}=d(o?.rawConfiguration,n?.rawConfiguration),l=[],a=n?.getAllOverrideIdentifiers()||[],g=o?.getAllOverrideIdentifiers()||[];if(o){const E=g.filter(A=>!a.includes(A));for(const A of E)l.push([A,o.getKeysForOverrideIdentifier(A)])}if(n){const E=a.filter(A=>!g.includes(A));for(const A of E)l.push([A,n.getKeysForOverrideIdentifier(A)])}if(o&&n){for(const E of a)if(g.includes(E)){const A=d({contents:n.getOverrideValue(void 0,E)||{},keys:n.getKeysForOverrideIdentifier(E)},{contents:o.getOverrideValue(void 0,E)||{},keys:o.getKeysForOverrideIdentifier(E)});l.push([E,[...A.added,...A.removed,...A.updated]])}}return{added:t,removed:r,updated:s,overrides:l}}function d(n,o){const t=n?o?n.keys.filter(l=>o.keys.indexOf(l)===-1):[...n.keys]:[],r=o?n?o.keys.filter(l=>n.keys.indexOf(l)===-1):[...o.keys]:[],s=[];if(n&&o){for(const l of o.keys)if(n.keys.indexOf(l)!==-1){const a=(0,b.getConfigurationValue)(o.contents,l),g=(0,b.getConfigurationValue)(n.contents,l);P.equals(a,g)||s.push(l)}}return{added:t,removed:r,updated:s}}}),define(re[213],se([0,1,20,3,2,32,15,16,73,45,7,60,39]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class m extends R.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new i.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new f(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(S.Registry.as(w.Extensions.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:c})=>this.onDidUpdateConfiguration(p,c))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(p,c){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:p})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=m;class f extends I.ConfigurationModel{constructor(p={}){const c=S.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(c),d=Object.create(null),n=[];for(const o in c){const t=p[o],r=t!==void 0?t:c[o].default;(0,P.addToValueTree)(d,o,r,s=>console.error(`Conflict in default settings: ${s}`))}for(const o of Object.keys(d))w.OVERRIDE_PROPERTY_REGEX.test(o)&&n.push({identifiers:(0,w.overrideIdentifiersFromKey)(o),keys:Object.keys(d[o]),contents:(0,P.toValuesTree)(d[o],t=>console.error(`Conflict in default settings file: ${t}`))});super(d,u,n)}}e.DefaultConfigurationModel=f;class v{constructor(){this.onDidChangeConfiguration=i.Event.None,this.configurationModel=new I.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=v;let y=class extends R.Disposable{get configurationModel(){return this._configurationModel}constructor(p,c,u){super(),this.defaultConfiguration=p,this.policyService=c,this.logService=u,this._onDidChangeConfiguration=this._register(new i.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new I.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(p=>this.onDidChangePolicies(p))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:p})=>this.update(await this.registerPolicyDefinitions(p),!0))),this._configurationModel}async registerPolicyDefinitions(p){const c={},u=[],d=S.Registry.as(w.Extensions.Configuration).getConfigurationProperties();for(const n of p){const o=d[n];if(!o){u.push(n);continue}if(o.policy){if(o.type!=="string"&&o.type!=="number"){this.logService.warn(`Policy ${o.policy.name} has unsupported type ${o.type}`);continue}u.push(n),c[o.policy.name]={type:o.type}}}return(0,L.isEmptyObject)(c)||await this.policyService.registerPolicyDefinitions(c),u}onDidChangePolicies(p){const c=S.Registry.as(w.Extensions.Configuration).getPolicyConfigurations(),u=(0,D.coalesce)(p.map(d=>c.get(d)));this.update(u,!0)}update(p,c){const u=S.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),d=[],n=this._configurationModel.isEmpty();for(const o of p){const t=u[o]?.policy?.name;if(t){const r=this.policyService.getPolicyValue(t);(n?r!==void 0:!(0,T.equals)(this._configurationModel.getValue(o),r))&&d.push([o,r])}else this._configurationModel.getValue(o)!==void 0&&d.push([o,void 0])}if(d.length){const o=this._configurationModel;this._configurationModel=new I.ConfigurationModel;for(const t of o.keys)this._configurationModel.setValue(t,o.getValue(t));for(const[t,r]of d)r===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,r);c&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};y=ve([K(1,C.IPolicyService),K(2,b.ILogService)],y),e.PolicyConfiguration=y}),define(re[214],se([0,1,6,3,2,21,16,73,213,60]),function(Q,e,D,i,R,T,L,P,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends R.Disposable{constructor(S,m,f,v){super(),this.settingsResource=S,this._onDidChangeConfiguration=this._register(new i.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new I.DefaultConfiguration),this.policyConfiguration=f instanceof w.NullPolicyService?new I.NullPolicyConfiguration:this._register(new I.PolicyConfiguration(this.defaultConfiguration,f,v)),this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,m)),this.configuration=new P.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:y,properties:h})=>this.onDidDefaultConfigurationChange(y,h))),this._register(this.policyConfiguration.onDidChangeConfiguration(y=>this.onDidPolicyConfigurationChange(y))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,m,f]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new P.Configuration(S,m,new P.ConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(S,m){const f=typeof S=="string"?S:void 0,v=(0,L.isConfigurationOverrides)(S)?S:(0,L.isConfigurationOverrides)(m)?m:{};return this.configuration.getValue(f,v,void 0)}updateValue(S,m,f,v){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const m=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(f,m,2)}onDidDefaultConfigurationChange(S,m){const f=this.configuration.toData(),v=this.configuration.compareAndUpdateDefaultConfiguration(S,m);this.trigger(v,f,7)}onDidPolicyConfigurationChange(S){const m=this.configuration.toData(),f=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(f,m,7)}trigger(S,m,f){const v=new P.ConfigurationChangeEvent(S,{data:m},this.configuration);v.source=f,v.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(v)}getTargetConfiguration(S){switch(S){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(re[215],se([0,1,11,4]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,i.createDecorator)("remoteAuthorityResolverService");var R;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends D.ErrorNoTelemetry{static isNotAvailable(P){return P instanceof T&&P._code===R.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof T&&P._code===R.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof T&&P._code===R.NoResolverFound}static isHandled(P){return P instanceof T&&P.isHandled}constructor(P,I=R.Unknown,w){super(P),this._message=P,this._code=I,this._detail=w,this.isHandled=I===R.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}}e.RemoteAuthorityResolverError=T}),define(re[105],se([0,1,22]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function i(w){return w.scheme===D.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=i;function R(w){if(!w)return;const b=w.indexOf("+");return b<0?w:w.substr(0,b)}e.getRemoteName=R;function T(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.getRemoteServerRootPath=T;function L(w){const{host:b,port:C}=I(w);if(typeof C>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:C}}e.parseAuthorityWithPort=L;function P(w,b){let{host:C,port:S}=I(w);return typeof S>"u"&&(S=b),{host:C,port:S}}e.parseAuthorityWithOptionalPort=P;function I(w){const b=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const C=w.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const S=w.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:w,port:void 0}}}),define(re[46],se([0,1,27,4,105]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=T;function L(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var I;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(I=e.TargetPlatform||(e.TargetPlatform={}));class w{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,y){if(typeof v>"u"||v===null)return typeof y>"u"||y===null;if(typeof y>"u"||y===null)return!1;if(typeof v=="string"||typeof y=="string"){const h=typeof v=="string"?v:v.value,p=typeof y=="string"?y:y.value;return D.equalsIgnoreCase(h,p)}return v._lower===y._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.ExtensionIdentifier=w;function b(f){return C(f)}e.isApplicationScopedExtension=b;function C(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function S(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function m(f,v){if(v){const y=`onResolveRemoteAuthority:${(0,R.getRemoteName)(v)}`;return f.activationEvents?.indexOf(y)!==-1}return!1}e.isResolverExtension=m,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(re[33],se([0,1,27,29,46,5,8,11,36]),function(Q,e,D,i,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function w(o,t){return o.uuid&&t.uuid?o.uuid===t.uuid:o.id===t.id?!0:(0,D.compareIgnoreCase)(o.id,t.id)===0}e.areSameExtensions=w;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class C{static create(t){const r=t.manifest?t.manifest.version:t.version,s=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new C(t.identifier,r,s)}static parse(t){const r=b.exec(t);return r&&r[1]&&r[2]?new C({id:r[1]},r[2],r[4]||void 0):null}constructor(t,r,s="undefined"){this.version=r,this.targetPlatform=s,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof C?w(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=C;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(o){const t=S.exec(o);return t&&t[1]?[v(t[1]),t[2]]:[v(o),void 0]}e.getIdAndVersion=m;function f(o,t){return`${o}.${t}`}e.getExtensionId=f;function v(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=v;function y(o,t){return v(f(o,t))}e.getGalleryExtensionId=y;function h(o,t){const r=[],s=l=>{for(const a of r)if(a.some(g=>w(t(g),t(l))))return a;return null};for(const l of o){const a=s(l);a?a.push(l):r.push([l])}return r}e.groupByExtension=h;function p(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function c(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.getGalleryExtensionTelemetryData=c,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function u(o,t){const r=[],s=t.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const l=s.shift();if(l&&r.every(a=>!w(a.identifier,{id:l}))){const a=o.filter(g=>w(g.identifier,{id:l}));a.length===1&&(r.push(a[0]),s.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=u;async function d(o,t){if(!T.isLinux)return!1;let r;try{r=(await o.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await o.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){t.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(l))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=d;async function n(o,t){const r=await d(o,t),s=(0,i.getTargetPlatform)(r?"alpine":T.platform,I.arch);return t.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=n}),define(re[51],se([0,1,6,17,2,41,8,33,14,4,7]),function(Q,e,D,i,R,T,L,P,I,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,w.createDecorator)("IExtensionsProfileScannerService");let C=class extends R.Disposable{constructor(m,f){super(),this.fileService=m,this.logService=f,this.resourcesAccessQueueMap=new T.ResourceMap}scanProfileExtensions(m){return this.withProfileExtensions(m)}addExtensionsToProfile(m,f){return this.withProfileExtensions(f,v=>(v=v.filter(y=>m.some(([h])=>!(0,P.areSameExtensions)(y.identifier,h.identifier))),v.push(...m.map(([y,h])=>({identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:h}))),v))}removeExtensionFromProfile(m,f){return this.withProfileExtensions(f,v=>v.filter(y=>!(0,P.areSameExtensions)(y.identifier,m)))}async withProfileExtensions(m,f){return this.getResourceAccessQueue(m).queue(async()=>{let v=[];try{const y=await this.fileService.readFile(m),h=JSON.parse(y.value.toString());for(const p of h){if(!p.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",p);continue}if(!p.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",p);continue}if(!p.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",p);continue}v.push({identifier:p.identifier,location:L.URI.revive(p.location),version:p.version,metadata:p.metadata})}}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}if(f){v=f(v);const y=v.map(h=>({identifier:h.identifier,version:h.version,location:h.location.toJSON(),metadata:h.metadata}));await this.fileService.writeFile(m,i.VSBuffer.fromString(JSON.stringify(y)))}return v})}getResourceAccessQueue(m){let f=this.resourcesAccessQueueMap.get(m);return f||(f=new D.Queue,this.resourcesAccessQueueMap.set(m,f)),f}};C=ve([K(0,I.IFileService),K(1,b.ILogService)],C),e.ExtensionsProfileScannerService=C}),define(re[216],se([0,1,24,33]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function R(T,L,P,I,w){try{const b=await T.getExtensionsControlManifest();if(!b.deprecated)return;const C=await T.getInstalled(1);for(const[S,m]of Object.entries(b.deprecated)){if(!m?.extension)continue;const{id:f,autoMigrate:v,preRelease:y}=m.extension;if(!v)continue;const h=C.find(c=>(0,i.areSameExtensions)(c.identifier,{id:S}));if(!h)continue;const p=(await L.getExtensions([{id:f,preRelease:y}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!p){w.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${f}' extension is not found`);continue}try{w.info(`Migrating '${h.identifier.id}' extension to '${f}' extension...`);const c=!I.getDisabledExtensions().some(d=>(0,i.areSameExtensions)(d,h.identifier));await T.uninstall(h),w.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let u=C.find(d=>(0,i.areSameExtensions)(d.identifier,{id:f}));(!u||!u.isPreReleaseVersion&&c)&&(u=await T.installFromGallery(p,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),w.info(`Installed the pre-release extension '${u.identifier.id}'`),c||(await I.disableExtension(u.identifier),w.info(`Disabled the pre-release extension '${u.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),v.storage&&(P.addToMigrationList((0,i.getExtensionId)(h.manifest.publisher,h.manifest.name),(0,i.getExtensionId)(u.manifest.publisher,u.manifest.name)),w.info("Added pre-release extension to the storage migration list"))),w.info(`Migrated '${h.identifier.id}' extension to '${f}' extension.`)}catch(c){w.error(c)}}}catch(b){w.error(b)}}e.migrateUnsupportedExtensions=R}),define(re[217],se([0,1,6,11,2,22,5,21,55,31,28,16,13,29,33,97,14,7]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let p=class pt extends R.Disposable{constructor(u,d,n,o,t,r){super(),this.fileService=d,this.extensionGalleryService=n,this.configurationService=o,this.extensionSignatureVerificationService=t,this.logService=r,this.extensionsDownloadDir=u.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(u,d){await this.cleanUpPromise;const n=(0,P.joinPath)(this.extensionsDownloadDir,this.getName(u));try{await this.downloadFile(u,n,t=>this.extensionGalleryService.download(u,t,d))}catch(t){throw new m.ExtensionManagementError(t.message,m.ExtensionManagementErrorCode.Download)}let o=!1;if(u.isSigned&&this.configurationService.getValue("extensions.verifySignature")===!0){const t=await this.downloadSignatureArchive(u);try{o=await this.extensionSignatureVerificationService.verify(n.fsPath,t.fsPath),this.logService.info(`Verified extension: ${u.identifier.id}`,o)}catch(r){throw await this.delete(t),await this.delete(n),new m.ExtensionManagementError(r.code,m.ExtensionManagementErrorCode.Signature)}}return{location:n,verified:o}}async downloadSignatureArchive(u){await this.cleanUpPromise;const d=(0,P.joinPath)(this.extensionsDownloadDir,`${this.getName(u)}${pt.SignatureArchiveExtension}`);return await this.downloadFile(u,d,n=>this.extensionGalleryService.downloadSignatureArchive(u,n)),d}async downloadFile(u,d,n){if(await this.fileService.exists(d))return;if(d.scheme!==T.Schemas.file){await n(d);return}const o=(0,P.joinPath)(this.extensionsDownloadDir,`.${(0,w.generateUuid)()}`);await this.fileService.exists(o)||await n(o);try{await this.rename(o,d,Date.now()+2*60*1e3)}catch(t){try{await this.fileService.del(o)}catch{}if(t.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",u.identifier.id,d.path);else throw this.logService.info(`Rename failed because of ${(0,i.getErrorMessage)(t)}. Deleted the file from downloaded location`,o.path),t}}async delete(u){await this.cleanUpPromise,await this.fileService.del(u)}async rename(u,d,n){try{await b.Promises.rename(u.fsPath,d.fsPath)}catch(o){if(L.isWindows&&o&&o.code==="EPERM"&&Date.now()<n)return this.logService.info(`Failed renaming ${u} to ${d} with 'EPERM' error. Trying again...`),this.rename(u,d,n);throw o}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const u=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(u.children){const d=[],n=[],o=[];for(const s of u.children)if(s.name.endsWith(pt.SignatureArchiveExtension))o.push(s.resource);else{const l=f.ExtensionKey.parse(s.name);l&&n.push([l,s])}const t=(0,f.groupByExtension)(n,([s])=>s),r=[];for(const s of t)s.sort((l,a)=>I.rcompare(l[0].version,a[0].version)),d.push(...s.slice(1).map(l=>l[1].resource)),r.push(s[0][1]);r.sort((s,l)=>s.mtime-l.mtime),d.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(s=>s.resource)),d.push(...o),await D.Promises.settled(d.map(s=>(this.logService.trace("Deleting from cache",s.path),this.fileService.del(s))))}}catch(u){this.logService.error(u)}}getName(u){return this.cache?f.ExtensionKey.create(u).toString().toLowerCase():(0,w.generateUuid)()}};p.SignatureArchiveExtension=".sigzip",p=ve([K(0,S.INativeEnvironmentService),K(1,y.IFileService),K(2,m.IExtensionGalleryService),K(3,C.IConfigurationService),K(4,v.IExtensionSignatureVerificationService),K(5,h.ILogService)],p),e.ExtensionsDownloader=p}),define(re[218],se([0,1,2,12,28,46]),function(Q,e,D,i,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class L extends D.Disposable{constructor(I,w){super(),this.environmentService=I,this.extensionsManifestCache=(0,i.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(w.onDidInstallExtensions(b=>this.onDidInstallExtensions(b))),this._register(w.onDidUninstallExtension(b=>this.onDidUnInstallExtension(b)))}onDidInstallExtensions(I){I.some(w=>!!w.local)&&this.invalidate()}onDidUnInstallExtension(I){I.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=L}),define(re[219],se([0,1,99,20,6,2,22,12,28,13,29,33,7,72,5,8]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let y=class extends m.LanguagePackBaseService{constructor(u,d,n,o){super(n),this.extensionManagementService=u,this.logService=o,this.cache=this._register(new h(d,o)),this.extensionManagementService.registerParticipant({postInstall:async t=>this.postInstallExtension(t),postUninstall:async t=>this.postUninstallExtension(t)})}async getBuiltInExtensionTranslationsUri(u){const n=(await this.cache.getLanguagePacks())[f.Language.value()];if(!n){this.logService.warn(`No language pack found for ${f.Language.value()}`);return}const o=n.translations[u];return o?v.URI.file(o):void 0}async getInstalledLanguages(){const u=await this.cache.getLanguagePacks(),d=Object.keys(u).map(n=>{const o=u[n];return{...this.createQuickPickItem(n,o.label),extensionId:o.extensions[0].extensionIdentifier.id}});return d.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),d.sort((n,o)=>n.label.localeCompare(o.label)),d}async postInstallExtension(u){u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",u.identifier.id),await this.update())}async postUninstallExtension(u){const d=await this.cache.getLanguagePacks();Object.keys(d).some(n=>d[n]&&d[n].extensions.some(o=>(0,C.areSameExtensions)(o.extensionIdentifier,u.identifier)))&&(this.logService.info("Removing language packs from the extension",u.identifier.id),await this.update())}async update(){const[u,d]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),n=await this.cache.update(d);return!(0,i.equals)(Object.keys(u),Object.keys(n))}};y=ve([K(0,b.IExtensionManagementService),K(1,w.INativeEnvironmentService),K(2,b.IExtensionGalleryService),K(3,S.ILogService)],y),e.NativeLanguagePackService=y;let h=class extends T.Disposable{constructor(u,d){super(),this.logService=d,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(u.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(u){return this.withLanguagePacks(d=>{Object.keys(d).forEach(n=>delete d[n]),this.createLanguagePacksFromExtensions(d,...u)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(u,...d){for(const n of d)n&&n.manifest&&n.manifest.contributes&&n.manifest.contributes.localizations&&n.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(u,n);Object.keys(u).forEach(n=>this.updateHash(u[n]))}createLanguagePacksFromExtension(u,d){const n=d.identifier,o=d.manifest.contributes&&d.manifest.contributes.localizations?d.manifest.contributes.localizations:[];for(const t of o)if(d.location.scheme===L.Schemas.file&&p(t)){let r=u[t.languageId];r||(r={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},u[t.languageId]=r);const s=r.extensions.filter(l=>(0,C.areSameExtensions)(l.extensionIdentifier,n))[0];s?s.version=d.manifest.version:r.extensions.push({extensionIdentifier:n,version:d.manifest.version});for(const l of t.translations)r.translations[l.id]=(0,P.join)(d.location.fsPath,l.path)}}updateHash(u){if(u){const d=(0,D.createHash)("md5");for(const n of u.extensions)d.update(n.extensionIdentifier.uuid||n.extensionIdentifier.id).update(n.version);u.hash=d.digest("hex")}}withLanguagePacks(u=()=>null){return this.languagePacksFileLimiter.queue(()=>{let d=null;return I.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,n=>n.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(n)).then(n=>{try{return JSON.parse(n)}catch{return{}}}).then(n=>(d=u(n),n)).then(n=>{for(const t of Object.keys(n))n[t]||delete n[t];this.languagePacks=n,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),I.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>d,n=>this.logService.error(n))})}};h=ve([K(0,w.INativeEnvironmentService),K(1,S.ILogService)],h);function p(c){if(typeof c.languageId!="string"||!Array.isArray(c.translations)||c.translations.length===0)return!1;for(const u of c.translations)if(typeof u.id!="string"||typeof u.path!="string")return!1;return!(c.languageName&&typeof c.languageName!="string"||c.localizedLanguageName&&typeof c.localizedLanguageName!="string")}}),define(re[220],se([0,1,6,17,24,11,3,2,31,91,215,105]),function(Q,e,D,i,R,T,L,P,I,w,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const S=30*1e3;var m;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(m=e.ConnectionType||(e.ConnectionType={}));function f(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function v(q){const x=new R.CancellationTokenSource;return setTimeout(()=>x.cancel(),q),x.token}function y(q,x){if(q.isCancellationRequested||x.isCancellationRequested)return R.CancellationToken.Cancelled;const _=new R.CancellationTokenSource;return q.onCancellationRequested(()=>_.cancel()),x.onCancellationRequested(()=>_.cancel()),_.token}class h{get didTimeout(){return this._state==="timedout"}constructor(x){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((_,M)=>{this._resolvePromise=_,this._rejectPromise=M}),x.isCancellationRequested?this._timeout():this._disposables.add(x.onCancellationRequested(()=>this._timeout()))}registerDisposable(x){this._state==="pending"?this._disposables.add(x):x.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const x=new Error("Time limit reached");return x.code="ETIMEDOUT",x.syscall="connect",x}resolve(x){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(x))}reject(x){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(x))}}function p(q,x){const _=new h(x);return _.registerDisposable(q.onControlMessage(M=>{const Y=JSON.parse(M.toString()),H=z(Y);H?_.reject(H):_.resolve(Y)})),_.promise}function c(q,x,_,M,Y,H,Z,oe){const X=new h(oe);return x.connect(_,M,Y,H,Z,(ie,ne)=>{X.didTimeout?(ie&&q.error(ie),ne?.dispose()):ie||!ne?X.reject(ie):X.resolve(ne)}),X.promise}function u(q,x){const _=new h(x);return q.then(M=>{_.didTimeout||_.resolve(M)},M=>{_.didTimeout||_.reject(M)}),_.promise}async function d(q,x,_,M){const Y=ee(q,x);q.logService.trace(`${Y} 1/6. invoking socketFactory.connect().`);let H;try{H=await c(q.logService,q.socketFactory,q.host,q.port,(0,C.getRemoteServerRootPath)(q),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,`renderer-${f(x)}-${q.reconnectionToken}`,M)}catch(ne){throw q.logService.error(`${Y} socketFactory.connect() failed or timed out. Error:`),q.logService.error(ne),ne}q.logService.trace(`${Y} 2/6. socketFactory.connect() was successful.`);let Z,oe;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(H,null),Z=q.reconnectionProtocol,oe=!1):(Z=new w.PersistentProtocol(H,null),oe=!0),q.logService.trace(`${Y} 3/6. sending AuthRequest control message.`);const X=await u(q.signService.createNewMessage((0,I.generateUuid)()),M),ie={type:"auth",auth:q.connectionToken||"00000000000000000000",data:X.data};Z.sendControl(i.VSBuffer.fromString(JSON.stringify(ie)));try{const ne=await p(Z,y(M,v(1e4)));if(ne.type!=="sign"||typeof ne.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(q.logService.trace(`${Y} 4/6. received SignRequest control message.`),!await u(q.signService.validate(X,ne.signedData),M)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const ue=await u(q.signService.sign(ne.data),M),pe={type:"connectionType",commit:q.commit,signedData:ue,desiredConnectionType:x};return _&&(pe.args=_),q.logService.trace(`${Y} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(i.VSBuffer.fromString(JSON.stringify(pe))),{protocol:Z,ownsProtocol:oe}}catch(ne){throw ne&&ne.code==="ETIMEDOUT"&&(q.logService.error(`${Y} the handshake timed out. Error:`),q.logService.error(ne)),ne&&ne.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${Y} received error control message when negotiating connection. Error:`),q.logService.error(ne)),oe&&V(Z),ne}}async function n(q,x,_,M){const Y=Date.now(),H=ee(q,x),{protocol:Z,ownsProtocol:oe}=await d(q,x,_,M),X=new h(M);return X.registerDisposable(Z.onControlMessage(ie=>{const ne=JSON.parse(ie.toString()),le=z(ne);le?(q.logService.error(`${H} received error control message when negotiating connection. Error:`),q.logService.error(le),oe&&V(Z),X.reject(le)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${ce(Y)}!`),X.resolve({protocol:Z,firstMessage:ne}))})),X.promise}async function o(q,x){const{protocol:_}=await n(q,1,void 0,x);return{protocol:_}}async function t(q,x,_){const{protocol:M,firstMessage:Y}=await n(q,2,x,_),H=Y&&Y.debugPort;return{protocol:M,debugPort:H}}async function r(q,x,_){const M=Date.now(),Y=ee(q,3),{protocol:H}=await d(q,3,x,_);return q.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${ce(M)}!`),H}async function s(q,x,_){const{host:M,port:Y,connectionToken:H}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,host:M,port:Y,connectionToken:H,reconnectionToken:x,reconnectionProtocol:_,socketFactory:q.socketFactory,signService:q.signService,logService:q.logService}}async function l(q,x,_){return g(q,async M=>{const{protocol:Y}=await o(M,R.CancellationToken.None);return new G(q,x,_,M.reconnectionToken,Y)})}e.connectRemoteAgentManagement=l;async function a(q,x){return g(q,async _=>{const{protocol:M,debugPort:Y}=await t(_,x,R.CancellationToken.None);return new W(q,x,_.reconnectionToken,M,Y)})}e.connectRemoteAgentExtensionHost=a;async function g(q,x){for(let M=1;;M++)try{const Y=(0,I.generateUuid)(),H=await s(q,Y,null);return await x(H)}catch(Y){if(M<5)q.logService.error(`[remote-connection][attempt ${M}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(Y);else throw q.logService.error(`[remote-connection][attempt ${M}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(Y),$.triggerPermanentFailure(0,0,b.RemoteAuthorityResolverError.isHandled(Y)),Y}}async function E(q,x,_){const M=await s(q,(0,I.generateUuid)(),null);return await r(M,{host:x,port:_},R.CancellationToken.None)}e.connectRemoteAgentTunnel=E;function A(q){return(0,D.createCancelablePromise)(x=>new Promise((_,M)=>{const Y=setTimeout(_,q*1e3);x.onCancellationRequested(()=>{clearTimeout(Y),_()})}))}var B;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(B=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class O{constructor(x,_){this.reconnectionToken=x,this.millisSinceLastIncomingData=_,this.type=0}}e.ConnectionLostEvent=O;class N{constructor(x,_,M,Y){this.reconnectionToken=x,this.millisSinceLastIncomingData=_,this.durationSeconds=M,this.cancellableTimer=Y,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=N;class F{constructor(x,_,M){this.reconnectionToken=x,this.millisSinceLastIncomingData=_,this.attempt=M,this.type=2}}e.ReconnectionRunningEvent=F;class k{constructor(x,_,M){this.reconnectionToken=x,this.millisSinceLastIncomingData=_,this.attempt=M,this.type=4}}e.ConnectionGainEvent=k;class U{constructor(x,_,M,Y){this.reconnectionToken=x,this.millisSinceLastIncomingData=_,this.attempt=M,this.handled=Y,this.type=3}}e.ReconnectionPermanentFailureEvent=U;class $ extends P.Disposable{static triggerPermanentFailure(x,_,M){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=x,this._permanentFailureAttempt=_,this._permanentFailureHandled=M,this._instances.forEach(Y=>Y._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(x=>x._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(x=>x._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||$._permanentFailure}constructor(x,_,M,Y,H){super(),this._connectionType=x,this._options=_,this.reconnectionToken=M,this.protocol=Y,this._reconnectionFailureIsFatal=H,this._onDidStateChange=this._register(new L.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new k(this.reconnectionToken,0,0)),this._register(Y.onSocketClose(Z=>{const oe=J(this._connectionType,this.reconnectionToken,!0);Z?Z.type===0?(this._options.logService.info(`${oe} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this._options.logService.error(Z.error)):(this._options.logService.info(`${oe} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this._options.logService.error(Z.event)):this._options.logService.info(`${oe} received socket close event.`),this._beginReconnecting()})),this._register(Y.onSocketTimeout(Z=>{const oe=J(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),$._instances.push(this),this._register((0,P.toDisposable)(()=>{const Z=$._instances.indexOf(this);Z>=0&&$._instances.splice(Z,1)})),this._isPermanentFailure&&this._gotoPermanentFailure($._permanentFailureMillisSinceLastIncomingData,$._permanentFailureAttempt,$._permanentFailureHandled)}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const x=J(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${x} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let M=-1;do{M++;const Y=M<_.length?_[M]:_[_.length-1];try{if(Y>0){const Z=A(Y);this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,Z)),this._options.logService.info(`${x} waiting for ${Y} seconds before reconnecting...`);try{await Z}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${x} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1)),this._options.logService.info(`${x} resolving connection...`);const H=await s(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${x} connecting to ${H.host}:${H.port}...`),await this._reconnect(H,v(S)),this._options.logService.info(`${x} reconnected!`),this._onDidStateChange.fire(new k(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1));break}catch(H){if(H.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${x} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(M>360){this._options.logService.error(`${x} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(b.RemoteAuthorityResolverError.isTemporarilyNotAvailable(H)){this._options.logService.info(`${x} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if((H.code==="ETIMEDOUT"||H.code==="ENETUNREACH"||H.code==="ECONNREFUSED"||H.code==="ECONNRESET")&&H.syscall==="connect"){this._options.logService.info(`${x} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if((0,T.isCancellationError)(H)){this._options.logService.info(`${x} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(H);continue}if(H instanceof b.RemoteAuthorityResolverError){this._options.logService.error(`${x} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,b.RemoteAuthorityResolverError.isHandled(H));break}this._options.logService.error(`${x} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(H),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(x,_,M){this._reconnectionFailureIsFatal?$.triggerPermanentFailure(x,_,M):this._gotoPermanentFailure(x,_,M)}_gotoPermanentFailure(x,_,M){this._onDidStateChange.fire(new U(this.reconnectionToken,x,_,M)),V(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=$,$._permanentFailure=!1,$._permanentFailureMillisSinceLastIncomingData=0,$._permanentFailureAttempt=0,$._permanentFailureHandled=!1,$._instances=[];class G extends ${constructor(x,_,M,Y,H){super(1,x,Y,H,!0),this.client=this._register(new w.Client(H,{remoteAuthority:_,clientId:M},x.ipcLogger))}async _reconnect(x,_){await o(x,_)}}e.ManagementPersistentConnection=G;class W extends ${constructor(x,_,M,Y,H){super(2,x,M,Y,!1),this._startArguments=_,this.debugPort=H}async _reconnect(x,_){await t(x,this._startArguments,_)}}e.ExtensionHostPersistentConnection=W;function V(q){try{q.acceptDisconnect();const x=q.getSocket();q.dispose(),x.dispose()}catch(x){(0,T.onUnexpectedError)(x)}}function z(q){if(q&&q.type==="error"){const x=new Error(`Connection error: ${q.reason}`);return x.code="VSCODE_CONNECTION_ERROR",x}return null}function j(q,x){for(;q.length<x;)q+=" ";return q}function J(q,x,_){return`[remote-connection][${j(f(q),13)}][${x.substr(0,5)}\u2026][${_?"reconnect":"initial"}]`}function ee(q,x){return`${J(x,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.host}:${q.port}]`}function ce(q){return`${Date.now()-q} ms`}}),define(re[221],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(re[222],se([0,1,84,150]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,T,L,P,I,w){const b=S=>w(S,void 0),C=D.createConnection({host:R,port:T},()=>{C.removeListener("error",b);const S=Buffer.alloc(16);for(let y=0;y<16;y++)S[y]=Math.round(Math.random()*256);const m=S.toString("base64"),f=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${T}${L}?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${m}`];C.write(f.join(`\r
`)+`\r
\r
`);const v=y=>{y.toString().indexOf(`\r
\r
`)>=0&&(C.off("data",v),w(void 0,new i.NodeSocket(C,I)))};C.on("data",v)});C.setNoDelay(!0),C.once("error",b)}}}),define(re[106],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,D.createDecorator)("IRemoteTunnelService");var i;(function(R){R.disconnected={type:"disconnected"},R.uninitialized={type:"uninitialized"},R.connected=T=>({type:"connected",info:T}),R.connecting=T=>({type:"connecting",progress:T})})(i=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride"}),define(re[223],se([0,1,133,16,7]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(P,I){this.configurationService=P,this.logService=I}async request(P,I){this.logService.trace("RequestService#request (browser) - begin",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const w=await(0,D.request)(P,I);return this.logService.trace("RequestService#request (browser) - success",P.url),w}catch(w){throw this.logService.error("RequestService#request (browser) - error",P.url,w),w}}async resolveProxy(P){}};T=ve([K(0,i.IConfigurationService),K(1,R.ILogService)],T),e.RequestService=T}),define(re[47],se([0,1,17,169,45,4,39]),function(Q,e,D,i,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function P(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}e.isSuccess=P;function I(v){return v.res.statusCode===204}async function w(v){return I(v)?null:(await(0,D.streamToBuffer)(v.stream)).toString()}e.asText=w;async function b(v){if(!P(v))throw new Error("Server returned "+v.res.statusCode);return w(v)}e.asTextOrError=b;async function C(v){if(!P(v))throw new Error("Server returned "+v.res.statusCode);if(I(v))return null;const h=(await(0,D.streamToBuffer)(v.stream)).toString();try{return JSON.parse(h)}catch(p){throw p.message+=`:
`+h,p}}e.asJson=C;function S(v){f(v)}e.updateProxyConfigurationsScope=S;let m;function f(v){const y=L.Registry.as(R.Extensions.Configuration),h=m;m={id:"http",order:15,title:(0,i.localize)(0,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,i.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,i.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,i.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,i.localize)(4,null),(0,i.localize)(5,null),(0,i.localize)(6,null),(0,i.localize)(7,null)],default:"override",description:(0,i.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,i.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[m],remove:h?[h]:[]})}f(2)}),define(re[224],se([0,1,24,22,14,47]),function(Q,e,D,i,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let L=class{constructor(I,w){this.requestService=I,this.fileService=w}async download(I,w,b=D.CancellationToken.None){if(I.scheme===i.Schemas.file||I.scheme===i.Schemas.vscodeRemote){await this.fileService.copy(I,w);return}const C={type:"GET",url:I.toString(!0)},S=await this.requestService.request(C,b);if(S.res.statusCode===200)await this.fileService.writeFile(w,S.stream);else{const m=await(0,T.asTextOrError)(S);throw new Error(`Expected 200, got back ${S.res.statusCode} instead.

${m}`)}}};L=ve([K(0,T.IRequestService),K(1,R.IFileService)],L),e.DownloadService=L}),define(re[225],se([0,1,20,24,2,21,187,14,7,25,47]),function(Q,e,D,i,R,T,L,P,I,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let C=class extends R.Disposable{constructor(m,f,v,y){super(),this.fileService=m,this.productService=f,this.requestService=v,this.logService=y,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,h])=>this.allConfigBasedTips.set(h.configPath,h))}getConfigBasedTips(m){return this.getValidConfigBasedTips(m)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(m){const f=[];for(const[v,y]of this.allConfigBasedTips)if(!(y.configScheme&&y.configScheme!==m.scheme))try{const h=await this.fileService.readFile((0,T.joinPath)(m,v)),p=new Map;Object.entries(y.recommendations).forEach(([u,d])=>{if((0,D.isNonEmptyArray)(d.remotes))for(const n of d.remotes)p.set(n,{extensionId:u,extensionName:d.name,configName:y.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled});else f.push({extensionId:u,extensionName:d.name,configName:y.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled})});const c=(0,L.getDomainsOfRemotes)(h.value.toString(),[...p.keys()]);for(const u of c){const d=p.get(u);d&&f.push(d)}}catch{}return f}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const m=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},i.CancellationToken.None);if(m.res.statusCode!==200)return[];const f=await(0,b.asJson)(m);return f?f.workspaceRecommendations||[]:[]}catch(m){return this.logService.error(m),[]}}};C=ve([K(0,P.IFileService),K(1,w.IProductService),K(2,b.IRequestService),K(3,I.ILogService)],C),e.ExtensionTipsService=C}),define(re[226],se([0,1,17,24]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class R{constructor(P){this.service=P}listen(P,I){throw new Error("Invalid listen")}call(P,I,w,b=i.CancellationToken.None){switch(I){case"request":return this.service.request(w[0],b).then(async({res:C,stream:S})=>{const m=await(0,D.streamToBuffer)(S);return[{statusCode:C.statusCode,headers:C.headers},m]});case"resolveProxy":return this.service.resolveProxy(w[0])}throw new Error("Invalid call")}}e.RequestChannel=R;class T{constructor(P){this.channel=P}async request(P,I){const[w,b]=await this.channel.call("request",[P],I);return{res:w,stream:(0,D.bufferToStream)(b)}}async resolveProxy(P){return this.channel.call("resolveProxy",[P])}}e.RequestChannelClient=T}),define(re[227],se([0,1,223,226]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class R{constructor(L,P,I){this.configurationService=P,this.logService=I,this.browserRequestService=new D.RequestService(P,I),this.mainRequestService=new i.RequestChannelClient(L.getChannel("request"))}request(L,P){return this.getRequestService().request(L,P)}async resolveProxy(L){return this.getRequestService().resolveProxy(L)}getRequestService(){return this.configurationService.getValue("developer.sharedProcess.redirectRequestsToMain")===!0?(this.logService.trace("Using main request service"),this.mainRequestService):(this.logService.trace("Using browser request service"),this.browserRequestService)}}e.SharedProcessRequestService=R}),define(re[107],se([0,1,66,4]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function R(T){return(0,D.hash)({moduleId:T.process.moduleId,windowId:T.reply.windowId})}e.hash=R,e.ISharedProcessWorkerService=(0,i.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(re[228],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(i){i.Spawn="vscode:shared-process->shared-process-worker=spawn",i.Terminate="vscode:shared-process->shared-process-worker=terminate",i.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",i.Ready="vscode:shared-process-worker->shared-process=ready",i.Ack="vscode:shared-process-worker->shared-process=ack",i.Trace="vscode:shared-process-worker->shared-process=trace",i.Info="vscode:shared-process-worker->shared-process=info",i.Warn="vscode:shared-process-worker->shared-process=warn",i.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(re[229],se([0,1,92,6,24,3,2,22,31,7,107,228]),function(Q,e,D,i,R,T,L,P,I,w,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let S=class{constructor(v){this.logService=v,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(v){const y=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${y})`);const h=(0,b.hash)(v);this.processeDisposables.has(h)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${y})`),this.doDisposeWorker(v));const p=new R.CancellationTokenSource;let c,u,d;this.processeDisposables.set(h,r=>{p.dispose(!0),c?.terminate(v,R.CancellationToken.None),u?.close(),d?.close(),this.processeDisposables.delete(h);const s=this.processResolvers.get(h);s&&(this.processResolvers.delete(h),s({reason:r}))}),c=await this.getOrCreateWebWorker(v);const n=new Promise(r=>{this.processResolvers.set(h,r)});if(p.token.isCancellationRequested)return n;const{port1:o,port2:t}=new MessageChannel;return u=o,d=t,await c.spawn(v,d,p.token),p.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${y})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",v,[u])),n}getOrCreateWebWorker(v){let y=this.workers.get(v.process.moduleId);if(!y){this.logService.trace(`SharedProcess: creating new web worker (${v.process.moduleId})`);const h=new m(v.process.type,this.logService);y=h.init(),h.onDidProcessSelfTerminate(({configuration:p,reason:c})=>{this.doDisposeWorker(p,c)}),this.workers.set(v.process.moduleId,y)}return y}async disposeWorker(v){return this.doDisposeWorker(v)}doDisposeWorker(v,y){const h=this.processeDisposables.get((0,b.hash)(v));h&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),h(y))}};S=ve([K(0,w.ILogService)],S),e.SharedProcessWorkerService=S;class m extends L.Disposable{constructor(v,y){super(),this.type=v,this.logService=y,this._onDidProcessSelfTerminate=this._register(new T.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const v=new i.DeferredPromise,y=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return y.onerror=h=>{this.logService.error(`SharedProcess: worker error (${this.type})`,h.message)},y.onmessageerror=h=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,h)},y.onmessage=h=>{const{id:p,message:c,configuration:u,nonce:d}=h.data;switch(p){case C.SharedProcessWorkerMessages.Ready:v.complete(y);break;case C.SharedProcessWorkerMessages.Ack:if(d){const n=this.mapMessageNonceToPendingMessageResolve.get(d);n&&(this.mapMessageNonceToPendingMessageResolve.delete(d),n())}break;case C.SharedProcessWorkerMessages.SelfTerminated:u&&c&&this._onDidProcessSelfTerminate.fire({configuration:u,reason:JSON.parse(c)});break;case C.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,c);break;case C.SharedProcessWorkerMessages.Info:c&&this.logService.info(c);break;case C.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,c);break;case C.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,c);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,h)}},y.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),v.p}async send(v,y,h){const p=await this.workerReady;if(!y.isCancellationRequested)return new Promise(c=>{const u=(0,I.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(u,c);const d={...v,nonce:u};h?p.postMessage(d,[h]):p.postMessage(d),y.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(u)&&c()})})}spawn(v,y,h){const p={id:C.SharedProcessWorkerMessages.Spawn,configuration:v,environment:{bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork",Q).fsPath}};return this.send(p,h,y)}terminate(v,y){const h={id:C.SharedProcessWorkerMessages.Terminate,configuration:v};return this.send(h,y)}}}),define(re[230],se([0,1,63,22,186]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class T extends R.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:i.Schemas.vscodeUserData})}}ve([D.memoize],T.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=T}),define(re[231],se([0,1,50,12,170,24,37,11,5,31,147,184,6]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const m=1e4;let f;async function v(h,p,c){return p["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(c)&&!p["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(c)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=S.Promises.withAsyncBody(async(u,d)=>{const n=new T.CancellationTokenSource,o=setTimeout(()=>{n.dispose(!0),d(new Error((0,R.localize)(0,null)))},m);try{u(await y(h,n.token))}catch(t){!(0,P.isCancellationError)(t)&&!n.token.isCancellationRequested?d(new Error((0,R.localize)(1,null,(0,L.toErrorMessage)(t)))):u({})}finally{clearTimeout(o),n.dispose()}})),f)}e.getResolvedShellEnv=v;async function y(h,p){const c=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",c);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",u);const d=(0,w.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(d+"(.*)"+d),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};h.trace("getUnixShellEnvironment#env",o);const t=await(0,b.getSystemShell)(I.OS,o);return h.trace("getUnixShellEnvironment#shell",t),new Promise((r,s)=>{if(p.isCancellationRequested)return s((0,P.canceled)());const l=(0,i.basename)(t);let a,g;const E=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(a=`& '${process.execPath}' ${E} -p '''${d}'' + JSON.stringify(process.env) + ''${d}'''`,g=["-Login","-Command"]):(a=`'${process.execPath}' ${E} -p '"${d}" + JSON.stringify(process.env) + "${d}"'`,l==="tcsh"?g=["-ic"]:g=["-ilc"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),a);const A=(0,D.spawn)(t,[...g,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});p.onCancellationRequested(()=>(A.kill(),s((0,P.canceled)()))),A.on("error",N=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(N)),s(N)});const B=[];A.stdout.on("data",N=>B.push(N));const O=[];A.stderr.on("data",N=>O.push(N)),A.on("close",(N,F)=>{const k=Buffer.concat(B).toString("utf8");h.trace("getUnixShellEnvironment#raw",k);const U=Buffer.concat(O).toString("utf8");if(U.trim()&&h.trace("getUnixShellEnvironment#stderr",U),N||F)return s(new Error((0,R.localize)(2,null,N,F)));const $=n.exec(k),G=$?$[1]:"{}";try{const W=JSON.parse(G);c?W.ELECTRON_RUN_AS_NODE=c:delete W.ELECTRON_RUN_AS_NODE,u?W.ELECTRON_NO_ATTACH_CONSOLE=u:delete W.ELECTRON_NO_ATTACH_CONSOLE,delete W.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",W),r(W)}catch(W){h.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(W)),s(W)}})})}}),define(re[108],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(re[232],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((R,T)=>Q(["vsda"],R,T))}async createNewMessage(R){try{const T=await this.vsda(),L=new T.validator;if(L){const P=String(D._nextId++);return this.validators.set(P,L),{id:P,data:L.createNewMessage(R)}}}catch{}return{id:"",data:R}}async validate(R,T){if(!R.id)return!0;const L=this.validators.get(R.id);if(!L)return!1;this.validators.delete(R.id);try{return L.validate(T)==="ok"}catch{return!1}}async sign(R){try{const T=await this.vsda(),L=new T.signer;if(L)return L.sign(R)}catch{}return R}}e.SignService=D,D._nextId=1}),define(re[74],se([0,1,3,2]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class R extends i.Disposable{constructor(C,S,m){super(),this.channel=C,this.profile=S,this.workspace=m}async getItems(){const C={profile:this.profile,workspace:this.workspace},S=await this.channel.call("getItems",C);return new Map(S)}updateItems(C){const S={profile:this.profile,workspace:this.workspace};return C.insert&&(S.insert=Array.from(C.insert.entries())),C.delete&&(S.delete=Array.from(C.delete.values())),this.channel.call("updateItems",S)}}class T extends R{constructor(C,S){super(C,S,void 0),this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(C=>this.onDidChangeStorage(C)))}onDidChangeStorage(C){(Array.isArray(C.changed)||Array.isArray(C.deleted))&&this._onDidChangeItemsExternal.fire({changed:C.changed?new Map(C.changed):void 0,deleted:C.deleted?new Set(C.deleted):void 0})}}class L extends T{constructor(C){super(C,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=L;class P extends T{constructor(C,S){super(C,S)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=P;class I extends R{constructor(C,S){super(C,void 0,S),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class w{constructor(C){this.channel=C}isUsed(C){const S={payload:C,profile:void 0,workspace:void 0};return this.channel.call("isUsed",S)}}e.StorageClient=w}),define(re[109],se([0,1,5,36,8,31]),function(Q,e,D,i,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function L(w){if(D.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function P(w,b,C,S,m,f,v,y,h,p){const c=Object.create(null);c["common.machineId"]=v,c.sessionID=(0,T.generateUuid)()+Date.now(),c.commitHash=m,c.version=f,c["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,D.PlatformToString)(D.platform),c["common.nodePlatform"]=i.platform,c["common.nodeArch"]=S,c["common.product"]=p||"desktop",y&&(c["common.msftInternal"]=y);let u=0;const d=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),D.isLinuxSnap&&(c["common.snap"]="true");const n=L(C);n&&(c["common.platformDetail"]=n);try{const o=await w.readFile(R.URI.file(h));c["common.source"]=o.value.toString().slice(0,30)}catch{}return c}e.resolveCommonProperties=P;function I(w){const b=i.env.USERDNSDOMAIN;if(!b)return!1;const C=b.toLowerCase();return w.some(S=>C===S)}e.verifyMicrosoftInternalDomain=I}),define(re[23],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var i;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(i=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(re[233],se([0,1,34,6,35,22,12,5,8,144,28,146,95,14,25,23]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const y=new Map;async function h(n,o){const t=`${n}::${o.join(":")}`,r=y.get(t);if(r)return r;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,a=new Map,g=2e4;function E(B,O,N,F){const k=O.substring(B.length+1);return i.Promises.withAsyncBody(async U=>{let $;try{$=await b.Promises.readdir(O,{withFileTypes:!0})}catch{U();return}if(F.count>=g){F.count+=$.length,F.maxReached=!0,U();return}let G=$.length;if(G===0){U();return}let W=$;F.count+$.length>g&&(F.maxReached=!0,G=g-F.count,W=$.slice(0,G)),F.count+=$.length;for(const V of W)if(V.isDirectory()){if(N.includes(V.name)||await E(B,(0,L.join)(O,V.name),N,F),--G===0){U();return}}else{const z=V.name.lastIndexOf(".");if(z>=0){const j=V.name.substring(z+1);j&&l.set(j,(l.get(j)??0)+1)}for(const j of s)j.relativePathPattern?.test(k)!==!1&&j.filePattern.test(V.name)&&a.set(j.tag,(a.get(j.tag)??0)+1);if(--G===0){U();return}}})}const A=i.Promises.withAsyncBody(async B=>{const O={count:0,maxReached:!1};await E(n,n,o,O);const N=await u(n);B({configFiles:p(a),fileTypes:p(l),fileCount:O.count,maxFilesReached:O.maxReached,launchConfigFiles:N})});return y.set(t,A),A}e.collectWorkspaceStats=h;function p(n){return Array.from(n.entries(),([o,t])=>({name:o,count:t})).sort((o,t)=>t.count-o.count)}function c(){const n={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.virtualMachineHint.value()*100)}%`},o=D.cpus();return o&&o.length>0&&(n.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),n}e.getMachineInfo=c;async function u(n){try{const o=new Map,t=(0,L.join)(n,".vscode","launch.json"),r=await b.Promises.readFile(t),s=[],l=(0,R.parse)(r.toString(),s);if(s.length)return console.log(`Unable to parse ${t}`),[];if((0,R.getNodeType)(l)==="object"&&l.configurations)for(const a of l.configurations){const g=a.type;g&&(o.has(g)?o.set(g,o.get(g)+1):o.set(g,1))}return p(o)}catch{return[]}}e.collectLaunchConfigs=u;let d=class{constructor(o,t){this.telemetryService=o,this.productService=t}formatMachineInfo(o){const t=[];return t.push(`OS Version:       ${o.os}`),t.push(`CPUs:             ${o.cpus}`),t.push(`Memory (System):  ${o.memory}`),t.push(`VM:               ${o.vmHint}`),t.join(`
`)}formatEnvironment(o){const t=[];t.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),t.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const r=D.cpus();return r&&r.length>0&&t.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),t.push(`Memory (System):  ${(D.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||t.push(`Load (avg):       ${D.loadavg().map(s=>Math.round(s)).join(", ")}`),t.push(`VM:               ${Math.round(w.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${o.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(o,t){return Promise.all([(0,C.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async r=>{let[s,l]=r,a=this.formatProcessList(o,s);return t.forEach(g=>{if((0,S.isRemoteDiagnosticError)(g))a+=`
${g.errorMessage}`,l+=`
${g.errorMessage}`;else if(a+=`

Remote: ${g.hostName}`,g.processes&&(a+=`
${this.formatProcessList(o,g.processes)}`),g.workspaceMetadata){l+=`
|  Remote: ${g.hostName}`;for(const E of Object.keys(g.workspaceMetadata)){const A=g.workspaceMetadata[E];let B=`${A.fileCount} files`;A.maxFilesReached&&(B=`more than ${B}`),l+=`|    Folder (${E}): ${B}`,l+=this.formatWorkspaceStats(A)}}}),{processInfo:a,workspaceInfo:l}})}async getSystemInfo(o,t){const{memory:r,vmHint:s,os:l,cpus:a}=c(),g={os:l,memory:r,cpus:a,vmHint:s,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:t};return P.isWindows||(g.load=`${D.loadavg().map(E=>Math.round(E)).join(", ")}`),P.isLinux&&(g.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(g)}async getDiagnostics(o,t){const r=[];return(0,C.listProcesses)(o.mainPID).then(async s=>(r.push(""),r.push(this.formatEnvironment(o)),r.push(""),r.push(this.formatProcessList(o,s)),o.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(o))),t.forEach(l=>{if((0,S.isRemoteDiagnosticError)(l))r.push(`
${l.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${l.hostName}`),r.push(this.formatMachineInfo(l.machineInfo)),l.processes&&r.push(this.formatProcessList(o,l.processes)),l.workspaceMetadata)for(const a of Object.keys(l.workspaceMetadata)){const g=l.workspaceMetadata[a];let E=`${g.fileCount} files`;g.maxFilesReached&&(E=`more than ${E}`),r.push(`Folder (${a}): ${E}`),r.push(this.formatWorkspaceStats(g))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(o){const t=[];let s=0;const l=(A,B)=>{const O=` ${A}(${B})`;s+O.length>60?(t.push(a),a="|                 ",s=a.length):s+=O.length,a+=O};let a="|      File types:";const g=10,E=o.fileTypes.length>g?g:o.fileTypes.length;for(let A=0;A<E;A++){const B=o.fileTypes[A];l(B.name,B.count)}if(t.push(a),o.configFiles.length>=0&&(a="|      Conf files:",s=0,o.configFiles.forEach(A=>{l(A.name,A.count)}),t.push(a)),o.launchConfigFiles.length>0){let A="|      Launch Configs:";o.launchConfigFiles.forEach(B=>{A+=B.count>1?` ${B.name}(${B.count})`:` ${B.name}`}),t.push(A)}return t.join(`
`)}expandGPUFeatures(o){const t=Math.max(...Object.keys(o).map(r=>r.length));return Object.keys(o).map(r=>`${r}:  ${" ".repeat(t-r.length)}  ${o[r]}`).join(`
                  `)}formatWorkspaceMetadata(o){const t=[],r=[];return o.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(t.push(`|  Window (${s.title})`),s.folderURIs.forEach(l=>{const a=I.URI.revive(l);if(a.scheme===T.Schemas.file){const g=a.fsPath;r.push(h(g,["node_modules",".git"]).then(E=>{let A=`${E.fileCount} files`;E.maxFilesReached&&(A=`more than ${A}`),t.push(`|    Folder (${(0,L.basename)(g)}): ${A}`),t.push(this.formatWorkspaceStats(E))}).catch(E=>{t.push(`|      Error: Unable to collect workspace stats for folder ${g} (${E.toString()})`)}))}else t.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(s=>t.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(o,t){const r=new Map;o.windows.forEach(l=>r.set(l.pid,l.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),t&&this.formatProcessItem(o.mainPID,r,s,t,0),s.join(`
`)}formatProcessItem(o,t,r,s,l){const a=l===0;let g;a?g=s.pid===o?`${this.productService.applicationName} main`:"remote agent":(g=`${"  ".repeat(l)} ${s.name}`,s.name==="window"&&(g=`${g} (${t.get(s.pid)})`));const E=process.platform==="win32"?s.mem:D.totalmem()*(s.mem/100);r.push(`${s.load.toFixed(0).padStart(5," ")}	${(E/m.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${g}`),Array.isArray(s.children)&&s.children.forEach(A=>this.formatProcessItem(o,t,r,A,l+1))}async getWorkspaceFileExtensions(o){const t=new Set;for(const{uri:r}of o.folders){const s=I.URI.revive(r);if(s.scheme!==T.Schemas.file)continue;const l=s.fsPath;try{(await h(l,["node_modules",".git"])).fileTypes.forEach(g=>t.add(g.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(o){for(const{uri:t}of o.folders){const r=I.URI.revive(t);if(r.scheme!==T.Schemas.file)continue;const s=r.fsPath;try{const l=await h(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),l.fileTypes.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),l.launchConfigFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),l.configFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};d=ve([K(0,v.ITelemetryService),K(1,f.IProductService)],d),e.DiagnosticsService=d}),define(re[234],se([0,1,106,3,23,13,2,7,12,50,25,5,6,101,16,168,34]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;let h=class extends L.Disposable{constructor(c,u,d,n,o,t){super(),this.telemetryService=c,this.productService=u,this.environmentService=d,this.configurationService=t,this._onDidTokenFailedEmitter=new i.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new i.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeAccountEmitter=new i.Emitter,this.onDidChangeAccount=this._onDidChangeAccountEmitter.event,this._tunnelStatus=D.TunnelStates.disconnected,this._logger=this._register(n.createLogger(d.remoteTunnelLogResource,{name:"remoteTunnel"})),this._startTunnelProcessDelayer=new S.Delayer(100),this._register(o.onWillShutdown(r=>{this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),this.dispose()})),this._register(t.onDidChangeConfiguration(r=>{r.affectsConfiguration(D.CONFIGURATION_KEY_HOST_NAME)&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}))}async getAccount(){return this._account}async updateAccount(c){if(c&&this._account?c.token!==this._account.token||c.authenticationProviderId!==this._account.authenticationProviderId:c!==this._account){this._account=c,this._onDidChangeAccountEmitter.fire(c),this._logger.info(`Account updated: ${c?c.authenticationProviderId:"undefined"}`),this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:!!c});try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(u){this._logger.error(u)}}}getTunnelCommandLocation(){if(!this._tunnelCommand){let c;C.isMacintosh?c=this.environmentService.appRoot:c=(0,I.dirname)((0,I.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,I.join)(c,"bin",`${this.productService.tunnelApplicationName}${C.isWindows?".exe":""}`)}return this._tunnelCommand}async updateTunnelProcess(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),!this._account){this.setTunnelStatus(D.TunnelStates.disconnected);return}const{token:c,authenticationProviderId:u}=this._account;this.setTunnelStatus(D.TunnelStates.connecting((0,v.localize)(0,null)));const d=(s,l)=>{s=s.replaceAll(c,"*".repeat(4)),l?this._logger.error(s):this._logger.info(s)},n=this.runCodeTunneCommand("login",["user","login","--provider",u,"--access-token",c],d);this._tunnelProcess=n;try{if(await n,this._tunnelProcess!==n)return}catch(s){this._logger.error(s),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(!0),this.setTunnelStatus(D.TunnelStates.disconnected);return}const o=["--parent-process-id",String(process.pid),"--accept-server-license-terms"],t=this.getHostName();t?o.push("--name",t):o.push("--random-name");const r=this.runCodeTunneCommand("tunnel",o,(s,l)=>{l?this._logger.error(s):this._logger.info(s);const a=s.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(a){const g={link:a[1],domain:a[2],extensionId:"ms-vscode.remote-server",hostName:a[4]};this.setTunnelStatus(D.TunnelStates.connected(g))}else s.match(/error refreshing token/)&&(r.cancel(),this._onDidTokenFailedEmitter.fire(!0),this.setTunnelStatus(D.TunnelStates.disconnected))});this._tunnelProcess=r,r.finally(()=>{r===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._account=void 0,this.setTunnelStatus(D.TunnelStates.disconnected))})}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(c){c!==this._tunnelStatus&&(this._tunnelStatus=c,this._onDidChangeTunnelStatusEmitter.fire(c))}runCodeTunneCommand(c,u,d=()=>{}){return(0,S.createCancelablePromise)(n=>new Promise((o,t)=>{n.isCancellationRequested&&o();let r;if(n.onCancellationRequested(()=>{r&&(this._logger.info(`${c} terminating (${r.pid})`),r.kill())}),process.env.VSCODE_DEV)d("Compiling tunnel CLI from sources and run",!1),d(`${c} Spawning: cargo run -- tunnel ${u.join(" ")}`,!1),r=(0,w.spawn)("cargo",["run","--","tunnel",...u],{cwd:(0,I.join)(this.environmentService.appRoot,"cli")});else{d("Running tunnel CLI",!1);const s=this.getTunnelCommandLocation();d(`${c} Spawning: ${s} tunnel ${u.join(" ")}`,!1),r=(0,w.spawn)(s,["tunnel",...u],{cwd:(0,y.homedir)()})}r.stdout.on("data",s=>{if(r){const l=s.toString();d(l,!1)}}),r.stderr.on("data",s=>{if(r){const l=s.toString();d(l,!0)}}),r.on("exit",s=>{r&&(d(`${c} exit (${r.pid}):  + ${s}`,!1),r=void 0,s===0?o():t())}),r.on("error",s=>{r&&(d(`${c} error (${r.pid}):  + ${s}`,!0),r=void 0,t())})}))}getHostName(){const c=this.configurationService.getValue(D.CONFIGURATION_KEY_HOST_NAME);if(c&&c.match(/^([\w-]+)$/)&&c.length<=20)return c;const u=(0,y.hostname)();if(u&&u.match(/^([\w-]+)$/))return u.substring(0,20)}};h=ve([K(0,R.ITelemetryService),K(1,b.IProductService),K(2,T.INativeEnvironmentService),K(3,P.ILoggerService),K(4,m.ISharedProcessLifecycleService),K(5,f.IConfigurationService)],h),e.RemoteTunnelService=h}),define(re[110],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(T){this.appenders=T}listen(T,L){throw new Error(`Event not found: ${L}`)}call(T,L,{eventName:P,data:I}){return this.appenders.forEach(w=>w.log(P,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class i{constructor(T){this.channel=T}log(T,L){return this.channel.call("log",{eventName:T,data:L}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=i}),define(re[52],se([0,1,32,86,15,16,109,23]),function(Q,e,D,i,R,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class I{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,i.staticObservableValue)(0)}publicLog(r,s){return Promise.resolve(void 0)}publicLog2(r,s){return this.publicLog(r,s)}publicLogError(r,s){return Promise.resolve(void 0)}publicLogError2(r,s){return this.publicLogError(r,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class w{async publicLog(r,s,l){}async publicLogError(r,s,l){}}e.NullEndpointTelemetryService=w,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(t,r){return r.onDidChangeConfiguration(s=>{s.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(s.source),configurationKeys:h(s.sourceConfig)})})}e.configurationTelemetry=b;function C(t,r){return!(r.disableTelemetry||!t.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=C;function S(t){const r=t.getValue(P.TELEMETRY_SETTING_ID),s=t.getValue("telemetry.enableCrashReporter");if(t.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function m(t){const r={},s={},l={};y(t,l);for(let a in l){a=a.length>150?a.substr(a.length-149):a;const g=l[a];typeof g=="number"?s[a]=g:typeof g=="boolean"?s[a]=g?1:0:typeof g=="string"?(g.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${g.length}`),r[a]=g.substring(0,8191)):typeof g<"u"&&g!==null&&(r[a]=g)}return{properties:r,measurements:s}}e.validateTelemetryData=m;const f=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function v(t){if(!t)return"none";for(const r of f)if(t.startsWith(`${r}+`))return r;return"other"}e.cleanRemoteAuthority=v;function y(t,r,s=0,l){if(!!t)for(const a of Object.getOwnPropertyNames(t)){const g=t[a],E=l?l+a:a;Array.isArray(g)?r[E]=(0,D.safeStringify)(g):g instanceof Date?r[E]=g.toISOString():(0,R.isObject)(g)?s<2?y(g,r,s+1,E+"."):r[E]=(0,D.safeStringify)(g):r[E]=g}}function h(t){if(!t)return[];const r=[];return p(r,"",t),r}function p(t,r,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(l=>p(t,r?`${r}.${l}`:l,s[l])):t.push(r)}function c(t,r){const s=t.msftInternalDomains||[],l=r.getValue("telemetry.internalTesting");return(0,L.verifyMicrosoftInternalDomain)(s)||l}e.isInternalTelemetry=c;function u(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.getPiiPathsFromEnvironment=u;function d(t,r){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const l=[];for(const A of r)for(;;){const B=A.exec(t);if(!B)break;l.push([B.index,A.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,g=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(s="";;){const A=g.exec(t);if(!A)break;const B=l.some(([O,N])=>A.index<N&&O<g.lastIndex);!a.test(A[0])&&!B&&(s+=t.substring(E,A.index)+"<REDACTED: user-file-path>",E=g.lastIndex)}return E<t.length&&(s+=t.substr(E)),s}function n(t){if(!t)return t;const r=t.toLowerCase(),s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of s)if(l.regex.test(r))return`<REDACTED: ${l.label}>`;return t}function o(t,r){return(0,D.cloneAndChange)(t,s=>{if(typeof s=="string"){let l=s;l=d(l,r);for(const a of r)l=l.replace(a,"");return l=n(l),l}})}e.cleanData=o}),define(re[235],se([0,1,44,52]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function R(T,L,P,I,w,b,C){const S={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${L.nameShort})`};if((0,i.supportsTelemetry)(L,P)&&(0,i.getTelemetryLevel)(I)===3){const m=await(0,D.getServiceMachineId)(P,w,b),{sessionId:f}=await C.getTelemetryInfo();S["X-Market-User-Id"]=m,S["VSCode-SessionId"]=f}return S}e.resolveMarketplaceHeaders=R}),define(re[236],se([0,1,11,32,52]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function L(I,w,b){const C=await new Promise((y,h)=>{Q(["@microsoft/1ds-core-js"],y,h)}),S=await new Promise((y,h)=>{Q(["@microsoft/1ds-post-js"],y,h)}),m=new C.AppInsightsCore,f=new S.PostChannel,v={instrumentationKey:I,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[f]]};if(b){v.extensionConfig={};const y={alwaysUseXhrOverride:!0,httpXHROverride:b};v.extensionConfig[f.identifier]=y}return m.initialize(v,[]),m.addTelemetryInitializer(y=>{w&&(y.ext=y.ext??{},y.ext.utc=y.ext.utc??{},y.ext.utc.flags=8462029)}),m}class P{constructor(w,b,C,S,m){this._isInternalTelemetry=w,this._eventPrefix=b,this._defaultData=C,this._xhrOverride=m,this.endPointUrl=T,this._defaultData||(this._defaultData={}),typeof S=="function"?this._aiCoreOrKey=S():this._aiCoreOrKey=S,this._asyncAiCore=null}_withAIClient(w){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){w(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=L(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(b=>{w(b)},b=>{(0,D.onUnexpectedError)(b),console.error(b)})}}log(w,b){if(!this._aiCoreOrKey)return;b=(0,i.mixin)(b,this._defaultData),b=(0,R.validateTelemetryData)(b);const C=this._eventPrefix+"/"+w;try{this._withAIClient(S=>{S.pluginVersionString=b?.properties.version??"Unknown",S.track({name:C,baseData:{name:C,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(w=>{this._withAIClient(b=>{b.unload(!0,()=>{this._aiCoreOrKey=void 0,w(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(re[111],se([0,1,2,13,7,52]),function(Q,e,D,i,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let L=class extends D.Disposable{constructor(I,w,b=""){super(),this.prefix=b;const C=I.getLogger(w.telemetryLogResource);C?this.logger=this._register(C):(this.logger=this._register(I.createLogger(w.telemetryLogResource)),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(I,w){this.logger.trace(`${this.prefix}telemetry/${I}`,(0,T.validateTelemetryData)(w))}};L=ve([K(0,R.ILoggerService),K(1,i.IEnvironmentService)],L),e.TelemetryLogAppender=L}),define(re[112],se([0,1,2,32,86,5,27,171,16,45,103,25,39,23,52]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let v=class{constructor(p,c,u){this._configurationService=c,this._productService=u,this._experimentProperties={},this.telemetryLevel=new R.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=p.appenders,this._commonProperties=p.commonProperties||Promise.resolve({}),this._piiPaths=p.piiPaths||[],this._sendErrorTelemetry=!!p.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(d),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(p,c){this._experimentProperties[p]=c}_updateTelemetryLevel(){let p=(0,f.getTelemetryLevel)(this._configurationService);const c=this._productService.enabledTelemetryLevels;if(c){this._sendErrorTelemetry=this.sendErrorTelemetry?c.error:!1;const u=c.usage?3:c.error?2:0;p=Math.min(p,u)}this.telemetryLevel.value=p}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const p=await this._commonProperties,c=p.sessionID,u=p["common.machineId"],d=p["common.firstSessionDate"],n=p["common.msftInternal"];return{sessionId:c,machineId:u,firstSessionDate:d,msftInternal:n}}dispose(){this._disposables.dispose()}_log(p,c,u,d){return this.telemetryLevel.value<c?Promise.resolve(void 0):this._commonProperties.then(n=>{u=(0,i.mixin)(u,this._experimentProperties),u=(0,f.cleanData)(u,this._cleanupPatterns),u=(0,i.mixin)(u,n),this._appenders.forEach(o=>o.log(p,u))},n=>{console.error(n)})}publicLog(p,c,u){return this._log(p,3,c,u)}publicLog2(p,c,u){return this.publicLog(p,c,u)}publicLogError(p,c){return this._sendErrorTelemetry?this._log(p,2,c,!0):Promise.resolve(void 0)}publicLogError2(p,c){return this.publicLogError(p,c)}};v.IDLE_START_EVENT_NAME="UserIdleStart",v.IDLE_STOP_EVENT_NAME="UserIdleStop",v=ve([K(1,I.IConfigurationService),K(2,C.IProductService)],v),e.TelemetryService=v;function y(){const h=(0,P.localize)(0,null,b.default.nameLong),p=b.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=T.isWeb?"":(0,P.localize)(3,null),u=(0,P.localize)(4,null),d=(0,P.localize)(5,null),n=(0,P.localize)(6,null),o=(0,P.localize)(7,null),t=`
|       | ${u} | ${d} | ${n} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,P.localize)(8,null);return`
${h} ${p} ${c}

&nbsp;

${o}
${t}

&nbsp;

${r}
`}S.Registry.as(w.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(w.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,P.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,P.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[237],se([0,1,287,236]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class R extends i.AbstractOneDataSystemAppender{constructor(L,P,I,w){const b={sendPOST:(C,S)=>{const m={method:"POST",headers:{...C.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(C.data)}};try{const f=D.request(C.urlString,m,v=>{v.on("data",function(y){S(v.statusCode??200,v.headers,y.toString())}),v.on("error",function(y){S(0,{})})});f.write(C.data),f.end()}catch{S(0,{})}}};super(L,P,I,w,b)}}e.OneDataSystemAppender=R}),define(re[238],se([0,1,22,68,16,13,7,25,23,110,111,112]),function(Q,e,D,i,R,T,L,P,I,w,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let S=class{constructor(f,v,y,h,p){this.configurationService=f,this.telemetryService=v,this.loggerService=y,this.environmentService=h,this.productService=p,this.customTelemetryServices=new Map}async getCustomTelemetryService(f){if(!this.customTelemetryServices.has(f.id)){const{machineId:v,sessionId:y}=await this.telemetryService.getTelemetryInfo(),h=Object.create(null);h["common.vscodemachineid"]=v,h["common.vscodesessionid"]=y;const p=[f.id,JSON.stringify(h),f.aiKey],u=new i.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:p,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),d=[new w.TelemetryAppenderClient(u),new b.TelemetryLogAppender(this.loggerService,this.environmentService,`[${f.id}] `)];this.customTelemetryServices.set(f.id,new C.TelemetryService({appenders:d,sendErrorTelemetry:f.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(f.id)}async publicLog(f,v,y){await(await this.getCustomTelemetryService(f)).publicLog(v,y)}async publicLogError(f,v,y){await(await this.getCustomTelemetryService(f)).publicLogError(v,y)}};S=ve([K(0,R.IConfigurationService),K(1,I.ITelemetryService),K(2,L.ILoggerService),K(3,T.IEnvironmentService),K(4,P.IProductService)],S),e.CustomEndpointTelemetryService=S}),define(re[239],se([0,1,6,24,3,2,7]),function(Q,e,D,i,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends T.Disposable{constructor(w,b){super(),this._logService=b,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=w===void 0?15e3:w}createRequest(w){return new Promise((b,C)=>{const S=++this._lastRequestId;this._pendingRequests.set(S,b),this._onCreateRequest.fire({requestId:S,...w});const m=new i.CancellationTokenSource;(0,D.timeout)(this._timeout,m.token).then(()=>C(`Request ${S} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(S,[(0,T.toDisposable)(()=>m.cancel())])})}acceptReply(w,b){const C=this._pendingRequests.get(w);C?(this._pendingRequests.delete(w),(0,T.dispose)(this._pendingRequestDisposables.get(w)||[]),this._pendingRequestDisposables.delete(w),C(b)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${w}`)}};P=ve([K(1,L.ILogService)],P),e.RequestStore=P}),define(re[113],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var i;(function(c){c.Shell="terminal.integrated.shell.",c.ShellArgs="terminal.integrated.shellArgs.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(i=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(c){c.ShellLinux="terminal.integrated.shell.linux",c.ShellMacOs="terminal.integrated.shell.osx",c.ShellWindows="terminal.integrated.shell.windows",c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationShellLinux="terminal.integrated.automationShell.linux",c.AutomationShellMacOs="terminal.integrated.automationShell.osx",c.AutomationShellWindows="terminal.integrated.automationShell.windows",c.AutomationProfileLinux="terminal.integrated.automationProfile.linux",c.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",c.AutomationProfileWindows="terminal.integrated.automationProfile.windows",c.ShellArgsLinux="terminal.integrated.shellArgs.linux",c.ShellArgsMacOs="terminal.integrated.shellArgs.osx",c.ShellArgsWindows="terminal.integrated.shellArgs.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsDefaultColor="terminal.integrated.tabs.defaultColor",c.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.TerminalTitleSeparator="terminal.integrated.tabs.separator",c.TerminalTitle="terminal.integrated.tabs.title",c.TerminalDescription="terminal.integrated.tabs.description",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoEnabled="terminal.integrated.localEchoEnabled",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover",c.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",c.AutoReplies="terminal.integrated.autoReplies",c.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",c.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",c.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",c.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",c.SmoothScrolling="terminal.integrated.smoothScrolling"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(c){c.FileName="ptyhost"})(T=e.TerminalLogConstants||(e.TerminalLogConstants={}));var L;(function(c){c.PowerShell="pwsh",c.Bash="bash",c.Fish="fish",c.Sh="sh",c.Csh="csh",c.Ksh="ksh",c.Zsh="zsh"})(L=e.PosixShellType||(e.PosixShellType={}));var P;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var I;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence",c[c.Config=3]="Config"})(I=e.TitleEventSource||(e.TitleEventSource={}));var w;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.Log="log",c.Heartbeat="heartbeat"})(w=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var b;(function(c){c.Cwd="cwd",c.InitialCwd="initialCwd",c.FixedDimensions="fixedDimensions",c.Title="title",c.ShellType="shellType",c.HasChildProcesses="hasChildProcesses",c.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",c.OverrideDimensions="overrideDimensions",c.FailedShellIntegrationActivation="failedShellIntegrationActivation",c.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(b=e.ProcessPropertyType||(e.ProcessPropertyType={}));var C;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(C=e.HeartbeatConstants||(e.HeartbeatConstants={}));var S;(function(c){c[c.Panel=1]="Panel",c[c.Editor=2]="Editor"})(S=e.TerminalLocation||(e.TerminalLocation={}));var m;(function(c){c.TerminalView="view",c.Editor="editor"})(m=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(f=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var v;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})(v=e.FlowControlConstants||(e.FlowControlConstants={}));var y;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})(y=e.ProfileSource||(e.ProfileSource={}));var h;(function(c){c[c.Off=0]="Off",c[c.FinalTerm=1]="FinalTerm",c[c.VSCode=2]="VSCode"})(h=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var p;(function(c){c[c.Unknown=0]="Unknown",c[c.Shutdown=1]="Shutdown",c[c.Process=2]="Process",c[c.User=3]="User",c[c.Extension=4]="Extension"})(p=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(re[240],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(re[241],se([0,1,34,22,32,12,5,36,27,15,28]),function(Q,e,D,i,R,T,L,P,I,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function C(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let d=0;return u&&u.length===4&&(d=parseInt(u[3])),d}e.getWindowsBuildNumber=C;async function S(u,d,n,o=P.env,t=b.Promises.exists){if(T.isAbsolute(u))return await t(u)?u:void 0;if(d===void 0&&(d=P.cwd()),T.dirname(u)!=="."){const a=T.join(d,u);return await t(a)?a:void 0}const s=(0,R.getCaseInsensitive)(o,"PATH");if(n===void 0&&(0,w.isString)(s)&&(n=s.split(T.delimiter)),n===void 0||n.length===0){const a=T.join(d,u);return await t(a)?a:void 0}for(const a of n){let g;if(T.isAbsolute(a)?g=T.join(a,u):g=T.join(d,a,u),await t(g))return g;if(L.isWindows){let E=g+".com";if(await t(E)||(E=g+".exe",await t(E)))return E}}const l=T.join(d,u);return await t(l)?l:void 0}e.findExecutable=S;function m(u,d,n,o,t){if(!d.shellIntegration.enabled||!u.executable||u.isFeatureTerminal||u.hideFromUser||u.ignoreShellIntegration||L.isWindows&&!d.windowsEnableConpty)return;const r=u.args,s=P.platform==="win32"?T.basename(u.executable).toLowerCase():T.basename(u.executable),l=T.dirname(i.FileAccess.asFileUri("",Q).fsPath);let a;const g={VSCODE_INJECTION:"1"};if(L.isWindows){if(s==="pwsh.exe")return!r||p(r)?a=e.shellIntegrationArgs.get(f.WindowsPwsh):h(r)&&(a=e.shellIntegrationArgs.get(f.WindowsPwshLogin)),a?(a=[...a],a[a.length-1]=(0,I.format)(a[a.length-1],l,""),{newArgs:a,envMixin:g}):void 0;o.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args);return}switch(s){case"bash":return!r||r.length===0?a=e.shellIntegrationArgs.get(f.Bash):c(r)&&(g.VSCODE_SHELL_LOGIN="1",a=e.shellIntegrationArgs.get(f.Bash)),a?(a=[...a],a[a.length-1]=(0,I.format)(a[a.length-1],l),{newArgs:a,envMixin:g}):void 0;case"pwsh":return!r||p(r)?a=e.shellIntegrationArgs.get(f.Pwsh):h(r)&&(a=e.shellIntegrationArgs.get(f.PwshLogin)),a?(a=[...a],a[a.length-1]=(0,I.format)(a[a.length-1],l,""),{newArgs:a,envMixin:g}):void 0;case"zsh":{if(!r||r.length===0?a=e.shellIntegrationArgs.get(f.Zsh):c(r)?a=e.shellIntegrationArgs.get(f.ZshLogin):(r===e.shellIntegrationArgs.get(f.Zsh)||r===e.shellIntegrationArgs.get(f.ZshLogin))&&(a=r),!a)return;a=[...a],a[a.length-1]=(0,I.format)(a[a.length-1],l);const E=T.join(D.tmpdir(),`${D.userInfo().username}-${t.applicationName}-zsh`);g.ZDOTDIR=E;const A=n?.ZDOTDIR??D.homedir()??"~";g.USER_ZDOTDIR=A;const B=[];return B.push({source:T.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:T.join(E,".zshrc")}),B.push({source:T.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:T.join(E,".zprofile")}),B.push({source:T.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:T.join(E,".zshenv")}),B.push({source:T.join(l,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:T.join(E,".zlogin")}),{newArgs:a,envMixin:g,filesToCopy:B}}}o.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args)}e.getShellIntegrationInjection=m;var f;(function(u){u.WindowsPwsh="windows-pwsh",u.WindowsPwshLogin="windows-pwsh-login",u.Pwsh="pwsh",u.PwshLogin="pwsh-login",u.Zsh="zsh",u.ZshLogin="zsh-login",u.Bash="bash"})(f=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(f.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(f.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(f.Zsh,["-i"]),e.shellIntegrationArgs.set(f.ZshLogin,["-il"]),e.shellIntegrationArgs.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const v=["-login","-l"],y=["-nol","-nologo"];function h(u){return typeof u=="string"?v.includes(u.toLowerCase()):u.length===1&&v.includes(u[0].toLowerCase())||u.length===2&&(v.includes(u[0].toLowerCase())||v.includes(u[1].toLowerCase()))&&(y.includes(u[0].toLowerCase())||y.includes(u[1].toLowerCase()))}function p(u){return typeof u=="string"?y.includes(u.toLowerCase()):u.length===0||u?.length===1&&y.includes(u[0].toLowerCase())}function c(u){return u==="string"&&v.includes(u.toLowerCase())||typeof u!="string"&&u.length===1&&v.includes(u[0].toLowerCase())}}),define(re[242],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var D;(function(T){T.DARK="dark",T.LIGHT="light",T.HIGH_CONTRAST_DARK="hcDark",T.HIGH_CONTRAST_LIGHT="hcLight"})(D=e.ColorScheme||(e.ColorScheme={}));function i(T){return T===D.HIGH_CONTRAST_DARK||T===D.HIGH_CONTRAST_LIGHT}e.isHighContrast=i;function R(T){return T===D.DARK||T===D.HIGH_CONTRAST_DARK}e.isDark=R}),define(re[114],se([0,1,53,3,2,4,39,242]),function(Q,e,D,i,R,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var I;(function(y){function h(p){return p&&typeof p=="object"&&typeof p.id=="string"}y.isThemeColor=h})(I=e.ThemeColor||(e.ThemeColor={}));function w(y){return{id:y}}e.themeColorFromId=w;var b;(function(y){function h(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||I.isThemeColor(r.color))}y.isThemeIcon=h;const p=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function c(r){const s=p.exec(r);if(!s)return;const[,l]=s;return{id:l}}y.fromString=c;function u(r){return{id:r}}y.fromId=u;function d(r,s){let l=r.id;const a=l.lastIndexOf("~");return a!==-1&&(l=l.substring(0,a)),s&&(l=`${l}~${s}`),{id:l}}y.modify=d;function n(r){const s=r.id.lastIndexOf("~");if(s!==-1)return r.id.substring(s+1)}y.getModifier=n;function o(r,s){return r.id===s.id&&r.color?.id===s.color?.id}y.isEqual=o;function t(r,s){return{id:r.id,color:s?w(s):void 0}}y.asThemeIcon=t,y.asClassNameArray=D.CSSIcon.asClassNameArray,y.asClassName=D.CSSIcon.asClassName,y.asCSSSelector=D.CSSIcon.asCSSSelector})(b=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function C(y){switch(y){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case P.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(h){return this.themingParticipants.push(h),this.onThemingParticipantAddedEmitter.fire(h),(0,R.toDisposable)(()=>{const p=this.themingParticipants.indexOf(h);this.themingParticipants.splice(p,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const m=new S;L.Registry.add(e.Extensions.ThemingContribution,m);function f(y){return m.onColorThemeChange(y)}e.registerThemingParticipant=f;class v extends R.Disposable{constructor(h){super(),this.themeService=h,this.theme=h.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(p=>this.onThemeChange(p)))}onThemeChange(h){this.theme=h,this.updateStyles()}updateStyles(){}getColor(h,p){let c=this.theme.getColor(h);return c&&p&&(c=p(c,this.theme)),c?c.toString():null}}e.Themable=v}),define(re[243],se([0,1,53,8,173,114]),function(Q,e,D,i,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function L(S,m){const f=[{name:null,description:(0,R.localize)(0,null)}];return f.push(...S.map(v=>({name:v.profileName,description:P(v)}))),m&&f.push(...m.map(v=>({name:v.title,description:I(v)}))),{values:f.map(v=>v.name),markdownDescriptions:f.map(v=>v.description)}}e.createProfileSchemaEnums=L;function P(S){let m=`$(${T.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:D.Codicon.terminal.id}) ${S.profileName}
- path: ${S.path}`;return S.args&&(typeof S.args=="string"?m+=`
- args: "${S.args}"`:m+=`
- args: [${S.args.length===0?"":`'${S.args.join("','")}'`}]`),S.overrideName!==void 0&&(m+=`
- overrideName: ${S.overrideName}`),S.color&&(m+=`
- color: ${S.color}`),S.env&&(m+=`
- env: ${JSON.stringify(S.env)}`),m}function I(S){return`$(${T.ThemeIcon.isThemeIcon(S.icon)?S.icon.id:S.icon?S.icon:D.Codicon.terminal.id}) ${S.title}
- extensionIdentifier: ${S.extensionIdentifier}`}function w(S,m){if(!S&&!m)return!0;if(typeof S=="string"&&typeof m=="string")return S===m;if(Array.isArray(S)&&Array.isArray(m)){if(S.length!==m.length)return!1;for(let f=0;f<S.length;f++)if(S[f]!==m[f])return!1;return!0}return!1}e.terminalProfileArgsMatch=w;function b(S,m){if(!S&&!m)return!0;if(!S||!m)return!1;if(T.ThemeIcon.isThemeIcon(S)&&T.ThemeIcon.isThemeIcon(m))return S.id===m.id&&S.color===m.color;if(typeof S=="object"&&"light"in S&&"dark"in S&&typeof m=="object"&&"light"in m&&"dark"in m){const f=S,v=m;if((i.URI.isUri(f.light)||C(f.light))&&(i.URI.isUri(f.dark)||C(f.dark))&&(i.URI.isUri(v.light)||C(v.light))&&(i.URI.isUri(v.dark)||C(v.dark)))return f.light.path===v.light.path&&f.dark.path===v.dark.path}if(i.URI.isUri(S)&&i.URI.isUri(m)||C(S)||C(m)){const f=S,v=m;return f.path===v.path&&f.scheme===v.scheme}return!1}e.terminalIconsEqual=b;function C(S){return S?typeof S.path=="string"&&typeof S.scheme=="string":!1}e.isUriComponents=C}),define(re[244],se([0,1,53,172,45,39,243]),function(Q,e,D,i,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(D.Codicon.getAll(),u=>u.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),u=>`$(${u.id})`)};const P={args:{description:(0,i.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,i.localize)(1,null),type:"boolean"},icon:{description:(0,i.localize)(2,null),...e.terminalIconSchema},color:{description:(0,i.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,i.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},I={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},w={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(6,null),type:["string"],items:{type:"string"}},...P}},b=(0,i.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),C=(0,i.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),S=(0,i.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),m=(0,i.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),f=(0,i.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),v=(0,i.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),y={id:"terminal",order:100,title:(0,i.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},w],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,i.localize)(26,null)}},{type:"string",markdownDescription:(0,i.localize)(27,null)}],default:[],markdownDeprecationMessage:S},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,i.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(30,null),type:"string"},id:{description:(0,i.localize)(31,null),type:"string"},title:{description:(0,i.localize)(32,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(34,null),type:"string"},id:{description:(0,i.localize)(35,null),type:"string"},title:{description:(0,i.localize)(36,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(38,null),type:"string"},id:{description:(0,i.localize)(39,null),type:"string"},title:{description:(0,i.localize)(40,null),type:"string"},...P}},{type:"null"},I]}},["terminal.integrated.useWslProfiles"]:{description:(0,i.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,i.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,i.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,i.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,i.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){T.Registry.as(R.Extensions.Configuration).registerConfiguration(y),c()}e.registerTerminalPlatformConfiguration=h;let p;function c(u,d){const n=T.Registry.as(R.Extensions.Configuration);let o;u&&(o=(0,L.createProfileSchemaEnums)(u?.profiles,d));const t=p;p={id:"terminal",order:100,title:(0,i.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:u?.os===3?o?.values:void 0,markdownEnumDescriptions:u?.os===3?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:u?.os===2?o?.values:void 0,markdownEnumDescriptions:u?.os===2?o?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:u?.os===1?o?.values:void 0,markdownEnumDescriptions:u?.os===1?o?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[p],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=c}),define(re[245],se([0,1,50,53,12,5,28,89,241,114]),function(Q,e,D,i,R,T,L,P,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let b,C=!0;function S(o,t,r,s,l=process.env,a,g,E,A){return a=a||{existsFile:L.SymlinkSupport.existsFile,readFile:L.Promises.readFile},T.isWindows?m(r,a,l,g,s.getValue("terminal.integrated.useWslProfiles")!==!1,o&&typeof o=="object"?{...o}:s.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:s.getValue("terminal.integrated.defaultProfile.windows"),A,E):u(a,g,r,o&&typeof o=="object"?{...o}:s.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:s.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),A,E,l)}e.detectAvailableProfiles=S;async function m(o,t,r,s,l,a,g,E,A){const B=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${B?"Sysnative":"System32"}`;let N=!1;(0,I.getWindowsBuildNumber)()>=16299&&(N=!0),await y(E);const F=new Map;o&&(F.set("PowerShell",{source:"PowerShell",icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),F.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:i.Codicon.terminalCmd,isAutoDetected:!0})),d(a,F);const k=await f(F.entries(),g,t,r,s,A);if(o||l)try{const U=await p(`${O}\\${N?"wsl":"bash"}.exe`,g);for(const $ of U)(!a||!($.profileName in a))&&k.push($)}catch{C&&(s?.info("WSL is not installed, so could not detect WSL profiles"),C=!1)}return k}async function f(o,t,r,s=process.env,l,a){const g=[];for(const[E,A]of o){if(A===null)continue;let B,O,N;if("source"in A){const U=b?.get(A.source);if(!U)continue;B=U.paths,O=A.args||U.args,A.icon?N=v(A.icon):U.icon&&(N=U.icon)}else B=Array.isArray(A.path)?A.path:[A.path],O=T.isWindows||Array.isArray(A.args)?A.args:void 0,N=v(A.icon);const F=await a?.(B)||B.slice(),k=await n(E,t,F,r,s,O,A.env,A.overrideName,A.isAutoDetected,l);k?(k.isAutoDetected=A.isAutoDetected,k.icon=N,k.color=A.color,g.push(k)):l?.debug("Terminal profile not validated",E,B)}return l?.debug("Validated terminal profiles",g),g}function v(o){return typeof o=="string"?{id:o}:o}async function y(o){b&&!o||(b=new Map,b.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),b.set("PowerShell",{profileName:"PowerShell",paths:o||await h(),icon:w.ThemeIcon.asThemeIcon(i.Codicon.terminalPowershell)}))}async function h(){const o=[];for await(const t of(0,P.enumeratePowerShellInstallations)())o.push(t.exePath);return o}async function p(o,t){const r=[],s=await new Promise((g,E)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(A,B)=>{if(A)return E("Problem occurred when getting wsl distros");g(B)})});if(!s)return[];const l=new RegExp(/[\r?\n]/),a=s.split(l).filter(g=>g.trim().length>0&&g!=="");for(const g of a){if(g===""||g.startsWith("docker-desktop"))continue;const E=`${g} (WSL)`,A={profileName:E,path:o,args:["-d",`${g}`],isDefault:E===t,icon:c(g),isAutoDetected:!1};r.push(A)}return r}function c(o){return o.includes("Ubuntu")?w.ThemeIcon.asThemeIcon(i.Codicon.terminalUbuntu):o.includes("Debian")?w.ThemeIcon.asThemeIcon(i.Codicon.terminalDebian):w.ThemeIcon.asThemeIcon(i.Codicon.terminalLinux)}async function u(o,t,r,s,l,a,g,E){const A=new Map;if(r){const B=(await o.readFile("/etc/shells")).toString(),O=a||B.split(`
`).filter(F=>F.trim().indexOf("#")!==0&&F.trim().length>0),N=new Map;for(const F of O){let k=(0,R.basename)(F),U=N.get(k)||0;U++,U>1&&(k=`${k} (${U})`),N.set(k,U),A.set(k,{path:F,isAutoDetected:!0})}}return d(s,A),await f(A.entries(),l,o,E,t,g)}function d(o,t){if(!!o)for(const[r,s]of Object.entries(o))s===null||!("path"in s)&&!("source"in s)?t.delete(r):(s.icon=s.icon||t.get(r)?.icon,t.set(r,s))}async function n(o,t,r,s,l,a,g,E,A,B){if(r.length===0)return Promise.resolve(void 0);const O=r.shift();if(O==="")return n(o,t,r,s,l,a,g,E,A);const N={profileName:o,path:O,args:a,env:g,overrideName:E,isAutoDetected:A,isDefault:o===t};if((0,R.basename)(O)===O){const k=l.PATH?l.PATH.split(R.delimiter):void 0,U=await(0,I.findExecutable)(O,void 0,k,void 0,s.existsFile);return U?(N.path=U,N.isFromPath=!0,N):n(o,t,r,s,l,a)}return await s.existsFile((0,R.normalize)(O))?N:n(o,t,r,s,l,a,g,E,A)}}),define(re[246],se([0,1,3,2,22,5,38,68,16,13,93,231,7,102,239,113,244,245]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var p;(function(d){d[d.MaxRestarts=5]="MaxRestarts"})(p||(p={}));let c=0,u=class extends i.Disposable{constructor(n,o,t,r){super(),this._reconnectConstants=n,this._configurationService=o,this._environmentService=t,this._logService=r,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,y.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,i.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new f.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,C.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(n){return this._logService.error("ptyHost was unable to resolve shell environment",n),{}}}_startPtyHost(){const n={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},o=(0,b.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);o&&(o.break&&o.port?n.debugBrk=o.port:!o.break&&o.port&&(n.debug=o.port));const t=new P.Client(R.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,n);this._onPtyHostStart.fire(),L.ProxyChannel.toService(t.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=p.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const s=t.getChannel(v.TerminalIpcChannels.Log);m.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{m.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const l=L.ProxyChannel.toService(t.getChannel(v.TerminalIpcChannels.PtyHost));return this._register(l.onProcessData(a=>this._onProcessData.fire(a))),this._register(l.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(l.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(l.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(l.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(l.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(l.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[t,l]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(n,o,t,r,s,l,a,g,E,A,B){const O=setTimeout(()=>this._handleUnresponsiveCreateProcess(),v.HeartbeatConstants.CreateProcessTimeout),N=await this._proxy.createProcess(n,o,t,r,s,l,a,g,E,A,B);return clearTimeout(O),c=Math.max(c,N),N}updateTitle(n,o,t){return this._proxy.updateTitle(n,o,t)}updateIcon(n,o,t,r){return this._proxy.updateIcon(n,o,t,r)}attachToProcess(n){return this._proxy.attachToProcess(n)}detachFromProcess(n,o){return this._proxy.detachFromProcess(n,o)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(n){return this._proxy.start(n)}shutdown(n,o){return this._proxy.shutdown(n,o)}input(n,o){return this._proxy.input(n,o)}processBinary(n,o){return this._proxy.processBinary(n,o)}resize(n,o,t){return this._proxy.resize(n,o,t)}acknowledgeDataEvent(n,o){return this._proxy.acknowledgeDataEvent(n,o)}setUnicodeVersion(n,o){return this._proxy.setUnicodeVersion(n,o)}getInitialCwd(n){return this._proxy.getInitialCwd(n)}getCwd(n){return this._proxy.getCwd(n)}getLatency(n){return this._proxy.getLatency(n)}orphanQuestionReply(n){return this._proxy.orphanQuestionReply(n)}installAutoReply(n,o){return this._proxy.installAutoReply(n,o)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(n){return this._proxy.uninstallAutoReply(n)}getDefaultSystemShell(n){return this._proxy.getDefaultSystemShell(n)}async getProfiles(n,o,t,r=!1){const s=await this._shellEnv;return(0,h.detectAvailableProfiles)(o,t,r,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,n))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(n){return this._proxy.getWslPath(n)}getRevivedPtyNewId(n){return this._proxy.getRevivedPtyNewId(n)}setTerminalLayoutInfo(n){return this._proxy.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this._proxy.getTerminalLayoutInfo(n)}async requestDetachInstance(n,o){return this._proxy.requestDetachInstance(n,o)}async acceptDetachInstanceReply(n,o){return this._proxy.acceptDetachInstanceReply(n,o)}async freePortKillProcess(n){if(!this._proxy.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this._proxy.freePortKillProcess(n)}async serializeTerminalState(n){return this._proxy.serializeTerminalState(n)}async reviveTerminalProcesses(n,o){return this._proxy.reviveTerminalProcesses(n,o)}async refreshProperty(n,o){return this._proxy.refreshProperty(n,o)}async updateProperty(n,o,t){return this._proxy.updateProperty(n,o,t)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(n,o){return this._resolveVariablesRequestStore.createRequest({workspaceId:n,originalText:o})}async acceptPtyHostResolvedVariables(n,o){this._resolveVariablesRequestStore.acceptReply(n,o)}};u=ve([K(1,I.IConfigurationService),K(2,w.IEnvironmentService),K(3,S.ILogService)],u),e.PtyHostService=u}),define(re[75],se([0,1,3,16,4,7]),function(Q,e,D,i,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,R.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,R.createDecorator)("sharedTunnelsService");var L;(function(v){v.Http="http",v.Https="https"})(L=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var I;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const y=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(!!y)return{address:y[1],port:+y[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=C;function S(v,y,h,p){if(h===1)return!1;if(h===2&&C(y)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(c?.length===4&&parseInt(c[1])>=18)return!1}return v<1024}e.isPortPrivileged=S;class m{constructor(y,h,p){this.remoteAddress=y,this.localAddress=h,this._dispose=p,this._onDispose=new D.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=m;let f=class{constructor(y,h){this.logService=y,this.configurationService=h,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const y=this.configurationService.getValue("remote.localPortHost");return!y||y==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(y){return this._tunnelProvider=y,y?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(y){this._canElevate=y.elevation,this._privacyOptions=y.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const y=[],h=Array.from(this._tunnels.values());for(const p of h){const c=Array.from(p.values());for(const u of c){const d=await u.value;d&&y.push(d)}}return y}async dispose(){for(const y of this._tunnels.values()){for(const{value:h}of y.values())await h.then(p=>p?.dispose());y.clear()}this._tunnels.clear()}setEnvironmentTunnel(y,h,p,c,u){this.addTunnelToMap(y,h,Promise.resolve({tunnelRemoteHost:y,tunnelRemotePort:h,localAddress:p,privacy:c,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(y,h){(C(y)||b(y))&&(y=e.LOCALHOST_ADDRESSES[0]);const p=this.getTunnelFromMap(y,h);if(p)return++p.refcount,p.value}openTunnel(y,h,p,c,u=!1,d,n){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${p} on local port ${c}.`),!y)return;if(h||(h="localhost"),this._tunnelProvider&&this._factoryInProgress.has(p)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.retainOrCreateTunnel(y,h,p,c,u,d,n);return o?o.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(h,p);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(t);return(t.tunnelRemoteHost!==h||t.tunnelRemotePort!==p)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}makeTunnel(y){return{tunnelRemotePort:y.tunnelRemotePort,tunnelRemoteHost:y.tunnelRemoteHost,tunnelLocalPort:y.tunnelLocalPort,localAddress:y.localAddress,privacy:y.privacy,protocol:y.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${y.tunnelRemoteHost}:${y.tunnelRemotePort} `);const h=this._tunnels.get(y.tunnelRemoteHost);if(h){const p=h.get(y.tunnelRemotePort);p&&(p.refcount--,await this.tryDisposeTunnel(y.tunnelRemoteHost,y.tunnelRemotePort,p))}}}}async tryDisposeTunnel(y,h,p){if(p.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${y}:${h}.`);const c=p.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(y)&&this._tunnels.get(y).delete(h),c}}async closeTunnel(y,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${y}:${h} `);const p=this._tunnels.get(y);if(p&&p.has(h)){const c=p.get(h);c.refcount=0,await this.tryDisposeTunnel(y,h,c)}}addTunnelToMap(y,h,p){this._tunnels.has(y)||this._tunnels.set(y,new Map),this._tunnels.get(y).set(h,{refcount:1,value:p})}async removeEmptyTunnelFromMap(y,h){const p=this._tunnels.get(y);p&&(await p.get(h)||p.delete(h),p.size===0&&this._tunnels.delete(y))}getTunnelFromMap(y,h){const p=[y];b(y)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):C(y)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const c=p.map(u=>this._tunnels.get(u));for(const u of c){const d=u?.get(h);if(d)return d}}canTunnel(y){return!!w(y)}createWithProvider(y,h,p,c,u,d,n){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${p} on local port ${c}.`);const o=p;this._factoryInProgress.add(o);const t=c===void 0?p:c,r={elevationRequired:u?this.isPortPrivileged(t):!1},s={remoteAddress:{host:h,port:p},localAddressPort:c,privacy:d,public:d?d!==P.Private:void 0,protocol:n},l=y.forwardPort(s,r);return l?(this.addTunnelToMap(h,p,l),l.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(o)})):this._factoryInProgress.delete(o),l}};f=ve([K(0,T.ILogService),K(1,i.IConfigurationService)],f),e.AbstractTunnelService=f}),define(re[247],se([0,1,7,75,2,11,6]),function(Q,e,D,i,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends R.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new L.DeferredPromise),this._addressPromise.p)}setAddress(b){this._address=b,this._addressPromise&&(this._addressPromise.complete(b),this._addressPromise=null)}setTunnel(b){this._register(b)}}let I=class kt extends R.Disposable{constructor(b,C){super(),this._tunnelService=b,this._logService=C,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(b=>b.dispose())}async createTunnel(){return{id:String(++kt._lastId)}}async startTunnel(b,C,S,m,f,v){const y=new P,h=await Promise.resolve(this._tunnelService.openTunnel(b,y,S,m,f,v));if(!h)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${S}:${m} (remote).`),y.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(C))throw this._disposedTunnels.delete(C),y.dispose(),await h.dispose(),(0,T.canceled)();return y.setTunnel(h),this._tunnels.set(C,y),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${C}: ${h.localAddress} (local) to ${S}:${m} (remote).`),{tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress}}async setAddress(b,C){const S=this._tunnels.get(b);!S||S.setAddress(C)}async destroyTunnel(b){const C=this._tunnels.get(b);if(C){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${b}.`),this._tunnels.delete(b),await C.dispose();return}this._disposedTunnels.add(b)}};I._lastId=0,I=ve([K(0,i.ISharedTunnelsService),K(1,D.ILogService)],I),e.SharedProcessTunnelService=I}),define(re[248],se([0,1,84,34,131,222,6,2,16,7,25,220,75,108,5]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(u,d,n,o,t){let r;for(let s=3;s&&(r?.dispose(),r=await new y(u,d,n,o,t).waitForReady(),!(t&&R.BROWSER_RESTRICTED_PORTS[t]||!R.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));s--);return r}class y extends P.Disposable{constructor(d,n,o,t,r){super(),this.defaultTunnelHost=n,this.suggestedLocalPort=r,this.privacy=S.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=d,this._server=D.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=t,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(n=>{n()})}async waitForReady(){const d=this.suggestedLocalPort??this.tunnelRemotePort,n=(0,S.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let o=await(0,R.findFreePortFaster)(d,2,1e3,n),t=null;return this._server.listen(o,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address(),t||(o=0,this._server.listen(o,this.defaultTunnelHost),await this._barrier.wait(),t=this._server.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async _onConnection(d){d.pause();const n=(0,S.isLocalhost)(this.tunnelRemoteHost)||(0,S.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,C.connectRemoteAgentTunnel)(this._options,n,this.tunnelRemotePort),t=o.getSocket().socket,r=o.readEntireBuffer();o.dispose(),r.byteLength>0&&d.write(r.buffer),d.on("end",()=>{d.localAddress&&this._socketsDispose.delete(d.localAddress),t.end()}),d.on("close",()=>t.end()),d.on("error",()=>{d.localAddress&&this._socketsDispose.delete(d.localAddress),t.destroy()}),t.on("end",()=>d.end()),t.on("close",()=>d.end()),t.on("error",()=>{d.destroy()}),d.pipe(t),t.pipe(d),d.localAddress&&this._socketsDispose.set(d.localAddress,()=>{d.end(),t.end()})}}let h=class extends S.AbstractTunnelService{constructor(d,n,o,t,r){super(n,r),this.socketFactory=d,this.signService=o,this.productService=t}isPortPrivileged(d){return(0,S.isPortPrivileged)(d,this.defaultTunnelHost,f.OS,i.release())}retainOrCreateTunnel(d,n,o,t,r,s,l){const a=this.getTunnelFromMap(n,o);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,n,o,t,r,s,l);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${o} on local port ${t}.`);const g={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:d,signService:this.signService,logService:this.logService,ipcLogger:null},E=v(g,this.defaultTunnelHost,n,o,t);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(n,o,E),E}}};h=ve([K(1,w.ILogService),K(2,m.ISignService),K(3,b.IProductService),K(4,I.IConfigurationService)],h),e.BaseTunnelService=h;let p=class extends h{constructor(d,n,o,t){super(T.nodeSocketFactory,d,n,o,t)}};p=ve([K(0,w.ILogService),K(1,m.ISignService),K(2,b.IProductService),K(3,I.IConfigurationService)],p),e.TunnelService=p;let c=class extends P.Disposable{constructor(d,n,o,t){super(),this.logService=d,this.productService=n,this.signService=o,this.configurationService=t,this._tunnelServices=new Map}async openTunnel(d,n,o,t,r,s,l,a){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${o}:${t} on local port ${r}.`),!this._tunnelServices.has(d)){const g=new p(this.logService,this.signService,this.productService,this.configurationService);this._register(g),this._tunnelServices.set(d,g),g.onTunnelClosed(async()=>{(await g.tunnels).length===0&&(g.dispose(),this._tunnelServices.delete(d))})}return this._tunnelServices.get(d).openTunnel(n,o,t,r,s,l,a)}};c=ve([K(0,w.ILogService),K(1,b.IProductService),K(2,m.ISignService),K(3,I.IConfigurationService)],c),e.SharedTunnelsService=c}),define(re[30],se([0,1,4]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(re[249],se([0,1,3,2,8,13,33,14,7,30]),function(Q,e,D,i,R,T,L,P,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let b=class extends i.Disposable{constructor(S,m,f,v,y){super(),this.extensionsManagementService=S,this.logService=v,this.uriIdentityService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(p=>{this.installedExtensions=p.map(c=>c.identifier),this.startTimestamp=Date.now()}),this._register(S.onInstallExtension(p=>this.onInstallExtension(p))),this._register(S.onDidInstallExtensions(p=>this.onDidInstallExtensions(p))),this._register(S.onDidUninstallExtension(p=>this.onDidUninstallExtension(p)));const h=R.URI.file(f.extensionsPath);this._register(m.watch(h)),this._register(D.Event.filter(m.onDidFilesChange,p=>p.rawChanges.some(c=>this.doesChangeAffects(c,h)))(()=>this.onDidChange()))}doesChangeAffects(S,m){return S.type!==1&&S.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(S.resource),m)?!1:this.uriIdentityService.extUri.isEqual(S.resource,this.uriIdentityService.extUri.joinPath(m,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(S.resource).startsWith(".")}onInstallExtension(S){this.addInstallingExtension(S.identifier)}onDidInstallExtensions(S){for(const m of S)this.removeInstallingExtension(m.identifier),m.local&&this.addInstalledExtension(m.identifier)}onDidUninstallExtension(S){S.error||this.removeInstalledExtension(S.identifier)}addInstallingExtension(S){this.removeInstallingExtension(S),this.installingExtensions.push(S)}removeInstallingExtension(S){this.installingExtensions=this.installingExtensions.filter(m=>!(0,L.areSameExtensions)(m,S))}addInstalledExtension(S){this.installedExtensions&&(this.removeInstalledExtension(S),this.installedExtensions.push(S))}removeInstalledExtension(S){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(m=>!(0,L.areSameExtensions)(m,S)))}async onDidChange(){if(this.installedExtensions){const S=await this.extensionsManagementService.getInstalled(),m=S.filter(v=>[...this.installingExtensions,...this.installedExtensions].some(y=>(0,L.areSameExtensions)(y,v.identifier))?!1:v.installedTimestamp&&v.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",v.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",v.identifier.id),!1)),f=this.installedExtensions.filter(v=>this.installingExtensions.some(y=>(0,L.areSameExtensions)(y,v))?!1:S.every(y=>!(0,L.areSameExtensions)(y.identifier,v))?(this.logService.info("Detected extension removed from another source",v.id),!0):!1);this.installedExtensions=S.map(v=>v.identifier),(m.length||f.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:m,removed:f})}}};b=ve([K(1,P.IFileService),K(2,T.INativeEnvironmentService),K(3,I.ILogService),K(4,w.IUriIdentityService)],b),e.ExtensionsWatcher=b}),define(re[250],se([0,1,30,94,14,21,129,3,2]),function(Q,e,D,i,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class w{constructor(S){this.uri=S,this.time=w._clock++}touch(){return this.time=w._clock++,this}}w._clock=0;let b=class{constructor(S){this._fileService=S,this._dispooables=new I.DisposableStore,this._limit=2**16;const m=new Map,f=v=>{let y=m.get(v.scheme);return y===void 0&&(y=S.hasProvider(v)&&!this._fileService.hasCapability(v,1024),m.set(v.scheme,y)),y};this._dispooables.add(P.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(v=>{m.delete(v.scheme)})),this.extUri=new T.ExtUri(f),this._canonicalUris=new L.SkipList((v,y)=>this.extUri.compare(v,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,T.normalizePath)(S));const m=this._canonicalUris.get(S);return m?m.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new w(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((f,v)=>f[1].touch<v[1].touch?1:f[1].touch>v[1].touch?-1:0);w._clock=0,this._canonicalUris.clear();const m=this._limit*.5;for(let f=0;f<m;f++)this._canonicalUris.set(S[f][0],S[f][1].touch())}};b=ve([K(0,R.IFileService)],b),e.UriIdentityService=b,(0,i.registerSingleton)(D.IUriIdentityService,b,1)}),define(re[251],se([0,1,3,2,14,43,49,17]),function(Q,e,D,i,R,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends i.Disposable{get capabilities(){return this.fileSystemProvider.capabilities&-5}constructor(b,C,S,m){super(),this.fileSystemScheme=b,this.fileSystemProvider=C,this.userDataScheme=S,this.logService=m,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=L.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(f=>this.handleFileChanges(f)))}watch(b,C){this.watchResources.set(b,b);const S=this.fileSystemProvider.watch(this.toFileSystemResource(b),C);return(0,i.toDisposable)(()=>{this.watchResources.delete(b),S.dispose()})}stat(b){return this.fileSystemProvider.stat(this.toFileSystemResource(b))}mkdir(b){return this.fileSystemProvider.mkdir(this.toFileSystemResource(b))}rename(b,C,S){return this.fileSystemProvider.rename(this.toFileSystemResource(b),this.toFileSystemResource(C),S)}readFile(b){return this.fileSystemProvider.readFile(this.toFileSystemResource(b),{atomic:!0})}readFileStream(b,C,S){const m=(0,T.newWriteableStream)(f=>P.VSBuffer.concat(f.map(v=>P.VSBuffer.wrap(v))).buffer);return(async()=>{try{const f=await this.readFile(b);m.end(f)}catch(f){m.error(f),m.end()}})(),m}readdir(b){return this.fileSystemProvider.readdir(this.toFileSystemResource(b))}writeFile(b,C,S){return this.fileSystemProvider.writeFile(this.toFileSystemResource(b),C,S)}delete(b,C){return this.fileSystemProvider.delete(this.toFileSystemResource(b),C)}copy(b,C,S){if((0,R.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(b),this.toFileSystemResource(C),S);throw new Error("copy not supported")}handleFileChanges(b){const C=[];for(const S of b){if(S.resource.scheme!==this.fileSystemScheme)continue;const m=this.toUserDataResource(S.resource);this.watchResources.findSubstr(m)&&C.push({resource:m,type:S.type})}C.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(C))}toFileSystemResource(b){return b.with({scheme:this.fileSystemScheme})}toUserDataResource(b){return b.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=I}),define(re[61],se([0,1,81]),function(Q,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function i(L,P,I,w){const b=(0,D.setProperty)(L,P,I,w)[0];return b&&(L=L.substring(0,b.offset)+b.content+L.substring(b.offset+b.length)),L}e.edit=i;function R(L,P,I){let w=I;for(;w>=0;){if(L.charAt(w)===P.charAt(P.length-1)&&P.length===1)return w+1;if(w--,P.length===2&&w>=0&&L.charAt(w)===P.charAt(0))return w+2}return 0}e.getLineStartOffset=R;function T(L,P,I){let w=I;for(;w>=0;)if(L.charAt(w)===P.charAt(P.length-1)&&P.length===1||(w++,P.length===2&&w>=0&&L.charAt(w)===P.charAt(1)))return w;return L.length-1}e.getLineEndOffset=T}),define(re[252],se([0,1,32,55,15]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(m,f,v,y,h,p){const c=[],u=[],d=[];if(!f){const U=m.filter(({identifier:$})=>h.every(G=>G.toLowerCase()!==$.id.toLowerCase()));return{local:{added:c,removed:u,updated:d},remote:U.length>0?{added:U,updated:[],removed:[],all:U}:null}}m=m.map(C),f=f.map(C),v=v?v.map(C):null;const n=new Map,o=U=>{U.uuid&&n.set(U.id.toLowerCase(),U.uuid)};m.forEach(({identifier:U})=>o(U)),f.forEach(({identifier:U})=>o(U)),v?.forEach(({identifier:U})=>o(U));const t=U=>{const $=U.identifier.uuid||n.get(U.identifier.id.toLowerCase());return $?`uuid:${$}`:`id:${U.identifier.id.toLowerCase()}`},r=(U,$)=>(U.set(t($),$),U),s=m.reduce(r,new Map),l=f.reduce(r,new Map),a=f.reduce((U,$)=>r(U,(0,D.deepClone)($)),new Map),g=v?v.reduce(r,new Map):null,E=y.reduce(r,new Map),A=h.reduce((U,$)=>{const G=n.get($.toLowerCase());return U.add(G?`uuid:${G}`:`id:${$.toLowerCase()}`)},new Set),B=p.reduce((U,{id:$,uuid:G})=>(G=G??n.get($.toLowerCase()),U.add(G?`uuid:${G}`:`id:${$.toLowerCase()}`)),new Set),O=L(s,l,A,!1);if(O.added.size>0||O.removed.size>0||O.updated.size>0){const U=L(g,s,A,!1),$=L(g,l,A,!0),G=(W,V,z,j)=>({...j,installed:V.installed||z.installed,version:z.version&&(!V.installed||i.gt(z.version,V.version))?z.version:V.version,state:I(V,z,g?.get(W)),preRelease:(V.installed?j.preRelease:z.preRelease)??V.preRelease});for(const W of $.removed.values()){const V=s.get(W);if(!V)continue;const z=(0,R.assertIsDefined)(g?.get(W)),j=!B.has(W)&&z.installed;V.installed&&j?u.push(V.identifier):a.set(W,V)}for(const W of $.added.values()){const V=(0,R.assertIsDefined)(l.get(W)),z=s.get(W);if(z){if(O.updated.has(W)){const j=G(W,z,V,V);P(z,V,!1,!1)||d.push(S(j,W)),a.set(W,j)}}else V.installed&&c.push(S(V,W))}for(const W of $.updated.values()){const V=(0,R.assertIsDefined)(l.get(W)),z=(0,R.assertIsDefined)(g?.get(W)),j=s.get(W);if(j)if(!B.has(W)&&z.installed&&j.installed&&!V.installed)u.push(j.identifier);else{const ee=G(W,j,V,V);d.push(S(ee,W)),a.set(W,ee)}else V.installed&&c.push(S(V,W))}for(const W of U.added.values())$.added.has(W)||a.set(W,(0,R.assertIsDefined)(s.get(W)));for(const W of U.updated.values()){if($.removed.has(W)||$.updated.has(W))continue;const V=(0,R.assertIsDefined)(s.get(W)),z=(0,R.assertIsDefined)(l.get(W));a.set(W,G(W,V,z,V))}for(const W of U.removed.values())$.updated.has(W)||$.removed.has(W)||E.has(W)||!(0,R.assertIsDefined)(l.get(W)).installed||B.has(W)||!(0,R.assertIsDefined)(g?.get(W)).installed||a.delete(W)}const N=[],F=L(l,a,new Set,!0),k=F.added.size>0||F.updated.size>0||F.removed.size>0;return k&&a.forEach((U,$)=>N.push(S(U,$))),{local:{added:c,removed:u,updated:d},remote:k?{added:[...F.added].map(U=>a.get(U)),updated:[...F.updated].map(U=>a.get(U)),removed:[...F.removed].map(U=>l.get(U)),all:N}:null}}e.merge=T;function L(m,f,v,y){const h=m?[...m.keys()].filter(n=>!v.has(n)):[],p=[...f.keys()].filter(n=>!v.has(n)),c=p.filter(n=>h.indexOf(n)===-1).reduce((n,o)=>(n.add(o),n),new Set),u=h.filter(n=>p.indexOf(n)===-1).reduce((n,o)=>(n.add(o),n),new Set),d=new Set;for(const n of h){if(u.has(n))continue;const o=m.get(n),t=f.get(n);(!t||!P(o,t,y,!0))&&d.add(n)}return{added:c,removed:u,updated:d}}function P(m,f,v,y){return!(m.disabled!==f.disabled||y&&m.installed!==f.installed||m.installed&&f.installed&&m.preRelease!==f.preRelease||!b(m.state,f.state)||v&&m.version!==f.version)}function I(m,f,v){const y=m.state,h=f.state,p=v?.state;if(!f.version||y&&i.gt(m.version,f.version))return y;if(h&&i.gt(f.version,m.version)||!y)return h;if(!h)return y;const c=(0,D.deepClone)(y),u=p?w(p,h):{added:Object.keys(h).reduce((n,o)=>(n.add(o),n),new Set),removed:new Set,updated:new Set},d=p?w(p,y):{added:Object.keys(y).reduce((n,o)=>(n.add(o),n),new Set),removed:new Set,updated:new Set};for(const n of[...u.added.values(),...u.updated.values()])c[n]=h[n];for(const n of u.removed.values())d.updated.has(n)||delete c[n];return c}function w(m,f){const v=Object.keys(m),y=Object.keys(f),h=y.filter(u=>v.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),p=v.filter(u=>y.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),c=new Set;for(const u of v){if(p.has(u))continue;const d=m[u],n=f[u];(0,D.equals)(d,n)||c.add(u)}return{added:h,removed:p,updated:c}}function b(m={},f={}){const{added:v,removed:y,updated:h}=w(m,f);return v.size===0&&y.size===0&&h.size===0}function C(m){return{...m,disabled:!!m.disabled,installed:!!m.installed}}function S(m,f){const v={identifier:{id:m.identifier.id,uuid:f.startsWith("uuid:")?f.substring(5):void 0},preRelease:!!m.preRelease};return m.version&&(v.version=m.version),m.disabled&&(v.disabled=!0),m.installed&&(v.installed=!0),m.state&&(v.state=m.state),v}}),define(re[115],se([0,1,20,16,4]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,I){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(b=>b.toLowerCase());return w=w.filter(b=>b!==P&&b!==`-${P}`),I&&w.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,2)}updateSynchronizedExtensions(P,I){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(b=>b.toLowerCase());return w=w.filter(b=>b!==P&&b!==`-${P}`),I&&w.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,2)}getIgnoredExtensions(P){const I=P.filter(S=>S.isMachineScoped).map(S=>S.identifier.id.toLowerCase()),w=this.getConfiguredIgnoredExtensions().map(S=>S.toLowerCase()),b=[],C=[];if(Array.isArray(w))for(const S of w)S.startsWith("-")?C.push(S.substring(1)):b.push(S);return(0,D.distinct)([...I,...b].filter(S=>C.indexOf(S)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};T=ve([K(0,i.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(re[253],se([0,1,20,35,32,192,61]),function(Q,e,D,i,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(u){return(0,i.parse)(u)||[]}e.parseKeybindings=P;async function I(u,d,n,o,t){const r=P(u),s=P(d),l=n?P(n):null,a=[...r,...s,...l||[]].map(G=>G.key),g=await t.resolveUserBindings(a),E=b(r,s,l,g);if(!E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:u,hasChanges:!1,hasConflicts:!1};if(!E.hasLocalForwarded&&E.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};if(E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:u,hasChanges:!0,hasConflicts:!1};const A=S(r),B=S(s),O=l?S(l):null,N=f(A,B,g),F=O?f(O,A,g):{added:[...A.keys()].reduce((G,W)=>(G.add(W),G),new Set),removed:new Set,updated:new Set},k=O?f(O,B,g):{added:[...B.keys()].reduce((G,W)=>(G.add(W),G),new Set),removed:new Set,updated:new Set},U=w(N,F,k);let $=u;for(const G of U.removed.values())U.conflicts.has(G)||($=p($,G,o));for(const G of U.added.values()){if(U.conflicts.has(G))continue;const W=B.get(G);if(W.some(V=>V.command!==`-${G}`&&E.conflicts.has(g[V.key]))){U.conflicts.add(G);continue}$=h($,W,o)}for(const G of U.updated.values()){if(U.conflicts.has(G))continue;const W=B.get(G);if(W.some(V=>V.command!==`-${G}`&&E.conflicts.has(g[V.key]))){U.conflicts.add(G);continue}$=c($,G,W,o)}return{mergeContent:$,hasChanges:!0,hasConflicts:U.conflicts.size>0}}e.merge=I;function w(u,d,n){const o=new Set,t=new Set,r=new Set,s=new Set;for(const l of d.removed.values())n.updated.has(l)&&s.add(l);for(const l of n.removed.values())s.has(l)||(d.updated.has(l)?s.add(l):t.add(l));for(const l of d.added.values())s.has(l)||n.added.has(l)&&u.updated.has(l)&&s.add(l);for(const l of n.added.values())s.has(l)||(d.added.has(l)?u.updated.has(l)&&s.add(l):o.add(l));for(const l of d.updated.values())s.has(l)||n.updated.has(l)&&u.updated.has(l)&&s.add(l);for(const l of n.updated.values())s.has(l)||(d.updated.has(l)?u.updated.has(l)&&s.add(l):r.add(l));return{added:o,removed:t,updated:r,conflicts:s}}function b(u,d,n,o){const t=new Set,r=C(u,o),s=C(d,o),l=n?C(n,o):null,a=m(r,s);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const g=l?m(l,r):{added:[...r.keys()].reduce((F,k)=>(F.add(k),F),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const E=l?m(l,s):{added:[...s.keys()].reduce((F,k)=>(F.add(k),F),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:A,removed:B,updated:O,conflicts:N}=w(a,g,E);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:B,updated:O,conflicts:N}}function C(u,d){const n=new Map;for(const o of u){const t=d[o.key];let r=n.get(t);r||(r=[],n.set(t,r)),r.push(o)}return n}function S(u){const d=new Map;for(const n of u){const o=n.command[0]==="-"?n.command.substring(1):n.command;let t=d.get(o);t||(t=[],d.set(o,t)),t.push(n)}return d}function m(u,d){const n=[...u.keys()],o=[...d.keys()],t=o.filter(l=>n.indexOf(l)===-1).reduce((l,a)=>(l.add(a),l),new Set),r=n.filter(l=>o.indexOf(l)===-1).reduce((l,a)=>(l.add(a),l),new Set),s=new Set;for(const l of n){if(r.has(l))continue;const a=u.get(l).map(E=>({...E,key:l})),g=d.get(l).map(E=>({...E,key:l}));(0,D.equals)(a,g,(E,A)=>y(E,A))||s.add(l)}return{added:t,removed:r,updated:s}}function f(u,d,n){const o=[...u.keys()],t=[...d.keys()],r=t.filter(a=>o.indexOf(a)===-1).reduce((a,g)=>(a.add(g),a),new Set),s=o.filter(a=>t.indexOf(a)===-1).reduce((a,g)=>(a.add(g),a),new Set),l=new Set;for(const a of o){if(s.has(a))continue;const g=u.get(a).map(A=>({...A,key:n[A.key]})),E=d.get(a).map(A=>({...A,key:n[A.key]}));v(g,E)||l.add(a)}return{added:r,removed:s,updated:l}}function v(u,d){return!(!(0,D.equals)(u.filter(({command:n})=>n[0]!=="-"),d.filter(({command:n})=>n[0]!=="-"),(n,o)=>y(n,o))||!(0,D.equals)(u.filter(({command:n})=>n[0]==="-"),d.filter(({command:n})=>n[0]==="-"),(n,o)=>y(n,o)))}function y(u,d){if(u.command!==d.command||u.key!==d.key)return!1;const n=T.ContextKeyExpr.deserialize(u.when),o=T.ContextKeyExpr.deserialize(d.when);return!(n&&!o||!n&&o||n&&o&&!n.equals(o)||!R.equals(u.args,d.args))}function h(u,d,n){for(const o of d)u=L.edit(u,[-1],o,n);return u}function p(u,d,n){const o=P(u);for(let t=o.length-1;t>=0;t--)(o[t].command===d||o[t].command===`-${d}`)&&(u=L.edit(u,[t],void 0,n));return u}function c(u,d,n,o){const t=P(u),r=t.findIndex(s=>s.command===d||s.command===`-${d}`);for(let s=t.length-1;s>=0;s--)(t[s].command===d||t[s].command===`-${d}`)&&(u=L.edit(u,[s],void 0,o));for(let s=n.length-1;s>=0;s--)u=L.edit(u,[r],n[s],o);return u}}),define(re[254],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(T,L,P){const I={},w={},b=new Set;if(!L)return{local:{added:I,updated:w,removed:[...b.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const C=i(T,L);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:I,updated:w,removed:[...b.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const S=i(P,T),m=i(P,L),f={},v={},y=new Set,h=new Set;for(const p of S.removed.values())m.updated.has(p)?I[p]=L[p]:y.add(p);for(const p of m.removed.values())h.has(p)||(S.updated.has(p)?h.add(p):b.add(p));for(const p of S.updated.values())h.has(p)||(m.updated.has(p)?C.updated.has(p)&&h.add(p):v[p]=T[p]);for(const p of m.updated.values())h.has(p)||(S.updated.has(p)?C.updated.has(p)&&h.add(p):T[p]!==void 0&&(w[p]=L[p]));for(const p of S.added.values())h.has(p)||(m.added.has(p)?C.updated.has(p)&&h.add(p):f[p]=T[p]);for(const p of m.added.values())h.has(p)||(S.added.has(p)?C.updated.has(p)&&h.add(p):I[p]=L[p]);return{local:{added:I,removed:[...b.values()],updated:w},remote:{added:f,removed:[...y.values()],updated:v},conflicts:[...h.values()]}}e.merge=D;function i(T,L){const P=T?Object.keys(T):[],I=L?Object.keys(L):[],w=I.filter(S=>P.indexOf(S)===-1).reduce((S,m)=>(S.add(m),S),new Set),b=P.filter(S=>I.indexOf(S)===-1).reduce((S,m)=>(S.add(m),S),new Set),C=new Set;for(const S of P){if(b.has(S))continue;const m=T[S],f=L[S];m!==f&&C.add(S)}return{added:w,removed:b,updated:C}}function R(T,L){const{added:P,removed:I,updated:w}=i(T,L);return P.size===0&&I.size===0&&w.size===0}e.areSame=R}),define(re[255],se([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(R,T,L,P){const I={local:{added:[],removed:[],updated:[]},remote:{added:[],removed:[],updated:[]}};if(!T){const b=R.filter(({id:C})=>!P.includes(C));return b.length?I.remote.added=b:I.remote=null,I}const w=i(R,T,P);if(w.added.length>0||w.removed.length>0||w.updated.length>0){const b=i(L,R,P),C=i(L,T,P);for(const S of C.removed){const m=R.find(f=>f.id===S);m&&I.local.removed.push(m)}for(const S of C.added){const m=T.find(f=>f.id===S);b.added.includes(S)?w.updated.includes(S)&&I.local.updated.push(m):I.local.added.push(m)}for(const S of C.updated)I.local.updated.push(T.find(m=>m.id===S));for(const S of b.added)C.added.includes(S)||I.remote.added.push(R.find(m=>m.id===S));for(const S of b.updated)C.removed.includes(S)||C.updated.includes(S)||I.remote.updated.push(R.find(m=>m.id===S));for(const S of b.removed)I.remote.removed.push(T.find(m=>m.id===S))}return I.remote.added.length===0&&I.remote.removed.length===0&&I.remote.updated.length===0&&(I.remote=null),I}e.merge=D;function i(R,T,L){R=R?R.filter(({id:S})=>!L.includes(S)):[],T=T.filter(({id:S})=>!L.includes(S));const P=R.map(({id:S})=>S),I=T.map(({id:S})=>S),w=I.filter(S=>P.indexOf(S)===-1),b=P.filter(S=>I.indexOf(S)===-1),C=[];for(const{id:S,name:m,shortName:f}of R){if(b.includes(S))continue;const v=T.find(y=>y.id===S);(!v||v.name!==m||v.shortName!==f)&&C.push(S)}return{added:w,removed:b,updated:C}}}),define(re[26],se([0,1,20,15,179,45,29,4,104,39]),function(Q,e,D,i,R,T,L,P,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function b(){const s=w.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(l=>!!s[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=b;function C(){const s=w.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(s).filter(E=>!!s[E].ignoreSync),a=Object.keys(s).filter(E=>s[E].scope===2||s[E].scope===6),g=b();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...l,...a,...g])}e.getDefaultIgnoredSettings=C,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function S(){const s="vscode://schemas/ignoredSettings",l=w.Registry.as(T.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:(0,R.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,R.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,R.localize)(2,null),items:[{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,R.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,R.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=w.Registry.as(I.Extensions.JSONContribution),g=()=>{const E=b(),A=C().filter(F=>F!==e.CONFIGURATION_SYNC_STORE_KEY),B=Object.keys(T.allSettings.properties).filter(F=>A.indexOf(F)===-1),O=A.filter(F=>E.indexOf(F)===-1),N={items:{type:"string",enum:[...B,...O.map(F=>`-${F}`)]}};a.registerSchema(s,N)};return l.onDidUpdateConfiguration(()=>g())}e.registerConfiguration=S;function m(s){return s&&(0,i.isObject)(s)&&(0,i.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=m;var f;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles"})(f=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function v(s,...l){return s?[s,...l]:l}e.getPathSegments=v;function y(s,l,a,g){return g.joinPath(a.userDataSyncHome,...v(s,l,`lastSync${l}.json`))}e.getLastSyncResourceUri=y,e.IUserDataSyncStoreManagementService=(0,P.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,P.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,P.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function h(s){const l={};return l[e.HEADER_EXECUTION_ID]=s,l}e.createSyncHeaders=h;var p;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(p=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class c extends Error{constructor(l,a,g,E){super(l),this.code=a,this.resource=g,this.operationId=E,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=c;class u extends c{constructor(l,a,g,E,A){super(l,g,void 0,A),this.url=a,this.serverCode=E}}e.UserDataSyncStoreError=u;class d extends c{constructor(l,a){super(l,a)}}e.UserDataAutoSyncError=d,function(s){function l(a){if(a instanceof s)return a;const g=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(g&&g[1]){const E=g[2]==="unknown"?void 0:g[2],A=g[3]==="unknown"?void 0:g[3];return new s(a.message,g[1],E,A)}return new s(a.message,"Unknown")}s.toUserDataSyncError=l}(c=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var o;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(o=e.Change||(e.Change={}));var t;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function r(s){return`sync.enable.${s}`}e.getEnablementKey=r,e.IUserDataSyncEnablementService=(0,P.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,P.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,P.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,P.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,P.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,P.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(re[256],se([0,1,32,26]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(L,P,I,w,b){if(!P)return{remote:{added:Object.keys(L),removed:[],updated:[],all:Object.keys(L).length>0?L:null},local:{added:{},removed:[],updated:{}}};const C=T(L,P);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const S=I?T(I,P):{added:Object.keys(P).reduce((p,c)=>(p.add(c),p),new Set),removed:new Set,updated:new Set},m=I?T(I,L):{added:Object.keys(L).reduce((p,c)=>(p.add(c),p),new Set),removed:new Set,updated:new Set},f={added:{},removed:[],updated:{}},v=D.deepClone(P),y=!I;for(const p of m.added.values())p!==i.SYNC_SERVICE_URL_TYPE&&y&&S.added.has(p)||(v[p]=L[p]);for(const p of m.updated.values())v[p]=L[p];for(const p of m.removed.values())w.unregistered.includes(p)||delete v[p];for(const p of S.added.values()){const c=P[p];if(w.machine.includes(p)){b.info(`GlobalState: Skipped adding ${p} in local storage because it is declared as machine scoped.`);continue}if(I&&m.added.has(p))continue;const u=L[p];u&&u.value===c.value||p===i.SYNC_SERVICE_URL_TYPE&&y&&m.added.has(p)||(u?f.updated[p]=c:f.added[p]=c)}for(const p of S.updated.values()){const c=P[p];if(w.machine.includes(p)){b.info(`GlobalState: Skipped updating ${p} in local storage because it is declared as machine scoped.`);continue}if(m.updated.has(p)||m.removed.has(p))continue;const u=L[p];u&&u.value===c.value||(f.updated[p]=c)}for(const p of S.removed.values()){if(w.machine.includes(p)){b.trace(`GlobalState: Skipped removing ${p} in local storage because it is declared as machine scoped.`);continue}m.updated.has(p)||m.removed.has(p)||f.removed.push(p)}const h=T(P,v);return{local:f,remote:{added:[...h.added],updated:[...h.updated],removed:[...h.removed],all:h.added.size===0&&h.removed.size===0&&h.updated.size===0?null:v}}}e.merge=R;function T(L,P){const I=Object.keys(L),w=Object.keys(P),b=w.filter(m=>I.indexOf(m)===-1).reduce((m,f)=>(m.add(f),m),new Set),C=I.filter(m=>w.indexOf(m)===-1).reduce((m,f)=>(m.add(f),m),new Set),S=new Set;for(const m of I){if(C.has(m))continue;const f=L[m],v=P[m];D.equals(f,v)||S.add(m)}return{added:b,removed:C,updated:S}}}),define(re[257],se([0,1,20,35,81,42,32,61,26]),function(Q,e,D,i,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function w(a,g,E){let A=[];E?A=C(E):A=b(g);const B=[],O=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(A))for(const N of A)N.startsWith("-")?O.push(N.substring(1)):B.push(N);return(0,D.distinct)([...a,...B].filter(N=>O.indexOf(N)===-1))}e.getIgnoredSettings=w;function b(a){let g=a.inspect("settingsSync.ignoredSettings").userValue;return g!==void 0||(g=a.inspect("sync.ignoredSettings").userValue,g!==void 0)?g:a.getValue("settingsSync.ignoredSettings")||[]}function C(a){const g=(0,i.parse)(a);return g?g["settingsSync.ignoredSettings"]||g["sync.ignoredSettings"]||[]:[]}function S(a,g){const E=(0,i.parse)(a)||{};let A="{}";for(const B of Object.keys(E)){const O=(0,R.setProperty)(A,[B],E[B],g);A=(0,R.applyEdits)(A,O)}return A}e.removeComments=S;function m(a,g,E,A){if(E.length){const B=l(g),O=(0,i.parse)(g)||{},N=(0,i.parse)(a);if(!N)return a;const F=[];for(const k of E){const U=O[k],$=N[k];U===void 0?a=P.edit(a,[k],void 0,A):$!==void 0?a=P.edit(a,[k],U,A):F.push(n(k,B))}F.sort((k,U)=>k.startOffset-U.startOffset),F.forEach(k=>a=p(k.setting.key,g,a,A))}return a}e.updateIgnoredSettings=m;function f(a,g,E,A,B,O){const N=m(a,g,A,O),F=E!==N,k=E!==g;if(!F&&!k)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!k)return{conflictsSettings:[],localContent:null,remoteContent:N,hasConflicts:!1};if(k&&!F)return{conflictsSettings:[],localContent:m(g,a,A,O),remoteContent:null,hasConflicts:!1};if(E===null&&y(a)){const H=v(a,g,A)?null:m(g,a,A,O);return{conflictsSettings:[],localContent:H,remoteContent:null,hasConflicts:!1}}let U=a,$=g;const G=(0,i.parse)(a),W=(0,i.parse)(g),V=E?(0,i.parse)(E):null,z=A.reduce((H,Z)=>(H.add(Z),H),new Set),j=h(G,W,z),J=h(V,G,z),ee=h(V,W,z),ce=new Map,q=new Set,x=H=>{q.add(H);const Z=B.filter(({key:oe})=>oe===H)[0];Z?(U=P.edit(U,[H],Z.value,O),$=P.edit($,[H],Z.value,O)):ce.set(H,{key:H,localValue:G[H],remoteValue:W[H]})};for(const H of J.removed.values())ee.updated.has(H)?x(H):$=P.edit($,[H],void 0,O);for(const H of ee.removed.values())q.has(H)||(J.updated.has(H)?x(H):U=P.edit(U,[H],void 0,O));for(const H of J.updated.values())q.has(H)||(ee.updated.has(H)?j.updated.has(H)&&x(H):$=P.edit($,[H],G[H],O));for(const H of ee.updated.values())q.has(H)||(J.updated.has(H)?j.updated.has(H)&&x(H):U=P.edit(U,[H],W[H],O));for(const H of J.added.values())q.has(H)||(ee.added.has(H)?j.updated.has(H)&&x(H):$=p(H,U,$,O));for(const H of ee.added.values())q.has(H)||(J.added.has(H)?j.updated.has(H)&&x(H):U=p(H,$,U,O));const _=ce.size>0||!v(U,$,A),M=_||!v(U,a,[]),Y=_||!v($,g,[]);return{localContent:M?U:null,remoteContent:Y?$:null,conflictsSettings:[...ce.values()],hasConflicts:_}}e.merge=f;function v(a,g,E){if(a===g)return!0;const A=(0,i.parse)(a),B=(0,i.parse)(g),O=E.reduce((k,U)=>(k.add(U),k),new Set),N=l(a).filter(k=>!(k.setting&&O.has(k.setting.key))),F=l(g).filter(k=>!(k.setting&&O.has(k.setting.key)));if(N.length!==F.length)return!1;for(let k=0;k<N.length;k++){const U=N[k],$=F[k];if(U.setting&&$.setting){if(U.setting.key!==$.setting.key||!L.equals(A[U.setting.key],B[U.setting.key]))return!1}else if(!U.setting&&!$.setting){if(U.value!==$.value)return!1}else return!1}return!0}e.areSame=v;function y(a){return a?l(a).length===0:!0}e.isEmpty=y;function h(a,g,E){const A=a?Object.keys(a).filter(k=>!E.has(k)):[],B=Object.keys(g).filter(k=>!E.has(k)),O=B.filter(k=>A.indexOf(k)===-1).reduce((k,U)=>(k.add(U),k),new Set),N=A.filter(k=>B.indexOf(k)===-1).reduce((k,U)=>(k.add(U),k),new Set),F=new Set;if(a)for(const k of A){if(N.has(k))continue;const U=a[k],$=g[k];L.equals(U,$)||F.add(k)}return{added:O,removed:N,updated:F}}function p(a,g,E,A){const B=(0,i.parse)(g),O=l(g),N=l(E),F=c(a,O,N);return u(E,a,B[a],F,N,A)}e.addSetting=p;function c(a,g,E){const A=g.findIndex(O=>O.setting?.key===a),B=g[A-1];if(B){if(B.setting){const N=n(B.setting.key,E);if(N)return{index:E.indexOf(N),insertAfter:!0}}else{const N=o(A,g);if(N){const F=n(N.setting.key,E);if(F){const k=t(E.indexOf(F),E),U=r(g,N,g[A]);if(k){const $=r(E,F,k),G=s(U,$);return G?{index:E.indexOf(G),insertAfter:!0}:{index:E.indexOf(k),insertAfter:!1}}else{const $=r(E,F,E[E.length-1]),G=s(U,$);return G?{index:E.indexOf(G),insertAfter:!0}:{index:E.length-1,insertAfter:!0}}}}}const O=g[A+1];if(O)if(O.setting){const N=n(O.setting.key,E);if(N)return{index:E.indexOf(N),insertAfter:!1}}else{const N=t(A,g);if(N){const F=n(N.setting.key,E);if(F){const k=o(E.indexOf(F),E),U=r(g,g[A],N);if(k){const $=r(E,k,F),G=s(U.reverse(),$.reverse());return G?{index:E.indexOf(G),insertAfter:!1}:{index:E.indexOf(k),insertAfter:!0}}else{const $=r(E,E[0],F),G=s(U.reverse(),$.reverse());return G?{index:E.indexOf(G),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:E.length-1,insertAfter:!0}}function u(a,g,E,A,B,O){let N;return A.index===-1?N=(0,R.setProperty)(a,[g],E,O):N=d(a,g,E,A,B,O).map(F=>(0,R.withFormatting)(a,F,O)[0]),(0,R.applyEdits)(a,N)}function d(a,g,E,A,B,O){const N=`${JSON.stringify(g)}: ${JSON.stringify(E)}`,F=(0,T.getEOL)(O,a),k=B[A.index];if(A.insertAfter){const U=[];if(k.setting)U.push({offset:k.endOffset,length:0,content:","+N});else{const $=t(A.index,B),G=o(A.index,B),W=G?.setting?.commaOffset;G&&W===void 0&&U.push({offset:G.endOffset,length:0,content:","});const V=W!==void 0&&W>k.endOffset;U.push({offset:V?W+1:k.endOffset,length:0,content:$?F+N+",":F+N})}return U}else{if(k.setting)return[{offset:k.startOffset,length:0,content:N+","}];const U=(B[A.index-1]&&!B[A.index-1].setting?F:"")+N+(t(A.index,B)?",":"")+F;return[{offset:k.startOffset,length:0,content:U}]}}function n(a,g){return g.filter(E=>E.setting?.key===a)[0]}function o(a,g){for(let E=a-1;E>=0;E--)if(g[E].setting)return g[E]}function t(a,g){for(let E=a+1;E<g.length;E++)if(g[E].setting)return g[E]}function r(a,g,E){const A=a.indexOf(g),B=a.indexOf(E);return a.filter((O,N)=>A<N&&N<B)}function s(a,g){if(a.length&&g.length){let E=0;for(;E<g.length&&E<a.length;E++)if(a[E].value!==g[E].value)return g[E-1];return g[E-1]}}function l(a){const g=[];let E=-1,A,B;const O={onObjectBegin:N=>{E++},onObjectProperty:(N,F,k)=>{E===0&&(A=F,B=N)},onObjectEnd:(N,F)=>{E--,E===0&&g.push({startOffset:A,endOffset:N+F,value:a.substring(A,N+F),setting:{key:B,commaOffset:void 0}})},onArrayBegin:(N,F)=>{E++},onArrayEnd:(N,F)=>{E--,E===0&&g.push({startOffset:A,endOffset:N+F,value:a.substring(A,N+F),setting:{key:B,commaOffset:void 0}})},onLiteralValue:(N,F,k)=>{E===0&&g.push({startOffset:A,endOffset:F+k,value:a.substring(A,F+k),setting:{key:B,commaOffset:void 0}})},onSeparator:(N,F,k)=>{if(E===0&&N===","){let U=g.length-1;for(;U>=0&&!g[U].setting;U--);const $=g[U];$&&g.splice(U,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:F}})}},onComment:(N,F)=>{E===0&&g.push({startOffset:N,endOffset:N+F,value:a.substring(N,N+F)})}};return(0,i.visit)(a,O),g}}),define(re[76],se([0,1,3,2,4,26]),function(Q,e,D,i,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let L=class extends i.Disposable{get account(){return this._account}constructor(I,w){super(),this.userDataSyncStoreService=I,this.logService=w,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(I.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(I.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(I){(I&&this._account?I.token!==this._account.token||I.authenticationProviderId!==this._account.authenticationProviderId:I!==this._account)&&(this._account=I,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(I))}};L=ve([K(0,T.IUserDataSyncStoreService),K(1,T.IUserDataSyncLogService)],L),e.UserDataSyncAccountService=L}),define(re[258],se([0,1,2,8]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(S){this.service=S}listen(S,m){switch(m){case"onError":return this.service.onError}throw new Error(`Event not found: ${m}`)}call(S,m,f){switch(m){case"triggerSync":return this.service.triggerSync(f[0],f[1],f[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(f[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class T{constructor(S){this.service=S}listen(S,m){throw new Error(`Event not found: ${m}`)}call(S,m,f){switch(m){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(f[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(i.URI.revive(f[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class L{constructor(S){this.channel=S}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(S){return this.channel.call("resolveUserKeybindings",[S])}async resolveFormattingOptions(S){return this.channel.call("resolveFormattingOptions",[S])}}e.UserDataSyncUtilServiceClient=L;class P{constructor(S){this.service=S}listen(S,m){switch(m){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${m}`)}async call(S,m,f){switch(m){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(f[0],f[1]);case"setEnablements":return this.service.setEnablements(f)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class I{constructor(S){this.service=S}listen(S,m){switch(m){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${m}`)}call(S,m,f){switch(m){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(f)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class w{constructor(S){this.service=S}listen(S,m){switch(m){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${m}`)}call(S,m,f){switch(m){case"switch":return this.service.switch(f[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=w;class b extends D.Disposable{constructor(S){super(),this.channel=S,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(S){return this.channel.call("switch",[S])}async getPreviousUserDataSyncStore(){const S=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(S)}revive(S){return{url:i.URI.revive(S.url),type:S.type,defaultUrl:i.URI.revive(S.defaultUrl),insidersUrl:i.URI.revive(S.insidersUrl),stableUrl:i.URI.revive(S.stableUrl),canSwitch:S.canSwitch,authenticationProviders:S.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=b}),define(re[259],se([0,1,13,7]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends i.AbstractLogger{constructor(L,P){super(),this.logger=this._register(L.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(L,...P){this.logger.trace(L,...P)}debug(L,...P){this.logger.debug(L,...P)}info(L,...P){this.logger.info(L,...P)}warn(L,...P){this.logger.warn(L,...P)}error(L,...P){this.logger.error(L,...P)}critical(L,...P){this.logger.critical(L,...P)}flush(){this.logger.flush()}};R=ve([K(0,i.ILoggerService),K(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(re[260],se([0,1,6,3,2]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends R.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:I,getActiveWindowId:w}){super(),this.disposables=this._register(new R.DisposableStore),i.Event.latch(i.Event.any(P,I))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>w()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(re[116],se([0,1,182,12,49,21,8,4,22]),function(Q,e,D,i,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function w(o){const t=o;return typeof t?.id=="string"&&L.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=w,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function b(o,t){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,i.basename)(o)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=o;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=b;function C(o){const t=o;return typeof t?.id=="string"&&L.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=C;function S(o){const t=o;if(t?.uri)return{id:t.id,uri:L.URI.revive(t.uri)};const r=o;if(r?.configPath)return{id:r.id,configPath:L.URI.revive(r.configPath)};if(o?.id)return{id:o.id}}e.reviveIdentifier=S;var m;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function f(o){const t=o;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=f;function v(o){const t=o;return!!(t&&typeof t=="object"&&L.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=v;class y{constructor(t,r,s,l,a){this._id=t,this._transient=s,this._configuration=l,this._ignorePathCasing=a,this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t)||null}updateFoldersMap(){this._foldersMap=R.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=y;class h{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,T.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function p(o){return new h({uri:o,index:0,name:(0,T.basenameOrAuthority)(o)},{uri:o.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(o,t){return T.extUriBiasedIgnorePathCase.isEqualOrParent(o,t.untitledWorkspacesHome)}e.isUntitledWorkspace=c;function u(o){let t;return L.URI.isUri(o)?t=o:t=o.configuration,t?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=u;function d(o,t){return!c(o,t)&&!u(o)}e.isSavedWorkspace=d;function n(o){return(typeof o=="string"?(0,i.extname)(o):(0,T.extname)(o))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=n}),define(re[18],se([0,1,66,3,2,21,15,8,174,13,14,4,7,116,41,30,6,31,27]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v,y,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function c(t){const r=t;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&P.URI.isUri(r.location)&&P.URI.isUri(r.globalStorageHome)&&P.URI.isUri(r.settingsResource)&&P.URI.isUri(r.keybindingsResource)&&P.URI.isUri(r.tasksResource)&&P.URI.isUri(r.snippetsHome)&&((0,L.isUndefined)(r.extensionsResource)||P.URI.isUri(r.extensionsResource)))}e.isUserDataProfile=c,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,C.createDecorator)("IUserDataProfilesService");function u(t,r){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:P.URI.revive(t.location).with({scheme:r}),globalStorageHome:P.URI.revive(t.globalStorageHome).with({scheme:r}),settingsResource:P.URI.revive(t.settingsResource).with({scheme:r}),keybindingsResource:P.URI.revive(t.keybindingsResource).with({scheme:r}),tasksResource:P.URI.revive(t.tasksResource).with({scheme:r}),snippetsHome:P.URI.revive(t.snippetsHome).with({scheme:r}),extensionsResource:P.URI.revive(t.extensionsResource)?.with({scheme:r}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=u,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function d(t,r,s,l){return{id:t,name:r,location:s,isDefault:!1,shortName:l?.shortName,globalStorageHome:(0,T.joinPath)(s,"globalStorage"),settingsResource:(0,T.joinPath)(s,"settings.json"),keybindingsResource:(0,T.joinPath)(s,"keybindings.json"),tasksResource:(0,T.joinPath)(s,"tasks.json"),snippetsHome:(0,T.joinPath)(s,"snippets"),extensionsResource:(0,T.joinPath)(s,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:l?.useDefaultFlags,isTransient:l?.transient}}e.toUserDataProfile=d;let n=class extends R.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(r,s,l,a){super(),this.environmentService=r,this.fileService=s,this.uriIdentityService=l,this.logService=a,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new i.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new i.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new i.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new i.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new f.ResourceMap},this.profilesHome=(0,T.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const r=this.enabled?this.getStoredProfiles().map(g=>d((0,T.basename)(g.location),g.name,g.location,{shortName:g.shortName,useDefaultFlags:g.useDefaultFlags})):[];let s;const l=new f.ResourceMap,a=d((0,D.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,I.localize)(0,null),this.environmentService.userRoamingDataHome);if(r.unshift({...a,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||r.length>0||this.transientProfilesObject.profiles.length>0?a.extensionsResource:void 0}),r.length){const g=this.getStoredProfileAssociations();if(g.workspaces)for(const[E,A]of Object.entries(g.workspaces)){const B=P.URI.parse(E),O=P.URI.parse(A),N=r.find(F=>this.uriIdentityService.extUri.isEqual(F.location,O));N&&l.set(B,N)}if(g.emptyWindow){const E=P.URI.parse(g.emptyWindow);s=r.find(A=>this.uriIdentityService.extUri.isEqual(A.location,E))}}this._profilesObject={profiles:r,workspaces:l,emptyWindow:s}}return this._profilesObject}async createTransientProfile(r){const s="Temp",l=new RegExp(`${(0,p.escapeRegExpCharacters)(s)}\\s(\\d+)`);let a=0;for(const E of this.profiles){const A=l.exec(E.name),B=A?parseInt(A[1]):0;a=B>a?B:a}const g=`${s} ${a+1}`;return this.createProfile((0,D.hash)((0,h.generateUuid)()).toString(16),g,{transient:!0},r)}async createNamedProfile(r,s,l){return this.createProfile((0,D.hash)((0,h.generateUuid)()).toString(16),r,s,l)}async createProfile(r,s,l,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const g=await this.doCreateProfile(r,s,l);return a&&await this.setProfileForWorkspace(a,g),g}async doCreateProfile(r,s,l){let a=this.profileCreationPromises.get(s);return a||(a=(async()=>{try{const g=this.profiles.find(B=>B.name===s||B.id===r);if(g)return g;const E=d(r,s,(0,T.joinPath)(this.profilesHome,r),l);await this.fileService.createFolder(E.location);const A=[];return this._onWillCreateProfile.fire({profile:E,join(B){A.push(B)}}),await y.Promises.settled(A),this.updateProfiles([E],[],[]),E}finally{this.profileCreationPromises.delete(s)}})(),this.profileCreationPromises.set(s,a)),a}async updateProfile(r,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let l=this.profiles.find(a=>a.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);return l=d(l.id,s.name??l.name,l.location,{shortName:s.shortName??l.shortName,transient:s.transient??l.isTransient,useDefaultFlags:s.useDefaultFlags??l.useDefaultFlags}),this.updateProfiles([],[],[l]),l}async removeProfile(r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(r.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(a=>a.id===r.id);if(!s)throw new Error(`Profile '${r.name}' does not exist`);const l=[];this._onWillRemoveProfile.fire({profile:s,join(a){l.push(a)}});try{await Promise.allSettled(l)}catch(a){this.logService.error(a)}s.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const a of[...this.profilesObject.workspaces.keys()])s.id===this.profilesObject.workspaces.get(a)?.id&&this.profilesObject.workspaces.delete(a);this.updateStoredProfileAssociations(),this.updateProfiles([],[s],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(s.location,{recursive:!0})}catch(a){this.logService.error(a)}}getOrSetProfileForWorkspace(r,s=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let l=this.getProfileForWorkspace(r);return l||(l=s,this.profiles.length>1&&this.setProfileForWorkspaceSync(r,l)),l}async setProfileForWorkspace(r,s){this.setProfileForWorkspaceSync(r,s)}setProfileForWorkspaceSync(r,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const l=this.profiles.find(a=>a.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);this.updateWorkspaceAssociation(r,l)}unsetWorkspace(r,s){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(r,void 0,s)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const r=await this.fileService.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(s=>s.isDirectory&&this.profiles.every(l=>!this.uriIdentityService.extUri.isEqual(l.location,s.resource))).map(s=>this.fileService.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const r=this.transientProfilesObject.profiles.filter(s=>!this.isProfileAssociatedToWorkspace(s));await Promise.allSettled(r.map(s=>this.removeProfile(s)))}getProfileForWorkspace(r){const s=this.getWorkspace(r);return P.URI.isUri(s)?this.transientProfilesObject.workspaces.get(s)??this.profilesObject.workspaces.get(s):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(r){return(0,m.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,m.isWorkspaceIdentifier)(r)?r.configPath:"empty-window"}isProfileAssociatedToWorkspace(r){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,r.location)||[...this.transientProfilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,r.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,r.location)||[...this.profilesObject.workspaces.values()].some(s=>this.uriIdentityService.extUri.isEqual(s.location,r.location)))}updateProfiles(r,s,l){const a=[...this.profiles,...r],g=[];this.transientProfilesObject.profiles=[];for(let E of a)E.isDefault||s.some(A=>E.id===A.id)||(E=l.find(A=>E.id===A.id)??E,E.isTransient?this.transientProfilesObject.profiles.push(E):g.push({location:E.location,name:E.name,shortName:E.shortName,useDefaultFlags:E.useDefaultFlags}));this.saveStoredProfiles(g),this._profilesObject=void 0,this.triggerProfilesChanges(r,s,l)}triggerProfilesChanges(r,s,l){this._onDidChangeProfiles.fire({added:r,removed:s,updated:l,all:this.profiles})}updateWorkspaceAssociation(r,s,l){l=s?.isTransient?!0:l,l||this.updateWorkspaceAssociation(r,void 0,!0);const a=this.getWorkspace(r),g=l?this.transientProfilesObject:this.profilesObject;P.URI.isUri(a)?(g.workspaces.delete(a),s&&g.workspaces.set(a,s)):g.emptyWindow=s,l||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[l,a]of this.profilesObject.workspaces.entries())r[l.toString()]=a.location.toString();const s=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:r,emptyWindow:s}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}};n.PROFILES_KEY="userDataProfiles",n.PROFILE_ASSOCIATIONS_KEY="profileAssociations",n=ve([K(0,w.IEnvironmentService),K(1,b.IFileService),K(2,v.IUriIdentityService),K(3,S.ILogService)],n),e.UserDataProfilesService=n;class o extends n{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(r){this.storedProfiles=r}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(r){this.storedProfileAssociations=r}}e.InMemoryUserDataProfilesService=o}),define(re[261],se([0,1,6,2,18]),function(Q,e,D,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let T=class extends i.Disposable{constructor(P){super(),this._register(new D.RunOnceScheduler(()=>{P.cleanUp()},10*1e3)).schedule()}};T=ve([K(0,R.IUserDataProfilesService)],T),e.UserDataProfilesCleaner=T}),define(re[262],se([0,1,20,6,24,11,3,2,5,8,155,29,33,46,7,25,23,18]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let p=class extends P.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(t,r,s,l,a){super(),this.galleryService=t,this.telemetryService=r,this.logService=s,this.productService=l,this.userDataProfilesService=a,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this._onDidInstallExtensions=this._register(new L.Emitter),this._onUninstallExtension=this._register(new L.Emitter),this._onDidUninstallExtension=this._register(new L.Emitter),this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(({task:g})=>g.cancel()),this.uninstallingExtensions.forEach(g=>g.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(s=>(0,C.isTargetPlatformCompatible)(s,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{if(!this.galleryService.isEnabled())throw new C.ExtensionManagementError(b.localize(0,null),C.ExtensionManagementErrorCode.Internal);const s=await this.checkAndGetCompatibleVersion(t,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(s.manifest,s.extension,r)}catch(s){throw d(this.telemetryService,"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(t),error:s}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(s),u(s)}}async uninstall(t,r={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,r)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(b.localize(1,null));const r=await this.getTargetPlatform(),[s]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:r,compatible:!0},R.CancellationToken.None);if(!s)throw new Error(b.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(s)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,r,s){const l=O=>`${S.ExtensionKey.create(O).toString()}${s.profileLocation?`-${s.profileLocation.toString()}`:""}`;if(!w.URI.isUri(r)){const O=this.installingExtensions.get(l(r));if(O){this.logService.info("Extensions is already requested to install",r.identifier.id);const{local:N}=await O.task.waitUntilTaskIsFinished();return N}s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const a=[],g=[],E=[],A=this.createInstallExtensionTask(t,r,s);w.URI.isUri(r)||this.installingExtensions.set(l(r),{task:A,waitingTasks:[]}),this._onInstallExtension.fire({identifier:A.identifier,source:r,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",A.identifier.id),a.push({task:A,manifest:t});let B=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",A.identifier.id);else try{const N=await this.getAllDepsAndPackExtensions(A.identifier,t,!!s.installOnlyNewlyAddedFromExtensionPack,!!s.installPreReleaseVersion,s.profileLocation),F=await this.getInstalled(void 0,s.profileLocation);for(const{gallery:k,manifest:U}of N){B=B||!!U.extensionDependencies?.some(W=>(0,S.areSameExtensions)({id:W},A.identifier));const $=l(k),G=this.installingExtensions.get($);if(G){if(this.canWaitForTask(A,G.task)){this.logService.info("Waiting for already requested installing extension",k.identifier.id,A.identifier.id),G.waitingTasks.push(A);const W=G.task.identifier;g.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,V=>V.some(z=>(0,S.areSameExtensions)(z.identifier,W)))).then(V=>{if(!V.find(j=>(0,S.areSameExtensions)(j.identifier,W))?.local)throw new Error(`Extension ${W.id} is not installed`)}))}}else if(!F.some(({identifier:W})=>(0,S.areSameExtensions)(W,k.identifier))){const W=this.createInstallExtensionTask(U,k,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set($,{task:W,waitingTasks:[A]}),this._onInstallExtension.fire({identifier:W.identifier,source:k,profileLocation:s.profileLocation}),this.logService.info("Installing extension:",W.identifier.id,A.identifier.id),a.push({task:W,manifest:U})}}}catch(N){if(w.URI.isUri(A.source))(0,D.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",A.identifier.id,N.message),(0,D.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",A.identifier.id,N.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",A.identifier.id),N}const O=a.reduce((N,{task:F,manifest:k})=>(N.set(F.identifier.id.toLowerCase(),{task:F,manifest:k}),N),new Map);for(;O.size;){let N;const F=[...O.values()].filter(({manifest:k})=>!k.extensionDependencies?.some(U=>O.has(U.toLowerCase())));F.length?N=O.size===1?F:F.filter(({task:k})=>!(k===A&&!B)):(this.logService.info("Found extensions with circular dependencies",F.map(({task:k})=>k.identifier.id)),N=[...O.values()]),await this.joinAllSettled(N.map(async({task:k})=>{const U=new Date().getTime();try{const{local:$}=await k.run();if(await this.joinAllSettled(this.participants.map(G=>G.postInstall($,k.source,s,R.CancellationToken.None))),!w.URI.isUri(k.source)){const G=k.operation===3,W=G?void 0:(new Date().getTime()-k.source.lastUpdated)/1e3;if(d(this.telemetryService,G?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(k.source),wasVerified:k.wasVerified,duration:new Date().getTime()-U,durationSinceUpdate:W}),I.isWeb&&k.operation!==3)try{await this.galleryService.reportStatistic($.manifest.publisher,$.manifest.name,$.manifest.version,"install")}catch{}}E.push({local:$,identifier:k.identifier,operation:k.operation,source:k.source,context:s.context,profileLocation:s.profileLocation,applicationScoped:$.isApplicationScoped})}catch($){throw w.URI.isUri(k.source)||d(this.telemetryService,k.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,S.getGalleryExtensionTelemetryData)(k.source),wasVerified:k.wasVerified,duration:new Date().getTime()-U,error:$}),this.logService.error("Error while installing the extension:",k.identifier.id),$}finally{O.delete(k.identifier.id.toLowerCase())}}))}return g.length&&await this.joinAllSettled(g),E.forEach(({identifier:N})=>this.logService.info("Extension installed successfully:",N.id)),this._onDidInstallExtensions.fire(E),E.filter(({identifier:N})=>(0,S.areSameExtensions)(N,A.identifier))[0].local}catch(O){if(a.forEach(({task:N})=>N.cancel()),E.length)try{const N=await Promise.allSettled(E.map(({local:F})=>this.createUninstallExtensionTask(F,{versionOnly:!0,profileLocation:s.profileLocation}).run()));for(let F=0;F<N.length;F++){const k=N[F],{identifier:U}=E[F];k.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",U.id):this.logService.warn("Rollback: Error while uninstalling extension",U.id,(0,T.getErrorMessage)(k.reason))}}catch(N){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(N),E.map(({identifier:F})=>F.id))}throw this._onDidInstallExtensions.fire(a.map(({task:N})=>({identifier:N.identifier,operation:2,source:N.source,context:s.context,profileLocation:s.profileLocation}))),O}finally{for(const[O,{task:N,waitingTasks:F}]of this.installingExtensions.entries()){const k=F.indexOf(A);k!==-1&&F.splice(k,1),F.length===0&&(N===A||k!==-1)&&this.installingExtensions.delete(O)}}}canWaitForTask(t,r){for(const[,{task:s,waitingTasks:l}]of this.installingExtensions.entries())if(s===t&&(l.includes(r)||l.some(a=>this.canWaitForTask(a,r)))||s===r&&l[0]&&!this.canWaitForTask(t,l[0]))return!1;return!0}async joinAllSettled(t){const r=[],s=[],l=await Promise.allSettled(t);for(const a of l)a.status==="fulfilled"?r.push(a.value):s.push(a.reason);if(s.length)throw c(s);return r}async getAllDepsAndPackExtensions(t,r,s,l,a){if(!this.galleryService.isEnabled())return[];const g=await this.getInstalled(void 0,a),E=[t],A=[],B=async(O,N)=>{const F=N.extensionDependencies||[],k=[...F];if(N.extensionPack){const U=s?g.find($=>(0,S.areSameExtensions)($.identifier,O)):void 0;for(const $ of N.extensionPack)U&&U.manifest.extensionPack&&U.manifest.extensionPack.some(G=>(0,S.areSameExtensions)({id:G},{id:$}))||k.every(G=>!(0,S.areSameExtensions)({id:G},{id:$}))&&k.push($)}if(k.length){const U=[...E,...A.map(G=>G.gallery.identifier)],$=k.filter(G=>U.every(W=>!(0,S.areSameExtensions)(W,{id:G})));if($.length){const G=await this.galleryService.getExtensions($.map(W=>({id:W,preRelease:l})),R.CancellationToken.None);for(const W of G){if(U.find(j=>(0,S.areSameExtensions)(j,W.identifier)))continue;const V=F.some(j=>(0,S.areSameExtensions)({id:j},W.identifier));let z;try{z=await this.checkAndGetCompatibleVersion(W,!1,l)}catch(j){if(j instanceof C.ExtensionManagementError&&j.code===C.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!V){this.logService.info("Skipping the packed extension as it cannot be installed",W.identifier.id);continue}else throw j}A.push({gallery:z.extension,manifest:z.manifest}),await B(z.extension.identifier,z.manifest)}}}};return await B(t,r),A}async checkAndGetCompatibleVersion(t,r,s){if((await this.getExtensionsControlManifest()).malicious.some(E=>(0,S.areSameExtensions)(t.identifier,E)))throw new C.ExtensionManagementError(b.localize(3,null,t.identifier.id),C.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const E=await this.getTargetPlatform();throw new C.ExtensionManagementError(b.localize(4,null,t.identifier.id,this.productService.nameLong,(0,C.TargetPlatformToString)(E)),C.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(t,r,s);if(a){if(s&&!r&&t.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new C.ExtensionManagementError(b.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),C.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!s&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],R.CancellationToken.None))[0]?new C.ExtensionManagementError(b.localize(6,null,t.identifier.id),C.ExtensionManagementErrorCode.ReleaseVersionNotFound):new C.ExtensionManagementError(b.localize(7,null,t.identifier.id,this.productService.nameLong,this.productService.version),C.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const g=await this.galleryService.getManifest(a,R.CancellationToken.None);if(g===null)throw new C.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,C.ExtensionManagementErrorCode.Invalid);if(g.version!==a.version)throw new C.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,C.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:g}}async getCompatibleVersion(t,r,s){const l=await this.getTargetPlatform();let a=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==s&&(a=(await this.galleryService.getExtensions([{...t.identifier,preRelease:s}],{targetPlatform:l,compatible:!0},R.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(t,s,l)&&(a=t),a||(r?a=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:l,compatible:!0},R.CancellationToken.None))[0]||null:a=await this.galleryService.getCompatibleExtension(t,s,l)),a}async uninstallExtension(t,r){const s=B=>`${B.id.toLowerCase()}${r.versionOnly?`-${t.manifest.version}`:""}${r.profileLocation?`@${r.profileLocation.toString()}`:""}`,l=this.uninstallingExtensions.get(s(t.identifier));if(l)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),l.waitUntilTaskIsFinished();const a=(B,O)=>{const N=this.createUninstallExtensionTask(B,O);return this.uninstallingExtensions.set(s(N.extension.identifier),N),r.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${B.identifier.id}@${B.manifest.version}`,r.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${B.identifier.id}@${B.manifest.version}`),this._onUninstallExtension.fire({identifier:B.identifier,profileLocation:r.profileLocation,applicationScoped:B.isApplicationScoped}),N},g=(B,O)=>{O?r.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${B.identifier.id}@${B.manifest.version}`,r.profileLocation.toString(),O.message):this.logService.error("Failed to uninstall extension:",`${B.identifier.id}@${B.manifest.version}`,O.message):r.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${B.identifier.id}@${B.manifest.version}`,r.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${B.identifier.id}@${B.manifest.version}`),d(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,S.getLocalExtensionTelemetryData)(B),error:O}),this._onDidUninstallExtension.fire({identifier:B.identifier,version:B.manifest.version,error:O?.code,profileLocation:r.profileLocation,applicationScoped:B.isApplicationScoped})},E=[],A=[];try{E.push(a(t,r));const B=await this.getInstalled(1,r.profileLocation);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const O=this.getAllPackExtensionsToUninstall(t,B);for(const N of O)this.uninstallingExtensions.has(s(N.identifier))?this.logService.info("Extensions is already requested to uninstall",N.identifier.id):E.push(a(N,r))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(E.map(O=>O.extension),B,t),await this.joinAllSettled(E.map(async O=>{try{if(await O.run(),await this.joinAllSettled(this.participants.map(N=>N.postUninstall(O.extension,r,R.CancellationToken.None))),O.extension.identifier.uuid)try{await this.galleryService.reportStatistic(O.extension.manifest.publisher,O.extension.manifest.name,O.extension.manifest.version,"uninstall")}catch{}g(O.extension)}catch(N){const F=N instanceof C.ExtensionManagementError?N:new C.ExtensionManagementError((0,T.getErrorMessage)(N),C.ExtensionManagementErrorCode.Internal);throw g(O.extension,F),F}finally{A.push(O)}}))}catch(B){const O=B instanceof C.ExtensionManagementError?B:new C.ExtensionManagementError((0,T.getErrorMessage)(B),C.ExtensionManagementErrorCode.Internal);for(const N of E){try{N.cancel()}catch{}A.includes(N)||g(N.extension,O)}throw O}finally{for(const B of E)this.uninstallingExtensions.delete(s(B.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",B.extension.identifier.id)}}checkForDependents(t,r,s){for(const l of t){const a=this.getDependents(l,r);if(a.length){const g=a.filter(E=>!t.some(A=>(0,S.areSameExtensions)(A.identifier,E.identifier)));if(g.length)throw new Error(this.getDependentsErrorMessage(l,g,s))}}}getDependentsErrorMessage(t,r,s){return s===t?r.length===1?b.localize(8,null,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(9,null,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(10,null,s.manifest.displayName||s.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?b.localize(11,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(12,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(13,null,s.manifest.displayName||s.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(t,r,s=[]){if(s.indexOf(t)!==-1)return[];s.push(t);const l=t.manifest.extensionPack?t.manifest.extensionPack:[];if(l.length){const a=r.filter(E=>!E.isBuiltin&&l.some(A=>(0,S.areSameExtensions)({id:A},E.identifier))),g=[];for(const E of a)g.push(...this.getAllPackExtensionsToUninstall(E,r,s));return[...a,...g]}return[]}getDependents(t,r){return r.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(l=>(0,S.areSameExtensions)({id:l},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(t,r,s){return s.profileLocation&&(0,m.isApplicationScopedExtension)(t)&&(s={...s,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(t,r,s)}createUninstallExtensionTask(t,r){return r.profileLocation&&t.isApplicationScoped&&(r={...r,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(t,r)}};p=ve([K(0,C.IExtensionGalleryService),K(1,y.ITelemetryService),K(2,f.ILogService),K(3,v.IProductService),K(4,h.IUserDataProfilesService)],p),e.AbstractExtensionManagementService=p;function c(o){const t=Array.isArray(o)?o:[o];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,s)=>new Error(`${r.message}${r.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=c;function u(o){if(o instanceof C.ExtensionManagementError)return o;const t=new C.ExtensionManagementError(o.message,C.ExtensionManagementErrorCode.Internal);return t.stack=o.stack,t}function d(o,t,{extensionData:r,wasVerified:s,duration:l,error:a,durationSinceUpdate:g}){let E,A;a&&(a instanceof C.ExtensionManagementError?(E=a.code,a.code===C.ExtensionManagementErrorCode.Signature&&(A=a.message)):E=C.ExtensionManagementErrorCode.Internal),o.publicLog(t,{...r,wasVerified:s,success:!a,duration:l,errorcode:E,errorcodeDetail:A,durationSinceUpdate:g})}e.reportTelemetry=d;class n{constructor(){this.barrier=new i.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,i.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,i.createCancelablePromise)(t=>new Promise((r,s)=>{const l=t.onCancellationRequested(()=>{l.dispose(),s(new T.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=n}),define(re[77],se([0,1,20,6,32,17,11,35,137,2,22,12,5,21,55,87,15,8,158,13,33,46,70,14,4,7,25,3,67,51,18,30,188]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v,y,h,p,c,u,d,n,o,t,r,s,l,a,g,E,A,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var O;(function(W){function V(z,j){if(z===j)return!0;const J=Object.keys(z),ee=new Set;for(const ce of Object.keys(j))ee.add(ce);if(J.length!==ee.size)return!1;for(const ce of J){if(z[ce]!==j[ce])return!1;ee.delete(ce)}return ee.size===0}W.equals=V})(O=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let N=class extends w.Disposable{constructor(V,z,j,J,ee,ce,q,x,_,M,Y){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=z,this.extensionsControlLocation=j,this.cacheLocation=J,this.userDataProfilesService=ee,this.extensionsProfileScannerService=ce,this.fileService=q,this.logService=x,this.environmentService=_,this.productService=M,this.instantiationService=Y,this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,m.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(U,(0,m.joinPath)(this.cacheLocation,d.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(U,(0,m.joinPath)(this.cacheLocation,d.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(k,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,u.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(V,z,j){const[J,ee]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(z)]),ce=j?await this.scanExtensionsUnderDevelopment(V,[...J,...ee]):[];return this.dedupExtensions(J,ee,ce,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const z=[];z.push(this.scanDefaultSystemExtensions(!!V.useCache,V.language)),z.push(this.scanDevSystemExtensions(V.language,!!V.checkControlFile));const[j,J]=await Promise.all(z);return this.applyScanOptions([...j,...J],0,V,!1)}async scanUserExtensions(V){this.logService.trace("Started scanning user extensions");const z=await this.createExtensionScannerInput(V.profileLocation??this.userExtensionsLocation,!!V.profileLocation,1,!V.includeUninstalled,V.language);let J=await(V.useCache&&!z.devMode&&z.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(z);return J=await this.applyScanOptions(J,1,V,!0),this.logService.trace("Scanned user extensions:",J.length),J}async scanExtensionsUnderDevelopment(V,z){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const j=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(J=>J.scheme===b.Schemas.file).map(async J=>{const ee=await this.createExtensionScannerInput(J,!1,1,!0,V.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(ee)).map(q=>(q.type=z.find(x=>(0,u.areSameExtensions)(x.identifier,q.identifier))?.type??q.type,this.extensionsScanner.validate(q,ee)))}))).flat();return this.applyScanOptions(j,"development",V,!0)}return[]}async scanExistingExtension(V,z,j){const J=await this.createExtensionScannerInput(V,!1,z,!0,j.language),ee=await this.extensionsScanner.scanExtension(J);return!ee||!j.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(V,z,j){const J=await this.createExtensionScannerInput(V,!1,z,!0,j.language),ee=await this.extensionsScanner.scanOneOrMultipleExtensions(J);return this.applyScanOptions(ee,z,j,!0)}async scanMetadata(V){const z=(0,m.joinPath)(V,"package.json"),j=(await this.fileService.readFile(z)).value.toString();return JSON.parse(j).__metadata}async updateMetadata(V,z){const j=(0,m.joinPath)(V,"package.json"),J=(await this.fileService.readFile(j)).value.toString(),ee=JSON.parse(J);z.isMachineScoped=z.isMachineScoped||void 0,z.isBuiltin=z.isBuiltin||void 0,z.installedTimestamp=z.installedTimestamp||void 0,ee.__metadata={...ee.__metadata,...z},await this.fileService.writeFile((0,m.joinPath)(V,"package.json"),T.VSBuffer.fromString(JSON.stringify(ee,null,"	")))}async applyScanOptions(V,z,j,J){return j.includeAllVersions||(V=this.dedupExtensions(z===0?V:void 0,z===1?V:void 0,z==="development"?V:void 0,await this.getTargetPlatform(),J)),j.includeInvalid||(V=V.filter(ee=>ee.isValid)),V.sort((ee,ce)=>{const q=C.basename(ee.location.fsPath),x=C.basename(ce.location.fsPath);return q<x?-1:q>x?1:0})}dedupExtensions(V,z,j,J,ee){const ce=(x,_,M)=>{if(x.isValid&&!_.isValid)return!1;if(x.isValid===_.isValid){if(ee&&f.gt(x.manifest.version,_.manifest.version))return this.logService.debug(`Skipping extension ${_.location.path} with lower version ${_.manifest.version} in favour of ${x.location.path} with version ${x.manifest.version}`),!1;if(f.eq(x.manifest.version,_.manifest.version)){if(x.type===0)return this.logService.debug(`Skipping extension ${_.location.path} in favour of system extension ${x.location.path} with same version`),!1;if(x.targetPlatform===J)return this.logService.debug(`Skipping extension ${_.location.path} from different target platform ${_.targetPlatform}`),!1}}return M?this.logService.warn(`Overwriting user extension ${x.location.path} with ${_.location.path}.`):this.logService.debug(`Overwriting user extension ${x.location.path} with ${_.location.path}.`),!0},q=new Map;return V?.forEach(x=>{const _=d.ExtensionIdentifier.toKey(x.identifier.id),M=q.get(_);(!M||ce(M,x,!1))&&q.set(_,x)}),z?.forEach(x=>{const _=d.ExtensionIdentifier.toKey(x.identifier.id),M=q.get(_);if(!M&&V&&x.type===0){this.logService.debug(`Skipping obsolete system extension ${x.location.path}.`);return}(!M||ce(M,x,!1))&&q.set(_,x)}),j?.forEach(x=>{const _=d.ExtensionIdentifier.toKey(x.identifier.id),M=q.get(_);(!M||ce(M,x,!0))&&q.set(_,x),q.set(_,x)}),[...q.values()]}async scanDefaultSystemExtensions(V,z){this.logService.trace("Started scanning system extensions");const j=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,z),ee=await(V&&!j.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(j);return this.logService.trace("Scanned system extensions:",ee.length),ee}async scanDevSystemExtensions(V,z){const j=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!j?.length)return[];this.logService.trace("Started scanning dev system extensions");const J=z?await this.getBuiltInExtensionControl():{},ee=[],ce=h.URI.file(C.normalize(C.join(b.FileAccess.asFileUri("",Q).fsPath,"..",".build","builtInExtensions")));for(const x of j){const _=J[x.name]||"marketplace";switch(_){case"disabled":break;case"marketplace":ee.push((0,m.joinPath)(ce,x.name));break;default:ee.push(h.URI.file(_));break}}const q=await Promise.all(ee.map(async x=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(x,!1,0,!0,V))));return this.logService.trace("Scanned dev system extensions:",q.length),(0,D.coalesce)(q)}async getBuiltInExtensionControl(){try{const V=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(V.value.toString())}catch{return{}}}async createExtensionScannerInput(V,z,j,J,ee,ce=!0){const q=await this.getTranslations(ee??S.language),x=await this.getMtime(V),_=z?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,M=_?await this.getMtime(_):void 0;return new F(V,x,_,M,z,j,J,ce,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,ee,q)}async getMtime(V){try{const z=await this.fileService.stat(V);if(typeof z.mtime=="number")return z.mtime}catch{}}};N=ve([K(4,E.IUserDataProfilesService),K(5,g.IExtensionsProfileScannerService),K(6,o.IFileService),K(7,r.ILogService),K(8,c.IEnvironmentService),K(9,s.IProductService),K(10,t.IInstantiationService)],N),e.AbstractExtensionsScannerService=N;class F{constructor(V,z,j,J,ee,ce,q,x,_,M,Y,H,Z,oe){this.location=V,this.mtime=z,this.applicationExtensionslocation=j,this.applicationExtensionslocationMtime=J,this.profile=ee,this.type=ce,this.excludeObsolete=q,this.validate=x,this.productVersion=_,this.productDate=M,this.productCommit=Y,this.devMode=H,this.language=Z,this.translations=oe}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,z){return(0,m.isEqual)(V.location,z.location)&&V.mtime===z.mtime&&(0,m.isEqual)(V.applicationExtensionslocation,z.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===z.applicationExtensionslocationMtime&&V.profile===z.profile&&V.type===z.type&&V.excludeObsolete===z.excludeObsolete&&V.validate===z.validate&&V.productVersion===z.productVersion&&V.productDate===z.productDate&&V.productCommit===z.productCommit&&V.devMode===z.devMode&&V.language===z.language&&O.equals(V.translations,z.translations)}}let k=class extends w.Disposable{constructor(V,z,j,J,ee){super(),this.obsoleteFile=V,this.extensionsProfileScannerService=z,this.uriIdentityService=j,this.fileService=J,this.logService=ee}async scanExtensions(V){const z=V.profile?await this.scanExtensionsFromProfile(V):await this.scanExtensionsFromLocation(V);let j={};if(V.excludeObsolete&&V.type===1)try{const J=(await this.fileService.readFile(this.obsoleteFile)).value.toString();j=JSON.parse(J)}catch{}return(0,y.isEmptyObject)(j)?z:z.filter(J=>!j[u.ExtensionKey.create(J).toString()])}async scanExtensionsFromLocation(V){const z=await this.fileService.resolve(V.location);if(!z.children?.length)return[];const j=await Promise.all(z.children.map(async J=>{if(!J.isDirectory||V.type===1&&(0,m.basename)(J.resource).indexOf(".")===0)return null;const ee=new F(J.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(ee)}));return(0,D.coalesce)(j).sort((J,ee)=>J.location.path<ee.location.path?-1:1)}async scanExtensionsFromProfile(V){let z=await this.scanExtensionsFromProfileResource(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(V.location,V.applicationExtensionslocation)){z=z.filter(J=>!J.metadata?.isApplicationScoped);const j=await this.scanExtensionsFromProfileResource(V.applicationExtensionslocation,J=>!!J.metadata?.isApplicationScoped,V);z.push(...j)}return z}async scanExtensionsFromProfileResource(V,z,j){const J=await this.extensionsProfileScannerService.scanProfileExtensions(V);if(!J.length)return[];const ee=await Promise.all(J.map(async ce=>{if(z(ce)){const q=new F(ce.location,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension(q,ce.metadata)}return null}));return(0,D.coalesce)(ee)}async scanOneOrMultipleExtensions(V){try{if(await this.fileService.exists((0,m.joinPath)(V.location,"package.json"))){const z=await this.scanExtension(V);return z?[z]:[]}else return await this.scanExtensions(V)}catch(z){return this.logService.error(`Error scanning extensions at ${V.location.path}:`,(0,L.getErrorMessage)(z)),[]}}async scanExtension(V,z){try{let j=await this.scanExtensionManifest(V.location);if(j){j.publisher||(j.publisher=d.UNDEFINED_PUBLISHER),z=z??j.__metadata,delete j.__metadata;const J=(0,u.getGalleryExtensionId)(j.publisher,j.name),ee=z?.id?{id:J,uuid:z.id}:{id:J},ce=z?.isSystem?0:V.type,q=ce===0||!!z?.isBuiltin;j=await this.translateManifest(V.location,j,F.createNlsConfiguration(V));const x={type:ce,identifier:ee,manifest:j,location:V.location,isBuiltin:q,targetPlatform:z?.targetPlatform??"undefined",metadata:z,isValid:!0,validations:[]};return V.validate?this.validate(x,V):x}}catch(j){V.type!==0&&this.logService.error(j)}return null}validate(V,z){let j=!0;const J=(0,n.validateExtensionManifest)(z.productVersion,z.productDate,z.location,V.manifest,V.isBuiltin);for(const[ee,ce]of J)ee===v.default.Error&&(j=!1,this.logService.error(this.formatMessage(z.location,ce)));return V.isValid=j,V.validations=J,V}async scanExtensionManifest(V){const z=(0,m.joinPath)(V,"package.json");let j;try{j=(await this.fileService.readFile(z)).value.toString()}catch(ee){return(0,o.toFileOperationResult)(ee)!==1&&this.logService.error(this.formatMessage(V,(0,p.localize)(0,null,z.path,ee.message))),null}let J;try{J=JSON.parse(j)}catch{const ce=[];(0,P.parse)(j,ce);for(const q of ce)this.logService.error(this.formatMessage(V,(0,p.localize)(1,null,z.path,q.offset,q.length,(0,I.getParseErrorMessage)(q.error))));return null}return(0,P.getNodeType)(J)!=="object"?(this.logService.error(this.formatMessage(V,(0,p.localize)(2,null,z.path))),null):J}async translateManifest(V,z,j){const J=await this.getLocalizedMessages(V,z,j);if(J)try{const ee=[],ce=await this.resolveOriginalMessageBundle(J.default,ee);if(ee.length>0)return ee.forEach(x=>{this.logService.error(this.formatMessage(V,(0,p.localize)(3,null,J.default?.path,(0,I.getParseErrorMessage)(x.error))))}),z;if((0,P.getNodeType)(J)!=="object")return this.logService.error(this.formatMessage(V,(0,p.localize)(4,null,J.default?.path))),z;const q=J.values||Object.create(null);return(0,B.localizeManifest)(z,q,ce)}catch{}return z}async getLocalizedMessages(V,z,j){const J=(0,m.joinPath)(V,"package.nls.json"),ee=(_,M)=>{M.forEach(Y=>{this.logService.error(this.formatMessage(V,(0,p.localize)(5,null,_?.path,(0,I.getParseErrorMessage)(Y.error))))})},ce=_=>{this.logService.error(this.formatMessage(V,(0,p.localize)(6,null,_?.path)))},q=`${z.publisher}.${z.name}`,x=j.translations[q];if(x)try{const _=h.URI.file(x),M=(await this.fileService.readFile(_)).value.toString(),Y=[],H=(0,P.parse)(M,Y);return Y.length>0?(ee(_,Y),{values:void 0,default:J}):(0,P.getNodeType)(H)!=="object"?(ce(_),{values:void 0,default:J}):{values:H.contents?H.contents.package:void 0,default:J}}catch{return{values:void 0,default:J}}else{if(!await this.fileService.exists(J))return;let M;try{M=await this.findMessageBundles(V,j)}catch{return}if(!M.localized)return{values:void 0,default:M.original};try{const Y=(await this.fileService.readFile(M.localized)).value.toString(),H=[],Z=(0,P.parse)(Y,H);return H.length>0?(ee(M.localized,H),{values:void 0,default:M.original}):(0,P.getNodeType)(Z)!=="object"?(ce(M.localized),{values:void 0,default:M.original}):{values:Z,default:M.original}}catch{return{values:void 0,default:M.original}}}}async resolveOriginalMessageBundle(V,z){if(V)try{const j=(await this.fileService.readFile(V)).value.toString();return(0,P.parse)(j,z)}catch{}}findMessageBundles(V,z){return new Promise((j,J)=>{const ee=ce=>{const q=(0,m.joinPath)(V,`package.nls.${ce}.json`);this.fileService.exists(q).then(x=>{x&&j({localized:q,original:(0,m.joinPath)(V,"package.nls.json")});const _=ce.lastIndexOf("-");_===-1?j({localized:(0,m.joinPath)(V,"package.nls.json"),original:null}):(ce=ce.substring(0,_),ee(ce))})};if(z.devMode||z.pseudo||!z.language)return j({localized:(0,m.joinPath)(V,"package.nls.json"),original:null});ee(z.language)})}formatMessage(V,z){return`[${V.path}]: ${z}`}};k=ve([K(1,g.IExtensionsProfileScannerService),K(2,A.IUriIdentityService),K(3,o.IFileService),K(4,r.ILogService)],k);let U=class extends k{constructor(V,z,j,J,ee,ce){super(z,j,J,ee,ce),this.cacheFile=V,this.cacheValidatorThrottler=this._register(new i.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(V){const z=await this.readExtensionCache();if(this.input=V,z&&z.input&&F.equals(z.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),z.result.map(J=>(J.location=h.URI.revive(J.location),J));const j=await super.scanExtensions(V);return await this.writeExtensionCache({input:V,result:j}),j}async readExtensionCache(){try{const V=await this.fileService.readFile(this.cacheFile),z=JSON.parse(V.value.toString());return{result:z.result,input:(0,a.revive)(z.input)}}catch(V){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,L.getErrorMessage)(V))}return null}async writeExtensionCache(V){try{await this.fileService.writeFile(this.cacheFile,T.VSBuffer.fromString(JSON.stringify(V)))}catch(z){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,L.getErrorMessage)(z))}}async validateCache(){if(!this.input)return;const V=await this.readExtensionCache();if(!V)return;const z=V.result,j=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!R.equals(j,z))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(J){this.logService.error(J)}}};U=ve([K(2,g.IExtensionsProfileScannerService),K(3,A.IUriIdentityService),K(4,o.IFileService),K(5,r.ILogService)],U);function $(W,V){const z=(0,u.getExtensionId)(W.manifest.publisher,W.manifest.name);return{id:z,identifier:new d.ExtensionIdentifier(z),isBuiltin:W.type===0,isUserBuiltin:W.type===1&&W.isBuiltin,isUnderDevelopment:V,extensionLocation:W.location,uuid:W.identifier.uuid,targetPlatform:W.targetPlatform,...W.manifest}}e.toExtensionDescription=$;class G extends N{constructor(V,z,j,J,ee,ce,q,x,_,M,Y){super(V,z,(0,m.joinPath)(j,".vscode-oss-dev","extensions","control.json"),(0,m.joinPath)(J,d.MANIFEST_CACHE_FOLDER),ee,ce,q,x,_,M,Y),this.translationsPromise=(async()=>{if(S.translationsConfigFile)try{const H=await this.fileService.readFile(h.URI.file(S.translationsConfigFile));return JSON.parse(H.value.toString())}catch{}return Object.create(null)})()}getTranslations(V){return this.translationsPromise}}e.NativeExtensionsScannerService=G}),define(re[263],se([0,1,50,6,37,3,2,22,12,28,7,18]),function(Q,e,D,i,R,T,L,P,I,w,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let S=class extends L.Disposable{constructor(f,v){super(),this.userDataProfilesService=f,this.logService=v,this.processesLimiter=new i.Limiter(5)}async postUninstall(f){const v=this.parseScript(f,"uninstall");return v&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(v.script,"uninstall",v.args,!0,f).then(()=>this.logService.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${y}`)))),w.Promises.rm(this.getExtensionStoragePath(f)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(f,v){const y=`vscode:${v}`;if(f.location.scheme===P.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[y]=="string"){const h=f.manifest.scripts[y].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${y} should be a node script`),null):{script:(0,I.join)(f.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}runLifecycleHook(f,v,y,h,p){return new Promise((c,u)=>{const d=this.start(f,v,y,p);let n;const o=t=>{n&&(clearTimeout(n),n=null),t?u(t):c(void 0)};d.on("error",t=>{o((0,R.toErrorMessage)(t)||"Unknown")}),d.on("exit",(t,r)=>{o(t?`post-${v} process exited with code ${t}`:void 0)}),h&&(n=setTimeout(()=>{n=null,d.kill(),u("timed out")},5e3))})}start(f,v,y,h){const p={silent:!0,execArgv:void 0},c=(0,D.fork)(f,[`--type=extension-post-${v}`,...y],p);c.stdout.setEncoding("utf8"),c.stderr.setEncoding("utf8");const u=T.Event.fromNodeEventEmitter(c.stdout,"data"),d=T.Event.fromNodeEventEmitter(c.stderr,"data");u(t=>this.logService.info(h.identifier.id,h.manifest.version,`post-${v}`,t)),d(t=>this.logService.error(h.identifier.id,h.manifest.version,`post-${v}`,t));const n=T.Event.any(T.Event.map(u,t=>({data:`%c${t}`,format:[""]})),T.Event.map(d,t=>({data:`%c${t}`,format:["color: red"]})));return T.Event.debounce(n,(t,r)=>t?{data:t.data+r.data,format:[...t.format,...r.format]}:{data:r.data,format:r.format},100)(t=>{console.group(h.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),c}getExtensionStoragePath(f){return(0,I.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};S=ve([K(0,C.IUserDataProfilesService),K(1,b.ILogService)],S),e.ExtensionsLifecycle=S}),define(re[264],se([0,1,8,13,51,77,14,4,7,25,18]),function(Q,e,D,i,R,T,L,P,I,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let C=class extends T.NativeExtensionsScannerService{constructor(m,f,v,y,h,p,c){super(D.URI.file(h.builtinExtensionsPath),D.URI.file(h.extensionsPath),h.userHome,D.URI.file(h.userDataPath),m,f,v,y,h,p,c)}};C=ve([K(0,b.IUserDataProfilesService),K(1,R.IExtensionsProfileScannerService),K(2,L.IFileService),K(3,I.ILogService),K(4,i.INativeEnvironmentService),K(5,w.IProductService),K(6,P.IInstantiationService)],C),e.ExtensionsScannerService=C}),define(re[19],se([0,1,6,3,2,206,15,69,4,18]),function(Q,e,D,i,R,T,L,P,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var b;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var C;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(C=e.StorageScope||(e.StorageScope={}));var S;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(S=e.StorageTarget||(e.StorageTarget={}));function m(p){const c=p.get(e.TARGET_KEY);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.loadKeyTargets=m;class f extends R.Disposable{constructor(c={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super(),this.options=c,this._onDidChangeValue=this._register(new i.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new i.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new i.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(c,u){if(u===e.TARGET_KEY){switch(c){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:c})}else this._onDidChangeValue.fire({scope:c,key:u,target:this.getKeyTargets(c)[u]})}emitWillSaveState(c){this._onWillSaveState.fire({reason:c})}get(c,u,d){return this.getStorage(u)?.get(c,d)}getBoolean(c,u,d){return this.getStorage(u)?.getBoolean(c,d)}getNumber(c,u,d){return this.getStorage(u)?.getNumber(c,d)}store(c,u,d,n){if((0,L.isUndefinedOrNull)(u)){this.remove(c,d);return}this.withPausedEmitters(()=>{this.updateKeyTarget(c,d,n),this.getStorage(d)?.set(c,u)})}remove(c,u){this.withPausedEmitters(()=>{this.updateKeyTarget(c,u,void 0),this.getStorage(u)?.delete(c)})}withPausedEmitters(c){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{c()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(c,u){const d=[],n=this.getKeyTargets(c);for(const o of Object.keys(n))n[o]===u&&d.push(o);return d}updateKeyTarget(c,u,d){const n=this.getKeyTargets(u);typeof d=="number"?n[c]!==d&&(n[c]=d,this.getStorage(u)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[c]=="number"&&(delete n[c],this.getStorage(u)?.set(e.TARGET_KEY,JSON.stringify(n)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(c){switch(c){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(c){const u=this.getStorage(c);return u?m(u):Object.create(null)}isNew(c){return this.getBoolean(e.IS_NEW_KEY,c)===!0}async flush(c=b.NONE){this._onWillSaveState.fire({reason:c});const u=this.getStorage(-1),d=this.getStorage(0),n=this.getStorage(1);switch(c){case b.NONE:await D.Promises.settled([u?.whenFlushed()??Promise.resolve(),d?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await D.Promises.settled([u?.flush(0)??Promise.resolve(),d?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.getStorage(-1)?.items??new Map,u=this.getStorage(0)?.items??new Map,d=this.getStorage(1)?.items??new Map;return h(c,u,d,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(c,u){return this.emitWillSaveState(b.NONE),(0,w.isUserDataProfile)(c)?this.switchToProfile(c,u):this.switchToWorkspace(c,u)}canSwitchProfile(c,u){return!(c.id===u.id||v(u)&&v(c))}switchData(c,u,d,n){this.withPausedEmitters(()=>{if(n)for(const[o,t]of c)u.set(o,t);else{const o=new Set;for(const[t,r]of c)o.add(t),u.get(t)!==r&&this.emitDidChangeValue(d,t);for(const[t]of u.items)o.has(t)||this.emitDidChangeValue(d,t)}})}}e.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;function v(p){return p.isDefault||!!p.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=v;class y extends f{constructor(){super(),this.applicationStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.profileStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(c=>this.emitDidChangeValue(1,c))),this._register(this.profileStorage.onDidChangeStorage(c=>this.emitDidChangeValue(0,c))),this._register(this.applicationStorage.onDidChangeStorage(c=>this.emitDidChangeValue(-1,c)))}getStorage(c){switch(c){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(c){return!1}}e.InMemoryStorageService=y;async function h(p,c,u,d,n,o){const t=O=>{try{return JSON.parse(O)}catch{return O}},r=new Map,s=new Map;p.forEach((O,N)=>{r.set(N,O),s.set(N,t(O))});const l=new Map,a=new Map;c.forEach((O,N)=>{l.set(N,O),a.set(N,t(O))});const g=new Map,E=new Map;u.forEach((O,N)=>{g.set(N,O),E.set(N,t(O))}),console.group(d!==n?`Storage: Application (path: ${d})`:`Storage: Application & Profile (path: ${d}, default profile)`);const A=[];if(r.forEach((O,N)=>{A.push({key:N,value:O})}),console.table(A),console.groupEnd(),console.log(s),d!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const O=[];l.forEach((N,F)=>{O.push({key:F,value:N})}),console.table(O),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const B=[];g.forEach((O,N)=>{B.push({key:N,value:O})}),console.table(B),console.groupEnd(),console.log(E)}e.logStorage=h}),define(re[117],se([0,1,3,2,15,29,33,19]),function(Q,e,D,i,R,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=class extends i.Disposable{constructor(C,S){super(),this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new w(C)),this._register(this.storageManger.onDidChange(m=>this._onDidChangeEnablement.fire({extensions:m,source:"storage"}))),this._register(S.onDidInstallExtensions(m=>m.forEach(({local:f,operation:v})=>{f&&v===4&&this._removeFromDisabledExtensions(f.identifier)})))}async enableExtension(C,S){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:S}),!0):!1}async disableExtension(C,S){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:S}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){const S=this.getDisabledExtensions();return S.every(m=>!(0,L.areSameExtensions)(m,C))?(S.push(C),this._setDisabledExtensions(S),!0):!1}_removeFromDisabledExtensions(C){const S=this.getDisabledExtensions();for(let m=0;m<S.length;m++){const f=S[m];if((0,L.areSameExtensions)(f,C))return S.splice(m,1),this._setDisabledExtensions(S),!0}return!1}_setDisabledExtensions(C){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,S){this.storageManger.set(C,S,0)}};I=ve([K(0,P.IStorageService),K(1,T.IExtensionManagementService)],I),e.GlobalExtensionEnablementService=I;class w extends i.Disposable{constructor(C){super(),this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(S=>this.onDidStorageChange(S)))}get(C,S){let m;return S===0?((0,R.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,S)),m=this.storage[C]):m=this._get(C,S),JSON.parse(m)}set(C,S,m){const f=JSON.stringify(S.map(({id:y,uuid:h})=>({id:y,uuid:h})));this._get(C,m)!==f&&(m===0&&(S.length?this.storage[C]=f:delete this.storage[C]),this._set(C,S.length?f:void 0,m))}onDidStorageChange(C){if(C.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const m=this.get(C.key,C.scope);delete this.storage[C.key];const f=this.get(C.key,C.scope),v=m.filter(h=>!f.some(p=>(0,L.areSameExtensions)(h,p))),y=f.filter(h=>!m.some(p=>(0,L.areSameExtensions)(p,h)));(v.length||y.length)&&this._onDidChange.fire([...v,...y])}}_get(C,S){return this.storageService.get(C,S,"[]")}_set(C,S,m){S?this.storageService.store(C,S,m,1):this.storageService.remove(C,m)}}e.StorageManager=w}),define(re[265],se([0,1,20,24,11,5,36,15,8,16,13,29,33,70,14,7,25,47,235,19,23]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v,y,h,p,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const d=T.isWeb?"web":(0,C.getTargetPlatform)(T.platform,L.arch);var n;(function(_){_[_.None=0]="None",_[_.IncludeVersions=1]="IncludeVersions",_[_.IncludeFiles=2]="IncludeFiles",_[_.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",_[_.IncludeSharedAccounts=8]="IncludeSharedAccounts",_[_.IncludeVersionProperties=16]="IncludeVersionProperties",_[_.ExcludeNonValidated=32]="ExcludeNonValidated",_[_.IncludeInstallationTargets=64]="IncludeInstallationTargets",_[_.IncludeAssetUri=128]="IncludeAssetUri",_[_.IncludeStatistics=256]="IncludeStatistics",_[_.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",_[_.Unpublished=4096]="Unpublished",_[_.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function o(..._){return String(_.reduce((M,Y)=>M|Y,0))}var t;(function(_){_[_.Tag=1]="Tag",_[_.ExtensionId=4]="ExtensionId",_[_.Category=5]="Category",_[_.ExtensionName=7]="ExtensionName",_[_.Target=8]="Target",_[_.Featured=9]="Featured",_[_.SearchText=10]="SearchText",_[_.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class g{constructor(M=a){this.state=M}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(M,Y=this.state.pageSize){return new g({...this.state,pageNumber:M,pageSize:Y})}withFilter(M,...Y){const H=[...this.state.criteria,...Y.length?Y.map(Z=>({filterType:M,value:Z})):[{filterType:M}]];return new g({...this.state,criteria:H})}withSortBy(M){return new g({...this.state,sortBy:M})}withSortOrder(M){return new g({...this.state,sortOrder:M})}withFlags(...M){return new g({...this.state,flags:M.reduce((Y,H)=>Y|H,0)})}withAssetTypes(...M){return new g({...this.state,assetTypes:M})}withSource(M){return new g({...this.state,source:M})}get raw(){const{criteria:M,pageNumber:Y,pageSize:H,sortBy:Z,sortOrder:oe,flags:X,assetTypes:ie}=this.state;return{filters:[{criteria:M,pageNumber:Y,pageSize:H,sortBy:Z,sortOrder:oe}],assetTypes:ie,flags:X}}get searchText(){const M=this.state.criteria.filter(Y=>Y.filterType===t.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(M=>String(M.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function E(_,M){const Y=(_||[]).filter(H=>H.statisticName===M)[0];return Y?Y.value:0}function A(_){const M="Microsoft.VisualStudio.Code.Translation.";return _.files.filter(H=>H.assetType.indexOf(M)===0).reduce((H,Z)=>{const oe=N(_,Z.assetType);return oe&&H.push([Z.assetType.substring(M.length),oe]),H},[])}function B(_){if(_.properties){const M=_.properties.filter(Z=>Z.key===r.Repository),Y=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),H=M.filter(Z=>Y.test(Z.value))[0];return H?{uri:H.value,fallbackUri:H.value}:null}return N(_,r.Repository)}function O(_){return{uri:`${_.fallbackAssetUri}/${r.VSIX}?redirect=true${_.targetPlatform?`&targetPlatform=${_.targetPlatform}`:""}`,fallbackUri:`${_.fallbackAssetUri}/${r.VSIX}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`}}function N(_,M){return _.files.filter(H=>H.assetType===M)[0]?{uri:`${_.assetUri}/${M}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`,fallbackUri:`${_.fallbackAssetUri}/${M}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`}:null}function F(_,M){const Y=_.properties?_.properties.filter(Z=>Z.key===M):[],H=Y.length>0&&Y[0].value;return H?H.split(",").map(Z=>(0,S.adoptToGalleryExtensionId)(Z)):[]}function k(_){const M=_.properties?_.properties.filter(Y=>Y.key===s.Engine):[];return M.length>0&&M[0].value||""}function U(_){const M=_.properties?_.properties.filter(Y=>Y.key===s.PreRelease):[];return M.length>0&&M[0].value==="true"}function $(_){const M=_.properties?_.properties.filter(H=>H.key===s.LocalizedLanguages):[],Y=M.length>0&&M[0].value||"";return Y?Y.split(","):[]}function G(_){return _.properties?.find(M=>M.key===s.SponsorLink)?.value}function W(_){return _.indexOf("preview")!==-1}function V(_){return _.targetPlatform?(0,C.toTargetPlatform)(_.targetPlatform):"undefined"}function z(_){const M=(0,D.distinct)(_.versions.map(V)),Y=!!_.tags?.includes(C.WEB_EXTENSION_TAG),H=M.indexOf("web");return Y?H===-1&&M.push("web"):H!==-1&&M.splice(H,1),M}function j(_,M){const Y=(0,C.getFallbackTargetPlarforms)(M);for(let H=0;H<_.length;H++){const Z=_[H];if(Z.version===_[H-1]?.version){let oe=H;const X=V(Z);if(X===M)for(;oe>0&&_[oe-1].version===Z.version;)oe--;else if(Y.includes(X))for(;oe>0&&_[oe-1].version===Z.version&&V(_[oe-1])!==M;)oe--;oe!==H&&(_.splice(H,1),_.splice(oe,0,Z))}}return _}e.sortExtensionVersions=j;function J(_,M,Y){_.telemetryData={index:M,querySource:Y}}function ee(_,M,Y){const H=_.versions[0],Z={manifest:N(M,r.Manifest),readme:N(M,r.Details),changelog:N(M,r.Changelog),license:N(M,r.License),repository:B(M),download:O(M),icon:N(M,r.Icon),signature:N(M,r.Signature),coreTranslations:A(M)};return{identifier:{id:(0,S.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},name:_.extensionName,version:M.version,displayName:_.displayName,publisherId:_.publisher.publisherId,publisher:_.publisher.publisherName,publisherDisplayName:_.publisher.displayName,publisherDomain:_.publisher.domain?{link:_.publisher.domain,verified:!!_.publisher.isDomainVerified}:void 0,publisherSponsorLink:G(H),description:_.shortDescription||"",installCount:E(_.statistics,"install"),rating:E(_.statistics,"averagerating"),ratingCount:E(_.statistics,"ratingcount"),categories:_.categories||[],tags:_.tags||[],releaseDate:Date.parse(_.releaseDate),lastUpdated:Date.parse(_.lastUpdated),allTargetPlatforms:Y,assets:Z,properties:{dependencies:F(M,s.Dependency),extensionPack:F(M,s.ExtensionPack),engine:k(M),localizedLanguages:$(M),targetPlatform:V(M),isPreReleaseVersion:U(M)},hasPreReleaseVersion:U(H),hasReleaseVersion:!0,preview:W(_.flags),isSigned:!!Z.signature}}let ce=class{constructor(M,Y,H,Z,oe,X,ie,ne){this.requestService=Y,this.logService=H,this.environmentService=Z,this.telemetryService=oe,this.fileService=X,this.productService=ie,this.configurationService=ne;const le=ie.extensionsGallery,ue=le?.servicePPEUrl&&ne.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=ue?le.servicePPEUrl:le?.serviceUrl,this.extensionsGallerySearchUrl=ue?void 0:le?.searchUrl,this.extensionsControlUrl=le?.controlUrl,this.commonHeadersPromise=(0,p.resolveMarketplaceHeaders)(ie.version,ie,this.environmentService,this.configurationService,this.fileService,M,this.telemetryService)}api(M=""){return`${this.extensionsGalleryUrl}${M}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(M,Y,H){const Z=i.CancellationToken.isCancellationToken(Y)?{}:Y,oe=i.CancellationToken.isCancellationToken(Y)?Y:H,X=[],ie=[],ne=[],le=[];let ue=!0;for(const Ee of M){Ee.uuid?ie.push(Ee.uuid):X.push(Ee.id);const Ce=!!(Ee.version||Ee.preRelease);ne.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ce}),Ee.version&&le.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),ue=ue&&!!Ee.hasPreRelease&&!Ce}if(!ie.length&&!X.length)return[];let pe=new g().withPage(1,M.length);ie.length&&(pe=pe.withFilter(t.ExtensionId,...ie)),X.length&&(pe=pe.withFilter(t.ExtensionName,...X)),(Z.queryAllVersions||ue)&&(pe=pe.withFlags(pe.flags,n.IncludeVersions)),Z.source&&(pe=pe.withSource(Z.source));const{extensions:we}=await this.queryGalleryExtensions(pe,{targetPlatform:Z.targetPlatform??d,includePreRelease:ne,versions:le,compatible:!!Z.compatible},oe);return Z.source&&we.forEach((Ee,Ce)=>J(Ee,Ce,Z.source)),we}async getCompatibleExtension(M,Y,H){if((0,C.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,H))return null;if(await this.isExtensionCompatible(M,Y,H))return M;const Z=new g().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,M.identifier.uuid),{extensions:oe}=await this.queryGalleryExtensions(Z,{targetPlatform:H,compatible:!0,includePreRelease:Y},i.CancellationToken.None);return oe[0]||null}async isExtensionCompatible(M,Y,H){if(!(0,C.isTargetPlatformCompatible)(M.properties.targetPlatform,M.allTargetPlatforms,H)||!Y&&M.properties.isPreReleaseVersion)return!1;let Z=M.properties.engine;if(!Z){const oe=await this.getManifest(M,i.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");Z=oe.engines.vscode}return(0,m.isEngineValid)(Z,this.productService.version,this.productService.date)}async isValidVersion(M,Y,H,Z,oe){if(!(0,C.isTargetPlatformCompatible)(V(M),Z,oe)||Y!=="any"&&U(M)!==(Y==="prerelease"))return!1;if(H)try{const X=await this.getEngine(M);if(!(0,m.isEngineValid)(X,this.productService.version,this.productService.date))return!1}catch(X){return this.logService.error(`Error while getting the engine for the version ${M.version}.`,(0,R.getErrorMessage)(X)),!1}return!0}async query(M,Y){let H=M.text||"";const Z=M.pageSize??50;let oe=new g().withPage(1,Z);H?(H=H.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,pe,we)=>(oe=oe.withFilter(t.Category,we||pe),"")),H=H.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,pe,we)=>(oe=oe.withFilter(t.Tag,we||pe),"")),H=H.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(t.Featured),"")),H=H.trim(),H&&(H=H.length<200?H:H.substring(0,200),oe=oe.withFilter(t.SearchText,H)),oe=oe.withSortBy(0)):M.ids?oe=oe.withFilter(t.ExtensionId,...M.ids):M.names?oe=oe.withFilter(t.ExtensionName,...M.names):oe=oe.withSortBy(4),typeof M.sortBy=="number"&&(oe=oe.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(oe=oe.withSortOrder(M.sortOrder)),M.source&&(oe=oe.withSource(M.source));const X=async(ue,pe)=>{const{extensions:we,total:Ee}=await this.queryGalleryExtensions(ue,{targetPlatform:d,compatible:!1,includePreRelease:!!M.includePreRelease},pe);return we.forEach((Ce,_e)=>J(Ce,(ue.pageNumber-1)*ue.pageSize+_e,M.source)),{extensions:we,total:Ee}},{extensions:ie,total:ne}=await X(oe,Y),le=async(ue,pe)=>{if(pe.isCancellationRequested)throw new R.CancellationError;const{extensions:we}=await X(oe.withPage(ue+1),pe);return we};return{firstPage:ie,total:ne,pageSize:oe.pageSize,getPage:le}}async queryGalleryExtensions(M,Y,H){const Z=M.flags;!!(M.flags&n.IncludeLatestVersionOnly)&&!!(M.flags&n.IncludeVersions)&&(M=M.withFlags(M.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(M.flags&n.IncludeLatestVersionOnly)&&!(M.flags&n.IncludeVersions)&&(M=M.withFlags(M.flags,n.IncludeLatestVersionOnly)),Y.versions?.length&&(M=M.withFlags(M.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),M=M.withFlags(M.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:oe,total:X}=await this.queryRawGalleryExtensions(M,H);if(!(M.flags&n.IncludeLatestVersionOnly)){const ue=[];for(const pe of oe){const we=await this.toGalleryExtensionWithCriteria(pe,Y);we&&ue.push(we)}return{extensions:ue,total:X}}const ne=[],le=new Map;for(let ue=0;ue<oe.length;ue++){const pe=oe[ue],we={id:(0,S.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},Ee=(0,P.isBoolean)(Y.includePreRelease)?Y.includePreRelease:!!Y.includePreRelease.find(_e=>(0,S.areSameExtensions)(_e,we))?.includePreRelease;if(Y.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(z(pe),Y.targetPlatform))continue;const Ce=await this.toGalleryExtensionWithCriteria(pe,Y);!Ce||Ce.properties.isPreReleaseVersion&&(!Ee||!Ce.hasReleaseVersion)||!Ce.properties.isPreReleaseVersion&&Ce.properties.targetPlatform!==Y.targetPlatform&&Ce.hasPreReleaseVersion?le.set(pe.extensionId,ue):ne.push([ue,Ce])}if(le.size){const ue=new Date().getTime(),pe=new g().withFlags(Z&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,le.size).withFilter(t.ExtensionId,...le.keys()),{extensions:we}=await this.queryGalleryExtensions(pe,Y,H);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ue,count:le.size});for(const Ee of we){const Ce=le.get(Ee.identifier.uuid);ne.push([Ce,Ee])}}return{extensions:ne.sort((ue,pe)=>ue[0]-pe[0]).map(([,ue])=>ue),total:X}}async toGalleryExtensionWithCriteria(M,Y){const H={id:(0,S.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},Z=Y.versions?.find(ne=>(0,S.areSameExtensions)(ne,H))?.version,oe=(0,P.isBoolean)(Y.includePreRelease)?Y.includePreRelease:!!Y.includePreRelease.find(ne=>(0,S.areSameExtensions)(ne,H))?.includePreRelease,X=z(M),ie=j(M.versions,Y.targetPlatform);if(Y.compatible&&(0,C.isNotWebExtensionInWebTargetPlatform)(X,Y.targetPlatform))return null;for(let ne=0;ne<ie.length;ne++){const le=ie[ne];if(!(Z&&le.version!==Z)){if(await this.isValidVersion(le,oe?"any":"release",Y.compatible,X,Y.targetPlatform))return ee(M,le,X);if(Z&&le.version===Z)return null}}return Z||Y.compatible?null:ee(M,M.versions[0],X)}async queryRawGalleryExtensions(M,Y){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,o(n.Unpublished));const H=await this.commonHeadersPromise,Z=JSON.stringify(M.raw),oe={...H,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},X=new Date().getTime();let ie,ne,le=0;try{if(ie=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&M.criteria.some(pe=>pe.filterType===t.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:Z,headers:oe},Y),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:le};const ue=await(0,h.asJson)(ie);if(ue){const pe=ue.results[0],we=pe.extensions,Ee=pe.resultMetadata&&pe.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return le=Ee&&Ee.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:le}}return{galleryExtensions:[],total:le}}catch(ue){throw ne=ue,ue}finally{this.telemetryService.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(Z.length),duration:new Date().getTime()-X,success:!!ie&&(0,h.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:ne?(0,R.isCancellationError)(ne)?"canceled":(0,R.getErrorMessage)(ne).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(le)})}}async reportStatistic(M,Y,H,Z){if(!this.isEnabled())return;const oe=T.isWeb?this.api(`/itemName/${M}.${Y}/version/${H}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${M}/extensions/${Y}/${H}/stats?statType=${Z}`),X=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ne={...await this.commonHeadersPromise,Accept:X};try{await this.requestService.request({type:"POST",url:oe,headers:ne},i.CancellationToken.None)}catch{}}async download(M,Y,H){this.logService.trace("ExtensionGalleryService#download",M.identifier.id);const Z=(0,S.getGalleryExtensionTelemetryData)(M),oe=new Date().getTime(),X=ue=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Z,duration:ue}),ie=H===2?"install":H===3?"update":"",ne=ie?{uri:`${M.assets.download.uri}${I.URI.parse(M.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${M.assets.download.fallbackUri}${I.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:M.assets.download,le=await this.getAsset(ne);await this.fileService.writeFile(Y,le.stream),X(new Date().getTime()-oe)}async downloadSignatureArchive(M,Y){if(!M.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",M.identifier.id);const H=await this.getAsset(M.assets.signature);await this.fileService.writeFile(Y,H.stream)}async getReadme(M,Y){if(M.assets.readme){const H=await this.getAsset(M.assets.readme,{},Y);return await(0,h.asTextOrError)(H)||""}return""}async getManifest(M,Y){if(M.assets.manifest){const H=await this.getAsset(M.assets.manifest,{},Y),Z=await(0,h.asTextOrError)(H);return Z?JSON.parse(Z):null}return null}async getManifestFromRawExtensionVersion(M,Y){const H=N(M,r.Manifest);if(!H)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},oe=await this.getAsset(H,{headers:Z});return await(0,h.asJson)(oe)}async getCoreTranslation(M,Y){const H=M.assets.coreTranslations.filter(Z=>Z[0]===Y.toUpperCase())[0];if(H){const Z=await this.getAsset(H[1]),oe=await(0,h.asTextOrError)(Z);return oe?JSON.parse(oe):null}return null}async getChangelog(M,Y){if(M.assets.changelog){const H=await this.getAsset(M.assets.changelog,{},Y);return await(0,h.asTextOrError)(H)||""}return""}async getAllCompatibleVersions(M,Y,H){let Z=new g().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?Z=Z.withFilter(t.ExtensionId,M.identifier.uuid):Z=Z.withFilter(t.ExtensionName,M.identifier.id);const{galleryExtensions:oe}=await this.queryRawGalleryExtensions(Z,i.CancellationToken.None);if(!oe.length)return[];const X=z(oe[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(X,H))return[];const ie=[];await Promise.all(oe[0].versions.map(async ue=>{try{await this.isValidVersion(ue,Y?"any":"release",!0,X,H)&&ie.push(ue)}catch{}}));const ne=[],le=new Set;for(const ue of j(ie,H))le.has(ue.version)||(le.add(ue.version),ne.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:U(ue)}));return ne}async getAsset(M,Y={},H=i.CancellationToken.None){const Z=await this.commonHeadersPromise,oe={type:"GET"},X={...Z,...Y.headers||{}};Y={...Y,...oe,headers:X};const ie=M.uri,ne=M.fallbackUri,le={...Y,url:ie};try{const ue=await this.requestService.request(le,H);if(ue.res.statusCode===200)return ue;const pe=await(0,h.asTextOrError)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${pe}`)}catch(ue){if((0,R.isCancellationError)(ue))throw ue;const pe=(0,R.getErrorMessage)(ue);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:pe});const we={...Y,url:ne};return this.requestService.request(we,H)}}async getEngine(M){let Y=k(M);if(!Y){const H=await this.getManifestFromRawExtensionVersion(M,i.CancellationToken.None);if(!H)throw new Error("Manifest was not found");Y=H.engines.vscode}return Y}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const M=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},i.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const Y=await(0,h.asJson)(M),H=[],Z={};if(Y){for(const oe of Y.malicious)H.push({id:oe});if(Y.migrateToPreRelease)for(const[oe,X]of Object.entries(Y.migrateToPreRelease))(!X.engine||(0,m.isEngineValid)(X.engine,this.productService.version,this.productService.date))&&(Z[oe.toLowerCase()]={disallowInstall:!0,extension:{id:X.id,displayName:X.displayName,autoMigrate:{storage:!!X.migrateStorage},preRelease:!0}});if(Y.deprecated)for(const[oe,X]of Object.entries(Y.deprecated))X&&(Z[oe.toLowerCase()]=(0,P.isBoolean)(X)?{}:X)}return{malicious:H,deprecated:Z}}};ce=ve([K(1,h.IRequestService),K(2,v.ILogService),K(3,b.IEnvironmentService),K(4,u.ITelemetryService),K(5,f.IFileService),K(6,y.IProductService),K(7,w.IConfigurationService)],ce);let q=class extends ce{constructor(M,Y,H,Z,oe,X,ie,ne){super(M,Y,H,Z,oe,X,ie,ne)}};q=ve([K(0,c.IStorageService),K(1,h.IRequestService),K(2,v.ILogService),K(3,b.IEnvironmentService),K(4,u.ITelemetryService),K(5,f.IFileService),K(6,y.IProductService),K(7,w.IConfigurationService)],q),e.ExtensionGalleryService=q;let x=class extends ce{constructor(M,Y,H,Z,oe,X,ie){super(void 0,M,Y,H,Z,oe,X,ie)}};x=ve([K(0,h.IRequestService),K(1,v.ILogService),K(2,b.IEnvironmentService),K(3,u.ITelemetryService),K(4,f.IFileService),K(5,y.IProductService),K(6,w.IConfigurationService)],x),e.ExtensionGalleryServiceWithNoStorageService=x}),define(re[78],se([0,1,4,3,2,19,33,25,20,7,15]),function(Q,e,D,i,R,T,L,P,I,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const C=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let S=class Ze extends R.Disposable{static toKey(f){return`extensionKeys/${(0,L.adoptToGalleryExtensionId)(f.id)}@${f.version}`}static fromKey(f){const v=C.exec(f);if(v&&v[1])return{id:v[1],version:v[2]}}static async removeOutdatedExtensionVersions(f,v){const y=await f.getInstalled(),h=[];for(const[p,c]of Ze.readAllExtensionsWithKeysForSync(v)){const u=y.find(d=>(0,L.areSameExtensions)(d.identifier,{id:p}))?.manifest.version;for(const d of c)u!==d&&h.push(Ze.toKey({id:p,version:d}))}for(const p of h)v.remove(p,0)}static readAllExtensionsWithKeysForSync(f){const v=new Map,y=f.keys(0,1);for(const h of y){const p=Ze.fromKey(h);if(p){let c=v.get(p.id.toLowerCase());c||v.set(p.id.toLowerCase(),c=[]),c.push(p.version)}}return v}constructor(f,v,y){super(),this.storageService=f,this.productService=v,this.logService=y,this._onDidChangeExtensionStorageToSync=this._register(new i.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Ze.readAllExtensionsWithKeysForSync(f),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}onDidChangeStorageValue(f){if(f.scope!==0)return;if(this.extensionsWithKeysForSync.has(f.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const v=Ze.fromKey(f.key);if(v){if(this.storageService.get(f.key,0)===void 0)this.extensionsWithKeysForSync.delete(v.id.toLowerCase());else{let y=this.extensionsWithKeysForSync.get(v.id.toLowerCase());y||this.extensionsWithKeysForSync.set(v.id.toLowerCase(),y=[]),y.push(v.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(f){if((0,b.isString)(f))return f;const v=f.manifest?f.manifest.publisher:f.publisher,y=f.manifest?f.manifest.name:f.name;return(0,L.getExtensionId)(v,y)}getExtensionState(f,v){const y=this.getExtensionId(f),h=this.storageService.get(y,v?0:1);if(h)try{return JSON.parse(h)}catch(p){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${v}): ${p}`)}}setExtensionState(f,v,y){const h=this.getExtensionId(f);v===void 0?this.storageService.remove(h,y?0:1):this.storageService.store(h,JSON.stringify(v),y?0:1,1)}setKeysForSync(f,v){this.storageService.store(Ze.toKey(f),JSON.stringify(v),0,1)}getKeysForSync(f){const v=this.productService.extensionSyncedKeys?.[f.id.toLowerCase()],y=this.storageService.get(Ze.toKey(f),0),h=y?JSON.parse(y):void 0;return h&&v?(0,I.distinct)([...h,...v]):h||v}addToMigrationList(f,v){if(f!==v){const y=this.migrationList.filter(h=>!h.includes(f)&&!h.includes(v));y.push([f,v]),this.migrationList=y}}getSourceExtensionToMigrate(f){const v=this.migrationList.find(([,y])=>f===y);return v?v[0]:void 0}get migrationList(){const f=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const v=JSON.parse(f);if(Array.isArray(v))return v}catch{}return[]}set migrationList(f){f.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(f),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};S=ve([K(0,T.IStorageService),K(1,P.IProductService),K(2,w.ILogService)],S),e.ExtensionStorageService=S}),define(re[266],se([0,1,20,6,3,12,5,36,8,159,13,29,33,225,98,14,7,59,25,47,19,23]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v,y,h,p,c,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const n="extensionTips/promptedExecutableTips",o="extensionTips/lastPromptedMediumImpExeTime";let t=class extends m.ExtensionTipsService{constructor(s,l,a,g,E,A,B,O,N,F){super(B,O,N,F),this.environmentService=s,this.telemetryService=l,this.extensionManagementService=a,this.storageService=g,this.nativeHostService=E,this.extensionRecommendationNotificationService=A,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&Object.entries(O.exeBasedExtensionTips).forEach(([k,U])=>{const $=[],G=[],W=[];Object.entries(U.recommendations).forEach(([V,z])=>{z.important?U.important?$.push({extensionId:V,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):G.push({extensionId:V,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):W.push({extensionId:V,extensionName:z.name,isExtensionPack:!!z.isExtensionPack})}),$.length&&this.highImportanceExecutableTips.set(k,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:$}),G.length&&this.mediumImportanceExecutableTips.set(k,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:G}),W.length&&this.allOtherExecutableTips.set(k,{exeFriendlyName:U.friendlyName,windowsPath:U.windowsPath,recommendations:W})}),(0,i.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),a=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,a),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,a)}groupImportantTipsByExe(s,l){const a=new Map;s.forEach(O=>a.set(O.extensionId.toLowerCase(),O));const{installed:g,uninstalled:E}=this.groupByInstalled([...a.keys()],l);for(const O of g){const N=a.get(O);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:N.exeName})}for(const O of E){const N=a.get(O);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:N.exeName})}const A=this.getPromptedExecutableTips(),B=new Map;for(const O of E){const N=a.get(O);if(N&&(!A[N.exeName]||!A[N.exeName].includes(N.extensionId))){let F=B.get(N.exeName);F||(F=[],B.set(N.exeName,F)),F.push(N)}}return B}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(a=>{switch(a){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":{const g=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(g(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const g=this._register((0,i.disposableTimeout)(()=>{g.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),l=Date.now()-s,a=7*24*60*60*1e3;if(l<a){const A=this._register((0,i.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},a-l));return}const[g,E]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(E).then(A=>{switch(A){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(g),this.addToRecommendedExecutables(E[0].exeName,E);const B=this._register((0,i.disposableTimeout)(()=>{B.dispose(),this.promptMediumImportanceExeBasedTip()},a));break}case"ignored":this.mediumImportanceTipsByExe.delete(g),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const B=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(B(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const B=this._register((0,i.disposableTimeout)(()=>{B.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(s){const l=await this.extensionManagementService.getInstalled(1),a=s.filter(E=>!E.whenNotInstalled||E.whenNotInstalled.every(A=>l.every(B=>!(0,S.areSameExtensions)(B.identifier,{id:A})))).map(({extensionId:E})=>E.toLowerCase()),g=(0,w.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(a,g,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(o,-1);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(o,s,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(n,-1,"{}"))}addToRecommendedExecutables(s,l){const a=this.getPromptedExecutableTips();a[s]=l.map(({extensionId:g})=>g.toLowerCase()),this.storageService.store(n,JSON.stringify(a),-1,0)}groupByInstalled(s,l){const a=[],g=[],E=l.reduce((A,B)=>(A.add(B.identifier.id.toLowerCase()),A),new Set);return s.forEach(A=>{E.has(A.toLowerCase())?a.push(A):g.push(A)}),{installed:a,uninstalled:g}}async getValidExecutableBasedExtensionTips(s){const l=[],a=new Map;for(const g of s.keys()){const E=s.get(g);if(!E||!(0,D.isNonEmptyArray)(E.recommendations))continue;const A=[];L.isWindows?E.windowsPath&&A.push(E.windowsPath.replace("%USERPROFILE%",P.env.USERPROFILE).replace("%ProgramFiles(x86)%",P.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",P.env.ProgramFiles).replace("%APPDATA%",P.env.APPDATA).replace("%WINDIR%",P.env.WINDIR)):(A.push((0,T.join)("/usr/local/bin",g)),A.push((0,T.join)("/usr/bin",g)),A.push((0,T.join)(this.environmentService.userHome.fsPath,g)));for(const B of A){let O=a.get(B);if(O===void 0&&(O=await this.fileService.exists(I.URI.file(B)),a.set(B,O)),O)for(const{extensionId:N,extensionName:F,isExtensionPack:k,whenNotInstalled:U}of E.recommendations)l.push({extensionId:N,extensionName:F,isExtensionPack:k,exeName:g,exeFriendlyName:E.exeFriendlyName,windowsPath:E.windowsPath,whenNotInstalled:U})}}return l}};t=ve([K(0,b.INativeEnvironmentService),K(1,d.ITelemetryService),K(2,C.IExtensionManagementService),K(3,u.IStorageService),K(4,h.INativeHostService),K(5,f.IExtensionRecommendationNotificationService),K(6,v.IFileService),K(7,p.IProductService),K(8,c.IRequestService),K(9,y.ILogService)],t),e.ExtensionTipsService=t}),define(re[267],se([0,1,6,2,21,69,19,74,18]),function(Q,e,D,i,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class w extends L.AbstractStorageService{constructor(C,S,m,f){super(),this.initialWorkspace=C,this.initialProfiles=S,this.mainProcessService=m,this.environmentService=f,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new i.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new i.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const C=this._register(new P.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),S=this._register(new T.Storage(C));return this._register(S.onDidChangeStorage(m=>this.emitDidChangeValue(-1,m))),S}createProfileStorage(C){this.profileStorageDisposables.clear(),this.profileStorageProfile=C;let S;if((0,L.isProfileUsingDefaultStorage)(C))S=this.applicationStorage;else{const m=this.profileStorageDisposables.add(new P.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),C));S=this.profileStorageDisposables.add(new T.Storage(m))}return this.profileStorageDisposables.add(S.onDidChangeStorage(m=>this.emitDidChangeValue(0,m))),S}createWorkspaceStorage(C){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=C?.id;let S;if(C){const m=this.workspaceStorageDisposables.add(new P.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),C));S=this.workspaceStorageDisposables.add(new T.Storage(m)),this.workspaceStorageDisposables.add(S.onDidChangeStorage(f=>this.emitDidChangeValue(1,f)))}return S}async doInitialize(){await D.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(C){switch(C){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(C){switch(C){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,R.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(L.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(C,S){if(!this.canSwitchProfile(this.profileStorageProfile,C))return;const m=this.profileStorage,f=m.items;m!==this.applicationStorage&&await m.close(),this.profileStorage=this.createProfileStorage(C),await this.profileStorage.init(),this.switchData(f,this.profileStorage,0,S)}async switchToWorkspace(C,S){const m=this.workspaceStorage,f=m?.items??new Map;await m?.close(),this.workspaceStorage=this.createWorkspaceStorage(C),await this.workspaceStorage.init(),this.switchData(f,this.workspaceStorage,1,S)}hasScope(C){return(0,I.isUserDataProfile)(C)?this.profileStorageProfile.id===C.id:this.workspaceStorageId===C.id}}e.NativeStorageService=w}),define(re[268],se([0,1,3,2,21,13,58,18]),function(Q,e,D,i,R,T,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let I=class extends i.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(b,C,S){super(),this._profiles=[],this._onDidChangeProfiles=this._register(new D.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this.channel=C.getChannel("userDataProfiles"),this.profilesHome=(0,R.joinPath)(S.userRoamingDataHome,"profiles"),this._profiles=b.map(m=>(0,P.reviveProfile)(m,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(m=>{const f=m.added.map(h=>(0,P.reviveProfile)(h,this.profilesHome.scheme)),v=m.removed.map(h=>(0,P.reviveProfile)(h,this.profilesHome.scheme)),y=m.updated.map(h=>(0,P.reviveProfile)(h,this.profilesHome.scheme));this._profiles=m.all.map(h=>(0,P.reviveProfile)(h,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:f,removed:v,updated:y,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(b){this.enabled=b}isEnabled(){return this.enabled}async createNamedProfile(b,C,S){const m=await this.channel.call("createNamedProfile",[b,C,S]);return(0,P.reviveProfile)(m,this.profilesHome.scheme)}async createProfile(b,C,S,m){const f=await this.channel.call("createProfile",[b,C,S,m]);return(0,P.reviveProfile)(f,this.profilesHome.scheme)}async createTransientProfile(b){const C=await this.channel.call("createTransientProfile",[b]);return(0,P.reviveProfile)(C,this.profilesHome.scheme)}async setProfileForWorkspace(b,C){await this.channel.call("setProfileForWorkspace",[b,C])}removeProfile(b){return this.channel.call("removeProfile",[b])}async updateProfile(b,C){const S=await this.channel.call("updateProfile",[b,C]);return(0,P.reviveProfile)(S,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}};I=ve([K(1,L.IMainProcessService),K(2,T.IEnvironmentService)],I),e.UserDataProfilesNativeService=I}),define(re[40],se([0,1,20,6,17,24,3,35,2,27,15,175,16,13,14,7,44,19,23,30,26,18]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v,y,h,p,c,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=void 0;function n(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&(Object.keys(a).length===2||Object.keys(a).length===3&&a.machineId!==void 0&&typeof a.machineId=="string"))}e.isSyncData=n;function o(a,g){return`${(0,w.uppercaseFirstLetter)(a)}${g.isDefault?"":` (${g.name})`}`}e.getSyncResourceLogLabel=o;let t=class extends I.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(g,E,A,B,O,N,F,k,U,$,G,W){super(),this.syncResource=g,this.collection=E,this.fileService=A,this.environmentService=B,this.userDataSyncStoreService=N,this.userDataSyncBackupStoreService=F,this.userDataSyncEnablementService=k,this.telemetryService=U,this.logService=$,this.configurationService=G,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new i.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=o(g.syncResource,g.profile),this.extUri=W.extUri,this.syncFolder=this.extUri.joinPath(B.userDataSyncHome,...(0,u.getPathSegments)(g.profile.isDefault?void 0:g.profile.id,g.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,u.PREVIEW_DIR_NAME),this.lastSyncResource=(0,u.getLastSyncResourceUri)(g.profile.isDefault?void 0:g.profile.id,g.syncResource,B,this.extUri),this.currentMachineIdPromise=(0,y.getServiceMachineId)(B,A,O)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const g=await this.syncPreviewPromise;this.syncPreviewPromise=null;const E=await this.performSync(g.remoteUserData,g.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(E)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const g=await this.getLastSyncUserData();(g?await this.hasRemoteChanged(g):!0)&&this._onDidChangeLocal.fire()}}setStatus(g){this._status!==g&&(this._status=g,this._onDidChangStatus.fire(g))}async sync(g,E={}){await this._sync(g,!0,this.getUserDataSyncConfiguration(),E)}async preview(g,E,A={}){return this._sync(g,!1,E,A)}async apply(g,E={}){try{this.syncHeaders={...E};const A=await this.doApply(g);return this.setStatus(A),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(g,E,A,B){try{if(this.syncHeaders={...B},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let O="idle";try{const N=await this.getLastSyncUserData(),F=await this.getLatestRemoteUserData(g,N);return O=await this.performSync(F,N,E,A),O==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):O==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(O)}}finally{this.syncHeaders={}}}async replace(g){const E=this.parseSyncData(g);if(!E)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const A=await this.getLastSyncUserData(),B=await this.getLatestRemoteUserData(null,A),O=await this.isRemoteDataFromCurrentMachine(B),N=await this.generateSyncPreview({ref:B.ref,syncData:E},A,O,this.getUserDataSyncConfiguration(),T.CancellationToken.None),F=[];for(const k of N){const U=await this.getAcceptResult(k,k.remoteResource,void 0,T.CancellationToken.None),{remoteChange:$}=await this.getAcceptResult(k,k.previewResource,k.remoteContent,T.CancellationToken.None);F.push([k,{...U,remoteChange:$!==0?$:2}])}await this.applyResult(B,A,F,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(g){const E=await this.currentMachineIdPromise;return!!g.syncData?.machineId&&g.syncData.machineId===E}async getLatestRemoteUserData(g,E){if(E){const A=g?g[this.resource]:void 0;if(E.ref===A||A===void 0&&E.syncData===null)return E}return this.getRemoteUserData(E)}async performSync(g,E,A,B){if(g.syncData&&g.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new u.UserDataSyncError((0,C.localize)(0,null,this.resource,this.version,g.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(g,E,A,B)}catch(O){if(O instanceof u.UserDataSyncError)switch(O.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(g,E,A,B);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),g=await this.getRemoteUserData(null),E=await this.getLastSyncUserData(),this.performSync(g,E,A,B)}throw O}}async doSync(g,E,A,B){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,i.createCancelablePromise)(N=>this.doGenerateSyncResourcePreview(g,E,A,B,N)));const O=await this.syncPreviewPromise;return this.updateConflicts(O.resourcePreviews),O.resourcePreviews.some(({mergeState:N})=>N==="conflict")?"hasConflicts":A?await this.doApply(!1):"syncing"}catch(O){throw this.syncPreviewPromise=null,O}}async merge(g){return await this.updateSyncResourcePreview(g,async E=>{const A=await this.getMergeResult(E,T.CancellationToken.None);await this.fileService.writeFile(E.previewResource,R.VSBuffer.fromString(A?.content||""));const B=A&&!A.hasConflicts?await this.getAcceptResult(E,E.previewResource,void 0,T.CancellationToken.None):void 0;return E.acceptResult=B,E.mergeState=A.hasConflicts?"conflict":B?"accepted":"preview",E.localChange=B?B.localChange:A.localChange,E.remoteChange=B?B.remoteChange:A.remoteChange,E}),this.syncPreviewPromise}async accept(g,E){return await this.updateSyncResourcePreview(g,async A=>{const B=await this.getAcceptResult(A,g,E,T.CancellationToken.None);return A.acceptResult=B,A.mergeState="accepted",A.localChange=B.localChange,A.remoteChange=B.remoteChange,A}),this.syncPreviewPromise}async discard(g){return await this.updateSyncResourcePreview(g,async E=>{const A=await this.getMergeResult(E,T.CancellationToken.None);return await this.fileService.writeFile(E.previewResource,R.VSBuffer.fromString(A.content||"")),E.acceptResult=void 0,E.mergeState="preview",E.localChange=A.localChange,E.remoteChange=A.remoteChange,E}),this.syncPreviewPromise}async updateSyncResourcePreview(g,E){if(!this.syncPreviewPromise)return;let A=await this.syncPreviewPromise;const B=A.resourcePreviews.findIndex(({localResource:O,remoteResource:N,previewResource:F})=>this.extUri.isEqual(O,g)||this.extUri.isEqual(N,g)||this.extUri.isEqual(F,g));B!==-1&&(this.syncPreviewPromise=(0,i.createCancelablePromise)(async O=>{const N=[...A.resourcePreviews];return N[B]=await E(N[B]),{...A,resourcePreviews:N}}),A=await this.syncPreviewPromise,this.updateConflicts(A.resourcePreviews),A.resourcePreviews.some(({mergeState:O})=>O==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(g){if(!this.syncPreviewPromise)return"idle";const E=await this.syncPreviewPromise;return E.resourcePreviews.some(({mergeState:A})=>A==="conflict")?"hasConflicts":E.resourcePreviews.some(({mergeState:A})=>A!=="accepted")?"syncing":(await this.applyResult(E.remoteUserData,E.lastSyncUserData,E.resourcePreviews.map(A=>[A,A.acceptResult]),g),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(g){const E=g.filter(({mergeState:A})=>A==="conflict");(0,D.equals)(this._conflicts,E,(A,B)=>this.extUri.isEqual(A.previewResource,B.previewResource))||(this._conflicts=E,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const g=await this.getLastSyncUserData();return!!g&&g.syncData!==null}async resolvePreviewContent(g){const E=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(E)for(const A of E.resourcePreviews){if(this.extUri.isEqual(A.acceptedResource,g))return A.acceptResult?A.acceptResult.content:null;if(this.extUri.isEqual(A.remoteResource,g))return A.remoteContent;if(this.extUri.isEqual(A.localResource,g))return A.localContent;if(this.extUri.isEqual(A.baseResource,g))return A.baseContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(g,E,A,B,O){const N=await this.isRemoteDataFromCurrentMachine(g),F=await this.generateSyncPreview(g,E,N,B,O),k=[];for(const U of F){const $=U.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(U.localChange===0&&U.remoteChange===0)k.push({...U,acceptedResource:$,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const G=A?await this.getMergeResult(U,O):void 0;if(O.isCancellationRequested)break;await this.fileService.writeFile(U.previewResource,R.VSBuffer.fromString(G?.content||""));const W=G&&!G.hasConflicts?await this.getAcceptResult(U,U.previewResource,void 0,O):void 0;k.push({...U,acceptResult:W,mergeState:G?.hasConflicts?"conflict":W?"accepted":"preview",localChange:W?W.localChange:G?G.localChange:U.localChange,remoteChange:W?W.remoteChange:G?G.remoteChange:U.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:g,lastSyncUserData:E,resourcePreviews:k,isLastSyncFromCurrentMachine:N}}async getLastSyncUserData(){try{const g=await this.fileService.readFile(this.lastSyncResource),E=JSON.parse(g.value.toString()),A=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=E.version&&A&&E.version!==A,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${E.version} is not compatible with current sync state version ${A}.`),await this.resetLocal(),null;const B=E;if(B.content===null)return{ref:E.ref,syncData:null};const O=JSON.parse(B.content);if(n(O))return{...E,syncData:O,content:void 0}}catch(g){g instanceof f.FileOperationError&&g.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Not synced yet. Last sync resource does not exist.`):this.logService.error(g)}return null}async updateLastSyncUserData(g,E={}){if(E.ref||E.content||E.version)throw new Error("Cannot have core properties as additional");const A=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),B={ref:g.ref,content:g.syncData?JSON.stringify(g.syncData):null,version:A,...E};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(B)))}async getRemoteUserData(g){const{ref:E,content:A}=await this.getUserData(g);let B=null;return A!==null&&(B=this.parseSyncData(A)),{ref:E,syncData:B}}parseSyncData(g){try{const E=JSON.parse(g);if(n(E))return E}catch(E){this.logService.error(E)}throw new u.UserDataSyncError((0,C.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(g){const E=g?{ref:g.ref,content:g.syncData?JSON.stringify(g.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,E,this.collection,this.syncHeaders)}async updateRemoteUserData(g,E){const A=await this.currentMachineIdPromise,B={version:this.version,machineId:A,content:g};try{return E=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(B),E,this.collection,this.syncHeaders),{ref:E,syncData:B}}catch(O){throw O instanceof u.UserDataSyncError&&O.code==="TooLarge"&&(O=new u.UserDataSyncError(O.message,O.code,this.resource)),O}}async backupLocal(g){const E={version:this.version,content:g};return this.userDataSyncBackupStoreService.backup(this.syncResource.profile,this.resource,JSON.stringify(E))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=ve([K(2,f.IFileService),K(3,m.IEnvironmentService),K(4,h.IStorageService),K(5,u.IUserDataSyncStoreService),K(6,u.IUserDataSyncBackupStoreService),K(7,u.IUserDataSyncEnablementService),K(8,p.ITelemetryService),K(9,u.IUserDataSyncLogService),K(10,S.IConfigurationService),K(11,c.IUriIdentityService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(g,E,A,B,O,N,F,k,U,$,G,W,V){super(E,A,B,O,N,F,k,U,$,G,W,V),this.file=g,this._register(this.fileService.watch(this.extUri.dirname(g))),this._register(this.fileService.onDidFilesChange(z=>this.onFileChanges(z)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(g,E,A){try{E?await this.fileService.writeFile(this.file,R.VSBuffer.fromString(g),A?void 0:E):await this.fileService.createFile(this.file,R.VSBuffer.fromString(g),{overwrite:A})}catch(B){throw B instanceof f.FileOperationError&&B.fileOperationResult===1||B instanceof f.FileOperationError&&B.fileOperationResult===3?new u.UserDataSyncError(B.message,"LocalPreconditionFailed"):B}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(g){if(!(g instanceof f.FileOperationError&&g.fileOperationResult===1))throw g}}onFileChanges(g){!g.contains(this.file)||this.triggerLocalChange()}};r=ve([K(3,f.IFileService),K(4,m.IEnvironmentService),K(5,h.IStorageService),K(6,u.IUserDataSyncStoreService),K(7,u.IUserDataSyncBackupStoreService),K(8,u.IUserDataSyncEnablementService),K(9,p.ITelemetryService),K(10,u.IUserDataSyncLogService),K(11,S.IConfigurationService),K(12,c.IUriIdentityService)],r),e.AbstractFileSynchroniser=r;let s=class extends r{constructor(g,E,A,B,O,N,F,k,U,$,G,W,V,z){super(g,E,A,B,O,N,F,k,U,$,G,V,z),this.userDataSyncUtilService=W,this._formattingOptions=void 0}hasErrors(g,E){const A=[],B=(0,P.parse)(g,A,{allowEmptyContent:!0,allowTrailingComma:!0});return A.length>0||!(0,b.isUndefined)(B)&&E!==Array.isArray(B)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};s=ve([K(3,f.IFileService),K(4,m.IEnvironmentService),K(5,h.IStorageService),K(6,u.IUserDataSyncStoreService),K(7,u.IUserDataSyncBackupStoreService),K(8,u.IUserDataSyncEnablementService),K(9,p.ITelemetryService),K(10,u.IUserDataSyncLogService),K(11,u.IUserDataSyncUtilService),K(12,S.IConfigurationService),K(13,c.IUriIdentityService)],s),e.AbstractJsonFileSynchroniser=s;let l=class{constructor(g,E,A,B,O,N){this.resource=g,this.userDataProfilesService=E,this.environmentService=A,this.logService=B,this.fileService=O,this.extUri=N.extUri,this.lastSyncResource=(0,u.getLastSyncResourceUri)(void 0,this.resource,A,this.extUri)}async initialize({ref:g,content:E}){if(!E){this.logService.info("Remote content does not exist.",this.resource);return}const A=this.parseSyncData(E);if(!!A)try{await this.doInitialize({ref:g,syncData:A})}catch(B){this.logService.error(B)}}parseSyncData(g){try{const E=JSON.parse(g);if(n(E))return E}catch(E){this.logService.error(E)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(g,E={}){const A={ref:g.ref,content:g.syncData?JSON.stringify(g.syncData):null,...E};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(A)))}};l=ve([K(1,d.IUserDataProfilesService),K(2,m.IEnvironmentService),K(3,v.ILogService),K(4,f.IFileService),K(5,c.IUriIdentityService)],l),e.AbstractInitializer=l}),define(re[118],se([0,1,20,17,3,35,5,15,176,16,13,14,19,23,30,18,40,253,26]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v,y,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function c(n,o,t){try{const r=JSON.parse(n);if(!o)return(0,P.isUndefined)(r.all)?null:r.all;switch(L.OS){case 2:return(0,P.isUndefined)(r.mac)?null:r.mac;case 3:return(0,P.isUndefined)(r.linux)?null:r.linux;case 1:return(0,P.isUndefined)(r.windows)?null:r.windows}}catch(r){return t.error(r),null}}e.getKeybindingsContentFromSyncContent=c;let u=class extends y.AbstractJsonFileSynchroniser{constructor(o,t,r,s,l,a,g,E,A,B,O,N,F){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},t,E,A,B,r,s,g,N,l,O,a,F),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.filter(a.onDidChangeConfiguration,k=>k.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(o,t,r,s){const l=o.syncData?c(o.syncData.content,s.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&r?o:t;const a=t?this.getKeybindingsContentFromLastSyncUserData(t):null,g=await this.getLocalFileContent(),E=await this.getFormattingOptions();let A=null,B=!1,O=!1,N=!1;if(l){let U=g?g.value.toString():"[]";if(U=U||"[]",this.hasErrors(U,!0))throw new p.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==U||a!==l){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const $=await(0,h.merge)(U,l,a,E,this.userDataSyncUtilService);$.hasChanges&&(A=$.mergeContent,N=$.hasConflicts,B=N||$.mergeContent!==U,O=N||$.mergeContent!==l)}}else g&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),A=g.value.toString(),O=!0);const F={content:N?a:A,localChange:B?g?2:1:0,remoteChange:O?2:0,hasConflicts:N},k=g?g.value.toString():null;return[{fileContent:g,baseResource:this.baseResource,baseContent:a,localResource:this.localResource,localContent:k,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:l,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const t=this.getKeybindingsContentFromLastSyncUserData(o);if(t===null)return!0;const r=await this.getLocalFileContent(),s=r?r.value.toString():"",l=await this.getFormattingOptions(),a=await(0,h.merge)(s||"[]",t,t,l,this.userDataSyncUtilService);return a.hasConflicts||a.mergeContent!==t}async getMergeResult(o,t){return o.previewResult}async getAcceptResult(o,t,r,s){if(this.extUri.isEqual(t,this.localResource))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(o,t,r,s){const{fileContent:l}=r[0][0];let{content:a,localChange:g,remoteChange:E}=r[0][1];if(g===0&&E===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a,!0)))throw new p.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(g!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),l&&await this.backupLocal(this.toSyncContent(l.value.toString())),await this.updateLocalFileContent(a||"[]",l,s),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),E!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const A=this.toSyncContent(a||"[]",o.syncData?.content);o=await this.updateRemoteUserData(A,s?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(o,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const t=(0,T.parse)(o.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.baseResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)?this.resolvePreviewContent(o):null}getKeybindingsContentFromLastSyncUserData(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.syncKeybindingsPerPlatform()?null:c(o.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(o,t){let r={};try{r=JSON.parse(t||"{}")}catch(s){this.logService.error(s)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=o,L.OS){case 2:r.mac=o;break;case 3:r.linux=o;break;case 1:r.windows=o;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(p.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};u=ve([K(2,p.IUserDataSyncStoreService),K(3,p.IUserDataSyncBackupStoreService),K(4,p.IUserDataSyncLogService),K(5,w.IConfigurationService),K(6,p.IUserDataSyncEnablementService),K(7,C.IFileService),K(8,b.IEnvironmentService),K(9,S.IStorageService),K(10,p.IUserDataSyncUtilService),K(11,m.ITelemetryService),K(12,f.IUriIdentityService)],u),e.KeybindingsSynchroniser=u;let d=class extends y.AbstractInitializer{constructor(o,t,r,s,l){super("keybindings",t,r,s,o,l)}async doInitialize(o){const t=o.syncData?this.getKeybindingsContentFromSyncContent(o.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,i.VSBuffer.fromString(t)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),t=(0,T.parse)(o.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(o){return o.fileOperationResult===1}}getKeybindingsContentFromSyncContent(o){try{return c(o,!0,this.logService)}catch(t){return this.logService.error(t),null}}};d=ve([K(0,C.IFileService),K(1,v.IUserDataProfilesService),K(2,b.IEnvironmentService),K(3,p.IUserDataSyncLogService),K(4,f.IUriIdentityService)],d),e.KeybindingsInitializer=d}),define(re[119],se([0,1,17,3,177,16,73,13,29,14,19,23,30,18,40,61,257,26]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function p(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function c(n){const o=JSON.parse(n);return p(o)?o:{settings:n}}e.parseSettingsSyncContent=c;let u=class extends f.AbstractJsonFileSynchroniser{constructor(o,t,r,s,l,a,g,E,A,B,O,N,F,k){super(o.settingsResource,{syncResource:"settings",profile:o},t,r,s,l,a,g,O,N,E,A,B,k),this.extensionManagementService=F,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(o){const t=await this.getLastSyncUserData(),r=await this.getLatestRemoteUserData(o,t),s=this.getSettingsSyncContent(r),l=new L.ConfigurationModelParser(h.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&l.parse(s.settings),l.configurationModel.getValue(h.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(o,t,r){const s=await this.getLocalFileContent(),l=await this.getFormattingOptions(),a=this.getSettingsSyncContent(o);t=t===null&&r?o:t;const g=t?this.getSettingsSyncContent(t):null,E=await this.getIgnoredSettings();let A=null,B=!1,O=!1,N=!1;if(a){let $=s?s.value.toString().trim():"{}";$=$||"{}",this.validateContent($),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const G=(0,y.merge)($,a.settings,g?g.settings:null,E,[],l);A=G.localContent||G.remoteContent,B=G.localContent!==null,O=G.remoteContent!==null,N=G.hasConflicts}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),A=s.value.toString().trim()||"{}",this.validateContent(A),O=!0);const F=s?s.value.toString():null,k=g?.settings??null,U={content:N?k:A,localChange:B?2:0,remoteChange:O?2:0,hasConflicts:N};return[{fileContent:s,baseResource:this.baseResource,baseContent:k,localResource:this.localResource,localContent:F,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:a?a.settings:null,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(o){const t=this.getSettingsSyncContent(o);if(t===null)return!0;const r=await this.getLocalFileContent(),s=r?r.value.toString().trim():"",l=await this.getIgnoredSettings(),a=await this.getFormattingOptions();return(0,y.merge)(s||"{}",t.settings,t.settings,l,[],a).remoteContent!==null}async getMergeResult(o,t){const r=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...o.previewResult,content:o.previewResult.content?(0,y.updateIgnoredSettings)(o.previewResult.content,"{}",s,r):null}}async getAcceptResult(o,t,r,s){const l=await this.getFormattingOptions(),a=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:o.fileContent?(0,y.updateIgnoredSettings)(o.fileContent.value.toString(),"{}",a,l):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:o.remoteContent!==null?(0,y.updateIgnoredSettings)(o.remoteContent,o.fileContent?o.fileContent.value.toString():"{}",a,l):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:r!==null?(0,y.updateIgnoredSettings)(r,o.fileContent?o.fileContent.value.toString():"{}",a,l):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(o,t,r,s){const{fileContent:l}=r[0][0];let{content:a,localChange:g,remoteChange:E}=r[0][1];if(g===0&&E===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),a=a?a.trim():"{}",a=a||"{}",this.validateContent(a),g!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),l&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(l.value.toString()))),await this.updateLocalFileContent(a,l,s),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),E!==0){const A=await this.getFormattingOptions(),B=this.getSettingsSyncContent(o),O=await this.getIgnoredSettings(a);a=(0,y.updateIgnoredSettings)(a,B?B.settings:"{}",O,A),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),o=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(a)),s?null:o.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==o.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(o),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const o=await this.getLocalFileContent();if(o){const t=await this.getFormattingOptions(),r=(0,v.edit)(o.value.toString(),[h.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,y.isEmpty)(r)}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.extUri.isEqual(this.remoteResource,o)||this.extUri.isEqual(this.localResource,o)||this.extUri.isEqual(this.acceptedResource,o)||this.extUri.isEqual(this.baseResource,o)?this.resolvePreviewContent(o):null}async resolvePreviewContent(o){let t=await super.resolvePreviewContent(o);if(t){const r=await this.getFormattingOptions(),s=await this.getIgnoredSettings();t=(0,y.updateIgnoredSettings)(t,"{}",s,r)}return t}getSettingsSyncContent(o){return o.syncData?this.parseSettingsSyncContent(o.syncData.content):null}parseSettingsSyncContent(o){try{return c(o)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(o){return{settings:o}}async getIgnoredSettings(o){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const r=i.Event.any(i.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:l})=>!!l)),i.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{r.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings;return(0,y.getIgnoredSettings)(t,this.configurationService,o)}validateContent(o){if(this.hasErrors(o,!1))throw new h.UserDataSyncError((0,R.localize)(0,null),"LocalInvalidContent",this.resource)}};u=ve([K(2,w.IFileService),K(3,P.IEnvironmentService),K(4,b.IStorageService),K(5,h.IUserDataSyncStoreService),K(6,h.IUserDataSyncBackupStoreService),K(7,h.IUserDataSyncLogService),K(8,h.IUserDataSyncUtilService),K(9,T.IConfigurationService),K(10,h.IUserDataSyncEnablementService),K(11,C.ITelemetryService),K(12,I.IExtensionManagementService),K(13,S.IUriIdentityService)],u),e.SettingsSynchroniser=u;let d=class extends f.AbstractInitializer{constructor(o,t,r,s,l){super("settings",t,r,s,o,l)}async doInitialize(o){const t=o.syncData?this.parseSettingsSyncContent(o.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,D.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(o)}async isEmpty(){try{const o=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,y.isEmpty)(o.value.toString().trim())}catch(o){return o.fileOperationResult===1}}parseSettingsSyncContent(o){try{return c(o)}catch(t){this.logService.error(t)}return null}};d=ve([K(0,w.IFileService),K(1,m.IUserDataProfilesService),K(2,P.IEnvironmentService),K(3,h.IUserDataSyncLogService),K(4,S.IUriIdentityService)],d),e.SettingsInitializer=d}),define(re[120],se([0,1,17,3,32,16,13,14,19,23,30,18,40,254,26]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function v(p){return JSON.parse(p.content)}e.parseSnippets=v;let y=class extends S.AbstractSynchroniser{constructor(c,u,d,n,o,t,r,s,l,a,g,E){super({syncResource:"snippets",profile:c},u,n,d,o,t,r,a,g,s,l,E),this.version=1,this.snippetsFolder=c.snippetsHome,this._register(this.fileService.watch(d.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(i.Event.filter(this.fileService.onDidFilesChange,A=>A.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(c,u,d){const n=await this.getSnippetsFileContents(),o=this.toSnippetsContents(n),t=c.syncData?this.parseSnippets(c.syncData):null;u=u===null&&d?c:u;const r=u&&u.syncData?this.parseSnippets(u.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,m.merge)(o,t,r);return this.getResourcePreviews(s,n,t||{},r||{})}async hasRemoteChanged(c){const u=c.syncData?this.parseSnippets(c.syncData):null;if(u===null)return!0;const d=await this.getSnippetsFileContents(),n=this.toSnippetsContents(d),o=(0,m.merge)(n,u,u);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async getMergeResult(c,u){return c.previewResult}async getAcceptResult(c,u,d,n){if(this.extUri.isEqualOrParent(u,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:c.fileContent?c.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(u,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:c.remoteContent,localChange:c.remoteContent!==null?c.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(u,this.syncPreviewFolder))return d===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:d,localChange:d===null?c.fileContent!==null?3:0:2,remoteChange:d===null?c.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async applyResult(c,u,d,n){const o=d.map(([t,r])=>({...t,acceptResult:r}));o.every(({localChange:t,remoteChange:r})=>t===0&&r===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),o.some(({localChange:t})=>t!==0)&&(await this.updateLocalBackup(o),await this.updateLocalSnippets(o,n)),o.some(({remoteChange:t})=>t!==0)&&(c=await this.updateRemoteSnippets(o,c,n)),u?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(c),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:t}of o)try{await this.fileService.del(t)}catch{}}getResourcePreviews(c,u,d,n){const o=new Map;for(const t of Object.keys(c.local.added)){const r={content:c.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(c.local.updated)){const r={content:c.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},s=u[t]?u[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[t],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of c.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0},s=u[t]?u[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[t],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(c.remote.added)){const r={content:c.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},s=u[t]?u[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[t],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(c.remote.updated)){const r={content:c.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},s=u[t]?u[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[t],localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of c.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t],previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of c.conflicts){const r={content:n[t]??null,hasConflicts:!0,localChange:u[t]?2:1,remoteChange:d[t]?2:1},s=u[t]?u[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[t]||null,localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(u))if(!o.has(t)){const r={content:u[t]?u[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},s=u[t]?u[t].value.toString():null;o.set(t,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[t]||null,localContent:s,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[t]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,t),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,t).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...o.values()]}async resolveContent(c){return this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(c):null}async hasLocalData(){try{const c=await this.getSnippetsFileContents();if(Object.keys(c).length)return!0}catch{}return!1}async updateLocalBackup(c){const u={};for(const d of c)d.fileContent&&(u[this.extUri.basename(d.localResource)]=d.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(u)))}async updateLocalSnippets(c,u){for(const{fileContent:d,acceptResult:n,localResource:o,remoteResource:t,localChange:r}of c)if(r!==0){const s=t?this.extUri.basename(t):this.extUri.basename(o),l=this.extUri.joinPath(this.snippetsFolder,s);r===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(l)),await this.fileService.del(l),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(l))):r===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(l)),await this.fileService.createFile(l,D.VSBuffer.fromString(n.content),{overwrite:u}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(l))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(l)),await this.fileService.writeFile(l,D.VSBuffer.fromString(n.content),u?void 0:d),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(l)))}}async updateRemoteSnippets(c,u,d){const n=u.syncData?this.parseSnippets(u.syncData):{},o=(0,R.deepClone)(n);for(const{acceptResult:t,localResource:r,remoteResource:s,remoteChange:l}of c)if(l!==0){const a=r?this.extUri.basename(r):this.extUri.basename(s);l===3?delete o[a]:o[a]=t.content}return(0,m.areSame)(n,o)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),u=await this.updateRemoteUserData(JSON.stringify(o),d?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),u}parseSnippets(c){return v(c)}toSnippetsContents(c){const u={};for(const d of Object.keys(c))u[d]=c[d].value.toString();return u}async getSnippetsFileContents(){const c={};let u;try{u=await this.fileService.resolve(this.snippetsFolder)}catch(d){if(d instanceof P.FileOperationError&&d.fileOperationResult===1)return c;throw d}for(const d of u.children||[]){const n=d.resource,o=this.extUri.extname(n);if(o===".json"||o===".code-snippets"){const t=this.extUri.relativePath(this.snippetsFolder,n),r=await this.fileService.readFile(n);c[t]=r}}return c}};y=ve([K(2,L.IEnvironmentService),K(3,P.IFileService),K(4,I.IStorageService),K(5,f.IUserDataSyncStoreService),K(6,f.IUserDataSyncBackupStoreService),K(7,f.IUserDataSyncLogService),K(8,T.IConfigurationService),K(9,f.IUserDataSyncEnablementService),K(10,w.ITelemetryService),K(11,b.IUriIdentityService)],y),e.SnippetsSynchroniser=y;let h=class extends S.AbstractInitializer{constructor(c,u,d,n,o){super("snippets",u,d,n,c,o)}async doInitialize(c){const u=c.syncData?JSON.parse(c.syncData.content):null;if(!u){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const n of Object.keys(u)){const o=u[n];if(o){const t=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,n);await this.fileService.createFile(t,D.VSBuffer.fromString(o)),this.logService.info("Created snippet",this.extUri.basename(t))}}await this.updateLastSyncUserData(c)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(c){return c.fileOperationResult===1}}};h=ve([K(0,P.IFileService),K(1,C.IUserDataProfilesService),K(2,L.IEnvironmentService),K(3,f.IUserDataSyncLogService),K(4,b.IUriIdentityService)],h),e.SnippetsInitializer=h}),define(re[121],se([0,1,17,16,13,14,19,23,30,18,40,26]),function(Q,e,D,i,R,T,L,P,I,w,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function S(y,h){try{return JSON.parse(y).tasks??null}catch(p){return h.error(p),null}}e.getTasksContentFromSyncContent=S;let m=class extends b.AbstractFileSynchroniser{constructor(h,p,c,u,d,n,o,t,r,s,l,a){super(h.tasksResource,{syncResource:"tasks",profile:h},p,t,r,s,c,u,o,l,d,n,a),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:C.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(h,p,c,u){const d=h.syncData?S(h.syncData.content,this.logService):null;p=p===null&&c?h:p;const n=p?.syncData?S(p.syncData.content,this.logService):null,o=await this.getLocalFileContent();let t=null,r=!1,s=!1,l=!1;if(h.syncData){const E=o?o.value.toString():null;if(!n||n!==E||n!==d){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const A=v(E,d,n);t=A.content,l=A.hasConflicts,r=A.hasLocalChanged,s=A.hasRemoteChanged}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=o.value.toString(),s=!0);const a={content:l?n:t,localChange:r?o?2:1:0,remoteChange:s?2:0,hasConflicts:l},g=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:n,localResource:this.localResource,localContent:g,localChange:a.localChange,remoteResource:this.remoteResource,remoteContent:d,remoteChange:a.remoteChange,previewResource:this.previewResource,previewResult:a,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(h){const p=h?.syncData?S(h.syncData.content,this.logService):null;if(p===null)return!0;const c=await this.getLocalFileContent(),u=c?c.value.toString():null,d=v(u,p,p);return d.hasLocalChanged||d.hasRemoteChanged}async getMergeResult(h,p){return h.previewResult}async getAcceptResult(h,p,c,u){if(this.extUri.isEqual(p,this.localResource))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(p,this.remoteResource))return{content:h.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(p,this.previewResource))return c===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:c,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${p.toString()}`)}async applyResult(h,p,c,u){const{fileContent:d}=c[0][0],{content:n,localChange:o,remoteChange:t}=c[0][1];if(o===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),d&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(d.value.toString()))),n?await this.updateLocalFileContent(n,d,u):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const r=JSON.stringify(this.toTasksSyncContent(n));h=await this.updateRemoteUserData(r,u?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}p?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(h),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(h){return this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.baseResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h)?this.resolvePreviewContent(h):null}toTasksSyncContent(h){return h?{tasks:h}:{}}};m=ve([K(2,C.IUserDataSyncStoreService),K(3,C.IUserDataSyncBackupStoreService),K(4,C.IUserDataSyncLogService),K(5,i.IConfigurationService),K(6,C.IUserDataSyncEnablementService),K(7,T.IFileService),K(8,R.IEnvironmentService),K(9,L.IStorageService),K(10,P.ITelemetryService),K(11,I.IUriIdentityService)],m),e.TasksSynchroniser=m;let f=class extends b.AbstractInitializer{constructor(h,p,c,u,d){super("tasks",p,c,u,h,d),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(h){const p=h.syncData?S(h.syncData.content,this.logService):null;if(!p){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,D.VSBuffer.fromString(p)),await this.updateLastSyncUserData(h)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};f=ve([K(0,T.IFileService),K(1,w.IUserDataProfilesService),K(2,R.IEnvironmentService),K(3,C.IUserDataSyncLogService),K(4,I.IUriIdentityService)],f),e.TasksInitializer=f;function v(y,h,p){if(y===null&&h===null&&p===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(y===h)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const c=p!==y,u=p!==h;return!c&&!u?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:c&&!u?{content:y,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:u&&!c?{content:h,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:y,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(re[122],se([0,1,42,16,13,14,19,23,30,18,40,255,26]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let m=class extends b.AbstractSynchroniser{constructor(h,p,c,u,d,n,o,t,r,s,l,a,g){super({syncResource:"profiles",profile:h},p,u,d,n,o,t,l,a,r,s,g),this.userDataProfilesService=c,this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const h=await this.getLastSyncUserData();return h?.syncData?v(h.syncData):null}async getRemoteSyncedProfiles(h){const p=await this.getLastSyncUserData(),c=await this.getLatestRemoteUserData(h,p);return c?.syncData?v(c.syncData):null}async generateSyncPreview(h,p,c){const u=h.syncData?v(h.syncData):null,d=p?.syncData?v(p.syncData):null,n=this.getLocalUserDataProfiles(),{local:o,remote:t}=(0,C.merge)(n,u,d,[]),r={local:o,remote:t,content:d?this.stringifyRemoteProfiles(d):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:t!==null?2:0},s=f(n,!1);return[{baseResource:this.baseResource,baseContent:d?this.stringifyRemoteProfiles(d):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:u?this.stringifyRemoteProfiles(u):null,remoteProfiles:u,previewResource:this.previewResource,previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(h){const p=h?.syncData?v(h.syncData):null,c=this.getLocalUserDataProfiles(),{remote:u}=(0,C.merge)(c,p,p,[]);return!!u?.added.length||!!u?.removed.length||!!u?.updated.length}async getMergeResult(h,p){return{...h.previewResult,hasConflicts:!1}}async getAcceptResult(h,p,c,u){if(this.extUri.isEqual(p,this.localResource))return this.acceptLocal(h);if(this.extUri.isEqual(p,this.remoteResource))return this.acceptRemote(h);if(this.extUri.isEqual(p,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${p.toString()}`)}async acceptLocal(h){const p=this.getLocalUserDataProfiles(),c=(0,C.merge)(p,null,null,[]),{local:u,remote:d}=c;return{content:h.localContent,local:u,remote:d,localChange:u.added.length>0||u.removed.length>0||u.updated.length>0?2:0,remoteChange:d!==null?2:0}}async acceptRemote(h){const p=h.remoteContent?JSON.parse(h.remoteContent):null,c=[],u=[];for(const d of this.getLocalUserDataProfiles()){const n=p?.find(o=>o.id===d.id);n&&(c.push({id:d.id,name:d.name,collection:n.collection}),u.push(d))}if(p!==null){const d=(0,C.merge)(u,p,c,[]),{local:n,remote:o}=d;return{content:h.remoteContent,local:n,remote:o,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(h,p,c,u){const{local:d,remote:n,localChange:o,remoteChange:t}=c[0][1];if(o===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`),o!==0){await this.backupLocal(f(this.getLocalUserDataProfiles(),!1));const r=[];for(const s of d.added)r.push(this.userDataProfilesService.createProfile(s.id,s.name,{shortName:s.shortName}));for(const s of d.removed)r.push(this.userDataProfilesService.removeProfile(s));for(const s of d.updated){const l=this.userDataProfilesService.profiles.find(a=>a.id===s.id);l?r.push(this.userDataProfilesService.updateProfile(l,{name:s.name,shortName:s.shortName})):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${s.id}' to update.`)}await Promise.all(r)}if(t!==0){const r=c[0][0].remoteProfiles||[];this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);for(const s of n?.added||[]){const l=await this.userDataSyncStoreService.createCollection(this.syncHeaders);r.push({id:s.id,name:s.name,collection:l,shortName:s.shortName})}for(const s of n?.removed||[])r.splice(r.findIndex(({id:l})=>s.id===l),1);for(const s of n?.updated||[]){const l=r.find(({id:a})=>s.id===a);l&&r.splice(r.indexOf(l),1,{id:s.id,name:s.name,collection:l.collection,shortName:s.shortName})}h=await this.updateRemoteUserData(this.stringifyRemoteProfiles(r),u?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${n?.added.length?` Added: ${JSON.stringify(n.added.map(s=>s.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(s=>s.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(s=>s.name))}.`:""}`);for(const s of n?.removed||[])await this.userDataSyncStoreService.deleteCollection(s.collection,this.syncHeaders)}p?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(h),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(h){if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.baseResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h)){const p=await this.resolvePreviewContent(h);return p&&(0,D.toFormattedString)(JSON.parse(p),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(h=>!h.isDefault&&!h.isTransient)}stringifyRemoteProfiles(h){return JSON.stringify([...h].sort((p,c)=>p.name.localeCompare(c.name)))}};m=ve([K(2,w.IUserDataProfilesService),K(3,T.IFileService),K(4,R.IEnvironmentService),K(5,L.IStorageService),K(6,S.IUserDataSyncStoreService),K(7,S.IUserDataSyncBackupStoreService),K(8,S.IUserDataSyncLogService),K(9,i.IConfigurationService),K(10,S.IUserDataSyncEnablementService),K(11,P.ITelemetryService),K(12,I.IUriIdentityService)],m),e.UserDataProfilesManifestSynchroniser=m;function f(y,h){const p=[...y].sort((c,u)=>c.name.localeCompare(u.name)).map(c=>({id:c.id,name:c.name}));return h?(0,D.toFormattedString)(p,{}):JSON.stringify(p)}e.stringifyLocalProfiles=f;function v(y){return JSON.parse(y.content)}e.parseUserDataProfilesManifest=v}),define(re[269],se([0,1,6,17,65,2,21,16,13,14,18,26]),function(Q,e,D,i,R,T,L,P,I,w,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let S=class extends T.Disposable{constructor(f,v,y,h,p){super(),this.environmentService=f,this.fileService=v,this.configurationService=y,this.logService=h,this.userDataProfilesService=p;for(const c of this.userDataProfilesService.profiles)for(const u of C.ALL_SYNC_RESOURCES)this.cleanUpBackup(this.getResourceBackupHome(c,u))}async getAllRefs(f,v){const y=this.getResourceBackupHome(f,v),h=await this.fileService.resolve(y);return h.children?h.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort().reverse().map(c=>({ref:c.name,created:this.getCreationTime(c)})):[]}async resolveContent(f,v,y){const h=this.getResourceBackupHome(f,v),p=(0,L.joinPath)(h,y);try{return(await this.fileService.readFile(p)).value.toString()}catch(c){return this.logService.error(c),null}}async backup(f,v,y){const h=this.getResourceBackupHome(f,v),p=(0,L.joinPath)(h,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(p,i.VSBuffer.fromString(y))}catch(c){this.logService.error(c)}try{this.cleanUpBackup(h)}catch{}}getResourceBackupHome(f,v){return(0,L.joinPath)(this.environmentService.userDataSyncHome,...f.isDefault?[v]:[f.id,v])}async cleanUpBackup(f){try{try{if(!await this.fileService.exists(f))return}catch{return}const v=await this.fileService.resolve(f);if(v.children){const y=v.children.filter(u=>u.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(u.name)).sort(),h=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let p=y.filter(u=>Date.now()-this.getCreationTime(u)>h);const c=y.length-p.length;c<10&&(p=p.slice(10-c)),await D.Promises.settled(p.map(async u=>{this.logService.info("Deleting from backup",u.resource.path),await this.fileService.del(u.resource)}))}}catch(v){this.logService.error(v)}}getCreationTime(f){return f.ctime||new Date(parseInt(f.name.substring(0,4)),parseInt(f.name.substring(4,6))-1,parseInt(f.name.substring(6,8)),parseInt(f.name.substring(9,11)),parseInt(f.name.substring(11,13)),parseInt(f.name.substring(13,15))).getTime()}};S=ve([K(0,I.IEnvironmentService),K(1,w.IFileService),K(2,P.IConfigurationService),K(3,C.IUserDataSyncLogService),K(4,b.IUserDataProfilesService)],S),e.UserDataSyncBackupStoreService=S}),define(re[270],se([0,1,3,2,5,13,19,23,26]),function(Q,e,D,i,R,T,L,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const w="sync.enable";let b=class extends i.Disposable{constructor(S,m,f,v){super(),this.storageService=S,this.telemetryService=m,this.environmentService=f,this.userDataSyncStoreManagementService=v,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(S.onDidChangeValue(y=>this.onDidStorageChange(y)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(w,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(S){S&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(w,{enabled:S}),this.storageService.store(w,S,-1,1))}isResourceEnabled(S){return this.storageService.getBoolean((0,I.getEnablementKey)(S),-1,!0)}setResourceEnablement(S,m){if(this.isResourceEnabled(S)!==m){const f=(0,I.getEnablementKey)(S);this.storeResourceEnablement(f,m)}}getResourceSyncStateVersion(S){}storeResourceEnablement(S,m){this.storageService.store(S,m,-1,R.isWeb?0:1)}onDidStorageChange(S){if(S.scope!==-1)return;if(w===S.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const m=I.ALL_SYNC_RESOURCES.filter(f=>(0,I.getEnablementKey)(f)===S.key)[0];if(m){this._onDidChangeResourceEnablement.fire([m,this.isResourceEnabled(m)]);return}}};b=ve([K(0,L.IStorageService),K(1,P.ITelemetryService),K(2,T.IEnvironmentService),K(3,I.IUserDataSyncStoreManagementService)],b),e.UserDataSyncEnablementService=b}),define(re[79],se([0,1,3,2,5,27,180,13,14,4,25,44,19,26]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,w.createDecorator)("IUserDataSyncMachinesService");const f="sync.currentMachineName",v="Safari",y="Chrome",h="Edge",p="Firefox",c="Android";function u(o){switch(o){case v:case y:case h:case p:case c:case(0,R.PlatformToString)(0):return!0}return!1}e.isWebPlatform=u;function d(){return R.isSafari?v:R.isChrome?y:R.isEdge?h:R.isFirefox?p:R.isAndroid?c:(0,R.PlatformToString)(R.isWeb?0:R.platform)}let n=class ot extends i.Disposable{constructor(t,r,s,l,a,g){super(),this.storageService=s,this.userDataSyncStoreService=l,this.logService=a,this.productService=g,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(t,r,s)}async getMachines(t){const r=await this.currentMachineIdPromise;return(await this.readMachinesData(t)).machines.map(l=>({...l,isCurrent:l.id===r}))}async addCurrentMachine(t){const r=await this.currentMachineIdPromise,s=await this.readMachinesData(t);s.machines.some(({id:l})=>l===r)||(s.machines.push({id:r,name:this.computeCurrentMachineName(s.machines),platform:d()}),await this.writeMachinesData(s))}async removeCurrentMachine(t){const r=await this.currentMachineIdPromise,s=await this.readMachinesData(t),l=s.machines.filter(({id:a})=>a!==r);l.length!==s.machines.length&&(s.machines=l,await this.writeMachinesData(s))}async renameMachine(t,r,s){const l=await this.readMachinesData(s),a=l.machines.find(({id:g})=>g===t);if(a){a.name=r,await this.writeMachinesData(l);const g=await this.currentMachineIdPromise;t===g&&this.storageService.store(f,r,-1,1)}}async setEnablements(t){const r=await this.readMachinesData();for(const[s,l]of t){const a=r.machines.find(g=>g.id===s);a&&(a.disabled=l?void 0:!0)}await this.writeMachinesData(r)}computeCurrentMachineName(t){const r=this.storageService.get(f,-1);if(r)return r;const s=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${d()} (${this.productService.nameShort})`,l=new RegExp(`${(0,T.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let a=0;for(const g of t){const E=l.exec(g.name),A=E?parseInt(E[1]):0;a=A>a?A:a}return`${s} #${a+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const r=this.parse(this.userData);if(r.version!==ot.VERSION)throw new Error((0,L.localize)(0,null,this.productService.nameLong));return r}async writeMachinesData(t){const r=JSON.stringify(t),s=await this.userDataSyncStoreService.writeResource(ot.RESOURCE,r,this.userData?.ref||null);this.userData={ref:s,content:r},this._onDidChange.fire()}async readUserData(t){if(this.userData){const r=t&&t.latest?t.latest[ot.RESOURCE]:void 0;if(this.userData.ref===r)return this.userData;if(r===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(ot.RESOURCE,this.userData)}parse(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(r){this.logService.error(r)}return{version:ot.VERSION,machines:[]}}};n.VERSION=1,n.RESOURCE="machines",n=ve([K(0,P.IEnvironmentService),K(1,I.IFileService),K(2,S.IStorageService),K(3,m.IUserDataSyncStoreService),K(4,m.IUserDataSyncLogService),K(5,b.IProductService)],n),e.UserDataSyncMachinesService=n}),define(re[271],se([0,1,6,65,37,11,3,2,5,21,8,178,25,19,23,26,76,79]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const p="sync.disableMachineEventually",c="sync.sessionId",u="sync.storeUrl",d="sync.productQuality";let n=class extends P.Disposable{get syncUrl(){const r=this.storageService.get(u,-1);return r?b.URI.parse(r):void 0}set syncUrl(r){r?this.storageService.store(u,r.toString(),-1,1):this.storageService.remove(u,-1)}get productQuality(){return this.storageService.get(d,-1)}set productQuality(r){r?this.storageService.store(d,r,-1,1):this.storageService.remove(d,-1)}constructor(r,s,l,a,g,E,A,B,O,N){super(),this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=l,this.userDataSyncEnablementService=a,this.userDataSyncService=g,this.logService=E,this.userDataSyncAccountService=A,this.telemetryService=B,this.userDataSyncMachinesService=O,this.storageService=N,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=r.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,w.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(A.onDidChangeAccount(()=>this.updateAutoSync())),this._register(l.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(g.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this._register(L.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:r,message:s}=this.isAutoSyncEnabled();r?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(l=>this.onDidFinishSync(l))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,i.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(r,s,l){try{this.userDataSyncAccountService.account&&!l&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(c,-1),r?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(this.logService.error(a),s)this.updateEnablement(!1);else throw a}}updateEnablement(r){this.userDataSyncEnablementService.isEnabled()!==r&&(this.userDataSyncEnablementService.setEnablement(r),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(r){if(!r){this.successiveFailures=0;return}const s=v.UserDataSyncError.toUserDataSyncError(r);s instanceof v.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?I.isWeb&&s.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(p,!0,-1,1),await(0,D.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(p,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(p,-1)}async triggerSync(r,s,l){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...r),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",l)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};n=ve([K(0,S.IProductService),K(1,v.IUserDataSyncStoreManagementService),K(2,v.IUserDataSyncStoreService),K(3,v.IUserDataSyncEnablementService),K(4,v.IUserDataSyncService),K(5,v.IUserDataSyncLogService),K(6,y.IUserDataSyncAccountService),K(7,f.ITelemetryService),K(8,h.IUserDataSyncMachinesService),K(9,m.IStorageService)],n),e.UserDataAutoSyncService=n;class o extends P.Disposable{constructor(r,s,l,a,g,E,A,B){super(),this.lastSyncUrl=r,this.interval=s,this.userDataSyncStoreManagementService=l,this.userDataSyncStoreService=a,this.userDataSyncService=g,this.userDataSyncMachinesService=E,this.logService=A,this.storageService=B,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new L.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new L.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(r,s){const l=(0,D.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(g){if((0,T.isCancellationError)(g))return}return this.doSync(r,s,a)});return this.syncPromise=l,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,w.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const r=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!r&&(!(0,w.isEqual)(s.defaultUrl,r.defaultUrl)||!(0,w.isEqual)(s.insidersUrl,r.insidersUrl)||!(0,w.isEqual)(s.stableUrl,r.stableUrl))}async doSync(r,s,l){this.logService.info(`Auto Sync: Triggered by ${r}`),this._onDidStartSync.fire();let a;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),l.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new v.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const g=this.storageService.get(c,-1);if(g&&this.manifest&&g!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new v.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const E=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(l.isCancellationRequested)return;const A=E.find(B=>B.isCurrent);if(A?.disabled)throw new v.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(B){throw new v.UserDataAutoSyncError((0,R.toErrorMessage)(B),B instanceof v.UserDataSyncError?B.code:"Unknown")}if(this.manifest&&this.manifest.session!==g&&this.storageService.store(c,this.manifest.session,-1,1),l.isCancellationRequested)return;A||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(g){this.logService.error(g),a=g}this._onDidFinishSync.fire(a)}register(r){return super._register(r)}}o.INTERVAL_SYNCING="Interval"}),define(re[62],se([0,1,2,69,4,19]),function(Q,e,D,i,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataSyncProfilesStorageService=e.IUserDataSyncProfilesStorageService=void 0,e.IUserDataSyncProfilesStorageService=(0,R.createDecorator)("IUserDataSyncProfilesStorageService");let L=class extends D.Disposable{constructor(w){super(),this.storageService=w}async readStorageData(w){return this.withProfileScopedStorageService(w,async b=>this.getItems(b))}async updateStorageData(w,b,C){return this.withProfileScopedStorageService(w,async S=>this.writeItems(S,b,C))}async withProfileScopedStorageService(w,b){if(this.storageService.hasScope(w))return b(this.storageService);const C=await this.createStorageDatabase(w),S=new P(C);try{await S.initialize();const m=await b(S);return await S.flush(),m}finally{S.dispose(),await this.closeAndDispose(C)}}getItems(w){const b=new Map,C=S=>{for(const m of w.keys(0,S))b.set(m,{value:w.get(m,0),target:S})};return C(0),C(1),b}writeItems(w,b,C){for(const[S,m]of b)w.store(S,m,0,C)}async closeAndDispose(w){try{await w.close()}finally{(0,D.isDisposable)(w)&&w.dispose()}}};L=ve([K(0,T.IStorageService)],L),e.AbstractUserDataSyncProfilesStorageService=L;class P extends T.AbstractStorageService{constructor(w){super({flushInterval:100}),this.profileStorage=this._register(new i.Storage(w))}doInitialize(){return this.profileStorage.init()}getStorage(w){return w===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(re[123],se([0,1,6,24,11,3,42,2,27,16,13,117,29,33,78,14,4,71,7,19,23,30,18,40,252,115,26,62]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v,y,h,p,c,u,d,n,o,t,r,s,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function a(N,F){const k=JSON.parse(N.content);if(N.version===1||N.version===2){const U=(await F.getInstalled(0)).filter($=>$.isBuiltin);for(const $ of k)N.version===1&&($.enabled===!1&&($.disabled=!0),delete $.enabled),N.version===2&&U.every(G=>!(0,m.areSameExtensions)(G.identifier,$.identifier))&&($.installed=!0)}return k}function g(N){return JSON.parse(N.content)}e.parseExtensions=g;function E(N,F){return N.sort((k,U)=>!k.identifier.uuid&&U.identifier.uuid?-1:k.identifier.uuid&&!U.identifier.uuid?1:(0,I.compare)(k.identifier.id,U.identifier.id)),F?(0,L.toFormattedString)(N,{}):JSON.stringify(N)}e.stringify=E;let A=class extends o.AbstractSynchroniser{constructor(F,k,U,$,G,W,V,z,j,J,ee,ce,q,x,_,M,Y){super({syncResource:"extensions",profile:F},k,$,U,G,W,V,ce,q,J,ee,_),this.profile=F,this.extensionManagementService=z,this.ignoredExtensionsManagementService=j,this.instantiationService=Y,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(B),this._register(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,H=>H.some(({local:Z})=>!!Z)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,H=>!H.error),T.Event.filter(M.onDidChange,H=>H.valueChanges.some(({profile:Z,changes:oe})=>this.syncResource.profile.id===Z.id&&oe.some(X=>X.key===S.DISABLED_EXTENSIONS_STORAGE_PATH))),x.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(F,k){const U=F.syncData?await a(F.syncData,this.extensionManagementService):null,$=k?.skippedExtensions||[],G=k?.builtinExtensions||[],W=k?.syncData?await a(k.syncData,this.extensionManagementService):null,{localExtensions:V,ignoredExtensions:z}=await this.localExtensionsProvider.getLocalExtensions(this.profile);U?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:j,remote:J}=(0,t.merge)(V,U,W,$,z,G),ee={local:j,remote:J,content:this.getPreviewContent(V,j.added,j.updated,j.removed),localChange:j.added.length>0||j.removed.length>0||j.updated.length>0?2:0,remoteChange:J!==null?2:0},ce=this.stringify(V,!1);return[{skippedExtensions:$,builtinExtensions:G,baseResource:this.baseResource,baseContent:W?this.stringify(W,!1):ce,localResource:this.localResource,localContent:ce,localExtensions:V,remoteResource:this.remoteResource,remoteExtensions:U,remoteContent:U?this.stringify(U,!1):null,previewResource:this.previewResource,previewResult:ee,localChange:ee.localChange,remoteChange:ee.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(F){const k=F.syncData?await a(F.syncData,this.extensionManagementService):null,{localExtensions:U,ignoredExtensions:$}=await this.localExtensionsProvider.getLocalExtensions(this.profile),{remote:G}=(0,t.merge)(U,k,k,F.skippedExtensions||[],$,F.builtinExtensions||[]);return G!==null}getPreviewContent(F,k,U,$){const G=[...k,...U],W=new Set,V=z=>{W.add(z.id.toLowerCase()),z.uuid&&W.add(z.uuid)};G.forEach(({identifier:z})=>V(z)),$.forEach(V);for(const z of F)W.has(z.identifier.id.toLowerCase())||z.identifier.uuid&&W.has(z.identifier.uuid)||G.push(z);return this.stringify(G,!1)}async getMergeResult(F,k){return{...F.previewResult,hasConflicts:!1}}async getAcceptResult(F,k,U,$){if(this.extUri.isEqual(k,this.localResource))return this.acceptLocal(F);if(this.extUri.isEqual(k,this.remoteResource))return this.acceptRemote(F);if(this.extUri.isEqual(k,this.previewResource))return F.previewResult;throw new Error(`Invalid Resource: ${k.toString()}`)}async acceptLocal(F){const k=await this.extensionManagementService.getInstalled(void 0,this.profile.location),U=this.ignoredExtensionsManagementService.getIgnoredExtensions(k),$=(0,t.merge)(F.localExtensions,null,null,F.skippedExtensions,U,F.builtinExtensions),{local:G,remote:W}=$;return{content:F.localContent,local:G,remote:W,localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?2:0,remoteChange:W!==null?2:0}}async acceptRemote(F){const k=await this.extensionManagementService.getInstalled(void 0,this.profile.location),U=this.ignoredExtensionsManagementService.getIgnoredExtensions(k),$=F.remoteContent?JSON.parse(F.remoteContent):null;if($!==null){const G=(0,t.merge)(F.localExtensions,$,F.localExtensions,[],U,F.builtinExtensions),{local:W,remote:V}=G;return{content:F.remoteContent,local:W,remote:V,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:V!==null?2:0}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(F,k,U,$){let{skippedExtensions:G,localExtensions:W}=U[0][0];const{local:V,remote:z,localChange:j,remoteChange:J}=U[0][1];if(j===0&&J===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),j!==0&&(await this.backupLocal(JSON.stringify(W)),G=await this.localExtensionsProvider.updateLocalExtensions(V.added,V.removed,V.updated,G,this.profile)),z){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const ee=JSON.stringify(z.all);F=await this.updateRemoteUserData(ee,$?null:F.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${z.added.length?` Added: ${JSON.stringify(z.added.map(ce=>ce.identifier.id))}.`:""}${z.updated.length?` Updated: ${JSON.stringify(z.updated.map(ce=>ce.identifier.id))}.`:""}${z.removed.length?` Removed: ${JSON.stringify(z.removed.map(ce=>ce.identifier.id))}.`:""}`)}if(k?.ref!==F.ref){this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`);const ee=W.filter(ce=>!ce.installed).map(ce=>ce.identifier);await this.updateLastSyncUserData(F,{skippedExtensions:G,builtinExtensions:ee}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${G.length?` Skipped: ${JSON.stringify(G.map(ce=>ce.identifier.id))}.`:""}`)}}async resolveContent(F){if(this.extUri.isEqual(this.remoteResource,F)||this.extUri.isEqual(this.baseResource,F)||this.extUri.isEqual(this.localResource,F)||this.extUri.isEqual(this.acceptedResource,F)){const k=await this.resolvePreviewContent(F);return k&&this.stringify(JSON.parse(k),!0)}return null}stringify(F,k){return E(F,k)}async hasLocalData(){try{const{localExtensions:F}=await this.localExtensionsProvider.getLocalExtensions(this.profile);if(F.some(k=>k.installed||k.disabled))return!0}catch{}return!1}};A=ve([K(2,b.IEnvironmentService),K(3,v.IFileService),K(4,c.IStorageService),K(5,s.IUserDataSyncStoreService),K(6,s.IUserDataSyncBackupStoreService),K(7,S.IExtensionManagementService),K(8,r.IIgnoredExtensionsManagementService),K(9,s.IUserDataSyncLogService),K(10,w.IConfigurationService),K(11,s.IUserDataSyncEnablementService),K(12,u.ITelemetryService),K(13,f.IExtensionStorageService),K(14,d.IUriIdentityService),K(15,l.IUserDataSyncProfilesStorageService),K(16,y.IInstantiationService)],A),e.ExtensionsSynchroniser=A;let B=class{constructor(F,k,U,$,G,W){this.extensionManagementService=F,this.userDataSyncProfilesStorageService=k,this.extensionGalleryService=U,this.ignoredExtensionsManagementService=$,this.instantiationService=G,this.logService=W}async getLocalExtensions(F){const k=await this.extensionManagementService.getInstalled(void 0,F.extensionsResource),U=this.ignoredExtensionsManagementService.getIgnoredExtensions(k);return{localExtensions:await this.withProfileScopedServices(F,async(G,W)=>{const V=G.getDisabledExtensions();return k.map(z=>{const{identifier:j,isBuiltin:J,manifest:ee,preRelease:ce}=z,q={identifier:j,preRelease:ce,version:ee.version};V.some(x=>(0,m.areSameExtensions)(x,j))&&(q.disabled=!0),J||(q.installed=!0);try{const x=W.getKeysForSync({id:j.id,version:ee.version});if(x){const _=W.getExtensionState(z,!0)||{};q.state=Object.keys(_).reduce((M,Y)=>(x.includes(Y)&&(M[Y]=_[Y]),M),{})}}catch(x){this.logService.info(`${(0,o.getSyncResourceLogLabel)("extensions",F)}: Error while parsing extension state`,(0,R.getErrorMessage)(x))}return q})}),ignoredExtensions:U}}async updateLocalExtensions(F,k,U,$,G){const W=(0,o.getSyncResourceLogLabel)("extensions",G);return this.withProfileScopedServices(G,async(V,z)=>{const j=[],J=[],ee=await this.extensionManagementService.getInstalled(void 0,G.extensionsResource);if(k.length){const q=ee.filter(({identifier:x,isBuiltin:_})=>!_&&k.some(M=>(0,m.areSameExtensions)(x,M)));await D.Promises.settled(q.map(async x=>{this.logService.trace(`${W}: Uninstalling local extension...`,x.identifier.id),await this.extensionManagementService.uninstall(x,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:G.extensionsResource}),this.logService.info(`${W}: Uninstalled local extension.`,x.identifier.id),j.push(x.identifier)}))}(F.length||U.length)&&await D.Promises.settled([...F,...U].map(async q=>{const x=ee.find(M=>(0,m.areSameExtensions)(M.identifier,q.identifier));if(x&&x.isBuiltin){q.state&&x.manifest.version===q.version&&this.updateExtensionState(q.state,x,x.manifest.version,z),V.getDisabledExtensions().some(Y=>(0,m.areSameExtensions)(Y,q.identifier))!==!!q.disabled&&(q.disabled?(this.logService.trace(`${W}: Disabling extension...`,q.identifier.id),await V.disableExtension(q.identifier),this.logService.info(`${W}: Disabled extension`,q.identifier.id)):(this.logService.trace(`${W}: Enabling extension...`,q.identifier.id),await V.enableExtension(q.identifier),this.logService.info(`${W}: Enabled extension`,q.identifier.id))),j.push(q.identifier);return}const _=(await this.extensionGalleryService.getExtensions([{...q.identifier,preRelease:q.preRelease}],i.CancellationToken.None))[0];if(q.state&&(x?x.manifest.version===q.version:!!_)&&this.updateExtensionState(q.state,x||_,x?.manifest.version,z),_)try{V.getDisabledExtensions().some(Y=>(0,m.areSameExtensions)(Y,q.identifier))!==!!q.disabled&&(q.disabled?(this.logService.trace(`${W}: Disabling extension...`,q.identifier.id,_.version),await V.disableExtension(_.identifier),this.logService.info(`${W}: Disabled extension`,q.identifier.id,_.version)):(this.logService.trace(`${W}: Enabling extension...`,q.identifier.id,_.version),await V.enableExtension(_.identifier),this.logService.info(`${W}: Enabled extension`,q.identifier.id,_.version))),(!x||x.preRelease!==q.preRelease)&&(await this.extensionManagementService.canInstall(_)?(this.logService.trace(`${W}: Installing extension...`,q.identifier.id,_.version),await this.extensionManagementService.installFromGallery(_,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:q.preRelease,profileLocation:G.extensionsResource}),this.logService.info(`${W}: Installed extension.`,q.identifier.id,_.version),j.push(_.identifier)):(this.logService.info(`${W}: Skipped synchronizing extension because it cannot be installed.`,_.displayName||_.identifier.id),J.push(q)))}catch(M){J.push(q),M instanceof S.ExtensionManagementError&&[S.ExtensionManagementErrorCode.Incompatible,S.ExtensionManagementErrorCode.IncompatiblePreRelease,S.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(M.code)?this.logService.info(`${W}: Skipped synchronizing extension because the compatible extension is not found.`,_.displayName||_.identifier.id):(this.logService.error(M),this.logService.info(`${W}: Skipped synchronizing extension`,_.displayName||_.identifier.id))}else J.push(q),this.logService.info(`${W}: Skipped synchronizing extension because the extension is not found.`,q.identifier.id)}));const ce=[];for(const q of $)j.some(x=>(0,m.areSameExtensions)(x,q.identifier))||ce.push(q);for(const q of J)ce.some(x=>(0,m.areSameExtensions)(x.identifier,q.identifier))||ce.push(q);return ce})}updateExtensionState(F,k,U,$){const G=$.getExtensionState(k,!0)||{},W=U?$.getKeysForSync({id:k.identifier.id,version:U}):void 0;W?W.forEach(V=>{G[V]=F[V]}):Object.keys(F).forEach(V=>G[V]=F[V]),$.setExtensionState(k,G,!0)}async withProfileScopedServices(F,k){return this.userDataSyncProfilesStorageService.withProfileScopedStorageService(F,async U=>{const $=new P.DisposableStore,G=this.instantiationService.createChild(new h.ServiceCollection([c.IStorageService,U])),W=$.add(G.createInstance(C.GlobalExtensionEnablementService)),V=$.add(G.createInstance(f.ExtensionStorageService));try{return await k(W,V)}finally{$.dispose()}})}};B=ve([K(0,S.IExtensionManagementService),K(1,l.IUserDataSyncProfilesStorageService),K(2,S.IExtensionGalleryService),K(3,r.IIgnoredExtensionsManagementService),K(4,y.IInstantiationService),K(5,s.IUserDataSyncLogService)],B),e.LocalExtensionsProvider=B;let O=class extends o.AbstractInitializer{constructor(F,k,U,$,G,W,V){super("extensions",$,G,W,U,V),this.extensionManagementService=F,this.ignoredExtensionsManagementService=k}async parseExtensions(F){return F.syncData?await a(F.syncData,this.extensionManagementService):null}generatePreview(F,k){const U=[],$=[],G=[];for(const W of F){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(W.identifier.id))continue;const V=k.find(z=>(0,m.areSameExtensions)(z.identifier,W.identifier));V?(U.push(V),W.disabled&&G.push(W.identifier)):W.installed&&($.push({...W.identifier,preRelease:!!W.preRelease}),W.disabled&&G.push(W.identifier))}return{installedExtensions:U,newExtensions:$,disabledExtensions:G,remoteExtensions:F}}};O=ve([K(0,S.IExtensionManagementService),K(1,r.IIgnoredExtensionsManagementService),K(2,v.IFileService),K(3,n.IUserDataProfilesService),K(4,b.IEnvironmentService),K(5,p.ILogService),K(6,d.IUriIdentityService)],O),e.AbstractExtensionsInitializer=O}),define(re[124],se([0,1,17,11,3,35,42,5,31,16,13,14,7,44,19,23,30,40,61,256,26,18,62,4]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v,y,h,p,c,u,d,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",r=["locale"];function s(B,O){const N=B.storage?Object.keys(B.storage).sort():[],F={};return N.forEach(k=>F[k]=B.storage[k]),B.storage=F,O?(0,L.toFormattedString)(B,{}):JSON.stringify(B)}e.stringify=s;const l=1;let a=class extends h.AbstractSynchroniser{constructor(O,N,F,k,U,$,G,W,V,z,j,J,ee,ce){super({syncResource:"globalState",profile:O},N,k,W,J,U,$,V,z,G,j,ee),this.userDataSyncProfilesStorageService=F,this.version=l,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=ce.createInstance(g),this._register(k.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(R.Event.any(R.Event.filter(k.onDidFilesChange,q=>q.contains(this.environmentService.argvResource)),R.Event.filter(F.onDidChange,q=>!!(q.targetChanges.some(x=>this.syncResource.profile.id===x.id)||q.valueChanges.some(({profile:x,changes:_})=>this.syncResource.profile.id===x.id&&_.some(M=>M.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(O,N,F){const k=O.syncData?JSON.parse(O.syncData.content):null;N=N===null&&F?O:N;const U=N&&N.syncData?JSON.parse(N.syncData.content):null,$=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);k?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const G=await this.getStorageKeys(U),{local:W,remote:V}=(0,c.merge)($.storage,k?k.storage:null,U?U.storage:null,G,this.logService),z={content:null,local:W,remote:V,localChange:Object.keys(W.added).length>0||Object.keys(W.updated).length>0||W.removed.length>0?2:0,remoteChange:V.all!==null?2:0},j=s($,!1);return[{baseResource:this.baseResource,baseContent:U?s(U,!1):j,localResource:this.localResource,localContent:j,localUserData:$,remoteResource:this.remoteResource,remoteContent:k?s(k,!1):null,previewResource:this.previewResource,previewResult:z,localChange:z.localChange,remoteChange:z.remoteChange,acceptedResource:this.acceptedResource,storageKeys:G}]}async hasRemoteChanged(O){const N=O.syncData?JSON.parse(O.syncData.content):null;if(N===null)return!0;const F=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),k=await this.getStorageKeys(N),{remote:U}=(0,c.merge)(F.storage,N.storage,N.storage,k,this.logService);return U.all!==null}async getMergeResult(O,N){return{...O.previewResult,hasConflicts:!1}}async getAcceptResult(O,N,F,k){if(this.extUri.isEqual(N,this.localResource))return this.acceptLocal(O);if(this.extUri.isEqual(N,this.remoteResource))return this.acceptRemote(O);if(this.extUri.isEqual(N,this.previewResource))return O.previewResult;throw new Error(`Invalid Resource: ${N.toString()}`)}async acceptLocal(O){return{content:O.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(O.localUserData.storage),removed:[],updated:[],all:O.localUserData.storage},localChange:0,remoteChange:2}}async acceptRemote(O){if(O.remoteContent!==null){const N=JSON.parse(O.remoteContent),{local:F,remote:k}=(0,c.merge)(O.localUserData.storage,N.storage,null,O.storageKeys,this.logService);return{content:O.remoteContent,local:F,remote:k,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:k!==null?2:0}}else return{content:O.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async applyResult(O,N,F,k){const{localUserData:U}=F[0][0],{local:$,remote:G,localChange:W,remoteChange:V}=F[0][1];if(W===0&&V===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),W!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(U)),await this.localGlobalStateProvider.writeLocalGlobalState($,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),V!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const z=JSON.stringify({storage:G.all});O=await this.updateRemoteUserData(z,k?null:O.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${G.added.length?` Added: ${G.added}.`:""}${G.updated.length?` Updated: ${G.updated}.`:""}${G.removed.length?` Removed: ${G.removed}.`:""}`)}N?.ref!==O.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(O),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(O){if(this.extUri.isEqual(this.remoteResource,O)||this.extUri.isEqual(this.baseResource,O)||this.extUri.isEqual(this.localResource,O)||this.extUri.isEqual(this.acceptedResource,O)){const N=await this.resolvePreviewContent(O);return N&&s(JSON.parse(N),!0)}return null}async hasLocalData(){try{const{storage:O}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(O).length>1||O[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(O){const N=await this.userDataSyncProfilesStorageService.readStorageData(this.syncResource.profile),F=[],k=[];for(const[G,W]of N)W.target===0?F.push(G):W.target===1&&k.push(G);const U=[...F,...k],$=O?.storage?Object.keys(O.storage).filter(G=>!G.startsWith(t)&&!U.includes(G)&&N.get(G)!==void 0):[];if(!P.isWeb){const G=[...u.ALL_SYNC_RESOURCES.map(W=>(0,u.getEnablementKey)(W)),u.SYNC_SERVICE_URL_TYPE];$.push(...G),k.push(...G)}return{user:F,machine:k,unregistered:$}}};a=ve([K(2,n.IUserDataSyncProfilesStorageService),K(3,C.IFileService),K(4,u.IUserDataSyncStoreService),K(5,u.IUserDataSyncBackupStoreService),K(6,u.IUserDataSyncLogService),K(7,b.IEnvironmentService),K(8,u.IUserDataSyncEnablementService),K(9,v.ITelemetryService),K(10,w.IConfigurationService),K(11,f.IStorageService),K(12,y.IUriIdentityService),K(13,o.IInstantiationService)],a),e.GlobalStateSynchroniser=a;let g=class{constructor(O,N,F,k){this.fileService=O,this.environmentService=N,this.userDataSyncProfilesStorageService=F,this.logService=k}async getLocalGlobalState(O){const N={};if(O.isDefault){const k=await this.getLocalArgvContent(),U=(0,T.parse)(k);for(const $ of r)U[$]!==void 0&&(N[`${t}${$}`]={version:1,value:U[$]})}const F=await this.userDataSyncProfilesStorageService.readStorageData(O);for(const[k,U]of F)U.value&&U.target===0&&(N[k]={version:1,value:U.value});return{storage:N}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const O=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),O.value.toString()}catch(O){this.logService.debug((0,i.getErrorMessage)(O))}return"{}"}async writeLocalGlobalState({added:O,removed:N,updated:F},k){const U=(0,h.getSyncResourceLogLabel)("globalState",k),$={},G=new Map,W=await this.userDataSyncProfilesStorageService.readStorageData(k),V=(z,j)=>{for(const J of z){if(J.startsWith(t)){$[J.substring(t.length)]=j?j[J].value:void 0;continue}if(j){const ee=j[J];ee.value!==W.get(J)?.value&&G.set(J,ee.value)}else W.get(J)!==void 0&&G.set(J,void 0)}};if(V(Object.keys(O),O),V(Object.keys(F),F),V(N),Object.keys($).length){this.logService.trace(`${U}: Updating locale...`);const z=await this.getLocalArgvContent();let j=z;for(const J of Object.keys($))j=(0,p.edit)(j,[J],$[J],{});z!==j&&(this.logService.trace(`${U}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(j)),this.logService.info(`${U}: Updated locale.`)),this.logService.info(`${U}: Updated locale`)}G.size&&(this.logService.trace(`${U}: Updating global state...`),await this.userDataSyncProfilesStorageService.updateStorageData(k,G,0),this.logService.info(`${U}: Updated global state`,[...G.keys()]))}};g=ve([K(0,C.IFileService),K(1,b.IEnvironmentService),K(2,n.IUserDataSyncProfilesStorageService),K(3,u.IUserDataSyncLogService)],g),e.LocalGlobalStateProvider=g;let E=class extends h.AbstractInitializer{constructor(O,N,F,k,U,$){super("globalState",F,k,U,N,$),this.storageService=O}async doInitialize(O){const N=O.syncData?JSON.parse(O.syncData.content):null;if(!N){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const F={},k={};for(const U of Object.keys(N.storage))U.startsWith(t)?F[U.substring(t.length)]=N.storage[U].value:this.storageService.get(U,0)===void 0&&(k[U]=N.storage[U].value);if(Object.keys(F).length){let U="{}";try{U=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const $ of Object.keys(F))U=(0,p.edit)(U,[$],F[$],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(U))}if(Object.keys(k).length)for(const U of Object.keys(k))this.storageService.store(U,k[U],0,0)}};E=ve([K(0,f.IStorageService),K(1,C.IFileService),K(2,d.IUserDataProfilesService),K(3,b.IEnvironmentService),K(4,u.IUserDataSyncLogService),K(5,y.IUriIdentityService)],E),e.GlobalStateInitializer=E;let A=class{constructor(O,N,F,k,U){this.userDataSyncStoreClient=O,this.storageService=N,this.environmentService=F,this.fileService=k,this.logService=U}getSyncStoreType(O){return this.parseGlobalState(O)?.storage[u.SYNC_SERVICE_URL_TYPE]?.value}async sync(O){const N=(0,u.createSyncHeaders)((0,I.generateUuid)());try{return await this.doSync(O,N)}catch(F){if(F instanceof u.UserDataSyncError)switch(F.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(O,N)}throw F}}async doSync(O,N){const F=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,N),k=this.parseGlobalState(F)||{storage:{}};k.storage[u.SYNC_SERVICE_URL_TYPE]={value:O,version:l};const U=await(0,m.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),$={version:l,machineId:U,content:s(k,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify($),F.ref,void 0,N)}parseGlobalState({content:O}){if(!O)return null;const N=JSON.parse(O);if((0,h.isSyncData)(N))return N?JSON.parse(N.content):null;throw new Error("Invalid remote data")}};A=ve([K(1,f.IStorageService),K(2,b.IEnvironmentService),K(3,C.IFileService),K(4,S.ILogService)],A),e.UserDataSyncStoreTypeSynchronizer=A}),define(re[272],se([0,1,8,181,13,14,44,19,30,26,18,40,120,119,118,16,121,123,124,4,122,42]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v,y,h,p,c,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class Be{constructor(t,r,s,l,a,g,E,A,B,O){this.userDataSyncStoreService=t,this.userDataSyncBackupStoreService=r,this.logService=s,this.environmentService=a,this.storageService=g,this.fileService=E,this.userDataProfilesService=A,this.configurationService=B,this.instantiationService=O,this.extUri=l.extUri}async getRemoteSyncedProfiles(){const t=await this.userDataSyncStoreService.readResource("profiles",null,void 0);if(t.content){const r=this.parseSyncData(t.content,"profiles");return(0,u.parseUserDataProfilesManifest)(r)}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.userDataSyncStoreService.getAllResourceRefs(t,r?.collection)).map(({created:l,ref:a})=>({created:l,uri:this.toUri({remote:!0,syncResource:t,profile:r?.id??this.userDataProfilesService.defaultProfile.id,collection:r?.collection,ref:a,node:void 0})}))}async getLocalSyncResourceHandles(t,r){return(await this.userDataSyncBackupStoreService.getAllRefs(r,t)).map(({created:l,ref:a})=>({created:l,uri:this.toUri({remote:!1,syncResource:t,profile:r.id,collection:void 0,ref:a,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const r=this.resolveUri(t),s=r?this.userDataProfilesService.profiles.find(l=>l.id===r.profile):void 0;return r&&s?{profile:s,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.resolveUri(t);if(!r)return[];const s=this.userDataProfilesService.profiles.find(l=>l.id===r.profile);switch(r.syncResource){case"settings":return this.getSettingsAssociatedResources(t,s);case"keybindings":return this.getKeybindingsAssociatedResources(t,s);case"tasks":return this.getTasksAssociatedResources(t,s);case"snippets":return this.getSnippetsAssociatedResources(t,s);case"globalState":return this.getGlobalStateAssociatedResources(t,s);case"extensions":return this.getExtensionsAssociatedResources(t,s);case"profiles":return this.getProfilesAssociatedResources(t,s)}}async getMachineId({uri:t}){const r=this.resolveUri(t);if(!!r){if(r.remote){if(r.ref){const{content:s}=await this.getUserData(r.syncResource,r.ref,r.collection);if(s)return this.parseSyncData(s,r.syncResource)?.machineId}return}return(0,L.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(t){const r=this.resolveUri(t);if(!r||r.node===Be.NOT_EXISTING_RESOURCE)return null;if(r.ref){const s=await this.getContentFromStore(r.remote,r.syncResource,r.profile,r.collection,r.ref);return r.node&&s?this.resolveNodeContent(r.syncResource,s,r.node):s}return!r.remote&&!r.node?this.resolveLatestContent(r.syncResource,r.profile):null}async getContentFromStore(t,r,s,l,a){if(t){const{content:E}=await this.getUserData(r,a,l);return E}const g=this.userDataProfilesService.profiles.find(E=>E.id===s);return g?this.userDataSyncBackupStoreService.resolveContent(g,r,a):null}resolveNodeContent(t,r,s){const l=this.parseSyncData(r,t);switch(t){case"settings":return this.resolveSettingsNodeContent(l,s);case"keybindings":return this.resolveKeybindingsNodeContent(l,s);case"tasks":return this.resolveTasksNodeContent(l,s);case"snippets":return this.resolveSnippetsNodeContent(l,s);case"globalState":return this.resolveGlobalStateNodeContent(l,s);case"extensions":return this.resolveExtensionsNodeContent(l,s);case"profiles":return this.resolveProfileNodeContent(l,s)}}async resolveLatestContent(t,r){const s=this.userDataProfilesService.profiles.find(l=>l.id===r);if(!s)return null;switch(t){case"globalState":return this.resolveLatestGlobalStateContent(s);case"extensions":return this.resolveLatestExtensionsContent(s);case"profiles":return this.resolveLatestProfilesContent(s);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}getSettingsAssociatedResources(t,r){const s=this.extUri.joinPath(t,"settings.json"),l=r?r.settingsResource:this.extUri.joinPath(t,Be.NOT_EXISTING_RESOURCE);return[{resource:s,comparableResource:l}]}resolveSettingsNodeContent(t,r){switch(r){case"settings.json":return(0,m.parseSettingsSyncContent)(t.content).settings}return null}getKeybindingsAssociatedResources(t,r){const s=this.extUri.joinPath(t,"keybindings.json"),l=r?r.keybindingsResource:this.extUri.joinPath(t,Be.NOT_EXISTING_RESOURCE);return[{resource:s,comparableResource:l}]}resolveKeybindingsNodeContent(t,r){switch(r){case"keybindings.json":return(0,f.getKeybindingsContentFromSyncContent)(t.content,!!this.configurationService.getValue(w.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(t,r){const s=this.extUri.joinPath(t,"tasks.json"),l=r?r.tasksResource:this.extUri.joinPath(t,Be.NOT_EXISTING_RESOURCE);return[{resource:s,comparableResource:l}]}resolveTasksNodeContent(t,r){switch(r){case"tasks.json":return(0,y.getTasksContentFromSyncContent)(t.content,this.logService)}return null}async getSnippetsAssociatedResources(t,r){const s=await this.resolveContent(t);if(s){const l=this.parseSyncData(s,"snippets");if(l){const a=(0,S.parseSnippets)(l),g=[];for(const E of Object.keys(a)){const A=this.extUri.joinPath(t,E),B=r?this.extUri.joinPath(r.snippetsHome,E):this.extUri.joinPath(t,Be.NOT_EXISTING_RESOURCE);g.push({resource:A,comparableResource:B})}return g}}return[]}resolveSnippetsNodeContent(t,r){return(0,S.parseSnippets)(t)[r]||null}getExtensionsAssociatedResources(t,r){const s=this.extUri.joinPath(t,"extensions.json"),l=r?this.toUri({remote:!1,syncResource:"extensions",profile:r.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,Be.NOT_EXISTING_RESOURCE);return[{resource:s,comparableResource:l}]}resolveExtensionsNodeContent(t,r){switch(r){case"extensions.json":return(0,h.stringify)((0,h.parseExtensions)(t),!0)}return null}async resolveLatestExtensionsContent(t){const{localExtensions:r}=await this.instantiationService.createInstance(h.LocalExtensionsProvider).getLocalExtensions(t);return(0,h.stringify)(r,!0)}getGlobalStateAssociatedResources(t,r){const s=this.extUri.joinPath(t,"globalState.json"),l=r?this.toUri({remote:!1,syncResource:"globalState",profile:r.id,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(t,Be.NOT_EXISTING_RESOURCE);return[{resource:s,comparableResource:l}]}resolveGlobalStateNodeContent(t,r){switch(r){case"globalState.json":return(0,p.stringify)(JSON.parse(t.content),!0)}return null}async resolveLatestGlobalStateContent(t){const r=await this.instantiationService.createInstance(p.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,p.stringify)(r,!0)}getProfilesAssociatedResources(t,r){const s=this.extUri.joinPath(t,"profiles.json"),l=this.toUri({remote:!1,syncResource:"profiles",profile:this.userDataProfilesService.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:s,comparableResource:l}]}resolveProfileNodeContent(t,r){switch(r){case"profiles.json":return(0,d.toFormattedString)(JSON.parse(t.content),{})}return null}async resolveLatestProfilesContent(t){return(0,u.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}toUri(t){const r=t.remote?Be.REMOTE_BACKUP_AUTHORITY:Be.LOCAL_BACKUP_AUTHORITY,s=[t.syncResource,t.profile];return t.collection&&s.push(`collection:${t.collection}`),t.ref&&s.push(`ref:${t.ref}`),t.node&&s.push(t.node),this.extUri.joinPath(D.URI.from({scheme:w.USER_DATA_SYNC_SCHEME,authority:r,path:"/"}),...s)}resolveUri(t){if(t.scheme!==w.USER_DATA_SYNC_SCHEME||t.authority!==Be.LOCAL_BACKUP_AUTHORITY&&t.authority!==Be.REMOTE_BACKUP_AUTHORITY)return;const r=[];for(;t.path!=="/";)r.unshift(this.extUri.basename(t)),t=this.extUri.dirname(t);if(r.length<2)return;const s=t.authority===Be.REMOTE_BACKUP_AUTHORITY,l=r.shift(),a=r.shift();let g,E,A;for(;r.length;){const B=r.shift();B.startsWith("collection:")?g=B.substring(11):B.startsWith("ref:")?E=B.substring(4):A=B}return{remote:s,syncResource:l,profile:a,collection:g,ref:E,node:A}}parseSyncData(t,r){try{const s=JSON.parse(t);if((0,C.isSyncData)(s))return s}catch(s){this.logService.error(s)}throw new w.UserDataSyncError((0,i.localize)(0,null),"IncompatibleRemoteContent",r)}async getUserData(t,r,s){const l=await this.userDataSyncStoreService.resolveResourceContent(t,r,s);return{ref:r,content:l}}};n.NOT_EXISTING_RESOURCE="not-existing-resource",n.REMOTE_BACKUP_AUTHORITY="remote-backup",n.LOCAL_BACKUP_AUTHORITY="local-backup",n=ve([K(0,w.IUserDataSyncStoreService),K(1,w.IUserDataSyncBackupStoreService),K(2,w.IUserDataSyncLogService),K(3,I.IUriIdentityService),K(4,R.IEnvironmentService),K(5,P.IStorageService),K(6,T.IFileService),K(7,b.IUserDataProfilesService),K(8,v.IConfigurationService),K(9,c.IInstantiationService)],n),e.UserDataSyncResourceProviderService=n}),define(re[273],se([0,1,20,6,24,37,3,2,21,15,31,16,13,29,4,25,19,23,18,123,124,118,119,120,121,122,26]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v,y,h,p,c,u,d,n,o,t,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const l="sync.lastSyncTime";let a=class extends P.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(O,N,F,k,U,$,G,W,V,z,j){super(),this.userDataSyncStoreService=O,this.userDataSyncStoreManagementService=N,this.instantiationService=F,this.logService=k,this.telemetryService=U,this.storageService=$,this.userDataSyncEnablementService=G,this.userDataProfilesService=W,this.productService=V,this.environmentService=z,this.userDataSyncResourceProviderService=j,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=N.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(l,-1,void 0),this._register((0,P.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(O,N){this.checkEnablement(),this.logService.info("Sync started.");const F=new Date().getTime(),k=(0,b.generateUuid)();try{const W=(0,s.createSyncHeaders)(k);N&&(W["Cache-Control"]="no-cache"),O=await this.userDataSyncStoreService.manifest(O,W)}catch(W){const V=s.UserDataSyncError.toUserDataSyncError(W);throw A(V,k,this.userDataSyncStoreManagementService,this.telemetryService),V}const U=!1,$=this;let G;return{manifest:O,async run(){if(U)throw new Error("Can run a task only once");G=(0,i.createCancelablePromise)(W=>$.sync(O,!1,k,W)),await G.finally(()=>G=void 0),$.logService.info(`Sync done. Took ${new Date().getTime()-F}ms`),$.updateLastSyncTime()},stop(){return G?.cancel(),$.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new s.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const O=new Date().getTime(),N=(0,b.generateUuid)(),F=(0,s.createSyncHeaders)(N);let k;try{k=await this.userDataSyncStoreService.manifest(null,F)}catch(G){const W=s.UserDataSyncError.toUserDataSyncError(G);throw A(W,N,this.userDataSyncStoreManagementService,this.telemetryService),W}await this.resetLocal();const U=this,$=new R.CancellationTokenSource;return{id:N,async merge(){return U.sync(k,!0,N,$.token)},async apply(){await U.applyManualSync(k,N,$.token),U.logService.info(`Sync done. Took ${new Date().getTime()-O}ms`),U.updateLastSyncTime()},stop(){return $.cancel(),U.stop()},dispose(){$.cancel(),U.stop()}}}async sync(O,N,F,k){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const U=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(U,O,N,F,k));const $=U.enabled.find(G=>G.resource==="profiles");if($){const G=await $.getLastSyncedProfiles()||[];if(k.isCancellationRequested)return;await this.syncRemoteProfiles(G,O,N,F,k)}}finally{this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(O,N,F,k,U){for(const $ of O){if(U.isCancellationRequested)return;const G=this.userDataProfilesService.profiles.find(V=>V.id===$.id);if(!G){this.logService.error(`Settings Profile with id:${$.id} and name: ${$.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",$.name);const W=this.getOrCreateActiveProfileSynchronizer(G,$);this._syncErrors.push(...await this.syncProfile(W,N,F,k,U))}}async applyManualSync(O,N,F){const k=this.getActiveProfileSynchronizers();for(const V of k){if(F.isCancellationRequested)return;await V.apply(N,F)}const U=k.find(V=>V.profile.isDefault);if(!U)return;const $=U.enabled.find(V=>V.resource==="profiles");if(!$)return;const W=(await $.getRemoteSyncedProfiles(O?.latest??null)||[]).filter(V=>k.every(z=>z.profile.id!==V.id));W.length&&await this.syncRemoteProfiles(W,O,!1,N,F)}async syncProfile(O,N,F,k,U){return(await O.sync(N,F,k,U)).map(([G,W])=>({profile:O.profile,syncResource:G,error:W}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(O=>O.stop()))}async resolveContent(O){const N=await this.userDataSyncResourceProviderService.resolveContent(O);if(N)return N;for(const F of this.getActiveProfileSynchronizers())for(const k of F.enabled){const U=await k.resolveContent(O);if(U)return U}return null}async replace(O){this.checkEnablement();const N=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(O);if(!N)return;const F=await this.resolveContent(O.uri);!F||await this.performAction(N.profile,async k=>{if(N.syncResource===k.resource)return await k.replace(F),!0})}async accept(O,N,F,k){this.checkEnablement(),await this.performAction(O.profile,async U=>{if(O.syncResource===U.resource)return await U.accept(N,F),k&&await U.apply((0,w.isBoolean)(k)?!1:k.force,(0,s.createSyncHeaders)((0,b.generateUuid)())),!0})}getRemoteProfiles(){return this.userDataSyncResourceProviderService.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(O,N){return this.userDataSyncResourceProviderService.getRemoteSyncResourceHandles(O,N)}async getLocalSyncResourceHandles(O,N){return this.userDataSyncResourceProviderService.getLocalSyncResourceHandles(O,N??this.userDataProfilesService.defaultProfile)}async getAssociatedResources(O){return this.userDataSyncResourceProviderService.getAssociatedResources(O)}async getMachineId(O){return this.userDataSyncResourceProviderService.getMachineId(O)}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async N=>{if(N.resource!=="globalState"&&await N.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async N=>{if(await N.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(O){this.logService.error(O)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this.storageService.remove(l,-1);for(const[O]of this.activeProfileSynchronizers.values())try{await O.resetLocal()}catch(N){this.logService.error(N)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performAction(O,N){const F=new P.DisposableStore;try{const k=this.activeProfileSynchronizers.get(O.id);if(k){const V=await this.performActionWithProfileSynchronizer(k[0],N,F);return(0,w.isUndefined)(V)?null:V}if(O.isDefault){const V=F.add(this.instantiationService.createInstance(g,O,void 0)),z=await this.performActionWithProfileSynchronizer(V,N,F);return(0,w.isUndefined)(z)?null:z}if(this.userDataProfilesService.isEnabled()||this.environmentService.isBuilt&&(!this.productService.enableSyncingProfiles||(0,I.isEqual)(this.userDataSyncStoreManagementService.userDataSyncStore?.url,this.userDataSyncStoreManagementService.userDataSyncStore?.stableUrl)))return null;const U=F.add(this.instantiationService.createInstance(r.UserDataProfilesManifestSynchroniser,O,void 0)),$=await this.userDataSyncStoreService.manifest(null),W=(await U.getRemoteSyncedProfiles($?.latest??null)||[]).find(V=>V.id===O.id);if(W){const V=F.add(this.instantiationService.createInstance(g,O,W.collection)),z=await this.performActionWithProfileSynchronizer(V,N,F);return(0,w.isUndefined)(z)?null:z}return null}finally{F.dispose()}}async performActionWithProfileSynchronizer(O,N,F){const k=[...O.enabled,...O.disabled.map(U=>F.add(O.createSynchronizer(U)))];for(const U of k){const $=await N(U);if(!(0,w.isUndefined)($))return $}}setStatus(O){const N=this._status;this._status!==O&&(this._status=O,this._onDidChangeStatus.fire(O),N==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const O=this.getActiveProfileSynchronizers().map(N=>N.conflicts).flat();(0,D.equals)(this._conflicts,O,(N,F)=>N.profile.id===F.profile.id&&N.syncResource===F.syncResource&&(0,D.equals)(N.conflicts,F.conflicts,(k,U)=>(0,I.isEqual)(k.previewResource,U.previewResource)))||(this._conflicts=O,this._onDidChangeConflicts.fire(O))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(l,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(O,N){let F=this.activeProfileSynchronizers.get(O.id);if(!F){const k=new P.DisposableStore,U=k.add(this.instantiationService.createInstance(g,O,N?.collection));k.add(U.onDidChangeStatus($=>this.setStatus($))),k.add(U.onDidChangeConflicts($=>this.updateConflicts())),k.add(U.onDidChangeLocal($=>this._onDidChangeLocal.fire($))),this.activeProfileSynchronizers.set(O.id,F=[U,k])}return F[0]}getActiveProfileSynchronizers(){const O=[];for(const[N]of this.activeProfileSynchronizers.values())O.push(N);return O}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,O])=>O.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};a=ve([K(0,s.IUserDataSyncStoreService),K(1,s.IUserDataSyncStoreManagementService),K(2,f.IInstantiationService),K(3,s.IUserDataSyncLogService),K(4,h.ITelemetryService),K(5,y.IStorageService),K(6,s.IUserDataSyncEnablementService),K(7,p.IUserDataProfilesService),K(8,v.IProductService),K(9,S.IEnvironmentService),K(10,s.IUserDataSyncResourceProviderService)],a),e.UserDataSyncService=a;let g=class extends P.Disposable{get enabled(){return this._enabled.sort((O,N)=>O[1]-N[1]).map(([O])=>O)}get disabled(){return s.ALL_SYNC_RESOURCES.filter(O=>!this.userDataSyncEnablementService.isResourceEnabled(O))}get status(){return this._status}get conflicts(){return this._conflicts}get profile(){return this._profile}constructor(O,N,F,k,U,$,G,W,V,z,j,J){super(),this._profile=O,this.collection=N,this.userDataSyncEnablementService=F,this.instantiationService=k,this.extensionGalleryService=U,this.userDataSyncStoreManagementService=$,this.telemetryService=G,this.logService=W,this.productService=V,this.userDataProfilesService=z,this.configurationService=j,this.environmentService=J,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._profile.isDefault&&this._register(z.onDidChangeProfiles(()=>{if(z.defaultProfile.extensionsResource&&!this._profile.extensionsResource||!z.defaultProfile.extensionsResource&&this._profile.extensionsResource){this._profile=z.defaultProfile;for(const[ee]of this._enabled)ee instanceof c.ExtensionsSynchroniser&&(ee.profile=this._profile)}})),this._register(F.onDidChangeResourceEnablement(([ee,ce])=>this.onDidChangeResourceEnablement(ee,ce))),this._register((0,P.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,ee])=>ee.dispose())));for(const ee of s.ALL_SYNC_RESOURCES)F.isResourceEnabled(ee)&&this.registerSynchronizer(ee)}onDidChangeResourceEnablement(O,N){N?this.registerSynchronizer(O):this.deRegisterSynchronizer(O)}registerSynchronizer(O){if(this._enabled.some(([U])=>U.resource===O))return;if(O==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(O==="profiles"){if(!this._profile.isDefault||!this.userDataProfilesService.isEnabled())return;if(this.environmentService.isBuilt&&(!this.productService.enableSyncingProfiles||(0,I.isEqual)(this.userDataSyncStoreManagementService.userDataSyncStore?.url,this.userDataSyncStoreManagementService.userDataSyncStore?.stableUrl))){this.logService.debug("Skipping profiles sync");return}}const N=new P.DisposableStore,F=N.add(this.createSynchronizer(O));N.add(F.onDidChangeStatus(()=>this.updateStatus())),N.add(F.onDidChangeConflicts(()=>this.updateConflicts())),N.add(F.onDidChangeLocal(()=>this._onDidChangeLocal.fire(O)));const k=this.getOrder(O);this._enabled.push([F,k,N])}deRegisterSynchronizer(O){const N=this._enabled.findIndex(([F])=>F.resource===O);if(N!==-1){const F=this._enabled.splice(N,1);for(const[k,,U]of F){if(k.status!=="idle"){const $=k.conflicts.conflicts.length>0;k.stop(),$&&this.updateConflicts(),this.updateStatus()}U.dispose()}}}createSynchronizer(O){switch(O){case"settings":return this.instantiationService.createInstance(n.SettingsSynchroniser,this._profile,this.collection);case"keybindings":return this.instantiationService.createInstance(d.KeybindingsSynchroniser,this._profile,this.collection);case"snippets":return this.instantiationService.createInstance(o.SnippetsSynchroniser,this._profile,this.collection);case"tasks":return this.instantiationService.createInstance(t.TasksSynchroniser,this._profile,this.collection);case"globalState":return this.instantiationService.createInstance(u.GlobalStateSynchroniser,this._profile,this.collection);case"extensions":return this.instantiationService.createInstance(c.ExtensionsSynchroniser,this._profile,this.collection);case"profiles":return this.instantiationService.createInstance(r.UserDataProfilesManifestSynchroniser,this._profile,this.collection)}}async sync(O,N,F,k){if(k.isCancellationRequested)return[];const U=this.enabled;if(!U.length)return[];try{const $=[],G=(0,s.createSyncHeaders)(F),W=(this.collection?O?.collections?.[this.collection]?.latest:O?.latest)??null,V=N?await this.getUserDataSyncConfiguration(W):{};for(const z of U){if(k.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(z.resource))return[];try{if(N){const j=await z.preview(W,V,G);if(j)for(const J of j.resourcePreviews)(J.localChange!==0||J.remoteChange!==0)&&J.mergeState==="preview"&&await z.merge(J.previewResource)}else await z.sync(W,G)}catch(j){const J=s.UserDataSyncError.toUserDataSyncError(j);if(A(J,F,this.userDataSyncStoreManagementService,this.telemetryService),E(j))throw J;this.logService.error(j),this.logService.error(`${z.resource}: ${(0,T.toErrorMessage)(j)}`),$.push([z.resource,J])}}return $}finally{this.updateStatus()}}async apply(O,N){const F=(0,s.createSyncHeaders)(O);for(const k of this.enabled){if(N.isCancellationRequested)return;try{await k.apply(!1,F)}catch(U){const $=s.UserDataSyncError.toUserDataSyncError(U);if(A($,O,this.userDataSyncStoreManagementService,this.telemetryService),E(U))throw $;this.logService.error(U),this.logService.error(`${k.resource}: ${(0,T.toErrorMessage)(U)}`)}}}async stop(){for(const O of this.enabled)try{O.status!=="idle"&&await O.stop()}catch(N){this.logService.error(N)}}async resetLocal(){for(const O of this.enabled)try{await O.resetLocal()}catch(N){this.logService.error(`${O.resource}: ${(0,T.toErrorMessage)(N)}`),this.logService.error(N)}}async getUserDataSyncConfiguration(O){if(!this.profile.isDefault)return{};const N=this.configurationService.getValue(s.USER_DATA_SYNC_CONFIGURATION_SCOPE),F=this.enabled.find(k=>k instanceof n.SettingsSynchroniser);if(F){const k=await F.getRemoteUserDataSyncConfiguration(O);return{...N,...k}}return N}setStatus(O){this._status!==O&&(this._status=O,this._onDidChangeStatus.fire(O))}updateStatus(){return this.updateConflicts(),this.enabled.some(O=>O.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(O=>O.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const O=this.enabled.filter(N=>N.status==="hasConflicts").filter(N=>N.conflicts.conflicts.length>0).map(N=>N.conflicts);(0,D.equals)(this._conflicts,O,(N,F)=>N.syncResource===F.syncResource&&(0,D.equals)(N.conflicts,F.conflicts,(k,U)=>(0,I.isEqual)(k.previewResource,U.previewResource)))||(this._conflicts=O,this._onDidChangeConflicts.fire(O))}getOrder(O){switch(O){case"profiles":return 0;case"settings":return 1;case"keybindings":return 2;case"snippets":return 3;case"tasks":return 4;case"globalState":return 5;case"extensions":return 6}}};g=ve([K(2,s.IUserDataSyncEnablementService),K(3,f.IInstantiationService),K(4,m.IExtensionGalleryService),K(5,s.IUserDataSyncStoreManagementService),K(6,h.ITelemetryService),K(7,s.IUserDataSyncLogService),K(8,v.IProductService),K(9,p.IUserDataProfilesService),K(10,C.IConfigurationService),K(11,S.IEnvironmentService)],g);function E(B){if(B instanceof s.UserDataSyncError)switch(B.code){case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function A(B,O,N,F){F.publicLog2("sync/error",{code:B.code,serverCode:B instanceof s.UserDataSyncStoreError?String(B.serverCode):void 0,url:B instanceof s.UserDataSyncStoreError?B.url:void 0,resource:B.resource,executionId:O,service:N.userDataSyncStore.url.toString()})}}),define(re[274],se([0,1,3,2,8,18,26]),function(Q,e,D,i,R,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function P(S,m){return{...S,profile:(0,T.reviveProfile)(S.profile,m.profilesHome.scheme)}}function I(S){return{created:S.created,uri:R.URI.revive(S.uri)}}class w{constructor(m,f,v){this.service=m,this.userDataProfilesService=f,this.logService=v,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(m,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(m,f,v){try{return await this._call(m,f,v)}catch(y){throw this.logService.error(y),y}}async _call(m,f,v){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(R.URI.revive(v[0]));case"accept":return this.service.accept(P(v[0],this.userDataProfilesService),R.URI.revive(v[1]),v[2],v[3]);case"getRemoteProfiles":return this.service.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(v[0],(0,T.reviveProfile)(v[1],this.userDataProfilesService.profilesHome.scheme));case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(v[0],v[1]);case"replace":return this.service.replace(I(v[0]));case"getAssociatedResources":return this.service.getAssociatedResources(I(v[0]));case"getMachineId":return this.service.getMachineId(I(v[0]));case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const y=f.substring(11),h=v[0],p=this.getManualSyncTask(h);switch(v=v.slice(1),y){case"merge":return p.merge();case"apply":return p.apply();case"stop":return p.stop();case"dispose":return this.disposeManualSyncTask(p)}}throw new Error("Invalid call")}getManualSyncTask(m){const f=this.manualSyncTasks.get(this.createKey(m));if(!f)throw new Error(`Manual sync taks not found: ${m}`);return f.manualSyncTask}async createManualSyncTask(){const m=new i.DisposableStore,f=m.add(await this.service.createManualSyncTask());return this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:m}),f.id}disposeManualSyncTask(m){m.dispose();const f=this.createKey(m.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(m){return`manualSyncTask-${m}`}}e.UserDataSyncChannel=w;let b=class extends i.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(m,f){super(),this.userDataProfilesService=f,this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(v,y,h){return m.call(v,y,h).then(null,p=>{throw L.UserDataSyncError.toUserDataSyncError(p)})},listen(v,y){return m.listen(v,y)}},this.channel.call("_getInitialData").then(([v,y,h])=>{this.updateStatus(v),this.updateConflicts(y),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(p=>this.updateStatus(p))),this._register(this.channel.listen("onDidChangeLastSyncTime")(p=>this.updateLastSyncTime(p)))}),this._register(this.channel.listen("onDidChangeConflicts")(v=>this.updateConflicts(v))),this._register(this.channel.listen("onSyncErrors")(v=>this._onSyncErrors.fire(v.map(y=>({...y,error:L.UserDataSyncError.toUserDataSyncError(y.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const m=await this.channel.call("createManualSyncTask"),f=this;return new C(m,{async call(y,h,p){return f.channel.call(`manualSync/${y}`,[m,...Array.isArray(h)?h:[h]],p)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(m,f,v,y){return this.channel.call("accept",[m,f,v,y])}resolveContent(m){return this.channel.call("resolveContent",[m])}getRemoteProfiles(){return this.channel.call("getRemoteProfiles")}async getLocalSyncResourceHandles(m,f){return(await this.channel.call("getLocalSyncResourceHandles",[m,f])).map(({created:y,uri:h})=>({created:y,uri:R.URI.revive(h)}))}async getRemoteSyncResourceHandles(m,f){return(await this.channel.call("getRemoteSyncResourceHandles",[m,f])).map(({created:y,uri:h})=>({created:y,uri:R.URI.revive(h)}))}async getAssociatedResources(m){return(await this.channel.call("getAssociatedResources",[m])).map(({resource:v,comparableResource:y})=>({resource:R.URI.revive(v),comparableResource:R.URI.revive(y)}))}getMachineId(m){return this.channel.call("getMachineId",[m])}replace(m){return this.channel.call("replace",[m])}async updateStatus(m){this._status=m,this._onDidChangeStatus.fire(m)}async updateConflicts(m){this._conflicts=m.map(f=>({syncResource:f.syncResource,profile:(0,T.reviveProfile)(f.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:f.conflicts.map(v=>({...v,baseResource:R.URI.revive(v.baseResource),localResource:R.URI.revive(v.localResource),remoteResource:R.URI.revive(v.remoteResource),previewResource:R.URI.revive(v.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(m){this._lastSyncTime!==m&&(this._lastSyncTime=m,this._onDidChangeLastSyncTime.fire(m))}};b=ve([K(1,T.IUserDataProfilesService)],b),e.UserDataSyncChannelClient=b;class C extends i.Disposable{constructor(m,f){super(),this.id=m,this.channel=f}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose")}}}),define(re[275],se([0,1,6,24,11,3,2,139,5,21,15,8,31,16,13,14,25,47,44,19,26]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v,y,h,p,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const d="sync.previous.store",n="sync.donot-make-requests-until",o="sync.user-session-id",t="sync.machine-session-id",r=100,s=1e3*60*5;let l=class extends L.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(u.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(O){this.storageService.store(u.SYNC_SERVICE_URL_TYPE,O,-1,I.isWeb?0:1)}constructor(O,N,F){super(),this.productService=O,this.configurationService=N,this.storageService=F,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(F.onDidChangeValue,k=>k.key===u.SYNC_SERVICE_URL_TYPE&&k.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[u.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(u.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,N){O=I.isWeb&&O?.web?{...O,...O.web}:O;const F={...O||{},...N||{}};if(F&&(0,b.isString)(F.url)&&(0,b.isObject)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(k=>Array.isArray(F.authenticationProviders[k].scopes))){const k=F,U=!!k.canSwitch&&!N?.url,$=k.url===k.insidersUrl?"insiders":"stable",G=(U?this.userDataSyncStoreType:void 0)||$,W=N?.url||(G==="insiders"?k.insidersUrl:G==="stable"?k.stableUrl:k.url);return{url:C.URI.parse(W),type:G,defaultType:$,defaultUrl:C.URI.parse(k.url),stableUrl:C.URI.parse(k.stableUrl),insidersUrl:C.URI.parse(k.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(k.authenticationProviders).reduce((V,z)=>(V.push({id:z,scopes:k.authenticationProviders[z].scopes}),V),[])}}}};l=ve([K(0,y.IProductService),K(1,m.IConfigurationService),K(2,c.IStorageService)],l),e.AbstractUserDataSyncStoreManagementService=l;let a=class extends l{constructor(O,N,F){super(O,N,F);const k=this.storageService.get(d,-1);k&&(this.previousConfigurationSyncStore=JSON.parse(k));const U=this.productService[u.CONFIGURATION_SYNC_STORE_KEY];U?this.storageService.store(d,JSON.stringify(U),-1,1):this.storageService.remove(d,-1)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};a=ve([K(0,y.IProductService),K(1,m.IConfigurationService),K(2,c.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let g=class extends L.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(O,N,F,k,U,$,G){super(),this.requestService=F,this.logService=k,this.storageService=G,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,p.getServiceMachineId)(U,$,G).then(W=>{const V={"X-Client-Name":`${N.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(V["X-Client-Commit"]=N.commit),V}),this.session=new A(r,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,L.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(O,N){this.authToken={token:O,type:N}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,w.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(n,-1);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(n,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(N=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(n,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,w.joinPath)(this.userDataSyncStoreUrl,"collection").toString();O={...O},O["Content-Type"]="application/json";const F=await this.request(N,{type:"GET",headers:O},[],i.CancellationToken.None);return await(0,h.asJson)(F)||[]}async createCollection(O={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,w.joinPath)(this.userDataSyncStoreUrl,"collection").toString();O={...O},O["Content-Type"]=P.Mimes.text;const F=await this.request(N,{type:"POST",headers:O},[],i.CancellationToken.None),k=await(0,h.asTextOrError)(F);if(!k)throw new u.UserDataSyncStoreError("Server did not return the collection id",N,"NoCollection",F.res.statusCode,F.res.headers[u.HEADER_OPERATION_ID]);return k}async deleteCollection(O,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=O?(0,w.joinPath)(this.userDataSyncStoreUrl,"collection",O).toString():(0,w.joinPath)(this.userDataSyncStoreUrl,"collection").toString();N={...N},await this.request(F,{type:"DELETE",headers:N},[],i.CancellationToken.None)}async getAllResourceRefs(O,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=this.getResourceUrl(this.userDataSyncStoreUrl,N,O),k={},U=await this.request(F.toString(),{type:"GET",headers:k},[],i.CancellationToken.None);return(await(0,h.asJson)(U)||[]).map(({url:G,created:W})=>({ref:(0,w.relativePath)(F,F.with({path:G})),created:W*1e3}))}async resolveResourceContent(O,N,F,k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,w.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,F,O),N).toString();k={...k},k["Cache-Control"]="no-cache";const $=await this.request(U,{type:"GET",headers:k},[],i.CancellationToken.None);return await(0,h.asTextOrError)($)}async deleteResource(O,N,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=N!==null?(0,w.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,F,O),N).toString():this.getResourceUrl(this.userDataSyncStoreUrl,F,O).toString(),U={};await this.request(k,{type:"DELETE",headers:U},[],i.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,w.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":P.Mimes.text};await this.request(O,{type:"DELETE",headers:N},[],i.CancellationToken.None)}async readResource(O,N,F,k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,w.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,F,O),"latest").toString();k={...k},k["Cache-Control"]="no-cache",N&&(k["If-None-Match"]=N.ref);const $=await this.request(U,{type:"GET",headers:k},[304],i.CancellationToken.None);let G=null;if($.res.statusCode===304&&(G=N),G===null){const W=$.res.headers.etag;if(!W)throw new u.UserDataSyncStoreError("Server did not return the ref",U,"NoRef",$.res.statusCode,$.res.headers[u.HEADER_OPERATION_ID]);const V=await(0,h.asTextOrError)($);if(!V&&$.res.statusCode===304)throw new u.UserDataSyncStoreError("Empty response",U,"EmptyResponse",$.res.statusCode,$.res.headers[u.HEADER_OPERATION_ID]);G={ref:W,content:V}}return G}async writeResource(O,N,F,k,U={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=this.getResourceUrl(this.userDataSyncStoreUrl,k,O).toString();U={...U},U["Content-Type"]=P.Mimes.text,F&&(U["If-Match"]=F);const G=await this.request($,{type:"POST",data:N,headers:U},[],i.CancellationToken.None),W=G.res.headers.etag;if(!W)throw new u.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",G.res.statusCode,G.res.headers[u.HEADER_OPERATION_ID]);return W}async manifest(O,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,w.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",O&&(N["If-None-Match"]=O.ref);const k=await this.request(F,{type:"GET",headers:N},[304],i.CancellationToken.None);let U=null;if(k.res.statusCode===304&&(U=O),!U){const G=k.res.headers.etag;if(!G)throw new u.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",k.res.statusCode,k.res.headers[u.HEADER_OPERATION_ID]);const W=await(0,h.asTextOrError)(k);if(!W&&k.res.statusCode===304)throw new u.UserDataSyncStoreError("Empty response",F,"EmptyResponse",k.res.statusCode,k.res.headers[u.HEADER_OPERATION_ID]);W&&(U={...JSON.parse(W),ref:G})}const $=this.storageService.get(o,-1);return $&&U&&$!==U.session&&this.clearSession(),U===null&&$&&this.clearSession(),U&&this.storageService.store(o,U.session,-1,1),U}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteResources(),await this.deleteCollection(),this.clearSession()}getResourceUrl(O,N,F){return N?(0,w.joinPath)(O,"collection",N,"resource",F):(0,w.joinPath)(O,"resource",F)}clearSession(){this.storageService.remove(o,-1),this.storageService.remove(t,-1)}async request(O,N,F,k){if(!this.authToken)throw new u.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new u.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const U=await this.commonHeadersPromise;N.headers={...N.headers||{},...U,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:O,type:N.type,headers:{...N.headers,authorization:void 0}});let $;try{$=await this.session.request(O,N,k)}catch(z){if(!(z instanceof u.UserDataSyncStoreError)){let j="RequestFailed";const J=(0,R.getErrorMessage)(z).toLowerCase();J.includes("xhr timeout")?j="RequestTimeout":J.includes("protocol")&&J.includes("not supported")?j="RequestProtocolNotSupported":J.includes("request path contains unescaped characters")?j="RequestPathNotEscaped":J.includes("headers must be an object")?j="RequestHeadersNotObject":(0,R.isCancellationError)(z)&&(j="RequestCanceled"),z=new u.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,j,void 0,void 0)}throw this.logService.info("Request failed",O),z}const G=$.res.headers[u.HEADER_OPERATION_ID],W={url:O,status:$.res.statusCode,"execution-id":N.headers[u.HEADER_EXECUTION_ID],"operation-id":G},V=(0,h.isSuccess)($)||$.res.statusCode&&F.indexOf($.res.statusCode)!==-1;if(V?this.logService.trace("Request succeeded",W):this.logService.info("Request failed",W),$.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new u.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",$.res.statusCode,G);if(this._onTokenSucceed.fire(),$.res.statusCode===409)throw new u.UserDataSyncStoreError(`${N.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",$.res.statusCode,G);if($.res.statusCode===410)throw new u.UserDataSyncStoreError(`${N.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",$.res.statusCode,G);if($.res.statusCode===412)throw new u.UserDataSyncStoreError(`${N.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",$.res.statusCode,G);if($.res.statusCode===413)throw new u.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",$.res.statusCode,G);if($.res.statusCode===426)throw new u.UserDataSyncStoreError(`${N.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",$.res.statusCode,G);if($.res.statusCode===429){const z=$.res.headers["retry-after"];throw z?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(z)*1e3)),new u.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",$.res.statusCode,G)):new u.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",$.res.statusCode,G)}if(!V)throw new u.UserDataSyncStoreError("Server returned "+$.res.statusCode,O,"Unknown",$.res.statusCode,G);return $}addSessionHeaders(O){let N=this.storageService.get(t,-1);N===void 0&&(N=(0,S.generateUuid)(),this.storageService.store(t,N,-1,1)),O["X-Machine-Session-Id"]=N;const F=this.storageService.get(o,-1);F!==void 0&&(O["X-User-Session-Id"]=F)}};g=ve([K(1,y.IProductService),K(2,h.IRequestService),K(3,u.IUserDataSyncLogService),K(4,f.IEnvironmentService),K(5,v.IFileService),K(6,c.IStorageService)],g),e.UserDataSyncStoreClient=g;let E=class extends g{constructor(O,N,F,k,U,$,G){super(O.userDataSyncStore?.url,N,F,k,U,$,G),this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};E=ve([K(0,u.IUserDataSyncStoreManagementService),K(1,y.IProductService),K(2,h.IRequestService),K(3,u.IUserDataSyncLogService),K(4,f.IEnvironmentService),K(5,v.IFileService),K(6,c.IStorageService)],E),e.UserDataSyncStoreService=E;class A{constructor(O,N,F,k){this.limit=O,this.interval=N,this.requestService=F,this.logService=k,this.requests=[],this.startTime=void 0}request(O,N,F){if(this.isExpired()&&this.reset(),N.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new u.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(N,F)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=A}),define(re[276],se([0,1,3,59,25,19,23,271,26,76,79]),function(Q,e,D,i,R,T,L,P,I,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends P.UserDataAutoSyncService{constructor(m,f,v,y,h,p,c,u,d,n,o){super(m,f,v,y,h,c,u,d,n,o),this._register(D.Event.debounce(D.Event.any(D.Event.map(p.onDidFocusWindow,()=>"windowFocus"),D.Event.map(p.onDidOpenWindow,()=>"windowOpen")),(t,r)=>t?[...t,r]:[r],1e3)(t=>this.triggerSync(t,!0,!1)))}};C=ve([K(0,R.IProductService),K(1,I.IUserDataSyncStoreManagementService),K(2,I.IUserDataSyncStoreService),K(3,I.IUserDataSyncEnablementService),K(4,I.IUserDataSyncService),K(5,i.INativeHostService),K(6,I.IUserDataSyncLogService),K(7,w.IUserDataSyncAccountService),K(8,L.ITelemetryService),K(9,b.IUserDataSyncMachinesService),K(10,T.IStorageService)],C),e.UserDataAutoSyncService=C}),define(re[277],se([0,1,3,2,58,7,62,19,74,18]),function(Q,e,D,i,R,T,L,P,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncProfilesStorageService=void 0;let b=class extends L.AbstractUserDataSyncProfilesStorageService{constructor(S,m,f,v){super(f),this.mainProcessService=S;const y=S.getChannel("profileStorageListener"),h=this._register(new i.MutableDisposable);this._onDidChange=this._register(new D.Emitter({onFirstListenerAdd:()=>{h.value=y.listen("onDidChange")(p=>{v.trace("profile storage changes",p),this._onDidChange.fire({targetChanges:p.targetChanges.map(c=>(0,w.reviveProfile)(c,m.profilesHome.scheme)),valueChanges:p.valueChanges.map(c=>({...c,profile:(0,w.reviveProfile)(c.profile,m.profilesHome.scheme)}))})})},onLastListenerRemove:()=>h.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(S){const m=this.mainProcessService.getChannel("storage");return(0,P.isProfileUsingDefaultStorage)(S)?new I.ApplicationStorageDatabaseClient(m):new I.ProfileStorageDatabaseClient(m,S)}};b=ve([K(0,R.IMainProcessService),K(1,w.IUserDataProfilesService),K(2,P.IStorageService),K(3,T.ILogService)],b),e.UserDataSyncProfilesStorageService=b}),define(re[278],se([0,1,99,22,5,21]),function(Q,e,D,i,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function L(w){function b(){let C=w.scheme===i.Schemas.file?(0,T.originalFSPath)(w):w.toString();return R.isLinux||(C=C.toLowerCase()),(0,D.createHash)("md5").update(C).digest("hex")}return{id:b(),configPath:w}}e.getWorkspaceIdentifier=L;function P(w,b){function C(){if(w.scheme!==i.Schemas.file)return(0,D.createHash)("md5").update(w.toString()).digest("hex");if(!b)return;let m;return R.isLinux?m=b.ino:R.isMacintosh?m=b.birthtime.getTime():R.isWindows&&(typeof b.birthtimeMs=="number"?m=Math.floor(b.birthtimeMs):m=b.birthtime.getTime()),(0,D.createHash)("md5").update(w.fsPath).update(m?String(m):"").digest("hex")}const S=C();if(typeof S=="string")return{id:S,uri:w}}e.getSingleFolderWorkspaceIdentifier=P;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(re[279],se([0,1,6,11,2,12,28,13,58,7,59,74,116,278]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let f=class extends R.Disposable{constructor(y,h,p,c){super(),this.environmentService=y,this.logService=h,this.nativeHostService=p,this.mainProcessService=c,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const y=await L.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath),h=new C.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(y.map(async p=>{const c=(0,T.join)(this.environmentService.workspaceStorageHome.fsPath,p);p.length===m.NON_EMPTY_WORKSPACE_ID_LENGTH||p===S.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(n=>n.workspace?.id===p)||await h.isUsed(c)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${p} as it seems to be an unused empty workspace.`),await L.Promises.rm(c))}))}catch(y){(0,i.onUnexpectedError)(y)}}};f=ve([K(0,P.INativeEnvironmentService),K(1,w.ILogService),K(2,b.INativeHostService),K(3,I.IMainProcessService)],f),e.UnusedWorkspaceStorageDataCleaner=f}),define(re[125],se([0,1,54,6,12,15,28,151,288,289]),function(Q,e,D,i,R,T,L,P,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class b extends Error{constructor(n,o){let t=o.message;switch(n){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=n,this.cause=o}}e.ExtractError=b;function C(d){const n=d.externalFileAttributes>>16||33188;return[448,56,7].map(o=>n&o).reduce((o,t)=>o+t,n&61440)}function S(d){if(d instanceof b)return d;let n;return/end of central directory record signature not found/.test(d.message)&&(n="CorruptZip"),new b(n,d)}function m(d,n,o,t,r,s){const l=R.dirname(n),a=R.join(t,l);if(!a.startsWith(t))return Promise.reject(new Error(P.localize(0,null,n)));const g=R.join(t,n);let E;return s.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(L.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((A,B)=>{if(!s.isCancellationRequested)try{E=(0,D.createWriteStream)(g,{mode:o}),E.once("close",()=>A()),E.once("error",B),d.once("error",B),d.pipe(E)}catch(O){B(O)}}))}function f(d,n,o,t){let r=(0,i.createCancelablePromise)(()=>Promise.resolve()),s=0;return t.onCancellationRequested(()=>{r.cancel(),d.close()}),new Promise((l,a)=>{const g=new i.Sequencer,E=A=>{A.isCancellationRequested||(s++,d.readEntry())};d.once("error",a),d.once("close",()=>r.then(()=>{t.isCancellationRequested||d.entryCount===s?l():a(new b("Incomplete",new Error(P.localize(1,null,s,d.entryCount))))},a)),d.readEntry(),d.on("entry",A=>{if(t.isCancellationRequested)return;if(!o.sourcePathRegex.test(A.fileName)){E(t);return}const B=A.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(B)){const F=R.join(n,B);r=(0,i.createCancelablePromise)(k=>L.Promises.mkdir(F,{recursive:!0}).then(()=>E(k)).then(void 0,a));return}const O=y(d,A),N=C(A);r=(0,i.createCancelablePromise)(F=>g.queue(()=>O.then(k=>m(k,B,N,n,o,F).then(()=>E(F)))).then(null,a))})})}function v(d,n=!1){return new Promise((o,t)=>{(0,I.open)(d,n?{lazyEntries:!0}:void 0,(r,s)=>{r?t(S(r)):o((0,T.assertIsDefined)(s))})})}function y(d,n){return new Promise((o,t)=>{d.openReadStream(n,(r,s)=>{r?t(S(r)):o((0,T.assertIsDefined)(s))})})}function h(d,n){return new Promise((o,t)=>{const r=new w.ZipFile;n.forEach(l=>{l.contents?r.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&r.addFile(l.localPath,l.path)}),r.end();const s=(0,D.createWriteStream)(d);r.outputStream.pipe(s),r.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>o(d))})}e.zip=h;function p(d,n,o={},t){const r=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let s=v(d,!0);return o.overwrite&&(s=s.then(l=>L.Promises.rm(n).then(()=>l))),s.then(l=>f(l,n,{sourcePathRegex:r},t))}e.extract=p;function c(d,n){return v(d).then(o=>new Promise((t,r)=>{o.on("entry",s=>{s.fileName===n&&y(o,s).then(l=>t(l),l=>r(l))}),o.once("close",()=>r(new Error(P.localize(2,null,n))))}))}function u(d,n){return c(d,n).then(o=>new Promise((t,r)=>{const s=[];o.once("error",r),o.on("data",l=>s.push(l)),o.on("end",()=>t(Buffer.concat(s)))}))}e.buffer=u}),define(re[280],se([0,1,125,161]),function(Q,e,D,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(T){return(0,D.buffer)(T,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,i.localize)(0,null))}})}e.getManifest=R}),define(re[126],se([0,1,6,37,11,2,22,12,5,21,55,15,8,31,28,125,160,96,13,262,29,33,51,77,217,263,280,218,249,46,70,14,4,7,25,23,30,18]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v,y,h,p,c,u,d,n,o,t,r,s,l,a,g,E,A,B,O,N,F,k,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,B.refineServiceDecorator)(u.IExtensionManagementService);let $=class extends c.AbstractExtensionManagementService{constructor(q,x,_,M,Y,H,Z,oe,X,ie,ne,le){super(q,x,_,ie,le),this.extensionsScannerService=Y,this.extensionsProfileScannerService=H,this.downloadService=Z,this.fileService=X,this.installGalleryExtensionsTasks=new Map;const ue=this._register(oe.createInstance(r.ExtensionsLifecycle));this.extensionsScanner=this._register(oe.createInstance(G,we=>ue.postUninstall(we))),this.manifestCache=this._register(new l.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(oe.createInstance(t.ExtensionsDownloader));const pe=this._register(new a.ExtensionsWatcher(this,X,M,_,ne));this._register(pe.onDidChangeExtensionsByAnotherSource(({added:we,removed:Ee})=>{we.length&&this._onDidInstallExtensions.fire(we.map(Ce=>({identifier:Ce.identifier,operation:1,local:Ce}))),Ee.forEach(Ce=>this._onDidUninstallExtension.fire({identifier:Ce}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,d.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(q){this.logService.trace("ExtensionManagementService#zip",q.identifier.id);const x=await this.collectFiles(q),_=await(0,v.zip)((0,w.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,m.generateUuid)()).fsPath,x);return S.URI.file(_)}async unzip(q){return this.logService.trace("ExtensionManagementService#unzip",q.toString()),(await this.install(q)).identifier}async getManifest(q){const{location:x,cleanup:_}=await this.downloadVsix(q),M=P.resolve(x.fsPath);try{return await(0,s.getManifest)(M)}finally{await _()}}getInstalled(q,x){return this.extensionsScanner.scanExtensions(q??null,x)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(q,x={}){this.logService.trace("ExtensionManagementService#install",q.toString());const{location:_,cleanup:M}=await this.downloadVsix(q);try{const Y=await(0,s.getManifest)(P.resolve(_.fsPath));if(Y.engines&&Y.engines.vscode&&!(0,E.isEngineValid)(Y.engines.vscode,this.productService.version,this.productService.date))throw new Error(y.localize(0,null,(0,d.getGalleryExtensionId)(Y.publisher,Y.name),this.productService.version));return await this.installExtension(Y,_,x)}finally{await M()}}getMetadata(q){return this.extensionsScannerService.scanMetadata(q.location)}async updateMetadata(q,x){this.logService.trace("ExtensionManagementService#updateMetadata",q.identifier.id);const _={...x};return x.isPreReleaseVersion&&(_.preRelease=!0),q=await this.extensionsScanner.updateMetadata(q,_),this.manifestCache.invalidate(),q}async updateExtensionScope(q,x){return this.logService.trace("ExtensionManagementService#updateExtensionScope",q.identifier.id),q=await this.extensionsScanner.updateMetadata(q,{isMachineScoped:x}),this.manifestCache.invalidate(),q}removeUninstalledExtensions(q){return this.extensionsScanner.cleanUp(q)}async download(q,x){const{location:_}=await this.extensionsDownloader.download(q,x);return _}async downloadVsix(q){if(q.scheme===L.Schemas.file)return{location:q,async cleanup(){}};this.logService.trace("Downloading extension from",q.toString());const x=(0,w.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,m.generateUuid)());return await this.downloadService.download(q,x),this.logService.info("Downloaded extension to",x.toString()),{location:x,cleanup:async()=>{try{await this.fileService.del(x)}catch(M){this.logService.error(M)}}}}doCreateInstallExtensionTask(q,x,_){let M;if(S.URI.isUri(x))M=new z(q,x,_,this.galleryService,this.extensionsScanner,this.logService);else{const Y=d.ExtensionKey.create(x).toString();M=this.installGalleryExtensionsTasks.get(Y),M||(this.installGalleryExtensionsTasks.set(Y,M=new V(q,x,_,this.extensionsDownloader,this.extensionsScanner,this.logService)),M.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(Y)))}return _.profileLocation?new j(M,_.profileLocation,this.extensionsProfileScannerService):M}doCreateUninstallExtensionTask(q,x){return x.profileLocation?new ee(q,x.profileLocation,this.extensionsProfileScannerService):new J(q,x,this.extensionsScanner)}async collectFiles(q){const x=async M=>{let Y=await f.Promises.readdir(M);Y=Y.map(oe=>P.join(M,oe));const H=await Promise.all(Y.map(oe=>f.Promises.stat(oe)));let Z=Promise.resolve([]);return H.forEach((oe,X)=>{const ie=Y[X];oe.isFile()&&(Z=Z.then(ne=>[...ne,ie])),oe.isDirectory()&&(Z=Z.then(ne=>x(ie).then(le=>[...ne,...le])))}),Z};return(await x(q.location.fsPath)).map(M=>({path:`extension/${P.relative(q.location.fsPath,M)}`,localPath:M}))}};$=ve([K(0,u.IExtensionGalleryService),K(1,F.ITelemetryService),K(2,O.ILogService),K(3,p.INativeEnvironmentService),K(4,o.IExtensionsScannerService),K(5,n.IExtensionsProfileScannerService),K(6,h.IDownloadService),K(7,B.IInstantiationService),K(8,A.IFileService),K(9,N.IProductService),K(10,k.IUriIdentityService),K(11,U.IUserDataProfilesService)],$),e.ExtensionManagementService=$;let G=class extends T.Disposable{constructor(q,x,_,M){super(),this.beforeRemovingExtension=q,this.fileService=x,this.extensionsScannerService=_,this.logService=M,this.uninstalledPath=(0,w.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(q){await this.removeUninstalledExtensions(),q&&await this.removeOutdatedExtensions()}async scanExtensions(q,x){const _={includeInvalid:!0,profileLocation:x};let M=[];return q===null||q===0?M.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},_,!1)):q===1&&M.push(...await this.extensionsScannerService.scanUserExtensions(_)),M=q!==null?M.filter(Y=>Y.type===q):M,Promise.all(M.map(Y=>this.toLocalExtension(Y)))}async scanUserExtensions(q){const x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!q,includeInvalid:!0});return Promise.all(x.map(_=>this.toLocalExtension(_)))}async extractUserExtension(q,x,_,M){const Y=q.toString(),H=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,m.generateUuid)()}`),Z=P.join(this.extensionsScannerService.userExtensionsLocation.fsPath,Y);try{await f.Promises.rm(Z)}catch{throw new u.ExtensionManagementError(y.localize(1,null,Z,q.id),u.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(q,x,H,M),await this.extensionsScannerService.updateMetadata(S.URI.file(H),_);try{await this.rename(q,H,Z,Date.now()+2*60*1e3),this.logService.info("Renamed to",Z)}catch(oe){try{await f.Promises.rm(H)}catch{}if(oe.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",q.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(oe)}. Deleted from extracted location`,H),oe}return this.scanLocalExtension(S.URI.file(Z),1)}async updateMetadata(q,x){return await this.extensionsScannerService.updateMetadata(q.location,x),this.scanLocalExtension(q.location,q.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...q){const x=q.map(_=>d.ExtensionKey.create(_));await this.withUninstalledExtensions(_=>{x.forEach(M=>_[M.toString()]=!0)})}async setInstalled(q){await this.withUninstalledExtensions(M=>delete M[q.toString()]);const _=(await this.scanUserExtensions(!0)).find(M=>d.ExtensionKey.create(M).equals(q))||null;return _?this.updateMetadata(_,{installedTimestamp:Date.now()}):null}async removeExtension(q,x){this.logService.trace(`Deleting ${x} extension from disk`,q.identifier.id,q.location.fsPath),await f.Promises.rm(q.location.fsPath),this.logService.info("Deleted from disk",q.identifier.id,q.location.fsPath)}async removeUninstalledExtension(q){await this.removeExtension(q,"uninstalled"),await this.withUninstalledExtensions(x=>delete x[d.ExtensionKey.create(q).toString()])}async withUninstalledExtensions(q){return this.uninstalledFileLimiter.queue(async()=>{let x;try{x=await f.Promises.readFile(this.uninstalledPath,"utf8")}catch(M){if(M.code!=="ENOENT")throw M}let _={};if(x)try{_=JSON.parse(x)}catch{}return q&&(q(_),Object.keys(_).length?await f.Promises.writeFile(this.uninstalledPath,JSON.stringify(_)):await f.Promises.rm(this.uninstalledPath)),_})}async extractAtLocation(q,x,_,M){this.logService.trace(`Started extracting the extension from ${x} to ${_}`);try{await f.Promises.rm(_)}catch(Y){throw new u.ExtensionManagementError(this.joinErrors(Y).message,u.ExtensionManagementErrorCode.Delete)}try{await(0,v.extract)(x,_,{sourcePath:"extension",overwrite:!0},M),this.logService.info(`Extracted extension to ${_}:`,q.id)}catch(Y){try{await f.Promises.rm(_)}catch{}let H=u.ExtensionManagementErrorCode.Extract;throw Y instanceof v.ExtractError&&(Y.type==="CorruptZip"?H=u.ExtensionManagementErrorCode.CorruptZip:Y.type==="Incomplete"&&(H=u.ExtensionManagementErrorCode.IncompleteZip)),new u.ExtensionManagementError(Y.message,H)}}async rename(q,x,_,M){try{await f.Promises.rename(x,_)}catch(Y){if(I.isWindows&&Y&&Y.code==="EPERM"&&Date.now()<M)return this.logService.info(`Failed renaming ${x} to ${_} with 'EPERM' error. Trying again...`,q.id),this.rename(q,x,_,M);throw new u.ExtensionManagementError(Y.message||y.localize(2,null,x,_),Y.code||u.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(q,x){const _=await this.extensionsScannerService.scanExistingExtension(q,x,{includeInvalid:!0});if(_)return this.toLocalExtension(_);throw new Error(y.localize(3,null,q.path))}async toLocalExtension(q){const x=await this.fileService.resolve(q.location);let _,M;return x.children&&(_=x.children.find(({name:Y})=>/^readme(\.txt|\.md|)$/i.test(Y))?.resource,M=x.children.find(({name:Y})=>/^changelog(\.txt|\.md|)$/i.test(Y))?.resource),{identifier:q.identifier,type:q.type,isBuiltin:q.isBuiltin||!!q.metadata?.isBuiltin,location:q.location,manifest:q.manifest,targetPlatform:q.targetPlatform,validations:q.validations,isValid:q.isValid,readmeUrl:_,changelogUrl:M,publisherDisplayName:q.metadata?.publisherDisplayName||null,publisherId:q.metadata?.publisherId||null,isApplicationScoped:!!q.metadata?.isApplicationScoped,isMachineScoped:!!q.metadata?.isMachineScoped,isPreReleaseVersion:!!q.metadata?.isPreReleaseVersion,preRelease:!!q.metadata?.preRelease,installedTimestamp:q.metadata?.installedTimestamp,updated:!!q.metadata?.updated}}async removeUninstalledExtensions(){const q=await this.getUninstalledExtensions(),x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),_=new Set;for(const H of x)q[d.ExtensionKey.create(H).toString()]||_.add(H.identifier.id.toLowerCase());const M=(0,d.groupByExtension)(x,H=>H.identifier);await D.Promises.settled(M.map(async H=>{const Z=H.sort((oe,X)=>b.rcompare(oe.manifest.version,X.manifest.version))[0];_.has(Z.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(Z))}));const Y=x.filter(H=>q[d.ExtensionKey.create(H).toString()]);await D.Promises.settled(Y.map(H=>this.removeUninstalledExtension(H)))}async removeOutdatedExtensions(){const q=await this.extensionsScannerService.scanSystemExtensions({}),x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),_=[],M=await this.extensionsScannerService.getTargetPlatform(),Y=(0,d.groupByExtension)(x,H=>H.identifier);for(const H of Y)if(H.length>1&&_.push(...H.sort((Z,oe)=>{const X=b.rcompare(Z.manifest.version,oe.manifest.version);return X!==0?X:Z.targetPlatform===M?-1:1}).slice(1)),H[0].type===0){const Z=q.find(oe=>(0,d.areSameExtensions)(oe.identifier,H[0].identifier));(!Z||b.gte(Z.manifest.version,H[0].manifest.version))&&_.push(H[0])}await D.Promises.settled(_.map(H=>this.removeExtension(H,"outdated")))}joinErrors(q){const x=Array.isArray(q)?q:[q];return x.length===1?x[0]instanceof Error?x[0]:new Error(x[0]):x.reduce((_,M)=>new Error(`${_.message}${_.message?",":""}${M instanceof Error?M.message:M}`),new Error(""))}};G=ve([K(1,A.IFileService),K(2,o.IExtensionsScannerService),K(3,O.ILogService)],G),e.ExtensionsScanner=G;class W extends c.AbstractExtensionTask{get operation(){return(0,C.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(q,x,_,M,Y){super(),this.identifier=q,this.source=x,this.options=_,this.extensionsScanner=M,this.logService=Y,this.wasVerified=!1,this._operation=2}async installExtension(q,x){try{const _=await this.unsetUninstalledAndGetLocal(q.key);if(_)return this.extensionsScanner.updateMetadata(_,q.metadata)}catch{throw I.isMacintosh?new u.ExtensionManagementError(y.localize(4,null),u.ExtensionManagementErrorCode.Internal):new u.ExtensionManagementError(y.localize(5,null),u.ExtensionManagementErrorCode.Internal)}return this.extract(q,x)}async unsetUninstalledAndGetLocal(q){if(!await this.isUninstalled(q))return null;this.logService.trace("Removing the extension from uninstalled list:",q.id);const _=await this.extensionsScanner.setInstalled(q);return this.logService.info("Removed the extension from uninstalled list:",q.id),_}async isUninstalled(q){return!!(await this.extensionsScanner.getUninstalledExtensions())[q.toString()]}async extract({zipPath:q,key:x,metadata:_},M){const Y=await this.extensionsScanner.extractUserExtension(x,q,_,M);return this.logService.info("Extracting completed.",x.id),Y}}class V extends W{constructor(q,x,_,M,Y,H){super(x.identifier,x,_,Y,H),this.manifest=q,this.gallery=x,this.extensionsDownloader=M}async doRun(q){const _=(await this.extensionsScanner.scanExtensions(null,void 0)).find(Z=>(0,d.areSameExtensions)(Z.identifier,this.gallery.identifier));_&&(this._operation=3);const M={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,g.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||_?.isMachineScoped,isBuiltin:this.options.isBuiltin||_?.isBuiltin,isSystem:_?.type===0?!0:void 0,updated:!!_,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.gallery.properties.isPreReleaseVersion||((0,C.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:_?.preRelease)};if(_?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(_,M),metadata:M};const{location:Y,verified:H}=await this.extensionsDownloader.download(this.gallery,this._operation);try{this.wasVerified=!!H,this.validateManifest(Y.fsPath);const Z=await this.installExtension({zipPath:Y.fsPath,key:d.ExtensionKey.create(this.gallery),metadata:M},q);return _&&!this.options.profileLocation&&(_.targetPlatform!==Z.targetPlatform||b.neq(_.manifest.version,Z.manifest.version))&&await this.extensionsScanner.setUninstalled(_),{local:Z,metadata:M}}catch(Z){try{await this.extensionsDownloader.delete(Y)}catch(oe){this.logService.warn("Error while deleting the downloaded file",Y.toString(),(0,R.getErrorMessage)(oe))}throw Z}}async validateManifest(q){try{await(0,s.getManifest)(q)}catch(x){throw new u.ExtensionManagementError((0,c.joinErrors)(x).message,u.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=V;class z extends W{constructor(q,x,_,M,Y,H){super({id:(0,d.getGalleryExtensionId)(q.publisher,q.name)},x,_,Y,H),this.manifest=q,this.location=x,this.galleryService=M}async doRun(q){const x=new d.ExtensionKey(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1,void 0)).find(Z=>(0,d.areSameExtensions)(this.identifier,Z.identifier)),Y=await this.getMetadata(this.identifier.id,this.manifest.version,q);if(Y.isApplicationScoped=(0,g.isApplicationScopedExtension)(this.manifest),Y.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,Y.isBuiltin=this.options.isBuiltin||M?.isBuiltin,Y.installedTimestamp=Date.now(),M)if(this._operation=3,x.equals(new d.ExtensionKey(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch{throw new Error(y.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&b.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const Z=await this.unsetUninstalledAndGetLocal(x);if(Z)try{await this.extensionsScanner.removeExtension(Z,"existing")}catch{throw new Error(y.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:P.resolve(this.location.fsPath),key:x,metadata:Y},q),metadata:Y}}async getMetadata(q,x,_){try{let[M]=await this.galleryService.getExtensions([{id:q,version:x}],_);if(M||([M]=await this.galleryService.getExtensions([{id:q}],_)),M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId,isPreReleaseVersion:M.properties.isPreReleaseVersion,preRelease:M.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class j{constructor(q,x,_){this.task=q,this.profileLocation=x,this.extensionsProfileScannerService=_,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const q=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[q.local,q.metadata]],this.profileLocation),q}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class J extends c.AbstractExtensionTask{constructor(q,x,_){super(),this.extension=q,this.options=x,this.extensionsScanner=_}async doRun(q){const x=[],_=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=d.ExtensionKey.create(this.extension);x.push(..._.filter(Y=>M.equals(d.ExtensionKey.create(Y))))}else x.push(..._.filter(M=>(0,d.areSameExtensions)(M.identifier,this.extension.identifier)));if(!x.length)throw new Error(y.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...x),this.options.remove)for(const M of x)try{q.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(Y){throw new Error(y.localize(9,null,(0,i.toErrorMessage)(Y)))}}}class ee extends c.AbstractExtensionTask{constructor(q,x,_){super(),this.extension=q,this.profileLocation=x,this.extensionsProfileScannerService=_}async doRun(q){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(re[281],se([0,1,2,29,33,51,78,216,126,46,4,7,19,30,18]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;const v={versionOnly:!0,donotIncludePack:!0,donotCheckDependents:!0};let y=class extends D.Disposable{constructor(c,u,d,n,o,t,r,s){super(),this.userDataProfilesService=u,c.removeUninstalledExtensions(this.userDataProfilesService.profiles.length===1),(0,P.migrateUnsupportedExtensions)(c,d,n,o,s),L.ExtensionStorageService.removeOutdatedExtensionVersions(c,r),this._register(t.createInstance(h))}};y=ve([K(0,I.INativeServerExtensionManagementService),K(1,f.IUserDataProfilesService),K(2,i.IExtensionGalleryService),K(3,L.IExtensionStorageService),K(4,i.IGlobalExtensionEnablementService),K(5,b.IInstantiationService),K(6,S.IStorageService),K(7,C.ILogService)],y),e.ExtensionsCleaner=y;let h=class extends D.Disposable{constructor(c,u,d,n,o){super(),this.extensionManagementService=c,this.userDataProfilesService=u,this.extensionsProfileScannerService=d,this.uriIdentityService=n,this.logService=o,this.profileExtensionsLocations=new Map,this.profileModeDisposables=this._register(new D.MutableDisposable),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}async onDidChangeProfiles({added:c,removed:u,all:d}){try{await Promise.all(u.map(n=>n.extensionsResource?this.removeExtensionsFromProfile(n.extensionsResource):Promise.resolve()))}catch(n){this.logService.error(n)}if(d.length===1){this.profileModeDisposables.clear();const n=this._register(this.userDataProfilesService.onDidChangeProfiles(()=>{n.dispose(),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}));return}try{c.length&&(await Promise.all(c.map(n=>n.extensionsResource?this.populateExtensionsFromProfile(n.extensionsResource):Promise.resolve())),this.profileModeDisposables.value||(this.profileModeDisposables.value=new D.DisposableStore,this.profileModeDisposables.value.add((0,D.toDisposable)(()=>this.profileExtensionsLocations.clear())),this.profileModeDisposables.value.add(this.userDataProfilesService.onDidChangeProfiles(n=>this.onDidChangeProfiles(n))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidInstallExtensions(n=>this.onDidInstallExtensions(n))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidUninstallExtension(n=>this.onDidUninstallExtension(n))),await this.uninstallExtensionsNotInProfiles()))}catch(n){this.logService.error(n)}}async uninstallExtensionsNotInProfiles(){const u=(await this.extensionManagementService.getAllUserInstalled()).filter(d=>d.installedTimestamp&&!this.profileExtensionsLocations.has(this.getKey(d.identifier,d.manifest.version)));u.length&&await Promise.all(u.map(d=>this.extensionManagementService.uninstall(d,v)))}async onDidInstallExtensions(c){for(const{local:u,profileLocation:d}of c)!u||!d||this.addExtensionWithKey(this.getKey(u.identifier,u.manifest.version),d)}async onDidUninstallExtension(c){!c.profileLocation||!c.version||this.removeExtensionWithKey(this.getKey(c.identifier,c.version),c.profileLocation)&&await this.uninstallExtensions([{identifier:c.identifier,version:c.version}])}async populateExtensionsFromProfile(c){const u=await this.extensionsProfileScannerService.scanProfileExtensions(c);for(const d of u)this.addExtensionWithKey(this.getKey(d.identifier,d.version),c)}async removeExtensionsFromProfile(c){const u=[];for(const d of[...this.profileExtensionsLocations.keys()]){if(!this.removeExtensionWithKey(d,c))continue;const n=this.fromKey(d);n&&u.push(n)}u.length&&await this.uninstallExtensions(u)}addExtensionWithKey(c,u){let d=this.profileExtensionsLocations.get(c);d||(d=[],this.profileExtensionsLocations.set(c,d)),d.push(u)}removeExtensionWithKey(c,u){const d=this.profileExtensionsLocations.get(c);if(d){const n=d.findIndex(o=>this.uriIdentityService.extUri.isEqual(o,u));n>-1&&d.splice(n,1)}return d?.length?!1:(this.profileExtensionsLocations.delete(c),!0)}async uninstallExtensions(c){const d=(await this.extensionManagementService.getAllUserInstalled()).filter(n=>n.installedTimestamp&&c.some(o=>this.getKey(n.identifier,n.manifest.version)===this.getKey(o.identifier,o.version)));d.length&&await Promise.all(d.map(n=>this.extensionManagementService.uninstall(n,v)))}getKey(c,u){return`${w.ExtensionIdentifier.toKey(c.id)}@${u}`}fromKey(c){const[u,d]=(0,R.getIdAndVersion)(c);return d?{identifier:{id:u},version:d}:void 0}};h=ve([K(0,I.INativeServerExtensionManagementService),K(1,f.IUserDataProfilesService),K(2,T.IExtensionsProfileScannerService),K(3,m.IUriIdentityService),K(4,C.ILogService)],h)}),define(re[290],se([0,1,92,34,37,11,2,22,21,8,38,149,209,281,210,202,203,279,191,194,16,214,95,233,96,224,13,230,117,265,29,97,193,266,126,98,189,14,205,207,56,4,200,71,201,58,72,219,7,102,59,103,25,47,19,267,109,23,110,111,112,52,238,113,240,246,78,115,26,76,269,258,259,79,270,273,274,275,276,277,62,260,108,232,75,248,221,247,107,229,30,250,5,251,195,212,211,77,264,18,51,208,60,268,227,237,261,234,106,101,272]),function(Q,e,D,i,R,T,L,P,I,w,b,C,S,m,f,v,y,h,p,c,u,d,n,o,t,r,s,l,a,g,E,A,B,O,N,F,k,U,$,G,W,V,z,j,J,ee,ce,q,x,_,M,Y,H,Z,oe,X,ie,ne,le,ue,pe,we,Ee,Ce,_e,Ne,He,Xe,ae,fe,ge,be,Ie,Te,Re,Fe,Oe,Me,We,ke,Ae,te,he,de,me,Se,Pe,De,ze,$e,Le,qe,Ve,et,tt,Tt,St,Lt,At,yt,wt,_t,Et,Ot,Ut,Mt,Nt,Ft,bt,Ct,$t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Wt extends L.Disposable{constructor(ye){super(),this.configuration=ye,this.server=this._register(new C.Server),this.sharedProcessWorkerService=void 0,this.lifecycleService=void 0,this.registerListeners()}registerListeners(){const ye=async()=>{this.lifecycleService&&(await this.lifecycleService.fireOnWillShutdown(),this.lifecycleService.dispose(),this.lifecycleService=void 0),this.dispose()};process.once("exit",ye),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye);const Ue="vscode:electron-main->shared-process=disposeWorker",je=(Ge,it)=>{this.onDisposeWorker(it)};D.ipcRenderer.on(Ue,je),this._register((0,L.toDisposable)(()=>D.ipcRenderer.removeListener(Ue,je)))}onDisposeWorker(ye){this.sharedProcessWorkerService?.disposeWorker(ye)}async open(){const ye=await this.initServices();(0,ae.registerConfiguration)(),ye.invokeFunction(Ue=>{const je=Ue.get(x.ILogService);je.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(je)}),this._register((0,L.combinedDisposable)(ye.createInstance(S.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(f.LanguagePackCachedDataCleaner),ye.createInstance(h.UnusedWorkspaceStorageDataCleaner),ye.createInstance(y.LogsDataCleaner),ye.createInstance(v.LocalizationsUpdater),ye.createInstance(m.ExtensionsCleaner),ye.createInstance(Nt.UserDataProfilesCleaner)))}async initServices(){const ye=new j.ServiceCollection,Ue={_serviceBrand:void 0,...Y.default};ye.set(H.IProductService,Ue);const je=new b.StaticRouter(Je=>Je==="main"),Ge=new J.MessagePortMainProcessService(this.server,je);ye.set(ee.IMainProcessService,Ge);const it=this.configuration.policiesData?new _t.PolicyChannelClient(this.configuration.policiesData,Ge.getChannel("policy")):new Et.NullPolicyService;ye.set(Et.IPolicyService,it);const xe=new l.SharedProcessEnvironmentService(this.configuration.args,Ue);ye.set(s.INativeEnvironmentService,xe);const lt=new _.LogLevelChannelClient(this.server.getChannel("logLevel",je)),nt=new _.LoggerChannelClient(this.configuration.logLevel,lt.onDidChangeLogLevel,Ge.getChannel("logger"));ye.set(x.ILoggerService,nt);const ht=this._register(new x.MultiplexLogService([this._register(new x.ConsoleLogger(this.configuration.logLevel)),this._register(nt.createLogger((0,I.joinPath)(w.URI.file(xe.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ke=this._register(new _.FollowerLogService(lt,ht));ye.set(x.ILogService,Ke),this.lifecycleService=new Ct.SharedProcessLifecycleService(Ke),ye.set(Ct.ISharedProcessLifecycleService,this.lifecycleService),this.sharedProcessWorkerService=new $e.SharedProcessWorkerService(Ke),ye.set(ze.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Qe=this._register(new $.FileService(Ke));ye.set(U.IFileService,Qe);const dt=this._register(new G.DiskFileSystemProvider(Ke));Qe.registerProvider(P.Schemas.file,dt);const ft=this._register(new et.FileUserDataProvider(P.Schemas.file,this._register(new tt.DiskFileSystemProviderClient(Ge.getChannel(tt.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Ve.isLinux})),P.Schemas.vscodeUserData,Ke));Qe.registerProvider(P.Schemas.vscodeUserData,ft);const rt=this._register(new Ot.UserDataProfilesNativeService(this.configuration.profiles,Ge,xe));ye.set(yt.IUserDataProfilesService,rt);const Ye=this._register(new d.ConfigurationService(rt.defaultProfile.settingsResource,Qe,it,Ke));ye.set(u.IConfigurationService,Ye);const at=new X.NativeStorageService(void 0,{defaultProfile:rt.defaultProfile,currentProfile:rt.defaultProfile},Ge,xe);ye.set(oe.IStorageService,at),this._register((0,L.toDisposable)(()=>at.flush())),await Promise.all([Ye.initialize(),at.initialize()]),ye.set(Le.IUriIdentityService,new qe.UriIdentityService(Qe)),ye.set(Z.IRequestService,new Ut.SharedProcessRequestService(Ge,Ye,Ke)),ye.set(p.IChecksumService,new W.SyncDescriptor(c.ChecksumService,void 0,!1)),ye.set(St.IV8InspectProfilingService,new W.SyncDescriptor(Tt.InspectProfilingService,void 0,!1));const ut=b.ProxyChannel.toService(Ge.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(M.INativeHostService,ut),ye.set(t.IDownloadService,new W.SyncDescriptor(r.DownloadService,void 0,!0));const gt=this._register(new te.ActiveWindowManager(ut)),mt=new b.StaticRouter(Je=>gt.getActiveClientId().then(vt=>Je===vt));ye.set(F.IExtensionRecommendationNotificationService,new k.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",mt)));let st;const ct=[],It=(0,we.isInternalTelemetry)(Ue,Ye);if((0,we.supportsTelemetry)(Ue,xe)){const Je=new ue.TelemetryLogAppender(nt,xe);ct.push(Je);const{installSourcePath:vt}=xe;if(Ue.aiConfig?.ariaKey){const Rt=new Mt.OneDataSystemAppender(It,"monacoworkbench",null,Ue.aiConfig.ariaKey);this._register((0,L.toDisposable)(()=>Rt.flush())),ct.push(Rt)}st=new pe.TelemetryService({appenders:ct,commonProperties:(0,ie.resolveCommonProperties)(Qe,(0,i.release)(),(0,i.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,It,vt),sendErrorTelemetry:!0,piiPaths:(0,we.getPiiPathsFromEnvironment)(xe)},Ye,Ue)}else{st=we.NullTelemetryService;const Je=we.NullAppender;ct.push(Je)}this.server.registerChannel("telemetryAppender",new le.TelemetryAppenderChannel(ct)),ye.set(ne.ITelemetryService,st);const qt=new Ee.CustomEndpointTelemetryService(Ye,st,nt,xe,Ue);ye.set(ne.ICustomEndpointTelemetryService,qt),ye.set(wt.IExtensionsProfileScannerService,new W.SyncDescriptor(wt.ExtensionsProfileScannerService,void 0,!0)),ye.set(Lt.IExtensionsScannerService,new W.SyncDescriptor(At.ExtensionsScannerService,void 0,!0)),ye.set(A.IExtensionSignatureVerificationService,new W.SyncDescriptor(A.ExtensionSignatureVerificationService,void 0,!0)),ye.set(N.INativeServerExtensionManagementService,new W.SyncDescriptor(N.ExtensionManagementService,void 0,!0)),ye.set(E.IExtensionGalleryService,new W.SyncDescriptor(g.ExtensionGalleryService,void 0,!0)),ye.set(E.IExtensionTipsService,new W.SyncDescriptor(O.ExtensionTipsService,void 0,!1)),ye.set(ce.ILanguagePackService,new W.SyncDescriptor(q.NativeLanguagePackService,void 0,!1)),ye.set(n.IDiagnosticsService,new W.SyncDescriptor(o.DiagnosticsService,void 0,!1)),ye.set(fe.IUserDataSyncAccountService,new W.SyncDescriptor(fe.UserDataSyncAccountService,void 0,!0)),ye.set(ae.IUserDataSyncLogService,new W.SyncDescriptor(Ie.UserDataSyncLogService,void 0,!0)),ye.set(ae.IUserDataSyncUtilService,new be.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Je=>Je.ctx!=="main"))),ye.set(E.IGlobalExtensionEnablementService,new W.SyncDescriptor(a.GlobalExtensionEnablementService,void 0,!1)),ye.set(Xe.IIgnoredExtensionsManagementService,new W.SyncDescriptor(Xe.IgnoredExtensionsManagementService,void 0,!0)),ye.set(He.IExtensionStorageService,new W.SyncDescriptor(He.ExtensionStorageService)),ye.set(ae.IUserDataSyncStoreManagementService,new W.SyncDescriptor(Me.UserDataSyncStoreManagementService,void 0,!0)),ye.set(ae.IUserDataSyncStoreService,new W.SyncDescriptor(Me.UserDataSyncStoreService,void 0,!0)),ye.set(Te.IUserDataSyncMachinesService,new W.SyncDescriptor(Te.UserDataSyncMachinesService,void 0,!0)),ye.set(ae.IUserDataSyncBackupStoreService,new W.SyncDescriptor(ge.UserDataSyncBackupStoreService,void 0,!1)),ye.set(ae.IUserDataSyncEnablementService,new W.SyncDescriptor(Re.UserDataSyncEnablementService,void 0,!0)),ye.set(ae.IUserDataSyncService,new W.SyncDescriptor(Fe.UserDataSyncService,void 0,!1)),ye.set(Ae.IUserDataSyncProfilesStorageService,new W.SyncDescriptor(ke.UserDataSyncProfilesStorageService,void 0,!0)),ye.set(ae.IUserDataSyncResourceProviderService,new W.SyncDescriptor($t.UserDataSyncResourceProviderService,void 0,!0));const Dt=new Ne.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ye.getValue("terminal.integrated.persistentSessionScrollback")??100},Ye,xe,Ke);return Dt.initialize(),ye.set(_e.ILocalPtyService,this._register(Dt)),ye.set(he.ISignService,new W.SyncDescriptor(de.SignService,void 0,!1)),ye.set(me.ISharedTunnelsService,new W.SyncDescriptor(Se.SharedTunnelsService)),ye.set(Pe.ISharedProcessTunnelService,new W.SyncDescriptor(De.SharedProcessTunnelService)),ye.set(bt.IRemoteTunnelService,new W.SyncDescriptor(Ft.RemoteTunnelService)),new z.InstantiationService(ye)}initChannels(ye){const Ue=new _.LogLevelChannel(ye.get(x.ILogService),ye.get(x.ILoggerService));this.server.registerChannel("logLevel",Ue);const je=new B.ExtensionManagementChannel(ye.get(E.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",je);const Ge=b.ProxyChannel.fromService(ye.get(ce.ILanguagePackService));this.server.registerChannel("languagePacks",Ge);const it=b.ProxyChannel.fromService(ye.get(n.IDiagnosticsService));this.server.registerChannel("diagnostics",it);const xe=new B.ExtensionTipsChannel(ye.get(E.IExtensionTipsService));this.server.registerChannel("extensionTipsService",xe);const lt=b.ProxyChannel.fromService(ye.get(p.IChecksumService));this.server.registerChannel("checksum",lt);const nt=b.ProxyChannel.fromService(ye.get(St.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",nt);const ht=new be.UserDataSyncMachinesServiceChannel(ye.get(Te.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ht);const Ke=b.ProxyChannel.fromService(ye.get(ne.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Ke);const Qe=new be.UserDataSyncAccountServiceChannel(ye.get(fe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Qe);const dt=new be.UserDataSyncStoreManagementServiceChannel(ye.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",dt);const ft=new Oe.UserDataSyncChannel(ye.get(ae.IUserDataSyncService),ye.get(yt.IUserDataProfilesService),ye.get(x.ILogService));this.server.registerChannel("userDataSync",ft);const rt=this._register(ye.get(V.IInstantiationService).createInstance(We.UserDataAutoSyncService)),Ye=new be.UserDataAutoSyncChannel(rt);this.server.registerChannel("userDataAutoSync",Ye);const at=ye.get(_e.ILocalPtyService),ut=b.ProxyChannel.fromService(at);this.server.registerChannel(Ce.TerminalIpcChannels.LocalPty,ut);const gt=b.ProxyChannel.fromService(ye.get(Pe.ISharedProcessTunnelService));this.server.registerChannel(Pe.ipcSharedProcessTunnelChannelName,gt);const mt=b.ProxyChannel.fromService(ye.get(ze.ISharedProcessWorkerService));this.server.registerChannel(ze.ipcSharedProcessWorkerChannelName,mt);const st=b.ProxyChannel.fromService(ye.get(bt.IRemoteTunnelService));this.server.registerChannel("remoteTunnel",st)}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Ue=>{(0,T.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,T.setUnexpectedErrorHandler)(Ue=>{const je=(0,R.toErrorMessage)(Ue,!0);!je||ye.error(`[uncaught exception in sharedProcess]: ${je}`)})}}async function zt(Pt){const ye=new Wt(Pt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=zt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8fa188b2b301d36553cbc9ce1b0a146ccb93351f/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
